// bup_qsys_msgdma_rx.v

// Generated using ACDS version 17.1 169

`timescale 1 ps / 1 ps
module bup_qsys_msgdma_rx (
		input  wire        clock_clk,                                  //                   clock.clk
		input  wire [31:0] csr_writedata,                              //                     csr.writedata
		input  wire        csr_write,                                  //                        .write
		input  wire [3:0]  csr_byteenable,                             //                        .byteenable
		output wire [31:0] csr_readdata,                               //                        .readdata
		input  wire        csr_read,                                   //                        .read
		input  wire [2:0]  csr_address,                                //                        .address
		output wire        csr_irq_irq,                                //                 csr_irq.irq
		output wire [12:0] descriptor_read_master_address,             //  descriptor_read_master.address
		output wire        descriptor_read_master_read,                //                        .read
		input  wire [31:0] descriptor_read_master_readdata,            //                        .readdata
		input  wire        descriptor_read_master_waitrequest,         //                        .waitrequest
		input  wire        descriptor_read_master_readdatavalid,       //                        .readdatavalid
		output wire [12:0] descriptor_write_master_address,            // descriptor_write_master.address
		output wire        descriptor_write_master_write,              //                        .write
		output wire [3:0]  descriptor_write_master_byteenable,         //                        .byteenable
		output wire [31:0] descriptor_write_master_writedata,          //                        .writedata
		input  wire        descriptor_write_master_waitrequest,        //                        .waitrequest
		input  wire [1:0]  descriptor_write_master_response,           //                        .response
		input  wire        descriptor_write_master_writeresponsevalid, //                        .writeresponsevalid
		output wire [28:0] mm_write_address,                           //                mm_write.address
		output wire        mm_write_write,                             //                        .write
		output wire [3:0]  mm_write_byteenable,                        //                        .byteenable
		output wire [31:0] mm_write_writedata,                         //                        .writedata
		input  wire        mm_write_waitrequest,                       //                        .waitrequest
		input  wire [2:0]  prefetcher_csr_address,                     //          prefetcher_csr.address
		input  wire        prefetcher_csr_read,                        //                        .read
		input  wire        prefetcher_csr_write,                       //                        .write
		input  wire [31:0] prefetcher_csr_writedata,                   //                        .writedata
		output wire [31:0] prefetcher_csr_readdata,                    //                        .readdata
		input  wire        reset_n_reset_n,                            //                 reset_n.reset_n
		input  wire [31:0] st_sink_data,                               //                 st_sink.data
		input  wire        st_sink_valid,                              //                        .valid
		output wire        st_sink_ready,                              //                        .ready
		input  wire        st_sink_startofpacket,                      //                        .startofpacket
		input  wire        st_sink_endofpacket,                        //                        .endofpacket
		input  wire [1:0]  st_sink_empty,                              //                        .empty
		input  wire [5:0]  st_sink_error                               //                        .error
	);

	bup_qsys_msgdma_rx_altera_msgdma_171_v5dnzoq bup_qsys_msgdma_1 (
		.clock_clk                                  (clock_clk),                                  //   input,   width = 1,                   clock.clk
		.csr_writedata                              (csr_writedata),                              //   input,  width = 32,                     csr.writedata
		.csr_write                                  (csr_write),                                  //   input,   width = 1,                        .write
		.csr_byteenable                             (csr_byteenable),                             //   input,   width = 4,                        .byteenable
		.csr_readdata                               (csr_readdata),                               //  output,  width = 32,                        .readdata
		.csr_read                                   (csr_read),                                   //   input,   width = 1,                        .read
		.csr_address                                (csr_address),                                //   input,   width = 3,                        .address
		.csr_irq_irq                                (csr_irq_irq),                                //  output,   width = 1,                 csr_irq.irq
		.descriptor_read_master_address             (descriptor_read_master_address),             //  output,  width = 13,  descriptor_read_master.address
		.descriptor_read_master_read                (descriptor_read_master_read),                //  output,   width = 1,                        .read
		.descriptor_read_master_readdata            (descriptor_read_master_readdata),            //   input,  width = 32,                        .readdata
		.descriptor_read_master_waitrequest         (descriptor_read_master_waitrequest),         //   input,   width = 1,                        .waitrequest
		.descriptor_read_master_readdatavalid       (descriptor_read_master_readdatavalid),       //   input,   width = 1,                        .readdatavalid
		.descriptor_write_master_address            (descriptor_write_master_address),            //  output,  width = 13, descriptor_write_master.address
		.descriptor_write_master_write              (descriptor_write_master_write),              //  output,   width = 1,                        .write
		.descriptor_write_master_byteenable         (descriptor_write_master_byteenable),         //  output,   width = 4,                        .byteenable
		.descriptor_write_master_writedata          (descriptor_write_master_writedata),          //  output,  width = 32,                        .writedata
		.descriptor_write_master_waitrequest        (descriptor_write_master_waitrequest),        //   input,   width = 1,                        .waitrequest
		.descriptor_write_master_response           (descriptor_write_master_response),           //   input,   width = 2,                        .response
		.descriptor_write_master_writeresponsevalid (descriptor_write_master_writeresponsevalid), //   input,   width = 1,                        .writeresponsevalid
		.mm_write_address                           (mm_write_address),                           //  output,  width = 29,                mm_write.address
		.mm_write_write                             (mm_write_write),                             //  output,   width = 1,                        .write
		.mm_write_byteenable                        (mm_write_byteenable),                        //  output,   width = 4,                        .byteenable
		.mm_write_writedata                         (mm_write_writedata),                         //  output,  width = 32,                        .writedata
		.mm_write_waitrequest                       (mm_write_waitrequest),                       //   input,   width = 1,                        .waitrequest
		.prefetcher_csr_address                     (prefetcher_csr_address),                     //   input,   width = 3,          prefetcher_csr.address
		.prefetcher_csr_read                        (prefetcher_csr_read),                        //   input,   width = 1,                        .read
		.prefetcher_csr_write                       (prefetcher_csr_write),                       //   input,   width = 1,                        .write
		.prefetcher_csr_writedata                   (prefetcher_csr_writedata),                   //   input,  width = 32,                        .writedata
		.prefetcher_csr_readdata                    (prefetcher_csr_readdata),                    //  output,  width = 32,                        .readdata
		.reset_n_reset_n                            (reset_n_reset_n),                            //   input,   width = 1,                 reset_n.reset_n
		.st_sink_data                               (st_sink_data),                               //   input,  width = 32,                 st_sink.data
		.st_sink_valid                              (st_sink_valid),                              //   input,   width = 1,                        .valid
		.st_sink_ready                              (st_sink_ready),                              //  output,   width = 1,                        .ready
		.st_sink_startofpacket                      (st_sink_startofpacket),                      //   input,   width = 1,                        .startofpacket
		.st_sink_endofpacket                        (st_sink_endofpacket),                        //   input,   width = 1,                        .endofpacket
		.st_sink_empty                              (st_sink_empty),                              //   input,   width = 2,                        .empty
		.st_sink_error                              (st_sink_error)                               //   input,   width = 6,                        .error
	);

endmodule
