module tse_mac_altera_lvds_core14_171_ebyefrq #(
   parameter NUM_CHANNELS                                       = 0,
   parameter J_FACTOR                                           = 0,
   parameter RX_BITSLIP_ROLLOVER                                = 0,
   parameter TX_REGISTER_CLOCK                                  = "",
   parameter TX_OUTCLOCK_NON_STD_PHASE_SHIFT                    = "",
   parameter SERDES_DPA_MODE                                    = "",
   parameter TX_OUTCLOCK_ENABLED                                = "",
   parameter TX_OUTCLOCK_DIV_WORD                               = 0,
   parameter TX_OUTCLOCK_BYPASS_SERIALIZER                      = "",
   parameter TX_OUTCLOCK_USE_FALLING_CLOCK_EDGE                 = "",
   parameter EXTERNAL_PLL                                       = "",
   parameter ALIGN_TO_RISING_EDGE_ONLY                          = "",
   parameter LOSE_LOCK_ON_ONE_CHANGE                            = "",
   parameter USE_BITSLIP                                        = "",
   parameter VCO_DIV_EXPONENT                                   = 0,
   parameter VCO_FREQUENCY                                      = 0,
   parameter LOOPBACK_MODE                                      = 0,
   parameter SILICON_REV                                        = "",
   parameter USE_CPA                                            = "",
   parameter CPA_DIVIDER                                        = 0,
   parameter CPA_CORE_DIVIDER                                   = "",
   parameter USE_CPA_RECONFIG                                   = "",
   parameter NUM_CLOCKS                                         = 0,
   parameter WIDE_CT                                            = "",
   parameter DPRIO_ENABLED                                      = "",
   parameter USE_DUPLEX                                         = ""
) (
   input  logic [9:0]      tx_in,
   output logic [0:0]      tx_out,
   output logic            tx_outclock,
   output logic            tx_coreclock,
   input  logic [0:0]      rx_in,
   output logic [9:0]      rx_out,
   input  logic [0:0]      rx_bitslip_reset,
   input  logic [0:0]      rx_bitslip_ctrl,
   output logic [0:0]      rx_bitslip_max,
   output logic            rx_coreclock,
   input  logic            ext_fclk,
   input  logic            ext_loaden,
   input  logic            ext_coreclock,
   input  logic            ext_tx_outclock_fclk,
   input  logic            ext_tx_outclock_loaden,
   input  logic [7:0]      ext_vcoph,
   input  logic            ext_pll_locked,
   input  logic            inclock,
   input  logic            pll_areset,
   output logic [0:0]      rx_dpa_locked,
   input  logic [0:0]      rx_dpa_hold,
   input  logic [0:0]      rx_dpa_reset,
   input  logic [0:0]      rx_fifo_reset,
   output logic [0:0]      rx_divfwdclk,
   input  logic [0:0]      loopback_in,
   output logic [0:0]      loopback_out,
   input  logic            user_dprio_rst_n,
   input  logic            user_dprio_read,
   input  logic [8:0]      user_dprio_reg_addr,
   input  logic            user_dprio_write,
   input  logic [7:0]      user_dprio_writedata,
   input  logic            user_dprio_clk_in,
   input  logic            user_mdio_dis,
   output logic            user_dprio_clk,
   output logic            user_dprio_block_select,
   output logic [7:0]      user_dprio_readdata,
   output logic            user_dprio_ready,
   output logic            pll_locked
);
   timeunit 1ns;
   timeprecision 1ps;

   altera_lvds_core14_tse_mac_altera_lvds_core14_171_ebyefrq # (
      .NUM_CHANNELS (NUM_CHANNELS),
      .J_FACTOR (J_FACTOR),
      .RX_BITSLIP_ROLLOVER (RX_BITSLIP_ROLLOVER),
      .TX_REGISTER_CLOCK (TX_REGISTER_CLOCK),
      .TX_OUTCLOCK_NON_STD_PHASE_SHIFT (TX_OUTCLOCK_NON_STD_PHASE_SHIFT),
      .SERDES_DPA_MODE (SERDES_DPA_MODE),
      .TX_OUTCLOCK_ENABLED (TX_OUTCLOCK_ENABLED),
      .TX_OUTCLOCK_DIV_WORD (TX_OUTCLOCK_DIV_WORD),
      .TX_OUTCLOCK_BYPASS_SERIALIZER (TX_OUTCLOCK_BYPASS_SERIALIZER),
      .TX_OUTCLOCK_USE_FALLING_CLOCK_EDGE (TX_OUTCLOCK_USE_FALLING_CLOCK_EDGE),
      .EXTERNAL_PLL (EXTERNAL_PLL),
      .ALIGN_TO_RISING_EDGE_ONLY (ALIGN_TO_RISING_EDGE_ONLY),
      .LOSE_LOCK_ON_ONE_CHANGE (LOSE_LOCK_ON_ONE_CHANGE),
      .USE_BITSLIP (USE_BITSLIP),
      .VCO_DIV_EXPONENT (VCO_DIV_EXPONENT),
      .VCO_FREQUENCY (VCO_FREQUENCY),
      .LOOPBACK_MODE (LOOPBACK_MODE),
      .SILICON_REV (SILICON_REV),
      .USE_CPA (USE_CPA),
      .CPA_DIVIDER (CPA_DIVIDER),
      .CPA_CORE_DIVIDER (CPA_CORE_DIVIDER),
      .USE_CPA_RECONFIG (USE_CPA_RECONFIG),
      .NUM_CLOCKS (NUM_CLOCKS),
      .WIDE_CT (WIDE_CT),
      .DPRIO_ENABLED (DPRIO_ENABLED),
      .USE_DUPLEX (USE_DUPLEX)
   ) arch_inst (
      .tx_in (tx_in),
      .tx_out (tx_out),
      .tx_outclock (tx_outclock),
      .tx_coreclock (tx_coreclock),
      .rx_in (rx_in),
      .rx_out (rx_out),
      .rx_bitslip_reset (rx_bitslip_reset),
      .rx_bitslip_ctrl (rx_bitslip_ctrl),
      .rx_bitslip_max (rx_bitslip_max),
      .rx_coreclock (rx_coreclock),
      .ext_fclk (ext_fclk),
      .ext_loaden (ext_loaden),
      .ext_coreclock (ext_coreclock),
      .ext_tx_outclock_fclk (ext_tx_outclock_fclk),
      .ext_tx_outclock_loaden (ext_tx_outclock_loaden),
      .ext_vcoph (ext_vcoph),
      .ext_pll_locked (ext_pll_locked),
      .inclock (inclock),
      .pll_areset (pll_areset),
      .rx_dpa_locked (rx_dpa_locked),
      .rx_dpa_hold (rx_dpa_hold),
      .rx_dpa_reset (rx_dpa_reset),
      .rx_fifo_reset (rx_fifo_reset),
      .rx_divfwdclk (rx_divfwdclk),
      .loopback_in (loopback_in),
      .loopback_out (loopback_out),
      .user_dprio_rst_n (user_dprio_rst_n),
      .user_dprio_read (user_dprio_read),
      .user_dprio_reg_addr (user_dprio_reg_addr),
      .user_dprio_write (user_dprio_write),
      .user_dprio_writedata (user_dprio_writedata),
      .user_dprio_clk_in (user_dprio_clk_in),
      .user_mdio_dis (user_mdio_dis),
      .user_dprio_clk (user_dprio_clk),
      .user_dprio_block_select (user_dprio_block_select),
      .user_dprio_readdata (user_dprio_readdata),
      .user_dprio_ready (user_dprio_ready),
      .pll_locked (pll_locked)
   );
endmodule
