// q_sys_ext_flash.v

// Generated using ACDS version 17.1 240

`timescale 1 ps / 1 ps
module q_sys_ext_flash (
		input  wire        clk_clk,              //   clk.clk
		input  wire        reset_reset,          // reset.reset
		output wire        tcm_write_n_out,      //   tcm.write_n_out
		output wire        tcm_read_n_out,       //      .read_n_out
		output wire        tcm_chipselect_n_out, //      .chipselect_n_out
		output wire        tcm_reset_n_out,      //      .reset_n_out
		output wire        tcm_request,          //      .request
		input  wire        tcm_grant,            //      .grant
		output wire [26:0] tcm_address_out,      //      .address_out
		output wire [15:0] tcm_data_out,         //      .data_out
		output wire        tcm_data_outen,       //      .data_outen
		input  wire [15:0] tcm_data_in,          //      .data_in
		input  wire [26:0] uas_address,          //   uas.address
		input  wire [1:0]  uas_burstcount,       //      .burstcount
		input  wire        uas_read,             //      .read
		input  wire        uas_write,            //      .write
		output wire        uas_waitrequest,      //      .waitrequest
		output wire        uas_readdatavalid,    //      .readdatavalid
		input  wire [1:0]  uas_byteenable,       //      .byteenable
		output wire [15:0] uas_readdata,         //      .readdata
		input  wire [15:0] uas_writedata,        //      .writedata
		input  wire        uas_lock,             //      .lock
		input  wire        uas_debugaccess       //      .debugaccess
	);

	q_sys_ext_flash_altera_generic_tristate_controller_171_daa4o3a #(
		.TCM_ADDRESS_W                  (27),
		.TCM_DATA_W                     (16),
		.TCM_BYTEENABLE_W               (2),
		.TCM_READ_WAIT                  (200),
		.TCM_WRITE_WAIT                 (200),
		.TCM_SETUP_WAIT                 (60),
		.TCM_DATA_HOLD                  (60),
		.TCM_TURNAROUND_TIME            (2),
		.TCM_TIMING_UNITS               (0),
		.TCM_READLATENCY                (3),
		.TCM_SYMBOLS_PER_WORD           (2),
		.USE_READDATA                   (1),
		.USE_WRITEDATA                  (1),
		.USE_READ                       (1),
		.USE_WRITE                      (1),
		.USE_BYTEENABLE                 (0),
		.USE_CHIPSELECT                 (1),
		.USE_LOCK                       (0),
		.USE_ADDRESS                    (1),
		.USE_WAITREQUEST                (0),
		.USE_WRITEBYTEENABLE            (0),
		.USE_OUTPUTENABLE               (0),
		.USE_RESETREQUEST               (0),
		.USE_IRQ                        (0),
		.USE_RESET_OUTPUT               (1),
		.ACTIVE_LOW_READ                (1),
		.ACTIVE_LOW_LOCK                (0),
		.ACTIVE_LOW_WRITE               (1),
		.ACTIVE_LOW_CHIPSELECT          (1),
		.ACTIVE_LOW_BYTEENABLE          (0),
		.ACTIVE_LOW_OUTPUTENABLE        (0),
		.ACTIVE_LOW_WRITEBYTEENABLE     (0),
		.ACTIVE_LOW_WAITREQUEST         (0),
		.ACTIVE_LOW_BEGINTRANSFER       (0),
		.CHIPSELECT_THROUGH_READLATENCY (0)
	) ext_flash (
		.clk_clk              (clk_clk),              //   input,   width = 1,   clk.clk
		.reset_reset          (reset_reset),          //   input,   width = 1, reset.reset
		.tcm_write_n_out      (tcm_write_n_out),      //  output,   width = 1,   tcm.write_n_out
		.tcm_read_n_out       (tcm_read_n_out),       //  output,   width = 1,      .read_n_out
		.tcm_chipselect_n_out (tcm_chipselect_n_out), //  output,   width = 1,      .chipselect_n_out
		.tcm_reset_n_out      (tcm_reset_n_out),      //  output,   width = 1,      .reset_n_out
		.tcm_request          (tcm_request),          //  output,   width = 1,      .request
		.tcm_grant            (tcm_grant),            //   input,   width = 1,      .grant
		.tcm_address_out      (tcm_address_out),      //  output,  width = 27,      .address_out
		.tcm_data_out         (tcm_data_out),         //  output,  width = 16,      .data_out
		.tcm_data_outen       (tcm_data_outen),       //  output,   width = 1,      .data_outen
		.tcm_data_in          (tcm_data_in),          //   input,  width = 16,      .data_in
		.uas_address          (uas_address),          //   input,  width = 27,   uas.address
		.uas_burstcount       (uas_burstcount),       //   input,   width = 2,      .burstcount
		.uas_read             (uas_read),             //   input,   width = 1,      .read
		.uas_write            (uas_write),            //   input,   width = 1,      .write
		.uas_waitrequest      (uas_waitrequest),      //  output,   width = 1,      .waitrequest
		.uas_readdatavalid    (uas_readdatavalid),    //  output,   width = 1,      .readdatavalid
		.uas_byteenable       (uas_byteenable),       //   input,   width = 2,      .byteenable
		.uas_readdata         (uas_readdata),         //  output,  width = 16,      .readdata
		.uas_writedata        (uas_writedata),        //   input,  width = 16,      .writedata
		.uas_lock             (uas_lock),             //   input,   width = 1,      .lock
		.uas_debugaccess      (uas_debugaccess)       //   input,   width = 1,      .debugaccess
	);

endmodule
