// (C) 2001-2017 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// $Id: //acds/rel/17.1/ip/merlin/altera_tristate_conduit_bridge/altera_tristate_conduit_bridge.sv.terp#1 $
// $Revision: #1 $
// $Date: 2017/08/13 $
// $Author: swbranch $

//Defined Terp Parameters


			    

`timescale 1 ns / 1 ns
  				      
module q_sys_tb_fm_altera_tristate_conduit_bridge_171_w23ni5y (
     input  logic clk
    ,input  logic reset
    ,input  logic request
    ,output logic grant
    ,input  logic[ 26 :0 ] tcs_tb_fm_address
    ,output  wire [ 26 :0 ] tb_fm_address
    ,output logic[ 15 :0 ] tcs_tb_fm_data_in
    ,input  logic[ 15 :0 ] tcs_tb_fm_data
    ,input  logic tcs_tb_fm_data_outen
    ,inout  wire [ 15 :0 ]  tb_fm_data
    ,input  logic[ 0 :0 ] tcs_flash_csn
    ,output  wire [ 0 :0 ] flash_csn
    ,input  logic[ 0 :0 ] tcs_flash_ren
    ,output  wire [ 0 :0 ] flash_ren
    ,input  logic[ 0 :0 ] tcs_flash_wen
    ,output  wire [ 0 :0 ] flash_wen
    ,input  logic[ 0 :0 ] tcs_flash_resetn
    ,output  wire [ 0 :0 ] flash_resetn
		     
   );
   reg grant_reg;
   assign grant = grant_reg;
   
   always@(posedge clk) begin
      if(reset)
	grant_reg <= 0;
      else
	grant_reg <= request;      
   end
   


 // ** Output Pin tb_fm_address 
 
    reg                       tb_fm_addressen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   tb_fm_addressen_reg <= 'b0;
	 end
	 else begin
	   tb_fm_addressen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 26 : 0 ] tb_fm_address_reg;   

     always@(posedge clk) begin
	 tb_fm_address_reg   <= tcs_tb_fm_address[ 26 : 0 ];
      end
          
 
    assign 	tb_fm_address[ 26 : 0 ] = tb_fm_addressen_reg ? tb_fm_address_reg : 'z ;
        


 // ** Bidirectional Pin tb_fm_data 
   
    reg                       tb_fm_data_outen_reg;
  
    always@(posedge clk) begin
	 tb_fm_data_outen_reg <= tcs_tb_fm_data_outen;
     end
  
  
    reg [ 15 : 0 ] tb_fm_data_reg;   

     always@(posedge clk) begin
	 tb_fm_data_reg   <= tcs_tb_fm_data[ 15 : 0 ];
      end
         
  
    assign 	tb_fm_data[ 15 : 0 ] = tb_fm_data_outen_reg ? tb_fm_data_reg : 'z ;
       
  
    reg [ 15 : 0 ] 	tb_fm_data_in_reg;
								    
    always@(posedge clk) begin
	 tb_fm_data_in_reg <= tb_fm_data[ 15 : 0 ];
    end
    
  
    assign      tcs_tb_fm_data_in[ 15 : 0 ] = tb_fm_data_in_reg[ 15 : 0 ];
        


 // ** Output Pin flash_csn 
 
    reg                       flash_csnen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   flash_csnen_reg <= 'b0;
	 end
	 else begin
	   flash_csnen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 0 : 0 ] flash_csn_reg;   

     always@(posedge clk) begin
	 flash_csn_reg   <= tcs_flash_csn[ 0 : 0 ];
      end
          
 
    assign 	flash_csn[ 0 : 0 ] = flash_csnen_reg ? flash_csn_reg : 'z ;
        


 // ** Output Pin flash_ren 
 
    reg                       flash_renen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   flash_renen_reg <= 'b0;
	 end
	 else begin
	   flash_renen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 0 : 0 ] flash_ren_reg;   

     always@(posedge clk) begin
	 flash_ren_reg   <= tcs_flash_ren[ 0 : 0 ];
      end
          
 
    assign 	flash_ren[ 0 : 0 ] = flash_renen_reg ? flash_ren_reg : 'z ;
        


 // ** Output Pin flash_wen 
 
    reg                       flash_wenen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   flash_wenen_reg <= 'b0;
	 end
	 else begin
	   flash_wenen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 0 : 0 ] flash_wen_reg;   

     always@(posedge clk) begin
	 flash_wen_reg   <= tcs_flash_wen[ 0 : 0 ];
      end
          
 
    assign 	flash_wen[ 0 : 0 ] = flash_wenen_reg ? flash_wen_reg : 'z ;
        


 // ** Output Pin flash_resetn 
 
    reg                       flash_resetnen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   flash_resetnen_reg <= 'b0;
	 end
	 else begin
	   flash_resetnen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 0 : 0 ] flash_resetn_reg;   

     always@(posedge clk) begin
	 flash_resetn_reg   <= tcs_flash_resetn[ 0 : 0 ];
      end
          
 
    assign 	flash_resetn[ 0 : 0 ] = flash_resetnen_reg ? flash_resetn_reg : 'z ;
        

endmodule

