	component q_sys_tb_fm is
		port (
			clk                  : in    std_logic                     := 'X';             -- clk
			tb_fm_address        : out   std_logic_vector(26 downto 0);                    -- tb_fm_address
			tb_fm_data           : inout std_logic_vector(15 downto 0) := (others => 'X'); -- tb_fm_data
			flash_csn            : out   std_logic_vector(0 downto 0);                     -- flash_csn
			flash_ren            : out   std_logic_vector(0 downto 0);                     -- flash_ren
			flash_wen            : out   std_logic_vector(0 downto 0);                     -- flash_wen
			flash_resetn         : out   std_logic_vector(0 downto 0);                     -- flash_resetn
			reset                : in    std_logic                     := 'X';             -- reset
			request              : in    std_logic                     := 'X';             -- request
			grant                : out   std_logic;                                        -- grant
			tcs_tb_fm_address    : in    std_logic_vector(26 downto 0) := (others => 'X'); -- tb_fm_address_out
			tcs_tb_fm_data       : in    std_logic_vector(15 downto 0) := (others => 'X'); -- tb_fm_data_out
			tcs_tb_fm_data_outen : in    std_logic                     := 'X';             -- tb_fm_data_outen
			tcs_tb_fm_data_in    : out   std_logic_vector(15 downto 0);                    -- tb_fm_data_in
			tcs_flash_csn        : in    std_logic_vector(0 downto 0)  := (others => 'X'); -- flash_csn_out
			tcs_flash_ren        : in    std_logic_vector(0 downto 0)  := (others => 'X'); -- flash_ren_out
			tcs_flash_wen        : in    std_logic_vector(0 downto 0)  := (others => 'X'); -- flash_wen_out
			tcs_flash_resetn     : in    std_logic_vector(0 downto 0)  := (others => 'X')  -- flash_resetn_out
		);
	end component q_sys_tb_fm;

	u0 : component q_sys_tb_fm
		port map (
			clk                  => CONNECTED_TO_clk,                  --   clk.clk
			tb_fm_address        => CONNECTED_TO_tb_fm_address,        --   out.tb_fm_address
			tb_fm_data           => CONNECTED_TO_tb_fm_data,           --      .tb_fm_data
			flash_csn            => CONNECTED_TO_flash_csn,            --      .flash_csn
			flash_ren            => CONNECTED_TO_flash_ren,            --      .flash_ren
			flash_wen            => CONNECTED_TO_flash_wen,            --      .flash_wen
			flash_resetn         => CONNECTED_TO_flash_resetn,         --      .flash_resetn
			reset                => CONNECTED_TO_reset,                -- reset.reset
			request              => CONNECTED_TO_request,              --   tcs.request
			grant                => CONNECTED_TO_grant,                --      .grant
			tcs_tb_fm_address    => CONNECTED_TO_tcs_tb_fm_address,    --      .tb_fm_address_out
			tcs_tb_fm_data       => CONNECTED_TO_tcs_tb_fm_data,       --      .tb_fm_data_out
			tcs_tb_fm_data_outen => CONNECTED_TO_tcs_tb_fm_data_outen, --      .tb_fm_data_outen
			tcs_tb_fm_data_in    => CONNECTED_TO_tcs_tb_fm_data_in,    --      .tb_fm_data_in
			tcs_flash_csn        => CONNECTED_TO_tcs_flash_csn,        --      .flash_csn_out
			tcs_flash_ren        => CONNECTED_TO_tcs_flash_ren,        --      .flash_ren_out
			tcs_flash_wen        => CONNECTED_TO_tcs_flash_wen,        --      .flash_wen_out
			tcs_flash_resetn     => CONNECTED_TO_tcs_flash_resetn      --      .flash_resetn_out
		);

