	component q_sys_tb_fm_ps is
		port (
			clk_clk               : in  std_logic                     := 'X';             -- clk
			reset_reset           : in  std_logic                     := 'X';             -- reset
			request               : out std_logic;                                        -- request
			grant                 : in  std_logic                     := 'X';             -- grant
			tb_fm_address         : out std_logic_vector(26 downto 0);                    -- tb_fm_address_out
			flash_ren             : out std_logic_vector(0 downto 0);                     -- flash_ren_out
			flash_resetn          : out std_logic_vector(0 downto 0);                     -- flash_resetn_out
			flash_wen             : out std_logic_vector(0 downto 0);                     -- flash_wen_out
			tb_fm_data            : out std_logic_vector(15 downto 0);                    -- tb_fm_data_out
			tb_fm_data_in         : in  std_logic_vector(15 downto 0) := (others => 'X'); -- tb_fm_data_in
			tb_fm_data_outen      : out std_logic;                                        -- tb_fm_data_outen
			flash_csn             : out std_logic_vector(0 downto 0);                     -- flash_csn_out
			tcs0_request          : in  std_logic                     := 'X';             -- request
			tcs0_grant            : out std_logic;                                        -- grant
			tcs0_address_out      : in  std_logic_vector(26 downto 0) := (others => 'X'); -- address_out
			tcs0_read_n_out       : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- read_n_out
			tcs0_reset_n_out      : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- reset_n_out
			tcs0_write_n_out      : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- write_n_out
			tcs0_data_out         : in  std_logic_vector(15 downto 0) := (others => 'X'); -- data_out
			tcs0_data_in          : out std_logic_vector(15 downto 0);                    -- data_in
			tcs0_data_outen       : in  std_logic                     := 'X';             -- data_outen
			tcs0_chipselect_n_out : in  std_logic_vector(0 downto 0)  := (others => 'X')  -- chipselect_n_out
		);
	end component q_sys_tb_fm_ps;

	u0 : component q_sys_tb_fm_ps
		port map (
			clk_clk               => CONNECTED_TO_clk_clk,               --   clk.clk
			reset_reset           => CONNECTED_TO_reset_reset,           -- reset.reset
			request               => CONNECTED_TO_request,               --   tcm.request
			grant                 => CONNECTED_TO_grant,                 --      .grant
			tb_fm_address         => CONNECTED_TO_tb_fm_address,         --      .tb_fm_address_out
			flash_ren             => CONNECTED_TO_flash_ren,             --      .flash_ren_out
			flash_resetn          => CONNECTED_TO_flash_resetn,          --      .flash_resetn_out
			flash_wen             => CONNECTED_TO_flash_wen,             --      .flash_wen_out
			tb_fm_data            => CONNECTED_TO_tb_fm_data,            --      .tb_fm_data_out
			tb_fm_data_in         => CONNECTED_TO_tb_fm_data_in,         --      .tb_fm_data_in
			tb_fm_data_outen      => CONNECTED_TO_tb_fm_data_outen,      --      .tb_fm_data_outen
			flash_csn             => CONNECTED_TO_flash_csn,             --      .flash_csn_out
			tcs0_request          => CONNECTED_TO_tcs0_request,          --  tcs0.request
			tcs0_grant            => CONNECTED_TO_tcs0_grant,            --      .grant
			tcs0_address_out      => CONNECTED_TO_tcs0_address_out,      --      .address_out
			tcs0_read_n_out       => CONNECTED_TO_tcs0_read_n_out,       --      .read_n_out
			tcs0_reset_n_out      => CONNECTED_TO_tcs0_reset_n_out,      --      .reset_n_out
			tcs0_write_n_out      => CONNECTED_TO_tcs0_write_n_out,      --      .write_n_out
			tcs0_data_out         => CONNECTED_TO_tcs0_data_out,         --      .data_out
			tcs0_data_in          => CONNECTED_TO_tcs0_data_in,          --      .data_in
			tcs0_data_outen       => CONNECTED_TO_tcs0_data_outen,       --      .data_outen
			tcs0_chipselect_n_out => CONNECTED_TO_tcs0_chipselect_n_out  --      .chipselect_n_out
		);

