
# (C) 2001-2017 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Intel 
# Program License Subscription Agreement, Intel MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Intel and sold by Intel 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ACDS 17.1 240 linux 2017.11.07.10:42:35
# ----------------------------------------
# Auto-generated simulation script rivierapro_setup.tcl
# ----------------------------------------
# This script provides commands to simulate the following IP detected in
# your Quartus project:
#     ed_sim_mem.ed_sim_mem
#     ed_sim_local_reset_combiner.ed_sim_local_reset_combiner
#     ed_sim_sim_checker.ed_sim_sim_checker
#     ed_sim_local_reset_source.ed_sim_local_reset_source
#     ed_sim_emif_s10_0.ed_sim_emif_s10_0
#     ed_sim_tg.ed_sim_tg
#     ed_sim_pll_ref_clk_source.ed_sim_pll_ref_clk_source
#     ed_sim.ed_sim
# 
# Intel recommends that you source this Quartus-generated IP simulation
# script from your own customized top-level script, and avoid editing this
# generated script.
# 
# To write a top-level script that compiles Intel simulation libraries and
# the Quartus-generated IP in your project, along with your design and
# testbench files, copy the text from the TOP-LEVEL TEMPLATE section below
# into a new file, e.g. named "aldec.do", and modify the text as directed.
# 
# ----------------------------------------
# # TOP-LEVEL TEMPLATE - BEGIN
# #
# # QSYS_SIMDIR is used in the Quartus-generated IP simulation script to
# # construct paths to the files required to simulate the IP in your Quartus
# # project. By default, the IP script assumes that you are launching the
# # simulator from the IP script location. If launching from another
# # location, set QSYS_SIMDIR to the output directory you specified when you
# # generated the IP script, relative to the directory from which you launch
# # the simulator.
# #
# set QSYS_SIMDIR <script generation output directory>
# #
# # Source the generated IP simulation script.
# source $QSYS_SIMDIR/aldec/rivierapro_setup.tcl
# #
# # Set any compilation options you require (this is unusual).
# set USER_DEFINED_COMPILE_OPTIONS <compilation options>
# set USER_DEFINED_VHDL_COMPILE_OPTIONS <compilation options for VHDL>
# set USER_DEFINED_VERILOG_COMPILE_OPTIONS <compilation options for Verilog>
# #
# # Call command to compile the Quartus EDA simulation library.
# dev_com
# #
# # Call command to compile the Quartus-generated IP simulation files.
# com
# #
# # Add commands to compile all design files and testbench files, including
# # the top level. (These are all the files required for simulation other
# # than the files compiled by the Quartus-generated IP simulation script)
# #
# vlog -sv2k5 <your compilation options> <design and testbench files>
# #
# # Set the top-level simulation or testbench module/entity name, which is
# # used by the elab command to elaborate the top level.
# #
# set TOP_LEVEL_NAME <simulation top>
# #
# # Set any elaboration options you require.
# set USER_DEFINED_ELAB_OPTIONS <elaboration options>
# #
# # Call command to elaborate your design and testbench.
# elab
# #
# # Run the simulation.
# run
# #
# # Report success to the shell.
# exit -code 0
# #
# # TOP-LEVEL TEMPLATE - END
# ----------------------------------------
# 
# IP SIMULATION SCRIPT
# ----------------------------------------

# ----------------------------------------
# Initialize variables
if ![info exists SYSTEM_INSTANCE_NAME] { 
  set SYSTEM_INSTANCE_NAME ""
} elseif { ![ string match "" $SYSTEM_INSTANCE_NAME ] } { 
  set SYSTEM_INSTANCE_NAME "/$SYSTEM_INSTANCE_NAME"
}

if ![info exists TOP_LEVEL_NAME] { 
  set TOP_LEVEL_NAME "ed_sim.ed_sim"
}

if ![info exists QSYS_SIMDIR] { 
  set QSYS_SIMDIR "./../"
}

if ![info exists QUARTUS_INSTALL_DIR] { 
  set QUARTUS_INSTALL_DIR "/acds_releases/acds/17.1/240/linux64/quartus/"
}

if ![info exists USER_DEFINED_COMPILE_OPTIONS] { 
  set USER_DEFINED_COMPILE_OPTIONS ""
}
if ![info exists USER_DEFINED_VHDL_COMPILE_OPTIONS] { 
  set USER_DEFINED_VHDL_COMPILE_OPTIONS ""
}
if ![info exists USER_DEFINED_VERILOG_COMPILE_OPTIONS] { 
  set USER_DEFINED_VERILOG_COMPILE_OPTIONS ""
}
if ![info exists USER_DEFINED_ELAB_OPTIONS] { 
  set USER_DEFINED_ELAB_OPTIONS ""
}

# ----------------------------------------
# Initialize simulation properties - DO NOT MODIFY!
set ELAB_OPTIONS ""
set SIM_OPTIONS ""
if ![ string match "*-64 vsim*" [ vsim -version ] ] {
} else {
}

set Aldec "Riviera"
if { [ string match "*Active-HDL*" [ vsim -version ] ] } {
  set Aldec "Active"
}

if { [ string match "Active" $Aldec ] } {
  scripterconf -tcl
  createdesign "$TOP_LEVEL_NAME"  "."
  opendesign "$TOP_LEVEL_NAME"
}

# ----------------------------------------
# Copy ROM/RAM files to simulation directory
alias file_copy {
  echo "\[exec\] file_copy"
  file copy -force $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_seq_params_sim.hex ./
  file copy -force $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_iossm_sim.hex ./
  file copy -force $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_seq_params_synth.hex ./
  file copy -force $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_iossm_synth.hex ./
}

# ----------------------------------------
# Create compilation libraries
proc ensure_lib { lib } { if ![file isdirectory $lib] { vlib $lib } }
ensure_lib      ./libraries     
ensure_lib      ./libraries/work
vmap       work ./libraries/work
ensure_lib                    ./libraries/altera_ver        
vmap       altera_ver         ./libraries/altera_ver        
ensure_lib                    ./libraries/lpm_ver           
vmap       lpm_ver            ./libraries/lpm_ver           
ensure_lib                    ./libraries/sgate_ver         
vmap       sgate_ver          ./libraries/sgate_ver         
ensure_lib                    ./libraries/altera_mf_ver     
vmap       altera_mf_ver      ./libraries/altera_mf_ver     
ensure_lib                    ./libraries/altera_lnsim_ver  
vmap       altera_lnsim_ver   ./libraries/altera_lnsim_ver  
ensure_lib                    ./libraries/fourteennm_ver    
vmap       fourteennm_ver     ./libraries/fourteennm_ver    
ensure_lib                    ./libraries/fourteennm_ct1_ver
vmap       fourteennm_ct1_ver ./libraries/fourteennm_ct1_ver
ensure_lib                                        ./libraries/altera_emif_mem_model_core_ddr3_171   
vmap       altera_emif_mem_model_core_ddr3_171    ./libraries/altera_emif_mem_model_core_ddr3_171   
ensure_lib                                        ./libraries/altera_emif_mem_model_171             
vmap       altera_emif_mem_model_171              ./libraries/altera_emif_mem_model_171             
ensure_lib                                        ./libraries/ed_sim_mem                            
vmap       ed_sim_mem                             ./libraries/ed_sim_mem                            
ensure_lib                                        ./libraries/altera_emif_local_reset_combiner_171  
vmap       altera_emif_local_reset_combiner_171   ./libraries/altera_emif_local_reset_combiner_171  
ensure_lib                                        ./libraries/ed_sim_local_reset_combiner           
vmap       ed_sim_local_reset_combiner            ./libraries/ed_sim_local_reset_combiner           
ensure_lib                                        ./libraries/altera_emif_sim_checker_171           
vmap       altera_emif_sim_checker_171            ./libraries/altera_emif_sim_checker_171           
ensure_lib                                        ./libraries/ed_sim_sim_checker                    
vmap       ed_sim_sim_checker                     ./libraries/ed_sim_sim_checker                    
ensure_lib                                        ./libraries/altera_emif_local_reset_sim_source_171
vmap       altera_emif_local_reset_sim_source_171 ./libraries/altera_emif_local_reset_sim_source_171
ensure_lib                                        ./libraries/ed_sim_local_reset_source             
vmap       ed_sim_local_reset_source              ./libraries/ed_sim_local_reset_source             
ensure_lib                                        ./libraries/altera_emif_arch_nd_171               
vmap       altera_emif_arch_nd_171                ./libraries/altera_emif_arch_nd_171               
ensure_lib                                        ./libraries/altera_emif_ecc_nd_171                
vmap       altera_emif_ecc_nd_171                 ./libraries/altera_emif_ecc_nd_171                
ensure_lib                                        ./libraries/altera_emif_ecc_171                   
vmap       altera_emif_ecc_171                    ./libraries/altera_emif_ecc_171                   
ensure_lib                                        ./libraries/altera_emif_s10_171                   
vmap       altera_emif_s10_171                    ./libraries/altera_emif_s10_171                   
ensure_lib                                        ./libraries/ed_sim_emif_s10_0                     
vmap       ed_sim_emif_s10_0                      ./libraries/ed_sim_emif_s10_0                     
ensure_lib                                        ./libraries/altera_emif_tg_avl_171                
vmap       altera_emif_tg_avl_171                 ./libraries/altera_emif_tg_avl_171                
ensure_lib                                        ./libraries/ed_sim_tg                             
vmap       ed_sim_tg                              ./libraries/ed_sim_tg                             
ensure_lib                                        ./libraries/altera_common_sv_packages             
vmap       altera_common_sv_packages              ./libraries/altera_common_sv_packages             
ensure_lib                                        ./libraries/altera_avalon_clock_source_171        
vmap       altera_avalon_clock_source_171         ./libraries/altera_avalon_clock_source_171        
ensure_lib                                        ./libraries/ed_sim_pll_ref_clk_source             
vmap       ed_sim_pll_ref_clk_source              ./libraries/ed_sim_pll_ref_clk_source             
ensure_lib                                        ./libraries/altera_merlin_master_translator_171   
vmap       altera_merlin_master_translator_171    ./libraries/altera_merlin_master_translator_171   
ensure_lib                                        ./libraries/altera_merlin_slave_translator_171    
vmap       altera_merlin_slave_translator_171     ./libraries/altera_merlin_slave_translator_171    
ensure_lib                                        ./libraries/altera_mm_interconnect_171            
vmap       altera_mm_interconnect_171             ./libraries/altera_mm_interconnect_171            
ensure_lib                                        ./libraries/altera_reset_controller_171           
vmap       altera_reset_controller_171            ./libraries/altera_reset_controller_171           
ensure_lib                                        ./libraries/ed_sim                                
vmap       ed_sim                                 ./libraries/ed_sim                                

# ----------------------------------------
# Compile device library files
alias dev_com {
  echo "\[exec\] dev_com"
  eval vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives.v"              -work altera_ver        
  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/220model.v"                       -work lpm_ver           
  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/sgate.v"                          -work sgate_ver         
  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf.v"                      -work altera_mf_ver     
  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_lnsim.sv"                  -work altera_lnsim_ver  
  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QUARTUS_INSTALL_DIR/eda/sim_lib/fourteennm_atoms.sv"              -work fourteennm_ver    
  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QUARTUS_INSTALL_DIR/eda/sim_lib/aldec/fourteennm_atoms_ncrypt.sv" -work fourteennm_ver    
  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QUARTUS_INSTALL_DIR/eda/sim_lib/ct1_hssi_atoms.sv"                -work fourteennm_ct1_ver
  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QUARTUS_INSTALL_DIR/eda/sim_lib/aldec/ct1_hssi_atoms_ncrypt.sv"   -work fourteennm_ct1_ver
  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QUARTUS_INSTALL_DIR/eda/sim_lib/ct1_hip_atoms.sv"                 -work fourteennm_ct1_ver
  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QUARTUS_INSTALL_DIR/eda/sim_lib/aldec/ct1_hip_atoms_ncrypt.sv"    -work fourteennm_ct1_ver
}

# ----------------------------------------
# Compile the design files in correct order
alias com {
  echo "\[exec\] com"
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model.sv"                                                            -work altera_emif_mem_model_core_ddr3_171   
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_per_ping_pong.sv"                                              -work altera_emif_mem_model_core_ddr3_171   
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_per_device.sv"                                                 -work altera_emif_mem_model_core_ddr3_171   
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_rank.sv"                                                       -work altera_emif_mem_model_core_ddr3_171   
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddr3_model_rdimm_chip.sv"                                                 -work altera_emif_mem_model_core_ddr3_171   
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddr3_model_lrdimm_chip.sv"                                                -work altera_emif_mem_model_core_ddr3_171   
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_bidir_delay.sv"                                                -work altera_emif_mem_model_core_ddr3_171   
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_171/sim/ed_sim_mem_altera_emif_mem_model_171_orc2ayi.v"                                                 -work altera_emif_mem_model_171             
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/sim/ed_sim_mem.v"                                                                                                             -work ed_sim_mem                            
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_combiner/altera_emif_local_reset_combiner_171/sim/altera_emif_local_reset_combiner.sv"                                -work altera_emif_local_reset_combiner_171  
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_combiner/altera_emif_local_reset_combiner_171/sim/altera_std_synchronizer_nocut.v"                                    -work altera_emif_local_reset_combiner_171  
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_combiner/sim/ed_sim_local_reset_combiner.v"                                                                           -work ed_sim_local_reset_combiner           
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_sim_checker/altera_emif_sim_checker_171/sim/altera_emif_sim_checker.sv"                                                           -work altera_emif_sim_checker_171           
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_sim_checker/sim/ed_sim_sim_checker.v"                                                                                             -work ed_sim_sim_checker                    
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_source/altera_emif_local_reset_sim_source_171/sim/altera_emif_local_reset_sim_source.sv"                              -work altera_emif_local_reset_sim_source_171
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_source/sim/ed_sim_local_reset_source.v"                                                                               -work ed_sim_local_reset_source             
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_top.sv"                                  -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_io_ssm.sv"                               -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_bufs.sv"                                                               -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_se_i.sv"                                                      -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_se_o.sv"                                                      -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_df_i.sv"                                                      -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_df_o.sv"                                                      -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_cp_i.sv"                                                      -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_bdir_df.sv"                                                        -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_bdir_se.sv"                                                        -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_unused.sv"                                                         -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_cal_counter.sv"                                                        -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_pll.sv"                                                                -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_pll_fast_sim.sv"                                                       -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_pll_extra_clks.sv"                                                     -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_oct.sv"                                                                -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_core_clks_rsts.sv"                                                     -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hps_clks_rsts.sv"                                                      -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_local_reset.sv"                                                        -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_tiles_wrap.sv"                                                      -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_tiles.sv"                                                           -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_tiles_abphy.sv"                                                     -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_abphy_mux.sv"                                                          -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_lane_remap.sv"                                                      -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_lane_remap_abphy.sv"                                                -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_avl_if.sv"                                                         -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_sideband_if.sv"                                                    -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_mmr_if.sv"                                                         -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_amm_data_if.sv"                                                    -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_ast_data_if.sv"                                                    -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_afi_if.sv"                                                             -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_seq_if.sv"                                                             -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_regs.sv"                                                               -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_oct.sv"                                                                             -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_oct_um_fsm.sv"                                                                      -work altera_emif_arch_nd_171               
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_std_synchronizer_nocut.v"                                                           -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/mem_array_abphy.sv"                                                                        -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/fourteennm_io_12_lane_abphy.sv"                                                            -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/fourteennm_io_12_lane_encrypted_abphy.sv"                                                  -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/fourteennm_io_12_lane_mdev40_encrypted_abphy.sv"                                           -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/io_12_lane__mdev40_abphy.sv"                                                               -work altera_emif_arch_nd_171               
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa.sv"                                      -work altera_emif_arch_nd_171               
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_ecc_core.v"                                                                     -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc.v"                                                                   -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_amm2ast.v"                                                           -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_cb.v"                                                                -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder.v"                                                           -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_64.v"                                                        -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_64_altecc_decoder.v"                                         -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_64_decode.v"                                                 -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_112.v"                                                       -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder.v"                                                           -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder_64.v"                                                        -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder_64_altecc_encoder.v"                                         -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_interface_fifo.v"                                                    -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder_112.v"                                                       -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_mmr.v"                                                               -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_pcm_112.v"                                                           -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_sv_112.v"                                                            -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_wrapper.v"                                                           -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_fifo.v"                                                                  -work altera_emif_ecc_nd_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_171/sim/ed_sim_emif_s10_0_altera_emif_ecc_171_7kpo3iy.v"                                               -work altera_emif_ecc_171                   
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_s10_171/sim/ed_sim_emif_s10_0_altera_emif_s10_171_6ekej7a.v"                                               -work altera_emif_s10_171                   
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/sim/ed_sim_emif_s10_0.v"                                                                                               -work ed_sim_emif_s10_0                     
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_defs.sv"                                                                         -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_top.sv"                                                                          -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_addr_gen.sv"                                                                     -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_avl_mm_if.sv"                                                                    -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_avl_mm_srw_if.sv"                                                                -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_block_rw_stage.sv"                                                               -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_burst_boundary_addr_gen.sv"                                                      -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_byteenable_stage.sv"                                                             -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_driver_simple.sv"                                                                -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_driver.sv"                                                                       -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_driver_fsm.sv"                                                                   -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_lfsr.sv"                                                                         -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_lfsr_wrapper.sv"                                                                 -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_addr_gen.sv"                                                                -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_burstcount_gen.sv"                                                          -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_num_gen.sv"                                                                 -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_seq_addr_gen.sv"                                                            -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_read_compare.sv"                                                                 -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_scfifo_wrapper.sv"                                                               -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_seq_addr_gen.sv"                                                                 -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_single_rw_stage.sv"                                                              -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_template_addr_gen.sv"                                                            -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_template_stage.sv"                                                               -work altera_emif_tg_avl_171                
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_amm_1x_bridge.sv"                                                                -work altera_emif_tg_avl_171                
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/sim/ed_sim_tg.v"                                                                                                               -work ed_sim_tg                             
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_pll_ref_clk_source/altera_avalon_clock_source_171/sim/verbosity_pkg.sv"                                                           -work altera_common_sv_packages             
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_pll_ref_clk_source/altera_avalon_clock_source_171/sim/altera_avalon_clock_source.sv"                 -l altera_common_sv_packages -work altera_avalon_clock_source_171        
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_pll_ref_clk_source/sim/ed_sim_pll_ref_clk_source.v"                                                                               -work ed_sim_pll_ref_clk_source             
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/altera_merlin_master_translator_171/sim/altera_merlin_master_translator.sv"                                                                           -work altera_merlin_master_translator_171   
  eval  vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS      "$QSYS_SIMDIR/altera_merlin_slave_translator_171/sim/altera_merlin_slave_translator.sv"                                                                             -work altera_merlin_slave_translator_171    
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/altera_mm_interconnect_171/sim/ed_sim_altera_mm_interconnect_171_wsqnxaa.v"                                                                           -work altera_mm_interconnect_171            
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/altera_reset_controller_171/sim/altera_reset_controller.v"                                                                                            -work altera_reset_controller_171           
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/altera_reset_controller_171/sim/altera_reset_synchronizer.v"                                                                                          -work altera_reset_controller_171           
  eval  vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/sim/ed_sim.v"                                                                                                                                         -work ed_sim                                
}

# ----------------------------------------
# Elaborate top level design
alias elab {
  echo "\[exec\] elab"
  eval vsim +access +r -t ps $ELAB_OPTIONS $USER_DEFINED_ELAB_OPTIONS -L work -L altera_emif_mem_model_core_ddr3_171 -L altera_emif_mem_model_171 -L ed_sim_mem -L altera_emif_local_reset_combiner_171 -L ed_sim_local_reset_combiner -L altera_emif_sim_checker_171 -L ed_sim_sim_checker -L altera_emif_local_reset_sim_source_171 -L ed_sim_local_reset_source -L altera_emif_arch_nd_171 -L altera_emif_ecc_nd_171 -L altera_emif_ecc_171 -L altera_emif_s10_171 -L ed_sim_emif_s10_0 -L altera_emif_tg_avl_171 -L ed_sim_tg -L altera_common_sv_packages -L altera_avalon_clock_source_171 -L ed_sim_pll_ref_clk_source -L altera_merlin_master_translator_171 -L altera_merlin_slave_translator_171 -L altera_mm_interconnect_171 -L altera_reset_controller_171 -L ed_sim -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L fourteennm_ver -L fourteennm_ct1_ver $TOP_LEVEL_NAME
}

# ----------------------------------------
# Elaborate the top level design with -dbg -O2 option
alias elab_debug {
  echo "\[exec\] elab_debug"
  eval vsim -dbg -O2 +access +r -t ps $ELAB_OPTIONS $USER_DEFINED_ELAB_OPTIONS -L work -L altera_emif_mem_model_core_ddr3_171 -L altera_emif_mem_model_171 -L ed_sim_mem -L altera_emif_local_reset_combiner_171 -L ed_sim_local_reset_combiner -L altera_emif_sim_checker_171 -L ed_sim_sim_checker -L altera_emif_local_reset_sim_source_171 -L ed_sim_local_reset_source -L altera_emif_arch_nd_171 -L altera_emif_ecc_nd_171 -L altera_emif_ecc_171 -L altera_emif_s10_171 -L ed_sim_emif_s10_0 -L altera_emif_tg_avl_171 -L ed_sim_tg -L altera_common_sv_packages -L altera_avalon_clock_source_171 -L ed_sim_pll_ref_clk_source -L altera_merlin_master_translator_171 -L altera_merlin_slave_translator_171 -L altera_mm_interconnect_171 -L altera_reset_controller_171 -L ed_sim -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L fourteennm_ver -L fourteennm_ct1_ver $TOP_LEVEL_NAME
}

# ----------------------------------------
# Compile all the design files and elaborate the top level design
alias ld "
  dev_com
  com
  elab
"

# ----------------------------------------
# Compile all the design files and elaborate the top level design with -dbg -O2
alias ld_debug "
  dev_com
  com
  elab_debug
"

# ----------------------------------------
# Print out user commmand line aliases
alias h {
  echo "List Of Command Line Aliases"
  echo
  echo "file_copy                                         -- Copy ROM/RAM files to simulation directory"
  echo
  echo "dev_com                                           -- Compile device library files"
  echo
  echo "com                                               -- Compile the design files in correct order"
  echo
  echo "elab                                              -- Elaborate top level design"
  echo
  echo "elab_debug                                        -- Elaborate the top level design with -dbg -O2 option"
  echo
  echo "ld                                                -- Compile all the design files and elaborate the top level design"
  echo
  echo "ld_debug                                          -- Compile all the design files and elaborate the top level design with -dbg -O2"
  echo
  echo 
  echo
  echo "List Of Variables"
  echo
  echo "TOP_LEVEL_NAME                                    -- Top level module name."
  echo "                                                     For most designs, this should be overridden"
  echo "                                                     to enable the elab/elab_debug aliases."
  echo
  echo "SYSTEM_INSTANCE_NAME                              -- Instantiated system module name inside top level module."
  echo
  echo "QSYS_SIMDIR                                       -- Qsys base simulation directory."
  echo
  echo "QUARTUS_INSTALL_DIR                               -- Quartus installation directory."
  echo
  echo "USER_DEFINED_COMPILE_OPTIONS                      -- User-defined compile options, added to com/dev_com aliases."
  echo
  echo "USER_DEFINED_VHDL_COMPILE_OPTIONS                 -- User-defined vhdl compile options, added to com/dev_com aliases."
  echo
  echo "USER_DEFINED_VERILOG_COMPILE_OPTIONS              -- User-defined verilog compile options, added to com/dev_com aliases."
  echo
  echo "USER_DEFINED_ELAB_OPTIONS                         -- User-defined elaboration options, added to elab/elab_debug aliases."
}
file_copy
h
