
# (C) 2001-2017 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Intel 
# Program License Subscription Agreement, Intel MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Intel and sold by Intel 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ACDS 17.1 240 linux 2017.11.07.10:42:35

# ----------------------------------------
# vcs - auto-generated simulation script

# ----------------------------------------
# This script provides commands to simulate the following IP detected in
# your Quartus project:
#     ed_sim_mem.ed_sim_mem
#     ed_sim_local_reset_combiner.ed_sim_local_reset_combiner
#     ed_sim_sim_checker.ed_sim_sim_checker
#     ed_sim_local_reset_source.ed_sim_local_reset_source
#     ed_sim_emif_s10_0.ed_sim_emif_s10_0
#     ed_sim_tg.ed_sim_tg
#     ed_sim_pll_ref_clk_source.ed_sim_pll_ref_clk_source
#     ed_sim.ed_sim
# 
# Intel recommends that you source this Quartus-generated IP simulation
# script from your own customized top-level script, and avoid editing this
# generated script.
# 
# To write a top-level shell script that compiles Intel simulation libraries
# and the Quartus-generated IP in your project, along with your design and
# testbench files, follow the guidelines below.
# 
# 1) Copy the shell script text from the TOP-LEVEL TEMPLATE section
# below into a new file, e.g. named "vcs_sim.sh".
# 
# 2) Copy the text from the DESIGN FILE LIST & OPTIONS TEMPLATE section into
# a separate file, e.g. named "filelist.f".
# 
# ----------------------------------------
# # TOP-LEVEL TEMPLATE - BEGIN
# #
# # TOP_LEVEL_NAME is used in the Quartus-generated IP simulation script to
# # set the top-level simulation or testbench module/entity name.
# #
# # QSYS_SIMDIR is used in the Quartus-generated IP simulation script to
# # construct paths to the files required to simulate the IP in your Quartus
# # project. By default, the IP script assumes that you are launching the
# # simulator from the IP script location. If launching from another
# # location, set QSYS_SIMDIR to the output directory you specified when you
# # generated the IP script, relative to the directory from which you launch
# # the simulator.
# #
# # Source the Quartus-generated IP simulation script and do the following:
# # - Compile the Quartus EDA simulation library and IP simulation files.
# # - Specify TOP_LEVEL_NAME and QSYS_SIMDIR.
# # - Compile the design and top-level simulation module/entity using
# #   information specified in "filelist.f".
# # - Override the default USER_DEFINED_SIM_OPTIONS. For example, to run
# #   until $finish(), set to an empty string: USER_DEFINED_SIM_OPTIONS="".
# # - Run the simulation.
# #
# source <script generation output directory>/synopsys/vcs/vcs_setup.sh \
TOP_LEVEL_NAME="ed_sim"
# QSYS_SIMDIR=<script generation output directory> \
# USER_DEFINED_ELAB_OPTIONS="\"-f filelist.f\"" \
# USER_DEFINED_SIM_OPTIONS=<simulation options for your design>
# #
# # TOP-LEVEL TEMPLATE - END
# ----------------------------------------
# 
# ----------------------------------------
# # DESIGN FILE LIST & OPTIONS TEMPLATE - BEGIN
# #
# # Compile all design files and testbench files, including the top level.
# # (These are all the files required for simulation other than the files
# # compiled by the Quartus-generated IP simulation script)
# #
# +systemverilogext+.sv
# <design and testbench files, compile-time options, elaboration options>
# #
# # DESIGN FILE LIST & OPTIONS TEMPLATE - END
# ----------------------------------------
# 
# IP SIMULATION SCRIPT
# ----------------------------------------
# ACDS 17.1 240 linux 2017.11.07.10:42:35
# ----------------------------------------
# initialize variables
TOP_LEVEL_NAME="ed_sim"
QSYS_SIMDIR="./../../"
QUARTUS_INSTALL_DIR="/acds_releases/acds/17.1/240/linux64/quartus/"
SKIP_FILE_COPY=0
SKIP_SIM=0
USER_DEFINED_ELAB_OPTIONS=""
USER_DEFINED_SIM_OPTIONS=""
# ----------------------------------------
# overwrite variables - DO NOT MODIFY!
# This block evaluates each command line argument, typically used for 
# overwriting variables. An example usage:
#   sh <simulator>_setup.sh SKIP_SIM=1
for expression in "$@"; do
  eval $expression
  if [ $? -ne 0 ]; then
    echo "Error: This command line argument, \"$expression\", is/has an invalid expression." >&2
    exit $?
  fi
done

# ----------------------------------------
# initialize simulation properties - DO NOT MODIFY!
ELAB_OPTIONS=""
SIM_OPTIONS=""
if [[ `vcs -platform` != *"amd64"* ]]; then
  :
else
  :
fi

# ----------------------------------------
# copy RAM/ROM files to simulation directory
if [ $SKIP_FILE_COPY -eq 0 ]; then
  cp -f $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_seq_params_sim.hex ./
  cp -f $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_iossm_sim.hex ./
  cp -f $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_seq_params_synth.hex ./
  cp -f $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_iossm_synth.hex ./
fi

vcs -lca -timescale=1ps/1ps -sverilog +verilog2001ext+.v $ELAB_OPTIONS $USER_DEFINED_ELAB_OPTIONS \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives.v \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/220model.v \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/sgate.v \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf.v \
  $QUARTUS_INSTALL_DIR/eda/sim_lib/altera_lnsim.sv \
  $QUARTUS_INSTALL_DIR/eda/sim_lib/fourteennm_atoms.sv \
  $QUARTUS_INSTALL_DIR/eda/sim_lib/synopsys/fourteennm_atoms_ncrypt.sv \
  $QUARTUS_INSTALL_DIR/eda/sim_lib/ct1_hssi_atoms.sv \
  $QUARTUS_INSTALL_DIR/eda/sim_lib/synopsys/ct1_hssi_atoms_ncrypt.sv \
  $QUARTUS_INSTALL_DIR/eda/sim_lib/ct1_hip_atoms.sv \
  $QUARTUS_INSTALL_DIR/eda/sim_lib/synopsys/ct1_hip_atoms_ncrypt.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_per_ping_pong.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_per_device.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_rank.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddr3_model_rdimm_chip.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddr3_model_lrdimm_chip.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_bidir_delay.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_171/sim/ed_sim_mem_altera_emif_mem_model_171_orc2ayi.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/sim/ed_sim_mem.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_combiner/altera_emif_local_reset_combiner_171/sim/altera_emif_local_reset_combiner.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_combiner/altera_emif_local_reset_combiner_171/sim/altera_std_synchronizer_nocut.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_combiner/sim/ed_sim_local_reset_combiner.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_sim_checker/altera_emif_sim_checker_171/sim/altera_emif_sim_checker.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_sim_checker/sim/ed_sim_sim_checker.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_source/altera_emif_local_reset_sim_source_171/sim/altera_emif_local_reset_sim_source.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_source/sim/ed_sim_local_reset_source.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_top.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_io_ssm.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_bufs.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_se_i.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_se_o.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_df_i.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_df_o.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_cp_i.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_bdir_df.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_bdir_se.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_unused.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_cal_counter.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_pll.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_pll_fast_sim.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_pll_extra_clks.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_oct.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_core_clks_rsts.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hps_clks_rsts.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_local_reset.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_tiles_wrap.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_tiles.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_tiles_abphy.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_abphy_mux.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_lane_remap.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_lane_remap_abphy.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_avl_if.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_sideband_if.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_mmr_if.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_amm_data_if.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_ast_data_if.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_afi_if.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_seq_if.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_regs.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_oct.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_oct_um_fsm.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/mem_array_abphy.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/fourteennm_io_12_lane_abphy.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/fourteennm_io_12_lane_encrypted_abphy.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/fourteennm_io_12_lane_mdev40_encrypted_abphy.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/io_12_lane__mdev40_abphy.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_ecc_core.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_amm2ast.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_cb.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_64.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_64_altecc_decoder.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_64_decode.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_112.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder_64.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder_64_altecc_encoder.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_interface_fifo.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder_112.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_mmr.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_pcm_112.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_sv_112.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_wrapper.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_fifo.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_171/sim/ed_sim_emif_s10_0_altera_emif_ecc_171_7kpo3iy.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_s10_171/sim/ed_sim_emif_s10_0_altera_emif_s10_171_6ekej7a.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/sim/ed_sim_emif_s10_0.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_defs.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_top.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_addr_gen.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_avl_mm_if.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_avl_mm_srw_if.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_block_rw_stage.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_burst_boundary_addr_gen.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_byteenable_stage.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_driver_simple.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_driver.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_driver_fsm.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_lfsr.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_lfsr_wrapper.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_addr_gen.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_burstcount_gen.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_num_gen.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_seq_addr_gen.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_read_compare.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_scfifo_wrapper.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_seq_addr_gen.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_single_rw_stage.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_template_addr_gen.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_template_stage.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_amm_1x_bridge.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/sim/ed_sim_tg.v \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_pll_ref_clk_source/altera_avalon_clock_source_171/sim/verbosity_pkg.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_pll_ref_clk_source/altera_avalon_clock_source_171/sim/altera_avalon_clock_source.sv \
  $QSYS_SIMDIR/../ip/ed_sim/ed_sim_pll_ref_clk_source/sim/ed_sim_pll_ref_clk_source.v \
  $QSYS_SIMDIR/altera_merlin_master_translator_171/sim/altera_merlin_master_translator.sv \
  $QSYS_SIMDIR/altera_merlin_slave_translator_171/sim/altera_merlin_slave_translator.sv \
  $QSYS_SIMDIR/altera_mm_interconnect_171/sim/ed_sim_altera_mm_interconnect_171_wsqnxaa.v \
  $QSYS_SIMDIR/altera_reset_controller_171/sim/altera_reset_controller.v \
  $QSYS_SIMDIR/altera_reset_controller_171/sim/altera_reset_synchronizer.v \
  $QSYS_SIMDIR/sim/ed_sim.v \
  -top $TOP_LEVEL_NAME
# ----------------------------------------
# simulate
if [ $SKIP_SIM -eq 0 ]; then
  ./simv $SIM_OPTIONS $USER_DEFINED_SIM_OPTIONS
fi

