
# (C) 2001-2017 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Intel 
# Program License Subscription Agreement, Intel MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Intel and sold by Intel 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ACDS 17.1 240 linux 2017.11.07.10:42:35

# ----------------------------------------
# vcsmx - auto-generated simulation script

# ----------------------------------------
# This script provides commands to simulate the following IP detected in
# your Quartus project:
#     ed_sim_mem.ed_sim_mem
#     ed_sim_local_reset_combiner.ed_sim_local_reset_combiner
#     ed_sim_sim_checker.ed_sim_sim_checker
#     ed_sim_local_reset_source.ed_sim_local_reset_source
#     ed_sim_emif_s10_0.ed_sim_emif_s10_0
#     ed_sim_tg.ed_sim_tg
#     ed_sim_pll_ref_clk_source.ed_sim_pll_ref_clk_source
#     ed_sim.ed_sim
# 
# Intel recommends that you source this Quartus-generated IP simulation
# script from your own customized top-level script, and avoid editing this
# generated script.
# 
# To write a top-level shell script that compiles Intel simulation libraries 
# and the Quartus-generated IP in your project, along with your design and
# testbench files, copy the text from the TOP-LEVEL TEMPLATE section below
# into a new file, e.g. named "vcsmx_sim.sh", and modify text as directed.
# 
# You can also modify the simulation flow to suit your needs. Set the
# following variables to 1 to disable their corresponding processes:
# - SKIP_FILE_COPY: skip copying ROM/RAM initialization files
# - SKIP_DEV_COM: skip compiling the Quartus EDA simulation library
# - SKIP_COM: skip compiling Quartus-generated IP simulation files
# - SKIP_ELAB and SKIP_SIM: skip elaboration and simulation
# 
# ----------------------------------------
# # TOP-LEVEL TEMPLATE - BEGIN
# #
# # QSYS_SIMDIR is used in the Quartus-generated IP simulation script to
# # construct paths to the files required to simulate the IP in your Quartus
# # project. By default, the IP script assumes that you are launching the
# # simulator from the IP script location. If launching from another
# # location, set QSYS_SIMDIR to the output directory you specified when you
# # generated the IP script, relative to the directory from which you launch
# # the simulator. In this case, you must also copy the generated library
# # setup "synopsys_sim.setup" into the location from which you launch the
# # simulator, or incorporate into any existing library setup.
# #
# # Run Quartus-generated IP simulation script once to compile Quartus EDA
# # simulation libraries and Quartus-generated IP simulation files, and copy
# # any ROM/RAM initialization files to the simulation directory.
# #
# # - If necessary, specify any compilation options:
# #   USER_DEFINED_COMPILE_OPTIONS
# #   USER_DEFINED_VHDL_COMPILE_OPTIONS applied to vhdl compiler
# #   USER_DEFINED_VERILOG_COMPILE_OPTIONS applied to verilog compiler
# #
# source <script generation output directory>/synopsys/vcsmx/vcsmx_setup.sh \
# SKIP_ELAB=1 \
# SKIP_SIM=1 \
# USER_DEFINED_COMPILE_OPTIONS=<compilation options for your design> \
# USER_DEFINED_VHDL_COMPILE_OPTIONS=<VHDL compilation options for your design> \
# USER_DEFINED_VERILOG_COMPILE_OPTIONS=<Verilog compilation options for your design> \
# QSYS_SIMDIR=<script generation output directory>
# #
# # Compile all design files and testbench files, including the top level.
# # (These are all the files required for simulation other than the files
# # compiled by the IP script)
# #
# vlogan <compilation options> <design and testbench files>
# #
# # TOP_LEVEL_NAME is used in this script to set the top-level simulation or
# # testbench module/entity name.
# #
# # Run the IP script again to elaborate and simulate the top level:
# # - Specify TOP_LEVEL_NAME and USER_DEFINED_ELAB_OPTIONS.
# # - Override the default USER_DEFINED_SIM_OPTIONS. For example, to run
# #   until $finish(), set to an empty string: USER_DEFINED_SIM_OPTIONS="".
# #
# source <script generation output directory>/synopsys/vcsmx/vcsmx_setup.sh \
# SKIP_FILE_COPY=1 \
# SKIP_DEV_COM=1 \
# SKIP_COM=1 \
# TOP_LEVEL_NAME="'-top <simulation top>'" \
# QSYS_SIMDIR=<script generation output directory> \
# USER_DEFINED_ELAB_OPTIONS=<elaboration options for your design> \
# USER_DEFINED_SIM_OPTIONS=<simulation options for your design>
# #
# # TOP-LEVEL TEMPLATE - END
# ----------------------------------------
# 
# IP SIMULATION SCRIPT
# ----------------------------------------
# ACDS 17.1 240 linux 2017.11.07.10:42:35
# ----------------------------------------
# initialize variables
TOP_LEVEL_NAME="ed_sim.ed_sim"
QSYS_SIMDIR="./../../"
QUARTUS_INSTALL_DIR="/acds_releases/acds/17.1/240/linux64/quartus/"
SKIP_FILE_COPY=0
SKIP_DEV_COM=0
SKIP_COM=0
SKIP_ELAB=0
SKIP_SIM=0
USER_DEFINED_ELAB_OPTIONS=""
USER_DEFINED_SIM_OPTIONS=""

# ----------------------------------------
# overwrite variables - DO NOT MODIFY!
# This block evaluates each command line argument, typically used for 
# overwriting variables. An example usage:
#   sh <simulator>_setup.sh SKIP_SIM=1
for expression in "$@"; do
  eval $expression
  if [ $? -ne 0 ]; then
    echo "Error: This command line argument, \"$expression\", is/has an invalid expression." >&2
    exit $?
  fi
done

# ----------------------------------------
# initialize simulation properties - DO NOT MODIFY!
ELAB_OPTIONS=""
SIM_OPTIONS=""
if [[ `vcs -platform` != *"amd64"* ]]; then
  :
else
  :
fi

# ----------------------------------------
# create compilation libraries
mkdir -p ./libraries/work/
mkdir -p ./libraries/altera_emif_mem_model_core_ddr3_171/
mkdir -p ./libraries/altera_emif_mem_model_171/
mkdir -p ./libraries/ed_sim_mem/
mkdir -p ./libraries/altera_emif_local_reset_combiner_171/
mkdir -p ./libraries/ed_sim_local_reset_combiner/
mkdir -p ./libraries/altera_emif_sim_checker_171/
mkdir -p ./libraries/ed_sim_sim_checker/
mkdir -p ./libraries/altera_emif_local_reset_sim_source_171/
mkdir -p ./libraries/ed_sim_local_reset_source/
mkdir -p ./libraries/altera_emif_arch_nd_171/
mkdir -p ./libraries/altera_emif_ecc_nd_171/
mkdir -p ./libraries/altera_emif_ecc_171/
mkdir -p ./libraries/altera_emif_s10_171/
mkdir -p ./libraries/ed_sim_emif_s10_0/
mkdir -p ./libraries/altera_emif_tg_avl_171/
mkdir -p ./libraries/ed_sim_tg/
mkdir -p ./libraries/altera_common_sv_packages/
mkdir -p ./libraries/altera_avalon_clock_source_171/
mkdir -p ./libraries/ed_sim_pll_ref_clk_source/
mkdir -p ./libraries/altera_merlin_master_translator_171/
mkdir -p ./libraries/altera_merlin_slave_translator_171/
mkdir -p ./libraries/altera_mm_interconnect_171/
mkdir -p ./libraries/altera_reset_controller_171/
mkdir -p ./libraries/ed_sim/
mkdir -p ./libraries/altera_ver/
mkdir -p ./libraries/lpm_ver/
mkdir -p ./libraries/sgate_ver/
mkdir -p ./libraries/altera_mf_ver/
mkdir -p ./libraries/altera_lnsim_ver/
mkdir -p ./libraries/fourteennm_ver/
mkdir -p ./libraries/fourteennm_ct1_ver/

# ----------------------------------------
# copy RAM/ROM files to simulation directory
if [ $SKIP_FILE_COPY -eq 0 ]; then
  cp -f $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_seq_params_sim.hex ./
  cp -f $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_iossm_sim.hex ./
  cp -f $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_seq_params_synth.hex ./
  cp -f $QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_iossm_synth.hex ./
fi

# ----------------------------------------
# compile device library files
if [ $SKIP_DEV_COM -eq 0 ]; then
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives.v"                 -work altera_ver        
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QUARTUS_INSTALL_DIR/eda/sim_lib/220model.v"                          -work lpm_ver           
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QUARTUS_INSTALL_DIR/eda/sim_lib/sgate.v"                             -work sgate_ver         
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf.v"                         -work altera_mf_ver     
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_lnsim.sv"                     -work altera_lnsim_ver  
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/fourteennm_atoms.sv"                 -work fourteennm_ver    
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/synopsys/fourteennm_atoms_ncrypt.sv" -work fourteennm_ver    
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/ct1_hssi_atoms.sv"                   -work fourteennm_ct1_ver
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/synopsys/ct1_hssi_atoms_ncrypt.sv"   -work fourteennm_ct1_ver
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/ct1_hip_atoms.sv"                    -work fourteennm_ct1_ver
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/synopsys/ct1_hip_atoms_ncrypt.sv"    -work fourteennm_ct1_ver
fi

# ----------------------------------------
# compile design files in correct order
if [ $SKIP_COM -eq 0 ]; then
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model.sv"                               -work altera_emif_mem_model_core_ddr3_171   
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_per_ping_pong.sv"                 -work altera_emif_mem_model_core_ddr3_171   
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_per_device.sv"                    -work altera_emif_mem_model_core_ddr3_171   
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_rank.sv"                          -work altera_emif_mem_model_core_ddr3_171   
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddr3_model_rdimm_chip.sv"                    -work altera_emif_mem_model_core_ddr3_171   
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddr3_model_lrdimm_chip.sv"                   -work altera_emif_mem_model_core_ddr3_171   
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_core_ddr3_171/sim/altera_emif_ddrx_model_bidir_delay.sv"                   -work altera_emif_mem_model_core_ddr3_171   
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/altera_emif_mem_model_171/sim/ed_sim_mem_altera_emif_mem_model_171_orc2ayi.v"                    -work altera_emif_mem_model_171             
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_mem/sim/ed_sim_mem.v"                                                                                -work ed_sim_mem                            
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_combiner/altera_emif_local_reset_combiner_171/sim/altera_emif_local_reset_combiner.sv"   -work altera_emif_local_reset_combiner_171  
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_combiner/altera_emif_local_reset_combiner_171/sim/altera_std_synchronizer_nocut.v"       -work altera_emif_local_reset_combiner_171  
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_combiner/sim/ed_sim_local_reset_combiner.v"                                              -work ed_sim_local_reset_combiner           
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_sim_checker/altera_emif_sim_checker_171/sim/altera_emif_sim_checker.sv"                              -work altera_emif_sim_checker_171           
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_sim_checker/sim/ed_sim_sim_checker.v"                                                                -work ed_sim_sim_checker                    
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_source/altera_emif_local_reset_sim_source_171/sim/altera_emif_local_reset_sim_source.sv" -work altera_emif_local_reset_sim_source_171
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_local_reset_source/sim/ed_sim_local_reset_source.v"                                                  -work ed_sim_local_reset_source             
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_top.sv"     -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa_io_ssm.sv"  -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_bufs.sv"                                  -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_se_i.sv"                         -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_se_o.sv"                         -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_df_i.sv"                         -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_df_o.sv"                         -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_udir_cp_i.sv"                         -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_bdir_df.sv"                           -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_bdir_se.sv"                           -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_buf_unused.sv"                            -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_cal_counter.sv"                           -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_pll.sv"                                   -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_pll_fast_sim.sv"                          -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_pll_extra_clks.sv"                        -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_oct.sv"                                   -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_core_clks_rsts.sv"                        -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hps_clks_rsts.sv"                         -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_local_reset.sv"                           -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_tiles_wrap.sv"                         -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_tiles.sv"                              -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_tiles_abphy.sv"                        -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_abphy_mux.sv"                             -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_lane_remap.sv"                         -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_io_lane_remap_abphy.sv"                   -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_avl_if.sv"                            -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_sideband_if.sv"                       -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_mmr_if.sv"                            -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_amm_data_if.sv"                       -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_hmc_ast_data_if.sv"                       -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_afi_if.sv"                                -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_seq_if.sv"                                -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_emif_arch_nd_regs.sv"                                  -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_oct.sv"                                                -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_oct_um_fsm.sv"                                         -work altera_emif_arch_nd_171               
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/altera_std_synchronizer_nocut.v"                              -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/mem_array_abphy.sv"                                           -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/fourteennm_io_12_lane_abphy.sv"                               -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/fourteennm_io_12_lane_encrypted_abphy.sv"                     -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/fourteennm_io_12_lane_mdev40_encrypted_abphy.sv"              -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/io_12_lane__mdev40_abphy.sv"                                  -work altera_emif_arch_nd_171               
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_arch_nd_171/sim/ed_sim_emif_s10_0_altera_emif_arch_nd_171_as2gzoa.sv"         -work altera_emif_arch_nd_171               
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_ecc_core.v"                                        -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc.v"                                      -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_amm2ast.v"                              -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_cb.v"                                   -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder.v"                              -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_64.v"                           -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_64_altecc_decoder.v"            -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_64_decode.v"                    -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_decoder_112.v"                          -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder.v"                              -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder_64.v"                           -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder_64_altecc_encoder.v"            -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_interface_fifo.v"                       -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_encoder_112.v"                          -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_mmr.v"                                  -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_pcm_112.v"                              -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_sv_112.v"                               -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_ecc_wrapper.v"                              -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_nd_171/sim/altera_emif_io_hmc_fifo.v"                                     -work altera_emif_ecc_nd_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_ecc_171/sim/ed_sim_emif_s10_0_altera_emif_ecc_171_7kpo3iy.v"                  -work altera_emif_ecc_171                   
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/altera_emif_s10_171/sim/ed_sim_emif_s10_0_altera_emif_s10_171_6ekej7a.v"                  -work altera_emif_s10_171                   
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_emif_s10_0/sim/ed_sim_emif_s10_0.v"                                                                  -work ed_sim_emif_s10_0                     
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_defs.sv"                                            -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_top.sv"                                             -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_addr_gen.sv"                                        -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_avl_mm_if.sv"                                       -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_avl_mm_srw_if.sv"                                   -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_block_rw_stage.sv"                                  -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_burst_boundary_addr_gen.sv"                         -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_byteenable_stage.sv"                                -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_driver_simple.sv"                                   -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_driver.sv"                                          -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_driver_fsm.sv"                                      -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_lfsr.sv"                                            -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_lfsr_wrapper.sv"                                    -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_addr_gen.sv"                                   -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_burstcount_gen.sv"                             -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_num_gen.sv"                                    -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_rand_seq_addr_gen.sv"                               -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_read_compare.sv"                                    -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_scfifo_wrapper.sv"                                  -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_seq_addr_gen.sv"                                    -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_single_rw_stage.sv"                                 -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_template_addr_gen.sv"                               -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_template_stage.sv"                                  -work altera_emif_tg_avl_171                
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/altera_emif_tg_avl_171/sim/altera_emif_avl_tg_amm_1x_bridge.sv"                                   -work altera_emif_tg_avl_171                
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_tg/sim/ed_sim_tg.v"                                                                                  -work ed_sim_tg                             
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_pll_ref_clk_source/altera_avalon_clock_source_171/sim/verbosity_pkg.sv"                              -work altera_common_sv_packages             
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_pll_ref_clk_source/altera_avalon_clock_source_171/sim/altera_avalon_clock_source.sv"                 -work altera_avalon_clock_source_171        
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../ip/ed_sim/ed_sim_pll_ref_clk_source/sim/ed_sim_pll_ref_clk_source.v"                                                  -work ed_sim_pll_ref_clk_source             
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/altera_merlin_master_translator_171/sim/altera_merlin_master_translator.sv"                                              -work altera_merlin_master_translator_171   
  vlogan +v2k -sverilog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/altera_merlin_slave_translator_171/sim/altera_merlin_slave_translator.sv"                                                -work altera_merlin_slave_translator_171    
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/altera_mm_interconnect_171/sim/ed_sim_altera_mm_interconnect_171_wsqnxaa.v"                                              -work altera_mm_interconnect_171            
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/altera_reset_controller_171/sim/altera_reset_controller.v"                                                               -work altera_reset_controller_171           
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/altera_reset_controller_171/sim/altera_reset_synchronizer.v"                                                             -work altera_reset_controller_171           
  vlogan +v2k $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/sim/ed_sim.v"                                                                                                            -work ed_sim                                
fi

# ----------------------------------------
# elaborate top level design
if [ $SKIP_ELAB -eq 0 ]; then
  vcs -lca -t ps $ELAB_OPTIONS $USER_DEFINED_ELAB_OPTIONS $TOP_LEVEL_NAME
fi

# ----------------------------------------
# simulate
if [ $SKIP_SIM -eq 0 ]; then
  ./simv $SIM_OPTIONS $USER_DEFINED_SIM_OPTIONS
fi

