// (C) 2001-2017 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module fourteennm_io_12_lane_abphy (
	input  [1:0] phy_clk,
	input  [7:0] phy_clk_phs,
	input        reset_n,
	input        pll_locked,
	input        dll_ref_clk,
	output [5:0] ioereg_locked,

	input  [47:0] oe_from_core,
	input  [95:0] data_from_core,
	output [95:0] data_to_core,
	input  [15:0] mrnk_read_core,
	input  [15:0] mrnk_write_core,
	input   [3:0] rdata_en_full_core,
	output  [3:0] rdata_valid_core,

	input         core2dbc_rd_data_rdy,
	input         core2dbc_wr_data_vld0,
	input         core2dbc_wr_data_vld1,
	input  [12:0] core2dbc_wr_ecc_info,
	output        dbc2core_rd_data_vld0,
	output        dbc2core_rd_data_vld1,
	output	      dbc2core_rd_type,
	output [11:0] dbc2core_wb_pointer,
	output	      dbc2core_wr_data_rdy,

	input  [95:0] ac_hmc,
	output  [5:0] afi_rlat_core,
	output  [5:0] afi_wlat_core,
	input  [17:0] cfg_dbc,
	input  [50:0] ctl2dbc0,
	input  [50:0] ctl2dbc1,
	output [22:0] dbc2ctl,

	input  [54:0] cal_avl_in,
	output [31:0] cal_avl_readdata_out,
	output [54:0] cal_avl_out,
	input  [31:0] cal_avl_readdata_in,

	input [1:0] dqs_in,
	input [1:0]	broadcast_in_bot,
	input [1:0]	broadcast_in_top,
	output [1:0] broadcast_out_bot,
	output [1:0] broadcast_out_top,

	input  [11:0] data_in,
	output [11:0] data_out,
	output [11:0] data_oe,
	output [11:0] oct_enable,

	input   [2:0] core_dll,
	output [12:0] dll_core,

	input	sync_clk_bot_in,
	output	sync_clk_bot_out,
	input	sync_clk_top_in,
	output	sync_clk_top_out,
	input	sync_data_bot_in,
	output	sync_data_bot_out,
	input	sync_data_top_in,
	output	sync_data_top_out,

    output [11:0] emif_phy_out_a,
    output [11:0] emif_phy_out_b,

	output [1:0]	dft_phy_clk,

	input   [99:0] dbg_in,
	output  [99:0] dbg_out

);

  timeunit 1ps;
  timeprecision 1ps;

parameter [7:0] pipe_latency = 8'd0;
parameter [6:0] dbc_wb_reserved_entry = 7'd0;
parameter [9:0] dll_ctl_static = 10'd0;
parameter [6:0] dqs_lgc_count_threshold = 7'd0;
parameter [5:0] db_afi_wlat_vlu = 6'd0;
parameter [5:0] db_afi_rlat_vlu = 6'd0;
parameter [9:0] dqs_lgc_pvt_input_delay_a = 10'd0;
parameter [9:0] dqs_lgc_pvt_input_delay_b = 10'd0;
parameter [12:0] pin_0_output_phase = 13'd0;
parameter [12:0] pin_1_output_phase = 13'd0;
parameter [12:0] pin_2_output_phase = 13'd0;
parameter [12:0] pin_3_output_phase = 13'd0;
parameter [12:0] pin_4_output_phase = 13'd0;
parameter [12:0] pin_5_output_phase = 13'd0;
parameter [12:0] pin_6_output_phase = 13'd0;
parameter [12:0] pin_7_output_phase = 13'd0;
parameter [12:0] pin_8_output_phase = 13'd0;
parameter [12:0] pin_9_output_phase = 13'd0;
parameter [12:0] pin_10_output_phase = 13'd0;
parameter [12:0] pin_11_output_phase = 13'd0;
parameter [12:0] dqs_lgc_phase_shift_b = 13'd0;
parameter [12:0] dqs_lgc_phase_shift_a = 13'd0;
parameter [3:0] oct_size = 4'd0;
parameter [6:0] rd_valid_delay = 7'd0;
parameter [5:0] dqs_enable_delay = 6'd0;
parameter [8:0] avl_base_addr = 9'd0;
parameter a_filter_code = "freq_16ghz";
parameter a_couple_enable = "couple_en";
parameter mode_rate_in = "in_rate_1_4";
parameter mode_rate_out = "out_rate_full";
parameter phy_clk_sel = "phy_clk_sel_uint0";
parameter pair_0_ddr4_mode = "pair0_ddr3_idle";
parameter pair_1_ddr4_mode = "pair1_ddr3_idle";
parameter pair_2_ddr4_mode = "pair2_ddr3_idle";
parameter pair_3_ddr4_mode = "pair3_ddr3_idle";
parameter pair_4_ddr4_mode = "pair4_ddr3_idle";
parameter pair_5_ddr4_mode = "pair5_ddr3_idle";
parameter mrnk_write_mode = "enabled";
parameter pair_0_dcc_split_mode = "pair0_dcc_split_disabled";
parameter pair_1_dcc_split_mode = "pair1_dcc_split_disabled";
parameter pair_2_dcc_split_mode = "pair2_dcc_split_disabled";
parameter pair_3_dcc_split_mode = "pair3_dcc_split_disabled";
parameter pair_4_dcc_split_mode = "pair4_dcc_split_disabled";
parameter pair_5_dcc_split_mode = "pair5_dcc_split_disabled";
parameter pin_0_initial_out = "pin0_initial_out_z";
parameter pin_0_oct_mode = "pin0_static_off";
parameter pin_0_mode_ddr = "pin0_mode_ddr";
parameter pin_0_dqs_mode = "pin0_dqs_sampler_a";
parameter pin_0_data_in_mode = "pin0_ca";
parameter pin_1_initial_out = "pin1_initial_out_z";
parameter pin_1_oct_mode = "pin1_static_off";
parameter pin_1_mode_ddr = "pin1_mode_ddr";
parameter pin_1_dqs_mode = "pin1_dqs_sampler_a";
parameter pin_1_data_in_mode = "pin1_ca";
parameter pin_2_initial_out = "pin2_initial_out_z";
parameter pin_2_oct_mode = "pin2_static_off";
parameter pin_2_mode_ddr = "pin2_mode_ddr";
parameter pin_2_dqs_mode = "pin2_dqs_sampler_a";
parameter pin_2_data_in_mode = "pin2_ca";
parameter pin_3_initial_out = "pin3_initial_out_z";
parameter pin_3_oct_mode = "pin3_static_off";
parameter pin_3_mode_ddr = "pin3_mode_ddr";
parameter pin_3_dqs_mode = "pin3_dqs_sampler_a";
parameter pin_3_data_in_mode = "pin3_ca";
parameter pin_4_initial_out = "pin4_initial_out_z";
parameter pin_4_oct_mode = "pin4_static_off";
parameter pin_4_mode_ddr = "pin4_mode_ddr";
parameter pin_4_dqs_mode = "pin4_dqs_sampler_a";
parameter pin_4_data_in_mode = "pin4_ca";
parameter pin_5_initial_out = "pin5_initial_out_z";
parameter pin_5_oct_mode = "pin5_static_off";
parameter pin_5_mode_ddr = "pin5_mode_ddr";
parameter pin_5_dqs_mode = "pin5_dqs_sampler_a";
parameter pin_5_data_in_mode = "pin5_ca";
parameter pin_6_initial_out = "pin6_initial_out_z";
parameter pin_6_oct_mode = "pin6_static_off";
parameter pin_6_mode_ddr = "pin6_mode_ddr";
parameter pin_6_dqs_mode = "pin6_dqs_sampler_a";
parameter pin_6_data_in_mode = "pin6_ca";
parameter pin_7_initial_out = "pin7_initial_out_z";
parameter pin_7_oct_mode = "pin7_static_off";
parameter pin_7_mode_ddr = "pin7_mode_ddr";
parameter pin_7_dqs_mode = "pin7_dqs_sampler_a";
parameter pin_7_data_in_mode = "pin7_ca";
parameter pin_8_initial_out = "pin8_initial_out_z";
parameter pin_8_oct_mode = "pin8_static_off";
parameter pin_8_mode_ddr = "pin8_mode_ddr";
parameter pin_8_dqs_mode = "pin8_dqs_sampler_a";
parameter pin_8_data_in_mode = "pin8_ca";
parameter pin_9_initial_out = "pin9_initial_out_z";
parameter pin_9_oct_mode = "pin9_static_off";
parameter pin_9_mode_ddr = "pin9_mode_ddr";
parameter pin_9_dqs_mode = "pin9_dqs_sampler_a";
parameter pin_9_data_in_mode = "pin9_ca";
parameter pin_10_initial_out = "pin10_initial_out_z";
parameter pin_10_oct_mode = "pin10_static_off";
parameter pin_10_mode_ddr = "pin10_mode_ddr";
parameter pin_10_dqs_mode = "pin10_dqs_sampler_a";
parameter pin_10_data_in_mode = "pin10_ca";
parameter pin_11_initial_out = "pin11_initial_out_z";
parameter pin_11_oct_mode = "pin11_static_off";
parameter pin_11_mode_ddr = "pin11_mode_ddr";
parameter pin_11_dqs_mode = "pin11_dqs_sampler_a";
parameter pin_11_data_in_mode = "pin11_ca";
parameter db_hmc_or_core = "core";
parameter db_dbi_sel = "db_dbi_sel_uint0";
parameter db_dbi_wr_en = "false";
parameter db_dbi_rd_en = "false";
parameter avl_ena = "false";
parameter db_boardcast_en = "false";
parameter db_pipeline = "pipeline_one_cycle";
parameter db_rwlat_mode = "avl_vlu";
parameter db_ptr_pipeline_depth = "db_ptr_pipeline_depth_uint0";
parameter db_preamble_mode = "preamble_one_cycle";
parameter db_reset_auto_release = "auto_release";
parameter db_data_alignment_mode = "align_disable";
parameter db_db2core_registered = "registered";
parameter dbc_core_clk_sel = "dbc_core_clk_sel_uint0";
parameter db_core_or_hmc2db_registered = "false";
parameter db_seq_rd_en_full_pipeline = "db_seq_rd_en_full_pipeline_uint0";
parameter db_pin_0_mode = "pin0_gpio_mode";
parameter db_pin_1_mode = "pin1_gpio_mode";
parameter db_pin_2_mode = "pin2_gpio_mode";
parameter db_pin_3_mode = "pin3_gpio_mode";
parameter db_pin_4_mode = "pin4_gpio_mode";
parameter db_pin_5_mode = "pin5_gpio_mode";
parameter db_pin_6_mode = "pin6_gpio_mode";
parameter db_pin_7_mode = "pin7_gpio_mode";
parameter db_pin_8_mode = "pin8_gpio_mode";
parameter db_pin_9_mode = "pin9_gpio_mode";
parameter db_pin_10_mode = "pin10_gpio_mode";
parameter db_pin_11_mode = "pin11_gpio_mode";
parameter dll_rst_en = "dll_rst_dis";
parameter dll_en = "dll_en";
parameter dll_core_updnen = "core_updn_en";
parameter dll_ctlsel = "ctl_static";
parameter hps_ctrl_en = "true";
parameter dqs_lgc_enable_toggler = "preamble_track_dqs_enable";
parameter dqs_lgc_dqs_b_interp_en = "dqsb_constant";
parameter dqs_lgc_dqs_a_interp_en = "dqsa_diff_in_1";
parameter dqs_lgc_pack_mode = "packed";
parameter dqs_lgc_pst_preamble_mode = "ddr4_preamble";
parameter dqs_lgc_pst_en_shrink = "shrink_0_0";
parameter vfifo_burst_length = "vburst_length_2";
parameter dqs_lgc_broadcast_enable = "disable_broadcast";
parameter dqs_lgc_burst_length = "burst_length_8";
parameter dqs_lgc_ddr4_search = "ddr4_search";
parameter fast_interpolator_sim = 1'b0;
parameter pingpong_secondary = "false";
parameter pingpong_primary = "false";
parameter memory_protocol = "PROTOCOL_DDR3";
parameter silicon_rev = "14nm5es";

    wire debug_dqs_gated_a;
    wire debug_dqs_enable_a;
    wire debug_dqs_gated_b;
    wire debug_dqs_enable_b;
    wire [11:0] debug_dq_delayed;
	wire [11:0] data_out_w;
	wire [11:0] data_oe_w;

    assign data_out = data_out_w;
    assign data_oe = data_oe_w;
    assign emif_phy_out_a = data_out_w;
    assign emif_phy_out_b = data_oe_w;

    fourteennm_io_12_lane_encrypted_abphy #(
.pipe_latency  (pipe_latency ),
.dbc_wb_reserved_entry          (dbc_wb_reserved_entry ),
.dll_ctl_static                 (dll_ctl_static ),
.dqs_lgc_count_threshold        (dqs_lgc_count_threshold ),
.db_afi_wlat_vlu                (db_afi_wlat_vlu ),
.db_afi_rlat_vlu                (db_afi_rlat_vlu ),
.dqs_lgc_pvt_input_delay_a      (dqs_lgc_pvt_input_delay_a),
.dqs_lgc_pvt_input_delay_b      (dqs_lgc_pvt_input_delay_b),
.pin_0_output_phase  (pin_0_output_phase ),
.pin_1_output_phase  (pin_1_output_phase ),
.pin_2_output_phase  (pin_2_output_phase ),
.pin_3_output_phase  (pin_3_output_phase ),
.pin_4_output_phase  (pin_4_output_phase ),
.pin_5_output_phase  (pin_5_output_phase ),
.pin_6_output_phase  (pin_6_output_phase ),
.pin_7_output_phase  (pin_7_output_phase ),
.pin_8_output_phase  (pin_8_output_phase ),
.pin_9_output_phase  (pin_9_output_phase ),
.pin_10_output_phase  (pin_10_output_phase ),
.pin_11_output_phase  (pin_11_output_phase ),
.dqs_lgc_phase_shift_b  (dqs_lgc_phase_shift_b ),
.dqs_lgc_phase_shift_a  (dqs_lgc_phase_shift_a ),
.oct_size  (oct_size ),
.rd_valid_delay  (rd_valid_delay ),
.dqs_enable_delay  (dqs_enable_delay ),
.a_filter_code  (a_filter_code ),
.a_couple_enable  (a_couple_enable ),
.mode_rate_in  (mode_rate_in ),
.mode_rate_out  (mode_rate_out ),
.phy_clk_sel  (phy_clk_sel ),
.pair_0_ddr4_mode  (pair_0_ddr4_mode ),
.pair_1_ddr4_mode  (pair_1_ddr4_mode ),
.pair_2_ddr4_mode  (pair_2_ddr4_mode ),
.pair_3_ddr4_mode  (pair_3_ddr4_mode ),
.pair_4_ddr4_mode  (pair_4_ddr4_mode ),
.pair_5_ddr4_mode  (pair_5_ddr4_mode ),
.mrnk_write_mode  (mrnk_write_mode),
.pair_0_dcc_split_mode  (pair_0_dcc_split_mode ),
.pair_1_dcc_split_mode  (pair_1_dcc_split_mode ),
.pair_2_dcc_split_mode  (pair_2_dcc_split_mode ),
.pair_3_dcc_split_mode  (pair_3_dcc_split_mode ),
.pair_4_dcc_split_mode  (pair_4_dcc_split_mode ),
.pair_5_dcc_split_mode  (pair_5_dcc_split_mode ),
.pin_0_initial_out  (pin_0_initial_out ),
.pin_0_oct_mode  (pin_0_oct_mode ),
.pin_0_mode_ddr  (pin_0_mode_ddr ),
.pin_0_dqs_mode  (pin_0_dqs_mode ),
.pin_0_data_in_mode  (pin_0_data_in_mode ),
.pin_1_initial_out  (pin_1_initial_out ),
.pin_1_oct_mode  (pin_1_oct_mode ),
.pin_1_mode_ddr  (pin_1_mode_ddr ),
.pin_1_dqs_mode  (pin_1_dqs_mode ),
.pin_1_data_in_mode  (pin_1_data_in_mode ),
.pin_2_initial_out  (pin_2_initial_out ),
.pin_2_oct_mode  (pin_2_oct_mode ),
.pin_2_mode_ddr  (pin_2_mode_ddr ),
.pin_2_dqs_mode  (pin_2_dqs_mode ),
.pin_2_data_in_mode  (pin_2_data_in_mode ),
.pin_3_initial_out  (pin_3_initial_out ),
.pin_3_oct_mode  (pin_3_oct_mode ),
.pin_3_mode_ddr  (pin_3_mode_ddr ),
.pin_3_dqs_mode  (pin_3_dqs_mode ),
.pin_3_data_in_mode  (pin_3_data_in_mode ),
.pin_4_initial_out  (pin_4_initial_out ),
.pin_4_oct_mode  (pin_4_oct_mode ),
.pin_4_mode_ddr  (pin_4_mode_ddr ),
.pin_4_dqs_mode  (pin_4_dqs_mode ),
.pin_4_data_in_mode  (pin_4_data_in_mode ),
.pin_5_initial_out  (pin_5_initial_out ),
.pin_5_oct_mode  (pin_5_oct_mode ),
.pin_5_mode_ddr  (pin_5_mode_ddr ),
.pin_5_dqs_mode  (pin_5_dqs_mode ),
.pin_5_data_in_mode  (pin_5_data_in_mode ),
.pin_6_initial_out  (pin_6_initial_out ),
.pin_6_oct_mode  (pin_6_oct_mode ),
.pin_6_mode_ddr  (pin_6_mode_ddr ),
.pin_6_dqs_mode  (pin_6_dqs_mode ),
.pin_6_data_in_mode  (pin_6_data_in_mode ),
.pin_7_initial_out  (pin_7_initial_out ),
.pin_7_oct_mode  (pin_7_oct_mode ),
.pin_7_mode_ddr  (pin_7_mode_ddr ),
.pin_7_dqs_mode  (pin_7_dqs_mode ),
.pin_7_data_in_mode  (pin_7_data_in_mode ),
.pin_8_initial_out  (pin_8_initial_out ),
.pin_8_oct_mode  (pin_8_oct_mode ),
.pin_8_mode_ddr  (pin_8_mode_ddr ),
.pin_8_dqs_mode  (pin_8_dqs_mode ),
.pin_8_data_in_mode  (pin_8_data_in_mode ),
.pin_9_initial_out  (pin_9_initial_out ),
.pin_9_oct_mode  (pin_9_oct_mode ),
.pin_9_mode_ddr  (pin_9_mode_ddr ),
.pin_9_dqs_mode  (pin_9_dqs_mode ),
.pin_9_data_in_mode  (pin_9_data_in_mode ),
.pin_10_initial_out  (pin_10_initial_out ),
.pin_10_oct_mode  (pin_10_oct_mode ),
.pin_10_mode_ddr  (pin_10_mode_ddr ),
.pin_10_dqs_mode  (pin_10_dqs_mode ),
.pin_10_data_in_mode  (pin_10_data_in_mode ),
.pin_11_initial_out  (pin_11_initial_out ),
.pin_11_oct_mode  (pin_11_oct_mode ),
.pin_11_mode_ddr  (pin_11_mode_ddr ),
.pin_11_dqs_mode  (pin_11_dqs_mode ),
.pin_11_data_in_mode  (pin_11_data_in_mode ),
.db_hmc_or_core  (db_hmc_or_core ),
.db_dbi_sel  (db_dbi_sel ),
.db_dbi_wr_en  (db_dbi_wr_en ),
.db_dbi_rd_en  (db_dbi_rd_en ),
.avl_ena  (avl_ena ),
.db_rwlat_mode  (db_rwlat_mode ),
.db_ptr_pipeline_depth  (db_ptr_pipeline_depth ),
.db_preamble_mode  (db_preamble_mode ),
.db_reset_auto_release  (db_reset_auto_release ),
.db_data_alignment_mode  (db_data_alignment_mode ),
.db_db2core_registered  (db_db2core_registered ),
.dbc_core_clk_sel  (dbc_core_clk_sel ),
.db_core_or_hmc2db_registered  (db_core_or_hmc2db_registered ),
.db_seq_rd_en_full_pipeline  (db_seq_rd_en_full_pipeline ),
.db_pin_0_mode  (db_pin_0_mode ),
.db_pin_1_mode  (db_pin_1_mode ),
.db_pin_2_mode  (db_pin_2_mode ),
.db_pin_3_mode  (db_pin_3_mode ),
.db_pin_4_mode  (db_pin_4_mode ),
.db_pin_5_mode  (db_pin_5_mode ),
.db_pin_6_mode  (db_pin_6_mode ),
.db_pin_7_mode  (db_pin_7_mode ),
.db_pin_8_mode  (db_pin_8_mode ),
.db_pin_9_mode  (db_pin_9_mode ),
.db_pin_10_mode  (db_pin_10_mode ),
.db_pin_11_mode  (db_pin_11_mode ),
.dll_rst_en  (dll_rst_en ),
.dll_en  (dll_en ),
.dll_core_updnen  (dll_core_updnen ),
.dll_ctlsel  (dll_ctlsel ),
.hps_ctrl_en  (hps_ctrl_en ),
.dqs_lgc_enable_toggler  (dqs_lgc_enable_toggler ),
.dqs_lgc_dqs_b_interp_en  (dqs_lgc_dqs_b_interp_en ),
.dqs_lgc_dqs_a_interp_en  (dqs_lgc_dqs_a_interp_en ),
.dqs_lgc_pack_mode  (dqs_lgc_pack_mode ),
.dqs_lgc_pst_preamble_mode  (dqs_lgc_pst_preamble_mode ),
.dqs_lgc_pst_en_shrink  (dqs_lgc_pst_en_shrink ),
.vfifo_burst_length  (vfifo_burst_length ),
.dqs_lgc_broadcast_enable  (dqs_lgc_broadcast_enable ),
.dqs_lgc_burst_length  (dqs_lgc_burst_length ),
.dqs_lgc_ddr4_search  (dqs_lgc_ddr4_search ),
.avl_base_addr  (avl_base_addr ),
.db_boardcast_en  (db_boardcast_en ),
.db_pipeline  (db_pipeline ),
.fast_interpolator_sim (fast_interpolator_sim ),
.silicon_rev(silicon_rev),
.pingpong_primary(pingpong_primary),
.pingpong_secondary(pingpong_secondary),
.memory_protocol(memory_protocol)
)
    inst (
        .phy_clk       (phy_clk       ),
        .phy_clk_phs   (phy_clk_phs   ),
        .reset_n       (reset_n       ),
        .pll_locked    (pll_locked    ),
        .dll_ref_clk   (dll_ref_clk   ),
        .ioereg_locked (ioereg_locked ),

        .oe_from_core       (oe_from_core       ),
        .data_from_core     (data_from_core     ),
        .data_to_core       (data_to_core       ),
        .mrnk_read_core     (mrnk_read_core     ),
        .mrnk_write_core    (mrnk_write_core    ),
        .rdata_en_full_core (rdata_en_full_core ),
        .rdata_valid_core   (rdata_valid_core   ),

        .core2dbc_rd_data_rdy  (core2dbc_rd_data_rdy  ),
        .core2dbc_wr_data_vld0 (core2dbc_wr_data_vld0 ),
        .core2dbc_wr_data_vld1 (core2dbc_wr_data_vld1 ),
        .core2dbc_wr_ecc_info  (core2dbc_wr_ecc_info  ),
        .dbc2core_rd_data_vld0 (dbc2core_rd_data_vld0 ),
        .dbc2core_rd_data_vld1 (dbc2core_rd_data_vld1 ),
        .dbc2core_rd_type      (dbc2core_rd_type      ),
        .dbc2core_wb_pointer   (dbc2core_wb_pointer   ),
        .dbc2core_wr_data_rdy  (dbc2core_wr_data_rdy  ),

        .ac_hmc        (ac_hmc        ),
        .afi_rlat_core (afi_rlat_core ),
        .afi_wlat_core (afi_wlat_core ),
        .cfg_dbc       (cfg_dbc       ),
        .ctl2dbc0      (ctl2dbc0      ),
        .ctl2dbc1      (ctl2dbc1      ),
        .dbc2ctl       (dbc2ctl       ),

        .cal_avl_in           (cal_avl_in           ),
        .cal_avl_readdata_out (cal_avl_readdata_out ),
        .cal_avl_out          (cal_avl_out          ),
        .cal_avl_readdata_in  (cal_avl_readdata_in  ),

        .dqs_in            (dqs_in            ),
        .broadcast_in_bot  (broadcast_in_bot  ),
        .broadcast_in_top  (broadcast_in_top  ),
        .broadcast_out_bot (broadcast_out_bot ),
        .broadcast_out_top (broadcast_out_top ),

        .data_in    (data_in    ),
        .data_out   (data_out_w   ),
        .data_oe    (data_oe_w    ),
        .oct_enable (oct_enable ),

        .core_dll (core_dll ),
        .dll_core (dll_core ),

        .sync_clk_bot_in   (sync_clk_bot_in  ),
        .sync_clk_bot_out  (sync_clk_bot_out ),
        .sync_clk_top_in   (sync_clk_top_in  ),
        .sync_clk_top_out  (sync_clk_top_out ),
        .sync_data_bot_in  (sync_data_bot_in ),
        .sync_data_bot_out (sync_data_bot_out),
        .sync_data_top_in  (sync_data_top_in ),
        .sync_data_top_out (sync_data_top_out),

        .debug_dqs_gated_a  (debug_dqs_gated_a  ),
        .debug_dqs_enable_a (debug_dqs_enable_a ),
        .debug_dqs_gated_b  (debug_dqs_gated_b  ),
        .debug_dqs_enable_b (debug_dqs_enable_b ),
        .debug_dq_delayed   (debug_dq_delayed   ),

        .dft_phy_clk (dft_phy_clk),

		.dbg_in(dbg_in),
		.dbg_out(dbg_out)

    );

endmodule 
