	component ed_synth_master_driver_msgdma_0 is
		generic (
			ENABLE_PER_INFO : integer := 1
		);
		port (
			waitrequest_in  : in  std_logic                     := 'X';             -- waitrequest
			csn             : out std_logic;                                        -- chipselect_n
			wen             : out std_logic;                                        -- write_n
			oen             : out std_logic;                                        -- read_n
			be              : out std_logic_vector(3 downto 0);                     -- byteenable
			address         : out std_logic_vector(31 downto 0);                    -- address
			data_write      : out std_logic_vector(31 downto 0);                    -- writedata
			data_read       : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			cal_fail        : in  std_logic                     := 'X';             -- export
			cal_success     : in  std_logic                     := 'X';             -- export
			clk             : in  std_logic                     := 'X';             -- clk
			csr_address     : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- address
			csr_read        : in  std_logic                     := 'X';             -- read
			csr_write       : in  std_logic                     := 'X';             -- write
			csr_readdata    : out std_logic_vector(31 downto 0);                    -- readdata
			csr_writedata   : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			csr_waitrequest : out std_logic;                                        -- waitrequest
			error_mon       : out std_logic;                                        -- export
			irq             : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- irq
			reset_n         : in  std_logic                     := 'X';             -- reset_n
			reset_out       : out std_logic;                                        -- reset
			status_mon      : out std_logic                                         -- export
		);
	end component ed_synth_master_driver_msgdma_0;

	u0 : component ed_synth_master_driver_msgdma_0
		generic map (
			ENABLE_PER_INFO => INTEGER_VALUE_FOR_ENABLE_PER_INFO
		)
		port map (
			waitrequest_in  => CONNECTED_TO_waitrequest_in,  --      avalon_master.waitrequest
			csn             => CONNECTED_TO_csn,             --                   .chipselect_n
			wen             => CONNECTED_TO_wen,             --                   .write_n
			oen             => CONNECTED_TO_oen,             --                   .read_n
			be              => CONNECTED_TO_be,              --                   .byteenable
			address         => CONNECTED_TO_address,         --                   .address
			data_write      => CONNECTED_TO_data_write,      --                   .writedata
			data_read       => CONNECTED_TO_data_read,       --                   .readdata
			cal_fail        => CONNECTED_TO_cal_fail,        --           cal_fail.export
			cal_success     => CONNECTED_TO_cal_success,     --        cal_success.export
			clk             => CONNECTED_TO_clk,             --              clock.clk
			csr_address     => CONNECTED_TO_csr_address,     --                csr.address
			csr_read        => CONNECTED_TO_csr_read,        --                   .read
			csr_write       => CONNECTED_TO_csr_write,       --                   .write
			csr_readdata    => CONNECTED_TO_csr_readdata,    --                   .readdata
			csr_writedata   => CONNECTED_TO_csr_writedata,   --                   .writedata
			csr_waitrequest => CONNECTED_TO_csr_waitrequest, --                   .waitrequest
			error_mon       => CONNECTED_TO_error_mon,       --          error_mon.export
			irq             => CONNECTED_TO_irq,             -- interrupt_receiver.irq
			reset_n         => CONNECTED_TO_reset_n,         --              reset.reset_n
			reset_out       => CONNECTED_TO_reset_out,       --       reset_source.reset
			status_mon      => CONNECTED_TO_status_mon       --         status_mon.export
		);

