// ed_synth_master_driver_msgdma_0.v

// Generated using ACDS version 17.1 240

`timescale 1 ps / 1 ps
module ed_synth_master_driver_msgdma_0 #(
		parameter ENABLE_PER_INFO = 1
	) (
		input  wire        waitrequest_in,  //      avalon_master.waitrequest
		output wire        csn,             //                   .chipselect_n
		output wire        wen,             //                   .write_n
		output wire        oen,             //                   .read_n
		output wire [3:0]  be,              //                   .byteenable
		output wire [31:0] address,         //                   .address
		output wire [31:0] data_write,      //                   .writedata
		input  wire [31:0] data_read,       //                   .readdata
		input  wire        cal_fail,        //           cal_fail.export
		input  wire        cal_success,     //        cal_success.export
		input  wire        clk,             //              clock.clk
		input  wire [3:0]  csr_address,     //                csr.address
		input  wire        csr_read,        //                   .read
		input  wire        csr_write,       //                   .write
		output wire [31:0] csr_readdata,    //                   .readdata
		input  wire [31:0] csr_writedata,   //                   .writedata
		output wire        csr_waitrequest, //                   .waitrequest
		output wire        error_mon,       //          error_mon.export
		input  wire [1:0]  irq,             // interrupt_receiver.irq
		input  wire        reset_n,         //              reset.reset_n
		output wire        reset_out,       //       reset_source.reset
		output wire        status_mon       //         status_mon.export
	);

	master_driver_msgdma #(
		.PRBS_PATTERN_GENERATOR_BASE (32'b00000000001000000000000001000000),
		.PRBS_PATTERN_CHECKER_BASE   (32'b00000000001000000000000000000000),
		.MEMORY_BASE_ADDRESS         (32'b00000000000000000000000000000000),
		.MEMORY_SPAN                 (32'b01000000000000000000000000000000),
		.BLOCK_SIZE                  (32'b01000000000000000000000100000000),
		.DISPATCHER_WRITE_CSR        (32'b00000000001000000000000001100000),
		.DISPATCHER_WRITE_DESCRIPTOR (32'b00000000001000000000000010100000),
		.DISPATCHER_READ_CSR         (32'b00000000001000000000000010000000),
		.DISPATCHER_READ_DESCRIPTOR  (32'b00000000001000000000000010110000),
		.TIMER_BASE                  (32'b00000000001010000001000000000000),
		.FREQUENCY_COUNTER_BASE      (32'b00000000001010010000000000000000),
		.ENABLE_PER_INFO             (ENABLE_PER_INFO),
		.LOCAL_DATA_WORDS            (32'b00000000000000000000000001000000)
	) master_driver_msgdma_0 (
		.reset_n         (reset_n),         //   input,   width = 1,              reset.reset_n
		.clk             (clk),             //   input,   width = 1,              clock.clk
		.csr_address     (csr_address),     //   input,   width = 4,                csr.address
		.csr_read        (csr_read),        //   input,   width = 1,                   .read
		.csr_write       (csr_write),       //   input,   width = 1,                   .write
		.csr_readdata    (csr_readdata),    //  output,  width = 32,                   .readdata
		.csr_writedata   (csr_writedata),   //   input,  width = 32,                   .writedata
		.csr_waitrequest (csr_waitrequest), //  output,   width = 1,                   .waitrequest
		.irq             (irq),             //   input,   width = 2, interrupt_receiver.irq
		.waitrequest_in  (waitrequest_in),  //   input,   width = 1,      avalon_master.waitrequest
		.csn             (csn),             //  output,   width = 1,                   .chipselect_n
		.wen             (wen),             //  output,   width = 1,                   .write_n
		.oen             (oen),             //  output,   width = 1,                   .read_n
		.be              (be),              //  output,   width = 4,                   .byteenable
		.address         (address),         //  output,  width = 32,                   .address
		.data_write      (data_write),      //  output,  width = 32,                   .writedata
		.data_read       (data_read),       //   input,  width = 32,                   .readdata
		.reset_out       (reset_out),       //  output,   width = 1,       reset_source.reset
		.cal_success     (cal_success),     //   input,   width = 1,        cal_success.export
		.cal_fail        (cal_fail),        //   input,   width = 1,           cal_fail.export
		.error_mon       (error_mon),       //  output,   width = 1,          error_mon.export
		.status_mon      (status_mon)       //  output,   width = 1,         status_mon.export
	);

endmodule
