// mSGDMA_dispatcher_write.v

// Generated using ACDS version 17.1 240

`timescale 1 ps / 1 ps
module mSGDMA_dispatcher_write (
		input  wire [31:0]  csr_writedata,          //                  CSR.writedata
		input  wire         csr_write,              //                     .write
		input  wire [3:0]   csr_byteenable,         //                     .byteenable
		output wire [31:0]  csr_readdata,           //                     .readdata
		input  wire         csr_read,               //                     .read
		input  wire [2:0]   csr_address,            //                     .address
		input  wire         descriptor_write,       //     Descriptor_Slave.write
		output wire         descriptor_waitrequest, //                     .waitrequest
		input  wire [127:0] descriptor_writedata,   //                     .writedata
		input  wire [15:0]  descriptor_byteenable,  //                     .byteenable
		output wire [255:0] src_write_master_data,  // Write_Command_Source.data
		output wire         src_write_master_valid, //                     .valid
		input  wire         src_write_master_ready, //                     .ready
		input  wire [255:0] snk_write_master_data,  //  Write_Response_Sink.data
		input  wire         snk_write_master_valid, //                     .valid
		output wire         snk_write_master_ready, //                     .ready
		input  wire         clk,                    //                clock.clk
		input  wire         reset,                  //          clock_reset.reset
		output wire         csr_irq                 //              csr_irq.irq
	);

	dispatcher #(
		.PREFETCHER_USE_CASE           (0),
		.MODE                          (2),
		.RESPONSE_PORT                 (2),
		.DESCRIPTOR_INTERFACE          (0),
		.DESCRIPTOR_FIFO_DEPTH         (1024),
		.ENHANCED_FEATURES             (0),
		.DESCRIPTOR_WIDTH              (128),
		.DESCRIPTOR_BYTEENABLE_WIDTH   (16),
		.DATA_WIDTH_DERIVED            (2),
		.DATA_FIFO_DEPTH_DERIVED       (1),
		.MAX_BYTE_DERIVED              (0),
		.TRANSFER_TYPE_DERIVED         (1),
		.BURST_ENABLE                  (0),
		.MAX_BURST_COUNT_DERIVED       (0),
		.BURST_WRAPPING_SUPPORT        (0),
		.STRIDE_ENABLE_DERIVED         (0),
		.MAX_STRIDE_DERIVED            (0),
		.PROGRAMMABLE_BURST_ENABLE     (0),
		.CHANNEL_ENABLE                (0),
		.CHANNEL_WIDTH_DERIVED         (7),
		.ERROR_ENABLE                  (0),
		.ERROR_WIDTH_DERIVED           (7),
		.PACKET_ENABLE                 (0),
		.DESCRIPTOR_FIFO_DEPTH_DERIVED (7)
	) dispatcher_write (
		.clk                     (clk),                                                                                                                                                                                                                                                                   //   input,    width = 1,                clock.clk
		.reset                   (reset),                                                                                                                                                                                                                                                                 //   input,    width = 1,          clock_reset.reset
		.csr_writedata           (csr_writedata),                                                                                                                                                                                                                                                         //   input,   width = 32,                  CSR.writedata
		.csr_write               (csr_write),                                                                                                                                                                                                                                                             //   input,    width = 1,                     .write
		.csr_byteenable          (csr_byteenable),                                                                                                                                                                                                                                                        //   input,    width = 4,                     .byteenable
		.csr_readdata            (csr_readdata),                                                                                                                                                                                                                                                          //  output,   width = 32,                     .readdata
		.csr_read                (csr_read),                                                                                                                                                                                                                                                              //   input,    width = 1,                     .read
		.csr_address             (csr_address),                                                                                                                                                                                                                                                           //   input,    width = 3,                     .address
		.descriptor_write        (descriptor_write),                                                                                                                                                                                                                                                      //   input,    width = 1,     Descriptor_Slave.write
		.descriptor_waitrequest  (descriptor_waitrequest),                                                                                                                                                                                                                                                //  output,    width = 1,                     .waitrequest
		.descriptor_writedata    (descriptor_writedata),                                                                                                                                                                                                                                                  //   input,  width = 128,                     .writedata
		.descriptor_byteenable   (descriptor_byteenable),                                                                                                                                                                                                                                                 //   input,   width = 16,                     .byteenable
		.src_write_master_data   (src_write_master_data),                                                                                                                                                                                                                                                 //  output,  width = 256, Write_Command_Source.data
		.src_write_master_valid  (src_write_master_valid),                                                                                                                                                                                                                                                //  output,    width = 1,                     .valid
		.src_write_master_ready  (src_write_master_ready),                                                                                                                                                                                                                                                //   input,    width = 1,                     .ready
		.snk_write_master_data   (snk_write_master_data),                                                                                                                                                                                                                                                 //   input,  width = 256,  Write_Response_Sink.data
		.snk_write_master_valid  (snk_write_master_valid),                                                                                                                                                                                                                                                //   input,    width = 1,                     .valid
		.snk_write_master_ready  (snk_write_master_ready),                                                                                                                                                                                                                                                //  output,    width = 1,                     .ready
		.csr_irq                 (csr_irq),                                                                                                                                                                                                                                                               //  output,    width = 1,              csr_irq.irq
		.src_response_data       (),                                                                                                                                                                                                                                                                      // (terminated),                                    
		.src_response_valid      (),                                                                                                                                                                                                                                                                      // (terminated),                                    
		.src_response_ready      (1'b0),                                                                                                                                                                                                                                                                  // (terminated),                                    
		.snk_descriptor_data     (128'b00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000),                                                                                                                                 // (terminated),                                    
		.snk_descriptor_valid    (1'b0),                                                                                                                                                                                                                                                                  // (terminated),                                    
		.snk_descriptor_ready    (),                                                                                                                                                                                                                                                                      // (terminated),                                    
		.mm_response_waitrequest (),                                                                                                                                                                                                                                                                      // (terminated),                                    
		.mm_response_byteenable  (4'b0000),                                                                                                                                                                                                                                                               // (terminated),                                    
		.mm_response_address     (1'b0),                                                                                                                                                                                                                                                                  // (terminated),                                    
		.mm_response_readdata    (),                                                                                                                                                                                                                                                                      // (terminated),                                    
		.mm_response_read        (1'b0),                                                                                                                                                                                                                                                                  // (terminated),                                    
		.src_read_master_data    (),                                                                                                                                                                                                                                                                      // (terminated),                                    
		.src_read_master_valid   (),                                                                                                                                                                                                                                                                      // (terminated),                                    
		.src_read_master_ready   (1'b0),                                                                                                                                                                                                                                                                  // (terminated),                                    
		.snk_read_master_data    (256'b0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000), // (terminated),                                    
		.snk_read_master_valid   (1'b0),                                                                                                                                                                                                                                                                  // (terminated),                                    
		.snk_read_master_ready   ()                                                                                                                                                                                                                                                                       // (terminated),                                    
	);

endmodule
