module mSGDMA (
		output wire         cal_fail_mon_export,             //             cal_fail_mon.export
		output wire         cal_success_mon_export,          //          cal_success_mon.export
		input  wire         clk_clk,                         //                      clk.clk
		input  wire         clk_0_clk,                       //                    clk_0.clk
		output wire         dispatcher_read_csr_irq_irq,     //  dispatcher_read_csr_irq.irq
		output wire         dispatcher_write_csr_irq_irq,    // dispatcher_write_csr_irq.irq
		output wire [31:0]  dma_read_master_address,         //          dma_read_master.address
		output wire         dma_read_master_read,            //                         .read
		output wire [63:0]  dma_read_master_byteenable,      //                         .byteenable
		input  wire [511:0] dma_read_master_readdata,        //                         .readdata
		input  wire         dma_read_master_waitrequest,     //                         .waitrequest
		input  wire         dma_read_master_readdatavalid,   //                         .readdatavalid
		output wire [5:0]   dma_read_master_burstcount,      //                         .burstcount
		output wire [31:0]  dma_write_master_address,        //         dma_write_master.address
		output wire         dma_write_master_write,          //                         .write
		output wire [63:0]  dma_write_master_byteenable,     //                         .byteenable
		output wire [511:0] dma_write_master_writedata,      //                         .writedata
		input  wire         dma_write_master_waitrequest,    //                         .waitrequest
		output wire [5:0]   dma_write_master_burstcount,     //                         .burstcount
		output wire         eset_source_reset_n,             //              eset_source.reset_n
		output wire         mm_bridge_slv_waitrequest,       //            mm_bridge_slv.waitrequest
		output wire [31:0]  mm_bridge_slv_readdata,          //                         .readdata
		output wire         mm_bridge_slv_readdatavalid,     //                         .readdatavalid
		input  wire [6:0]   mm_bridge_slv_burstcount,        //                         .burstcount
		input  wire [31:0]  mm_bridge_slv_writedata,         //                         .writedata
		input  wire [19:0]  mm_bridge_slv_address,           //                         .address
		input  wire         mm_bridge_slv_write,             //                         .write
		input  wire         mm_bridge_slv_read,              //                         .read
		input  wire [3:0]   mm_bridge_slv_byteenable,        //                         .byteenable
		input  wire         mm_bridge_slv_debugaccess,       //                         .debugaccess
		input  wire         reset_reset_n,                   //                    reset.reset_n
		input  wire         reset_0_reset_n,                 //                  reset_0.reset_n
		input  wire         status_mon_in_local_cal_success, //            status_mon_in.local_cal_success
		input  wire         status_mon_in_local_cal_fail     //                         .local_cal_fail
	);
endmodule

