// mSGDMA.v

// Generated using ACDS version 17.1 240

`timescale 1 ps / 1 ps
module mSGDMA (
		output wire         cal_fail_mon_export,             //             cal_fail_mon.export
		output wire         cal_success_mon_export,          //          cal_success_mon.export
		input  wire         clk_clk,                         //                      clk.clk
		input  wire         clk_0_clk,                       //                    clk_0.clk
		output wire         dispatcher_read_csr_irq_irq,     //  dispatcher_read_csr_irq.irq
		output wire         dispatcher_write_csr_irq_irq,    // dispatcher_write_csr_irq.irq
		output wire [31:0]  dma_read_master_address,         //          dma_read_master.address
		output wire         dma_read_master_read,            //                         .read
		output wire [63:0]  dma_read_master_byteenable,      //                         .byteenable
		input  wire [511:0] dma_read_master_readdata,        //                         .readdata
		input  wire         dma_read_master_waitrequest,     //                         .waitrequest
		input  wire         dma_read_master_readdatavalid,   //                         .readdatavalid
		output wire [5:0]   dma_read_master_burstcount,      //                         .burstcount
		output wire [31:0]  dma_write_master_address,        //         dma_write_master.address
		output wire         dma_write_master_write,          //                         .write
		output wire [63:0]  dma_write_master_byteenable,     //                         .byteenable
		output wire [511:0] dma_write_master_writedata,      //                         .writedata
		input  wire         dma_write_master_waitrequest,    //                         .waitrequest
		output wire [5:0]   dma_write_master_burstcount,     //                         .burstcount
		output wire         eset_source_reset_n,             //              eset_source.reset_n
		output wire         mm_bridge_slv_waitrequest,       //            mm_bridge_slv.waitrequest
		output wire [31:0]  mm_bridge_slv_readdata,          //                         .readdata
		output wire         mm_bridge_slv_readdatavalid,     //                         .readdatavalid
		input  wire [6:0]   mm_bridge_slv_burstcount,        //                         .burstcount
		input  wire [31:0]  mm_bridge_slv_writedata,         //                         .writedata
		input  wire [19:0]  mm_bridge_slv_address,           //                         .address
		input  wire         mm_bridge_slv_write,             //                         .write
		input  wire         mm_bridge_slv_read,              //                         .read
		input  wire [3:0]   mm_bridge_slv_byteenable,        //                         .byteenable
		input  wire         mm_bridge_slv_debugaccess,       //                         .debugaccess
		input  wire         reset_reset_n,                   //                    reset.reset_n
		input  wire         reset_0_reset_n,                 //                  reset_0.reset_n
		input  wire         status_mon_in_local_cal_success, //            status_mon_in.local_cal_success
		input  wire         status_mon_in_local_cal_fail     //                         .local_cal_fail
	);

	wire          dma_read_master_data_source_valid;                               // dma_read_master:src_valid -> prbs_pattern_checker:snk_valid
	wire  [511:0] dma_read_master_data_source_data;                                // dma_read_master:src_data -> prbs_pattern_checker:snk_data
	wire          dma_read_master_data_source_ready;                               // prbs_pattern_checker:snk_ready -> dma_read_master:src_ready
	wire          dispatcher_read_read_command_source_valid;                       // dispatcher_read:src_read_master_valid -> dma_read_master:snk_command_valid
	wire  [255:0] dispatcher_read_read_command_source_data;                        // dispatcher_read:src_read_master_data -> dma_read_master:snk_command_data
	wire          dispatcher_read_read_command_source_ready;                       // dma_read_master:snk_command_ready -> dispatcher_read:src_read_master_ready
	wire          dma_read_master_response_source_valid;                           // dma_read_master:src_response_valid -> dispatcher_read:snk_read_master_valid
	wire  [255:0] dma_read_master_response_source_data;                            // dma_read_master:src_response_data -> dispatcher_read:snk_read_master_data
	wire          dma_read_master_response_source_ready;                           // dispatcher_read:snk_read_master_ready -> dma_read_master:src_response_ready
	wire          dma_write_master_response_source_valid;                          // dma_write_master:src_response_valid -> dispatcher_write:snk_write_master_valid
	wire  [255:0] dma_write_master_response_source_data;                           // dma_write_master:src_response_data -> dispatcher_write:snk_write_master_data
	wire          dma_write_master_response_source_ready;                          // dispatcher_write:snk_write_master_ready -> dma_write_master:src_response_ready
	wire          dispatcher_write_write_command_source_valid;                     // dispatcher_write:src_write_master_valid -> dma_write_master:snk_command_valid
	wire  [255:0] dispatcher_write_write_command_source_data;                      // dispatcher_write:src_write_master_data -> dma_write_master:snk_command_data
	wire          dispatcher_write_write_command_source_ready;                     // dma_write_master:snk_command_ready -> dispatcher_write:src_write_master_ready
	wire          timing_adapter_out_valid;                                        // timing_adapter:out_valid -> dma_write_master:snk_valid
	wire  [511:0] timing_adapter_out_data;                                         // timing_adapter:out_data -> dma_write_master:snk_data
	wire          timing_adapter_out_ready;                                        // dma_write_master:snk_ready -> timing_adapter:out_ready
	wire          prbs_pattern_generator_st_pattern_output_valid;                  // prbs_pattern_generator:src_valid -> timing_adapter:in_valid
	wire  [511:0] prbs_pattern_generator_st_pattern_output_data;                   // prbs_pattern_generator:src_data -> timing_adapter:in_data
	wire          prbs_pattern_generator_st_pattern_output_ready;                  // timing_adapter:in_ready -> prbs_pattern_generator:src_ready
	wire          clk_clk_clk;                                                     // clk:clk_out -> [dispatcher_read:clk, dispatcher_write:clk, dma_read_master:clk, dma_write_master:clk, freq_counter_0:sample_clk, mm_bridge_slv:clk, mm_interconnect_0:clk_clk_clk, prbs_pattern_checker:clk, prbs_pattern_generator:clk, rst_controller:clk, rst_controller_002:clk, status_mon_0:slv_clk, timing_adapter:clk]
	wire          clk_0_clk_clk;                                                   // clk_0:clk_out -> [freq_counter_0:clk, mm_interconnect_0:clk_0_clk_clk, rst_controller_001:clk, rst_controller_003:clk, timer_0:clk]
	wire          mm_bridge_slv_m0_waitrequest;                                    // mm_interconnect_0:mm_bridge_slv_m0_waitrequest -> mm_bridge_slv:m0_waitrequest
	wire   [31:0] mm_bridge_slv_m0_readdata;                                       // mm_interconnect_0:mm_bridge_slv_m0_readdata -> mm_bridge_slv:m0_readdata
	wire          mm_bridge_slv_m0_debugaccess;                                    // mm_bridge_slv:m0_debugaccess -> mm_interconnect_0:mm_bridge_slv_m0_debugaccess
	wire   [19:0] mm_bridge_slv_m0_address;                                        // mm_bridge_slv:m0_address -> mm_interconnect_0:mm_bridge_slv_m0_address
	wire          mm_bridge_slv_m0_read;                                           // mm_bridge_slv:m0_read -> mm_interconnect_0:mm_bridge_slv_m0_read
	wire    [3:0] mm_bridge_slv_m0_byteenable;                                     // mm_bridge_slv:m0_byteenable -> mm_interconnect_0:mm_bridge_slv_m0_byteenable
	wire          mm_bridge_slv_m0_readdatavalid;                                  // mm_interconnect_0:mm_bridge_slv_m0_readdatavalid -> mm_bridge_slv:m0_readdatavalid
	wire   [31:0] mm_bridge_slv_m0_writedata;                                      // mm_bridge_slv:m0_writedata -> mm_interconnect_0:mm_bridge_slv_m0_writedata
	wire          mm_bridge_slv_m0_write;                                          // mm_bridge_slv:m0_write -> mm_interconnect_0:mm_bridge_slv_m0_write
	wire    [6:0] mm_bridge_slv_m0_burstcount;                                     // mm_bridge_slv:m0_burstcount -> mm_interconnect_0:mm_bridge_slv_m0_burstcount
	wire   [31:0] mm_interconnect_0_dispatcher_read_csr_readdata;                  // dispatcher_read:csr_readdata -> mm_interconnect_0:dispatcher_read_CSR_readdata
	wire    [2:0] mm_interconnect_0_dispatcher_read_csr_address;                   // mm_interconnect_0:dispatcher_read_CSR_address -> dispatcher_read:csr_address
	wire          mm_interconnect_0_dispatcher_read_csr_read;                      // mm_interconnect_0:dispatcher_read_CSR_read -> dispatcher_read:csr_read
	wire    [3:0] mm_interconnect_0_dispatcher_read_csr_byteenable;                // mm_interconnect_0:dispatcher_read_CSR_byteenable -> dispatcher_read:csr_byteenable
	wire          mm_interconnect_0_dispatcher_read_csr_write;                     // mm_interconnect_0:dispatcher_read_CSR_write -> dispatcher_read:csr_write
	wire   [31:0] mm_interconnect_0_dispatcher_read_csr_writedata;                 // mm_interconnect_0:dispatcher_read_CSR_writedata -> dispatcher_read:csr_writedata
	wire   [31:0] mm_interconnect_0_dispatcher_write_csr_readdata;                 // dispatcher_write:csr_readdata -> mm_interconnect_0:dispatcher_write_CSR_readdata
	wire    [2:0] mm_interconnect_0_dispatcher_write_csr_address;                  // mm_interconnect_0:dispatcher_write_CSR_address -> dispatcher_write:csr_address
	wire          mm_interconnect_0_dispatcher_write_csr_read;                     // mm_interconnect_0:dispatcher_write_CSR_read -> dispatcher_write:csr_read
	wire    [3:0] mm_interconnect_0_dispatcher_write_csr_byteenable;               // mm_interconnect_0:dispatcher_write_CSR_byteenable -> dispatcher_write:csr_byteenable
	wire          mm_interconnect_0_dispatcher_write_csr_write;                    // mm_interconnect_0:dispatcher_write_CSR_write -> dispatcher_write:csr_write
	wire   [31:0] mm_interconnect_0_dispatcher_write_csr_writedata;                // mm_interconnect_0:dispatcher_write_CSR_writedata -> dispatcher_write:csr_writedata
	wire          mm_interconnect_0_dispatcher_read_descriptor_slave_waitrequest;  // dispatcher_read:descriptor_waitrequest -> mm_interconnect_0:dispatcher_read_Descriptor_Slave_waitrequest
	wire   [15:0] mm_interconnect_0_dispatcher_read_descriptor_slave_byteenable;   // mm_interconnect_0:dispatcher_read_Descriptor_Slave_byteenable -> dispatcher_read:descriptor_byteenable
	wire          mm_interconnect_0_dispatcher_read_descriptor_slave_write;        // mm_interconnect_0:dispatcher_read_Descriptor_Slave_write -> dispatcher_read:descriptor_write
	wire  [127:0] mm_interconnect_0_dispatcher_read_descriptor_slave_writedata;    // mm_interconnect_0:dispatcher_read_Descriptor_Slave_writedata -> dispatcher_read:descriptor_writedata
	wire          mm_interconnect_0_dispatcher_write_descriptor_slave_waitrequest; // dispatcher_write:descriptor_waitrequest -> mm_interconnect_0:dispatcher_write_Descriptor_Slave_waitrequest
	wire   [15:0] mm_interconnect_0_dispatcher_write_descriptor_slave_byteenable;  // mm_interconnect_0:dispatcher_write_Descriptor_Slave_byteenable -> dispatcher_write:descriptor_byteenable
	wire          mm_interconnect_0_dispatcher_write_descriptor_slave_write;       // mm_interconnect_0:dispatcher_write_Descriptor_Slave_write -> dispatcher_write:descriptor_write
	wire  [127:0] mm_interconnect_0_dispatcher_write_descriptor_slave_writedata;   // mm_interconnect_0:dispatcher_write_Descriptor_Slave_writedata -> dispatcher_write:descriptor_writedata
	wire   [31:0] mm_interconnect_0_freq_counter_0_csr_readdata;                   // freq_counter_0:csr_readdata -> mm_interconnect_0:freq_counter_0_csr_readdata
	wire          mm_interconnect_0_freq_counter_0_csr_waitrequest;                // freq_counter_0:csr_waitrequest -> mm_interconnect_0:freq_counter_0_csr_waitrequest
	wire    [3:0] mm_interconnect_0_freq_counter_0_csr_address;                    // mm_interconnect_0:freq_counter_0_csr_address -> freq_counter_0:csr_address
	wire          mm_interconnect_0_freq_counter_0_csr_read;                       // mm_interconnect_0:freq_counter_0_csr_read -> freq_counter_0:csr_read
	wire   [31:0] mm_interconnect_0_prbs_pattern_checker_csr_readdata;             // prbs_pattern_checker:csr_readdata -> mm_interconnect_0:prbs_pattern_checker_csr_readdata
	wire    [3:0] mm_interconnect_0_prbs_pattern_checker_csr_address;              // mm_interconnect_0:prbs_pattern_checker_csr_address -> prbs_pattern_checker:csr_address
	wire          mm_interconnect_0_prbs_pattern_checker_csr_read;                 // mm_interconnect_0:prbs_pattern_checker_csr_read -> prbs_pattern_checker:csr_read
	wire    [3:0] mm_interconnect_0_prbs_pattern_checker_csr_byteenable;           // mm_interconnect_0:prbs_pattern_checker_csr_byteenable -> prbs_pattern_checker:csr_byteenable
	wire          mm_interconnect_0_prbs_pattern_checker_csr_write;                // mm_interconnect_0:prbs_pattern_checker_csr_write -> prbs_pattern_checker:csr_write
	wire   [31:0] mm_interconnect_0_prbs_pattern_checker_csr_writedata;            // mm_interconnect_0:prbs_pattern_checker_csr_writedata -> prbs_pattern_checker:csr_writedata
	wire   [31:0] mm_interconnect_0_prbs_pattern_generator_csr_readdata;           // prbs_pattern_generator:csr_readdata -> mm_interconnect_0:prbs_pattern_generator_csr_readdata
	wire    [2:0] mm_interconnect_0_prbs_pattern_generator_csr_address;            // mm_interconnect_0:prbs_pattern_generator_csr_address -> prbs_pattern_generator:csr_address
	wire          mm_interconnect_0_prbs_pattern_generator_csr_read;               // mm_interconnect_0:prbs_pattern_generator_csr_read -> prbs_pattern_generator:csr_read
	wire    [3:0] mm_interconnect_0_prbs_pattern_generator_csr_byteenable;         // mm_interconnect_0:prbs_pattern_generator_csr_byteenable -> prbs_pattern_generator:csr_byteenable
	wire          mm_interconnect_0_prbs_pattern_generator_csr_write;              // mm_interconnect_0:prbs_pattern_generator_csr_write -> prbs_pattern_generator:csr_write
	wire   [31:0] mm_interconnect_0_prbs_pattern_generator_csr_writedata;          // mm_interconnect_0:prbs_pattern_generator_csr_writedata -> prbs_pattern_generator:csr_writedata
	wire          mm_interconnect_0_timer_0_s1_chipselect;                         // mm_interconnect_0:timer_0_s1_chipselect -> timer_0:chipselect
	wire   [15:0] mm_interconnect_0_timer_0_s1_readdata;                           // timer_0:readdata -> mm_interconnect_0:timer_0_s1_readdata
	wire    [2:0] mm_interconnect_0_timer_0_s1_address;                            // mm_interconnect_0:timer_0_s1_address -> timer_0:address
	wire          mm_interconnect_0_timer_0_s1_write;                              // mm_interconnect_0:timer_0_s1_write -> timer_0:write_n
	wire   [15:0] mm_interconnect_0_timer_0_s1_writedata;                          // mm_interconnect_0:timer_0_s1_writedata -> timer_0:writedata
	wire          mm_interconnect_0_status_mon_0_slv_chipselect;                   // mm_interconnect_0:status_mon_0_slv_chipselect -> status_mon_0:slv_cs_n
	wire   [31:0] mm_interconnect_0_status_mon_0_slv_readdata;                     // status_mon_0:slv_data_read -> mm_interconnect_0:status_mon_0_slv_readdata
	wire    [1:0] mm_interconnect_0_status_mon_0_slv_address;                      // mm_interconnect_0:status_mon_0_slv_address -> status_mon_0:slv_address
	wire          mm_interconnect_0_status_mon_0_slv_read;                         // mm_interconnect_0:status_mon_0_slv_read -> status_mon_0:slv_read_n
	wire          mm_interconnect_0_status_mon_0_slv_write;                        // mm_interconnect_0:status_mon_0_slv_write -> status_mon_0:slv_write_n
	wire   [31:0] mm_interconnect_0_status_mon_0_slv_writedata;                    // mm_interconnect_0:status_mon_0_slv_writedata -> status_mon_0:slv_data_write
	wire          rst_controller_reset_out_reset;                                  // rst_controller:reset_out -> [dispatcher_read:reset, dispatcher_write:reset, dma_read_master:reset, dma_write_master:reset]
	wire          clk_clk_reset_reset;                                             // clk:reset_n_out -> [rst_controller:reset_in0, rst_controller_002:reset_in0, rst_controller_003:reset_in0]
	wire          rst_controller_001_reset_out_reset;                              // rst_controller_001:reset_out -> [freq_counter_0:reset_n, mm_interconnect_0:freq_counter_0_reset_reset_bridge_in_reset_reset]
	wire          clk_0_clk_reset_reset;                                           // clk_0:reset_n_out -> rst_controller_001:reset_in0
	wire          rst_controller_002_reset_out_reset;                              // rst_controller_002:reset_out -> [mm_bridge_slv:reset, mm_interconnect_0:dispatcher_read_clock_reset_reset_bridge_in_reset_reset, mm_interconnect_0:mm_bridge_slv_reset_reset_bridge_in_reset_reset, prbs_pattern_checker:reset, prbs_pattern_generator:reset, status_mon_0:slv_reset_n, timing_adapter:reset_n]
	wire          rst_controller_003_reset_out_reset;                              // rst_controller_003:reset_out -> [mm_interconnect_0:timer_0_reset_reset_bridge_in_reset_reset, timer_0:reset_n]

	mSGDMA_clk clk (
		.clk_out     (clk_clk_clk),         //  output,  width = 1,          clk.clk
		.in_clk      (clk_clk),             //   input,  width = 1,       clk_in.clk
		.reset_n     (reset_reset_n),       //   input,  width = 1, clk_in_reset.reset_n
		.reset_n_out (clk_clk_reset_reset)  //  output,  width = 1,    clk_reset.reset_n
	);

	mSGDMA_clk_0 clk_0 (
		.clk_out     (clk_0_clk_clk),         //  output,  width = 1,          clk.clk
		.in_clk      (clk_0_clk),             //   input,  width = 1,       clk_in.clk
		.reset_n     (reset_0_reset_n),       //   input,  width = 1, clk_in_reset.reset_n
		.reset_n_out (clk_0_clk_reset_reset)  //  output,  width = 1,    clk_reset.reset_n
	);

	mSGDMA_dispatcher_read dispatcher_read (
		.csr_writedata          (mm_interconnect_0_dispatcher_read_csr_writedata),                //   input,   width = 32,                 CSR.writedata
		.csr_write              (mm_interconnect_0_dispatcher_read_csr_write),                    //   input,    width = 1,                    .write
		.csr_byteenable         (mm_interconnect_0_dispatcher_read_csr_byteenable),               //   input,    width = 4,                    .byteenable
		.csr_readdata           (mm_interconnect_0_dispatcher_read_csr_readdata),                 //  output,   width = 32,                    .readdata
		.csr_read               (mm_interconnect_0_dispatcher_read_csr_read),                     //   input,    width = 1,                    .read
		.csr_address            (mm_interconnect_0_dispatcher_read_csr_address),                  //   input,    width = 3,                    .address
		.descriptor_write       (mm_interconnect_0_dispatcher_read_descriptor_slave_write),       //   input,    width = 1,    Descriptor_Slave.write
		.descriptor_waitrequest (mm_interconnect_0_dispatcher_read_descriptor_slave_waitrequest), //  output,    width = 1,                    .waitrequest
		.descriptor_writedata   (mm_interconnect_0_dispatcher_read_descriptor_slave_writedata),   //   input,  width = 128,                    .writedata
		.descriptor_byteenable  (mm_interconnect_0_dispatcher_read_descriptor_slave_byteenable),  //   input,   width = 16,                    .byteenable
		.src_read_master_data   (dispatcher_read_read_command_source_data),                       //  output,  width = 256, Read_Command_Source.data
		.src_read_master_valid  (dispatcher_read_read_command_source_valid),                      //  output,    width = 1,                    .valid
		.src_read_master_ready  (dispatcher_read_read_command_source_ready),                      //   input,    width = 1,                    .ready
		.snk_read_master_data   (dma_read_master_response_source_data),                           //   input,  width = 256,  Read_Response_Sink.data
		.snk_read_master_valid  (dma_read_master_response_source_valid),                          //   input,    width = 1,                    .valid
		.snk_read_master_ready  (dma_read_master_response_source_ready),                          //  output,    width = 1,                    .ready
		.clk                    (clk_clk_clk),                                                    //   input,    width = 1,               clock.clk
		.reset                  (rst_controller_reset_out_reset),                                 //   input,    width = 1,         clock_reset.reset
		.csr_irq                (dispatcher_read_csr_irq_irq)                                     //  output,    width = 1,             csr_irq.irq
	);

	mSGDMA_dispatcher_write dispatcher_write (
		.csr_writedata          (mm_interconnect_0_dispatcher_write_csr_writedata),                //   input,   width = 32,                  CSR.writedata
		.csr_write              (mm_interconnect_0_dispatcher_write_csr_write),                    //   input,    width = 1,                     .write
		.csr_byteenable         (mm_interconnect_0_dispatcher_write_csr_byteenable),               //   input,    width = 4,                     .byteenable
		.csr_readdata           (mm_interconnect_0_dispatcher_write_csr_readdata),                 //  output,   width = 32,                     .readdata
		.csr_read               (mm_interconnect_0_dispatcher_write_csr_read),                     //   input,    width = 1,                     .read
		.csr_address            (mm_interconnect_0_dispatcher_write_csr_address),                  //   input,    width = 3,                     .address
		.descriptor_write       (mm_interconnect_0_dispatcher_write_descriptor_slave_write),       //   input,    width = 1,     Descriptor_Slave.write
		.descriptor_waitrequest (mm_interconnect_0_dispatcher_write_descriptor_slave_waitrequest), //  output,    width = 1,                     .waitrequest
		.descriptor_writedata   (mm_interconnect_0_dispatcher_write_descriptor_slave_writedata),   //   input,  width = 128,                     .writedata
		.descriptor_byteenable  (mm_interconnect_0_dispatcher_write_descriptor_slave_byteenable),  //   input,   width = 16,                     .byteenable
		.src_write_master_data  (dispatcher_write_write_command_source_data),                      //  output,  width = 256, Write_Command_Source.data
		.src_write_master_valid (dispatcher_write_write_command_source_valid),                     //  output,    width = 1,                     .valid
		.src_write_master_ready (dispatcher_write_write_command_source_ready),                     //   input,    width = 1,                     .ready
		.snk_write_master_data  (dma_write_master_response_source_data),                           //   input,  width = 256,  Write_Response_Sink.data
		.snk_write_master_valid (dma_write_master_response_source_valid),                          //   input,    width = 1,                     .valid
		.snk_write_master_ready (dma_write_master_response_source_ready),                          //  output,    width = 1,                     .ready
		.clk                    (clk_clk_clk),                                                     //   input,    width = 1,                clock.clk
		.reset                  (rst_controller_reset_out_reset),                                  //   input,    width = 1,          clock_reset.reset
		.csr_irq                (dispatcher_write_csr_irq_irq)                                     //  output,    width = 1,              csr_irq.irq
	);

	mSGDMA_dma_read_master dma_read_master (
		.clk                  (clk_clk_clk),                               //   input,    width = 1,            Clock.clk
		.reset                (rst_controller_reset_out_reset),            //   input,    width = 1,      Clock_reset.reset
		.snk_command_data     (dispatcher_read_read_command_source_data),  //   input,  width = 256,     Command_Sink.data
		.snk_command_valid    (dispatcher_read_read_command_source_valid), //   input,    width = 1,                 .valid
		.snk_command_ready    (dispatcher_read_read_command_source_ready), //  output,    width = 1,                 .ready
		.master_address       (dma_read_master_address),                   //  output,   width = 32, Data_Read_Master.address
		.master_read          (dma_read_master_read),                      //  output,    width = 1,                 .read
		.master_byteenable    (dma_read_master_byteenable),                //  output,   width = 64,                 .byteenable
		.master_readdata      (dma_read_master_readdata),                  //   input,  width = 512,                 .readdata
		.master_waitrequest   (dma_read_master_waitrequest),               //   input,    width = 1,                 .waitrequest
		.master_readdatavalid (dma_read_master_readdatavalid),             //   input,    width = 1,                 .readdatavalid
		.master_burstcount    (dma_read_master_burstcount),                //  output,    width = 6,                 .burstcount
		.src_data             (dma_read_master_data_source_data),          //  output,  width = 512,      Data_Source.data
		.src_valid            (dma_read_master_data_source_valid),         //  output,    width = 1,                 .valid
		.src_ready            (dma_read_master_data_source_ready),         //   input,    width = 1,                 .ready
		.src_response_data    (dma_read_master_response_source_data),      //  output,  width = 256,  Response_Source.data
		.src_response_valid   (dma_read_master_response_source_valid),     //  output,    width = 1,                 .valid
		.src_response_ready   (dma_read_master_response_source_ready)      //   input,    width = 1,                 .ready
	);

	mSGDMA_dma_write_master dma_write_master (
		.clk                (clk_clk_clk),                                 //   input,    width = 1,             Clock.clk
		.reset              (rst_controller_reset_out_reset),              //   input,    width = 1,       Clock_reset.reset
		.snk_command_data   (dispatcher_write_write_command_source_data),  //   input,  width = 256,      Command_Sink.data
		.snk_command_valid  (dispatcher_write_write_command_source_valid), //   input,    width = 1,                  .valid
		.snk_command_ready  (dispatcher_write_write_command_source_ready), //  output,    width = 1,                  .ready
		.snk_data           (timing_adapter_out_data),                     //   input,  width = 512,         Data_Sink.data
		.snk_valid          (timing_adapter_out_valid),                    //   input,    width = 1,                  .valid
		.snk_ready          (timing_adapter_out_ready),                    //  output,    width = 1,                  .ready
		.master_address     (dma_write_master_address),                    //  output,   width = 32, Data_Write_Master.address
		.master_write       (dma_write_master_write),                      //  output,    width = 1,                  .write
		.master_byteenable  (dma_write_master_byteenable),                 //  output,   width = 64,                  .byteenable
		.master_writedata   (dma_write_master_writedata),                  //  output,  width = 512,                  .writedata
		.master_waitrequest (dma_write_master_waitrequest),                //   input,    width = 1,                  .waitrequest
		.master_burstcount  (dma_write_master_burstcount),                 //  output,    width = 6,                  .burstcount
		.src_response_data  (dma_write_master_response_source_data),       //  output,  width = 256,   Response_Source.data
		.src_response_valid (dma_write_master_response_source_valid),      //  output,    width = 1,                  .valid
		.src_response_ready (dma_write_master_response_source_ready)       //   input,    width = 1,                  .ready
	);

	mSGDMA_freq_counter_1 freq_counter_0 (
		.clk             (clk_0_clk_clk),                                    //   input,   width = 1,        clock.clk
		.csr_address     (mm_interconnect_0_freq_counter_0_csr_address),     //   input,   width = 4,          csr.address
		.csr_read        (mm_interconnect_0_freq_counter_0_csr_read),        //   input,   width = 1,             .read
		.csr_readdata    (mm_interconnect_0_freq_counter_0_csr_readdata),    //  output,  width = 32,             .readdata
		.csr_waitrequest (mm_interconnect_0_freq_counter_0_csr_waitrequest), //  output,   width = 1,             .waitrequest
		.reset_n         (~rst_controller_001_reset_out_reset),              //   input,   width = 1,        reset.reset_n
		.sample_clk      (clk_clk_clk)                                       //   input,   width = 1, sample_clock.clk
	);

	mSGDMA_mm_bridge_slv mm_bridge_slv (
		.clk              (clk_clk_clk),                        //   input,   width = 1,   clk.clk
		.m0_waitrequest   (mm_bridge_slv_m0_waitrequest),       //   input,   width = 1,    m0.waitrequest
		.m0_readdata      (mm_bridge_slv_m0_readdata),          //   input,  width = 32,      .readdata
		.m0_readdatavalid (mm_bridge_slv_m0_readdatavalid),     //   input,   width = 1,      .readdatavalid
		.m0_burstcount    (mm_bridge_slv_m0_burstcount),        //  output,   width = 7,      .burstcount
		.m0_writedata     (mm_bridge_slv_m0_writedata),         //  output,  width = 32,      .writedata
		.m0_address       (mm_bridge_slv_m0_address),           //  output,  width = 20,      .address
		.m0_write         (mm_bridge_slv_m0_write),             //  output,   width = 1,      .write
		.m0_read          (mm_bridge_slv_m0_read),              //  output,   width = 1,      .read
		.m0_byteenable    (mm_bridge_slv_m0_byteenable),        //  output,   width = 4,      .byteenable
		.m0_debugaccess   (mm_bridge_slv_m0_debugaccess),       //  output,   width = 1,      .debugaccess
		.reset            (rst_controller_002_reset_out_reset), //   input,   width = 1, reset.reset
		.s0_waitrequest   (mm_bridge_slv_waitrequest),          //  output,   width = 1,    s0.waitrequest
		.s0_readdata      (mm_bridge_slv_readdata),             //  output,  width = 32,      .readdata
		.s0_readdatavalid (mm_bridge_slv_readdatavalid),        //  output,   width = 1,      .readdatavalid
		.s0_burstcount    (mm_bridge_slv_burstcount),           //   input,   width = 7,      .burstcount
		.s0_writedata     (mm_bridge_slv_writedata),            //   input,  width = 32,      .writedata
		.s0_address       (mm_bridge_slv_address),              //   input,  width = 20,      .address
		.s0_write         (mm_bridge_slv_write),                //   input,   width = 1,      .write
		.s0_read          (mm_bridge_slv_read),                 //   input,   width = 1,      .read
		.s0_byteenable    (mm_bridge_slv_byteenable),           //   input,   width = 4,      .byteenable
		.s0_debugaccess   (mm_bridge_slv_debugaccess)           //   input,   width = 1,      .debugaccess
	);

	mSGDMA_prbs_pattern_checker_0 prbs_pattern_checker (
		.clk            (clk_clk_clk),                                           //   input,    width = 1,            clock.clk
		.csr_address    (mm_interconnect_0_prbs_pattern_checker_csr_address),    //   input,    width = 4,              csr.address
		.csr_writedata  (mm_interconnect_0_prbs_pattern_checker_csr_writedata),  //   input,   width = 32,                 .writedata
		.csr_write      (mm_interconnect_0_prbs_pattern_checker_csr_write),      //   input,    width = 1,                 .write
		.csr_readdata   (mm_interconnect_0_prbs_pattern_checker_csr_readdata),   //  output,   width = 32,                 .readdata
		.csr_read       (mm_interconnect_0_prbs_pattern_checker_csr_read),       //   input,    width = 1,                 .read
		.csr_byteenable (mm_interconnect_0_prbs_pattern_checker_csr_byteenable), //   input,    width = 4,                 .byteenable
		.reset          (rst_controller_002_reset_out_reset),                    //   input,    width = 1,            reset.reset
		.snk_data       (dma_read_master_data_source_data),                      //   input,  width = 512, st_pattern_input.data
		.snk_valid      (dma_read_master_data_source_valid),                     //   input,    width = 1,                 .valid
		.snk_ready      (dma_read_master_data_source_ready)                      //  output,    width = 1,                 .ready
	);

	mSGDMA_prbs_pattern_generator_0 prbs_pattern_generator (
		.clk            (clk_clk_clk),                                             //   input,    width = 1,             clock.clk
		.csr_address    (mm_interconnect_0_prbs_pattern_generator_csr_address),    //   input,    width = 3,               csr.address
		.csr_writedata  (mm_interconnect_0_prbs_pattern_generator_csr_writedata),  //   input,   width = 32,                  .writedata
		.csr_write      (mm_interconnect_0_prbs_pattern_generator_csr_write),      //   input,    width = 1,                  .write
		.csr_readdata   (mm_interconnect_0_prbs_pattern_generator_csr_readdata),   //  output,   width = 32,                  .readdata
		.csr_read       (mm_interconnect_0_prbs_pattern_generator_csr_read),       //   input,    width = 1,                  .read
		.csr_byteenable (mm_interconnect_0_prbs_pattern_generator_csr_byteenable), //   input,    width = 4,                  .byteenable
		.reset          (rst_controller_002_reset_out_reset),                      //   input,    width = 1,             reset.reset
		.src_data       (prbs_pattern_generator_st_pattern_output_data),           //  output,  width = 512, st_pattern_output.data
		.src_valid      (prbs_pattern_generator_st_pattern_output_valid),          //  output,    width = 1,                  .valid
		.src_ready      (prbs_pattern_generator_st_pattern_output_ready)           //   input,    width = 1,                  .ready
	);

	mSGDMA_status_mon_1 status_mon_0 (
		.cal_fail_mon      (cal_fail_mon_export),                            //  output,   width = 1,    cal_fail_mon.export
		.cal_success_mon   (cal_success_mon_export),                         //  output,   width = 1, cal_success_mon.export
		.slv_clk           (clk_clk_clk),                                    //   input,   width = 1,           clock.clk
		.slv_reset_n       (~rst_controller_002_reset_out_reset),            //   input,   width = 1,         reset_n.reset_n
		.reset_out_n       (eset_source_reset_n),                            //  output,   width = 1,    reset_source.reset_n
		.slv_read_n        (~mm_interconnect_0_status_mon_0_slv_read),       //   input,   width = 1,             slv.read_n
		.slv_write_n       (~mm_interconnect_0_status_mon_0_slv_write),      //   input,   width = 1,                .write_n
		.slv_address       (mm_interconnect_0_status_mon_0_slv_address),     //   input,   width = 2,                .address
		.slv_cs_n          (~mm_interconnect_0_status_mon_0_slv_chipselect), //   input,   width = 1,                .chipselect_n
		.slv_data_write    (mm_interconnect_0_status_mon_0_slv_writedata),   //   input,  width = 32,                .writedata
		.slv_data_read     (mm_interconnect_0_status_mon_0_slv_readdata),    //  output,  width = 32,                .readdata
		.local_cal_success (status_mon_in_local_cal_success),                //   input,   width = 1,          status.local_cal_success
		.local_cal_fail    (status_mon_in_local_cal_fail)                    //   input,   width = 1,                .local_cal_fail
	);

	mSGDMA_timer_0 timer_0 (
		.clk        (clk_0_clk_clk),                           //   input,   width = 1,   clk.clk
		.irq        (),                                        //  output,   width = 1,   irq.irq
		.reset_n    (~rst_controller_003_reset_out_reset),     //   input,   width = 1, reset.reset_n
		.address    (mm_interconnect_0_timer_0_s1_address),    //   input,   width = 3,    s1.address
		.writedata  (mm_interconnect_0_timer_0_s1_writedata),  //   input,  width = 16,      .writedata
		.readdata   (mm_interconnect_0_timer_0_s1_readdata),   //  output,  width = 16,      .readdata
		.chipselect (mm_interconnect_0_timer_0_s1_chipselect), //   input,   width = 1,      .chipselect
		.write_n    (~mm_interconnect_0_timer_0_s1_write)      //   input,   width = 1,      .write_n
	);

	mSGDMA_timing_adapter timing_adapter (
		.clk       (clk_clk_clk),                                    //   input,    width = 1,   clk.clk
		.in_data   (prbs_pattern_generator_st_pattern_output_data),  //   input,  width = 512,    in.data
		.in_valid  (prbs_pattern_generator_st_pattern_output_valid), //   input,    width = 1,      .valid
		.in_ready  (prbs_pattern_generator_st_pattern_output_ready), //  output,    width = 1,      .ready
		.out_data  (timing_adapter_out_data),                        //  output,  width = 512,   out.data
		.out_valid (timing_adapter_out_valid),                       //  output,    width = 1,      .valid
		.out_ready (timing_adapter_out_ready),                       //   input,    width = 1,      .ready
		.reset_n   (~rst_controller_002_reset_out_reset)             //   input,    width = 1, reset.reset_n
	);

	mSGDMA_altera_mm_interconnect_171_osvx36y mm_interconnect_0 (
		.clk_0_clk_clk                                           (clk_0_clk_clk),                                                   //   input,    width = 1,                                         clk_0_clk.clk
		.clk_clk_clk                                             (clk_clk_clk),                                                     //   input,    width = 1,                                           clk_clk.clk
		.dispatcher_read_CSR_address                             (mm_interconnect_0_dispatcher_read_csr_address),                   //  output,    width = 3,                               dispatcher_read_CSR.address
		.dispatcher_read_CSR_write                               (mm_interconnect_0_dispatcher_read_csr_write),                     //  output,    width = 1,                                                  .write
		.dispatcher_read_CSR_read                                (mm_interconnect_0_dispatcher_read_csr_read),                      //  output,    width = 1,                                                  .read
		.dispatcher_read_CSR_readdata                            (mm_interconnect_0_dispatcher_read_csr_readdata),                  //   input,   width = 32,                                                  .readdata
		.dispatcher_read_CSR_writedata                           (mm_interconnect_0_dispatcher_read_csr_writedata),                 //  output,   width = 32,                                                  .writedata
		.dispatcher_read_CSR_byteenable                          (mm_interconnect_0_dispatcher_read_csr_byteenable),                //  output,    width = 4,                                                  .byteenable
		.dispatcher_read_Descriptor_Slave_write                  (mm_interconnect_0_dispatcher_read_descriptor_slave_write),        //  output,    width = 1,                  dispatcher_read_Descriptor_Slave.write
		.dispatcher_read_Descriptor_Slave_writedata              (mm_interconnect_0_dispatcher_read_descriptor_slave_writedata),    //  output,  width = 128,                                                  .writedata
		.dispatcher_read_Descriptor_Slave_byteenable             (mm_interconnect_0_dispatcher_read_descriptor_slave_byteenable),   //  output,   width = 16,                                                  .byteenable
		.dispatcher_read_Descriptor_Slave_waitrequest            (mm_interconnect_0_dispatcher_read_descriptor_slave_waitrequest),  //   input,    width = 1,                                                  .waitrequest
		.dispatcher_read_clock_reset_reset_bridge_in_reset_reset (rst_controller_002_reset_out_reset),                              //   input,    width = 1, dispatcher_read_clock_reset_reset_bridge_in_reset.reset
		.dispatcher_write_CSR_address                            (mm_interconnect_0_dispatcher_write_csr_address),                  //  output,    width = 3,                              dispatcher_write_CSR.address
		.dispatcher_write_CSR_write                              (mm_interconnect_0_dispatcher_write_csr_write),                    //  output,    width = 1,                                                  .write
		.dispatcher_write_CSR_read                               (mm_interconnect_0_dispatcher_write_csr_read),                     //  output,    width = 1,                                                  .read
		.dispatcher_write_CSR_readdata                           (mm_interconnect_0_dispatcher_write_csr_readdata),                 //   input,   width = 32,                                                  .readdata
		.dispatcher_write_CSR_writedata                          (mm_interconnect_0_dispatcher_write_csr_writedata),                //  output,   width = 32,                                                  .writedata
		.dispatcher_write_CSR_byteenable                         (mm_interconnect_0_dispatcher_write_csr_byteenable),               //  output,    width = 4,                                                  .byteenable
		.dispatcher_write_Descriptor_Slave_write                 (mm_interconnect_0_dispatcher_write_descriptor_slave_write),       //  output,    width = 1,                 dispatcher_write_Descriptor_Slave.write
		.dispatcher_write_Descriptor_Slave_writedata             (mm_interconnect_0_dispatcher_write_descriptor_slave_writedata),   //  output,  width = 128,                                                  .writedata
		.dispatcher_write_Descriptor_Slave_byteenable            (mm_interconnect_0_dispatcher_write_descriptor_slave_byteenable),  //  output,   width = 16,                                                  .byteenable
		.dispatcher_write_Descriptor_Slave_waitrequest           (mm_interconnect_0_dispatcher_write_descriptor_slave_waitrequest), //   input,    width = 1,                                                  .waitrequest
		.freq_counter_0_csr_address                              (mm_interconnect_0_freq_counter_0_csr_address),                    //  output,    width = 4,                                freq_counter_0_csr.address
		.freq_counter_0_csr_read                                 (mm_interconnect_0_freq_counter_0_csr_read),                       //  output,    width = 1,                                                  .read
		.freq_counter_0_csr_readdata                             (mm_interconnect_0_freq_counter_0_csr_readdata),                   //   input,   width = 32,                                                  .readdata
		.freq_counter_0_csr_waitrequest                          (mm_interconnect_0_freq_counter_0_csr_waitrequest),                //   input,    width = 1,                                                  .waitrequest
		.freq_counter_0_reset_reset_bridge_in_reset_reset        (rst_controller_001_reset_out_reset),                              //   input,    width = 1,        freq_counter_0_reset_reset_bridge_in_reset.reset
		.mm_bridge_slv_m0_address                                (mm_bridge_slv_m0_address),                                        //   input,   width = 20,                                  mm_bridge_slv_m0.address
		.mm_bridge_slv_m0_waitrequest                            (mm_bridge_slv_m0_waitrequest),                                    //  output,    width = 1,                                                  .waitrequest
		.mm_bridge_slv_m0_burstcount                             (mm_bridge_slv_m0_burstcount),                                     //   input,    width = 7,                                                  .burstcount
		.mm_bridge_slv_m0_byteenable                             (mm_bridge_slv_m0_byteenable),                                     //   input,    width = 4,                                                  .byteenable
		.mm_bridge_slv_m0_read                                   (mm_bridge_slv_m0_read),                                           //   input,    width = 1,                                                  .read
		.mm_bridge_slv_m0_readdata                               (mm_bridge_slv_m0_readdata),                                       //  output,   width = 32,                                                  .readdata
		.mm_bridge_slv_m0_readdatavalid                          (mm_bridge_slv_m0_readdatavalid),                                  //  output,    width = 1,                                                  .readdatavalid
		.mm_bridge_slv_m0_write                                  (mm_bridge_slv_m0_write),                                          //   input,    width = 1,                                                  .write
		.mm_bridge_slv_m0_writedata                              (mm_bridge_slv_m0_writedata),                                      //   input,   width = 32,                                                  .writedata
		.mm_bridge_slv_m0_debugaccess                            (mm_bridge_slv_m0_debugaccess),                                    //   input,    width = 1,                                                  .debugaccess
		.mm_bridge_slv_reset_reset_bridge_in_reset_reset         (rst_controller_002_reset_out_reset),                              //   input,    width = 1,         mm_bridge_slv_reset_reset_bridge_in_reset.reset
		.prbs_pattern_checker_csr_address                        (mm_interconnect_0_prbs_pattern_checker_csr_address),              //  output,    width = 4,                          prbs_pattern_checker_csr.address
		.prbs_pattern_checker_csr_write                          (mm_interconnect_0_prbs_pattern_checker_csr_write),                //  output,    width = 1,                                                  .write
		.prbs_pattern_checker_csr_read                           (mm_interconnect_0_prbs_pattern_checker_csr_read),                 //  output,    width = 1,                                                  .read
		.prbs_pattern_checker_csr_readdata                       (mm_interconnect_0_prbs_pattern_checker_csr_readdata),             //   input,   width = 32,                                                  .readdata
		.prbs_pattern_checker_csr_writedata                      (mm_interconnect_0_prbs_pattern_checker_csr_writedata),            //  output,   width = 32,                                                  .writedata
		.prbs_pattern_checker_csr_byteenable                     (mm_interconnect_0_prbs_pattern_checker_csr_byteenable),           //  output,    width = 4,                                                  .byteenable
		.prbs_pattern_generator_csr_address                      (mm_interconnect_0_prbs_pattern_generator_csr_address),            //  output,    width = 3,                        prbs_pattern_generator_csr.address
		.prbs_pattern_generator_csr_write                        (mm_interconnect_0_prbs_pattern_generator_csr_write),              //  output,    width = 1,                                                  .write
		.prbs_pattern_generator_csr_read                         (mm_interconnect_0_prbs_pattern_generator_csr_read),               //  output,    width = 1,                                                  .read
		.prbs_pattern_generator_csr_readdata                     (mm_interconnect_0_prbs_pattern_generator_csr_readdata),           //   input,   width = 32,                                                  .readdata
		.prbs_pattern_generator_csr_writedata                    (mm_interconnect_0_prbs_pattern_generator_csr_writedata),          //  output,   width = 32,                                                  .writedata
		.prbs_pattern_generator_csr_byteenable                   (mm_interconnect_0_prbs_pattern_generator_csr_byteenable),         //  output,    width = 4,                                                  .byteenable
		.status_mon_0_slv_address                                (mm_interconnect_0_status_mon_0_slv_address),                      //  output,    width = 2,                                  status_mon_0_slv.address
		.status_mon_0_slv_write                                  (mm_interconnect_0_status_mon_0_slv_write),                        //  output,    width = 1,                                                  .write
		.status_mon_0_slv_read                                   (mm_interconnect_0_status_mon_0_slv_read),                         //  output,    width = 1,                                                  .read
		.status_mon_0_slv_readdata                               (mm_interconnect_0_status_mon_0_slv_readdata),                     //   input,   width = 32,                                                  .readdata
		.status_mon_0_slv_writedata                              (mm_interconnect_0_status_mon_0_slv_writedata),                    //  output,   width = 32,                                                  .writedata
		.status_mon_0_slv_chipselect                             (mm_interconnect_0_status_mon_0_slv_chipselect),                   //  output,    width = 1,                                                  .chipselect
		.timer_0_reset_reset_bridge_in_reset_reset               (rst_controller_003_reset_out_reset),                              //   input,    width = 1,               timer_0_reset_reset_bridge_in_reset.reset
		.timer_0_s1_address                                      (mm_interconnect_0_timer_0_s1_address),                            //  output,    width = 3,                                        timer_0_s1.address
		.timer_0_s1_write                                        (mm_interconnect_0_timer_0_s1_write),                              //  output,    width = 1,                                                  .write
		.timer_0_s1_readdata                                     (mm_interconnect_0_timer_0_s1_readdata),                           //   input,   width = 16,                                                  .readdata
		.timer_0_s1_writedata                                    (mm_interconnect_0_timer_0_s1_writedata),                          //  output,   width = 16,                                                  .writedata
		.timer_0_s1_chipselect                                   (mm_interconnect_0_timer_0_s1_chipselect)                          //  output,    width = 1,                                                  .chipselect
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("both"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller (
		.reset_in0      (~clk_clk_reset_reset),           //   input,  width = 1, reset_in0.reset
		.clk            (clk_clk_clk),                    //   input,  width = 1,       clk.clk
		.reset_out      (rst_controller_reset_out_reset), //  output,  width = 1, reset_out.reset
		.reset_req      (),                               // (terminated),                       
		.reset_req_in0  (1'b0),                           // (terminated),                       
		.reset_in1      (1'b0),                           // (terminated),                       
		.reset_req_in1  (1'b0),                           // (terminated),                       
		.reset_in2      (1'b0),                           // (terminated),                       
		.reset_req_in2  (1'b0),                           // (terminated),                       
		.reset_in3      (1'b0),                           // (terminated),                       
		.reset_req_in3  (1'b0),                           // (terminated),                       
		.reset_in4      (1'b0),                           // (terminated),                       
		.reset_req_in4  (1'b0),                           // (terminated),                       
		.reset_in5      (1'b0),                           // (terminated),                       
		.reset_req_in5  (1'b0),                           // (terminated),                       
		.reset_in6      (1'b0),                           // (terminated),                       
		.reset_req_in6  (1'b0),                           // (terminated),                       
		.reset_in7      (1'b0),                           // (terminated),                       
		.reset_req_in7  (1'b0),                           // (terminated),                       
		.reset_in8      (1'b0),                           // (terminated),                       
		.reset_req_in8  (1'b0),                           // (terminated),                       
		.reset_in9      (1'b0),                           // (terminated),                       
		.reset_req_in9  (1'b0),                           // (terminated),                       
		.reset_in10     (1'b0),                           // (terminated),                       
		.reset_req_in10 (1'b0),                           // (terminated),                       
		.reset_in11     (1'b0),                           // (terminated),                       
		.reset_req_in11 (1'b0),                           // (terminated),                       
		.reset_in12     (1'b0),                           // (terminated),                       
		.reset_req_in12 (1'b0),                           // (terminated),                       
		.reset_in13     (1'b0),                           // (terminated),                       
		.reset_req_in13 (1'b0),                           // (terminated),                       
		.reset_in14     (1'b0),                           // (terminated),                       
		.reset_req_in14 (1'b0),                           // (terminated),                       
		.reset_in15     (1'b0),                           // (terminated),                       
		.reset_req_in15 (1'b0)                            // (terminated),                       
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_001 (
		.reset_in0      (~clk_0_clk_reset_reset),             //   input,  width = 1, reset_in0.reset
		.clk            (clk_0_clk_clk),                      //   input,  width = 1,       clk.clk
		.reset_out      (rst_controller_001_reset_out_reset), //  output,  width = 1, reset_out.reset
		.reset_req      (),                                   // (terminated),                       
		.reset_req_in0  (1'b0),                               // (terminated),                       
		.reset_in1      (1'b0),                               // (terminated),                       
		.reset_req_in1  (1'b0),                               // (terminated),                       
		.reset_in2      (1'b0),                               // (terminated),                       
		.reset_req_in2  (1'b0),                               // (terminated),                       
		.reset_in3      (1'b0),                               // (terminated),                       
		.reset_req_in3  (1'b0),                               // (terminated),                       
		.reset_in4      (1'b0),                               // (terminated),                       
		.reset_req_in4  (1'b0),                               // (terminated),                       
		.reset_in5      (1'b0),                               // (terminated),                       
		.reset_req_in5  (1'b0),                               // (terminated),                       
		.reset_in6      (1'b0),                               // (terminated),                       
		.reset_req_in6  (1'b0),                               // (terminated),                       
		.reset_in7      (1'b0),                               // (terminated),                       
		.reset_req_in7  (1'b0),                               // (terminated),                       
		.reset_in8      (1'b0),                               // (terminated),                       
		.reset_req_in8  (1'b0),                               // (terminated),                       
		.reset_in9      (1'b0),                               // (terminated),                       
		.reset_req_in9  (1'b0),                               // (terminated),                       
		.reset_in10     (1'b0),                               // (terminated),                       
		.reset_req_in10 (1'b0),                               // (terminated),                       
		.reset_in11     (1'b0),                               // (terminated),                       
		.reset_req_in11 (1'b0),                               // (terminated),                       
		.reset_in12     (1'b0),                               // (terminated),                       
		.reset_req_in12 (1'b0),                               // (terminated),                       
		.reset_in13     (1'b0),                               // (terminated),                       
		.reset_req_in13 (1'b0),                               // (terminated),                       
		.reset_in14     (1'b0),                               // (terminated),                       
		.reset_req_in14 (1'b0),                               // (terminated),                       
		.reset_in15     (1'b0),                               // (terminated),                       
		.reset_req_in15 (1'b0)                                // (terminated),                       
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_002 (
		.reset_in0      (~clk_clk_reset_reset),               //   input,  width = 1, reset_in0.reset
		.clk            (clk_clk_clk),                        //   input,  width = 1,       clk.clk
		.reset_out      (rst_controller_002_reset_out_reset), //  output,  width = 1, reset_out.reset
		.reset_req      (),                                   // (terminated),                       
		.reset_req_in0  (1'b0),                               // (terminated),                       
		.reset_in1      (1'b0),                               // (terminated),                       
		.reset_req_in1  (1'b0),                               // (terminated),                       
		.reset_in2      (1'b0),                               // (terminated),                       
		.reset_req_in2  (1'b0),                               // (terminated),                       
		.reset_in3      (1'b0),                               // (terminated),                       
		.reset_req_in3  (1'b0),                               // (terminated),                       
		.reset_in4      (1'b0),                               // (terminated),                       
		.reset_req_in4  (1'b0),                               // (terminated),                       
		.reset_in5      (1'b0),                               // (terminated),                       
		.reset_req_in5  (1'b0),                               // (terminated),                       
		.reset_in6      (1'b0),                               // (terminated),                       
		.reset_req_in6  (1'b0),                               // (terminated),                       
		.reset_in7      (1'b0),                               // (terminated),                       
		.reset_req_in7  (1'b0),                               // (terminated),                       
		.reset_in8      (1'b0),                               // (terminated),                       
		.reset_req_in8  (1'b0),                               // (terminated),                       
		.reset_in9      (1'b0),                               // (terminated),                       
		.reset_req_in9  (1'b0),                               // (terminated),                       
		.reset_in10     (1'b0),                               // (terminated),                       
		.reset_req_in10 (1'b0),                               // (terminated),                       
		.reset_in11     (1'b0),                               // (terminated),                       
		.reset_req_in11 (1'b0),                               // (terminated),                       
		.reset_in12     (1'b0),                               // (terminated),                       
		.reset_req_in12 (1'b0),                               // (terminated),                       
		.reset_in13     (1'b0),                               // (terminated),                       
		.reset_req_in13 (1'b0),                               // (terminated),                       
		.reset_in14     (1'b0),                               // (terminated),                       
		.reset_req_in14 (1'b0),                               // (terminated),                       
		.reset_in15     (1'b0),                               // (terminated),                       
		.reset_req_in15 (1'b0)                                // (terminated),                       
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_003 (
		.reset_in0      (~clk_clk_reset_reset),               //   input,  width = 1, reset_in0.reset
		.clk            (clk_0_clk_clk),                      //   input,  width = 1,       clk.clk
		.reset_out      (rst_controller_003_reset_out_reset), //  output,  width = 1, reset_out.reset
		.reset_req      (),                                   // (terminated),                       
		.reset_req_in0  (1'b0),                               // (terminated),                       
		.reset_in1      (1'b0),                               // (terminated),                       
		.reset_req_in1  (1'b0),                               // (terminated),                       
		.reset_in2      (1'b0),                               // (terminated),                       
		.reset_req_in2  (1'b0),                               // (terminated),                       
		.reset_in3      (1'b0),                               // (terminated),                       
		.reset_req_in3  (1'b0),                               // (terminated),                       
		.reset_in4      (1'b0),                               // (terminated),                       
		.reset_req_in4  (1'b0),                               // (terminated),                       
		.reset_in5      (1'b0),                               // (terminated),                       
		.reset_req_in5  (1'b0),                               // (terminated),                       
		.reset_in6      (1'b0),                               // (terminated),                       
		.reset_req_in6  (1'b0),                               // (terminated),                       
		.reset_in7      (1'b0),                               // (terminated),                       
		.reset_req_in7  (1'b0),                               // (terminated),                       
		.reset_in8      (1'b0),                               // (terminated),                       
		.reset_req_in8  (1'b0),                               // (terminated),                       
		.reset_in9      (1'b0),                               // (terminated),                       
		.reset_req_in9  (1'b0),                               // (terminated),                       
		.reset_in10     (1'b0),                               // (terminated),                       
		.reset_req_in10 (1'b0),                               // (terminated),                       
		.reset_in11     (1'b0),                               // (terminated),                       
		.reset_req_in11 (1'b0),                               // (terminated),                       
		.reset_in12     (1'b0),                               // (terminated),                       
		.reset_req_in12 (1'b0),                               // (terminated),                       
		.reset_in13     (1'b0),                               // (terminated),                       
		.reset_req_in13 (1'b0),                               // (terminated),                       
		.reset_in14     (1'b0),                               // (terminated),                       
		.reset_req_in14 (1'b0),                               // (terminated),                       
		.reset_in15     (1'b0),                               // (terminated),                       
		.reset_req_in15 (1'b0)                                // (terminated),                       
	);

endmodule
