	component fmc_cmos_system is
		port (
			clkin_clk                                                 : in  std_logic                     := 'X';             -- clk
			clkin_reset_reset_n                                       : in  std_logic                     := 'X';             -- reset_n
			mm_bridge_0_s0_waitrequest                                : out std_logic;                                        -- waitrequest
			mm_bridge_0_s0_readdata                                   : out std_logic_vector(31 downto 0);                    -- readdata
			mm_bridge_0_s0_readdatavalid                              : out std_logic;                                        -- readdatavalid
			mm_bridge_0_s0_burstcount                                 : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- burstcount
			mm_bridge_0_s0_writedata                                  : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			mm_bridge_0_s0_address                                    : in  std_logic_vector(16 downto 0) := (others => 'X'); -- address
			mm_bridge_0_s0_write                                      : in  std_logic                     := 'X';             -- write
			mm_bridge_0_s0_read                                       : in  std_logic                     := 'X';             -- read
			mm_bridge_0_s0_byteenable                                 : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			mm_bridge_0_s0_debugaccess                                : in  std_logic                     := 'X';             -- debugaccess
			nativephy_loopback_cont_0_rx_seriallpbken_rx_seriallpbken : out std_logic_vector(1 downto 0);                     -- rx_seriallpbken
			pio_0_external_connection_export                          : out std_logic_vector(31 downto 0);                    -- export
			xcvr_st_converter_0_rx_parallel_data_rx_parallel_data     : in  std_logic_vector(31 downto 0) := (others => 'X'); -- rx_parallel_data
			xcvr_st_converter_0_tx_parallel_data_tx_parallel_data     : out std_logic_vector(31 downto 0)                     -- tx_parallel_data
		);
	end component fmc_cmos_system;

	u0 : component fmc_cmos_system
		port map (
			clkin_clk                                                 => CONNECTED_TO_clkin_clk,                                                 --                                     clkin.clk
			clkin_reset_reset_n                                       => CONNECTED_TO_clkin_reset_reset_n,                                       --                               clkin_reset.reset_n
			mm_bridge_0_s0_waitrequest                                => CONNECTED_TO_mm_bridge_0_s0_waitrequest,                                --                            mm_bridge_0_s0.waitrequest
			mm_bridge_0_s0_readdata                                   => CONNECTED_TO_mm_bridge_0_s0_readdata,                                   --                                          .readdata
			mm_bridge_0_s0_readdatavalid                              => CONNECTED_TO_mm_bridge_0_s0_readdatavalid,                              --                                          .readdatavalid
			mm_bridge_0_s0_burstcount                                 => CONNECTED_TO_mm_bridge_0_s0_burstcount,                                 --                                          .burstcount
			mm_bridge_0_s0_writedata                                  => CONNECTED_TO_mm_bridge_0_s0_writedata,                                  --                                          .writedata
			mm_bridge_0_s0_address                                    => CONNECTED_TO_mm_bridge_0_s0_address,                                    --                                          .address
			mm_bridge_0_s0_write                                      => CONNECTED_TO_mm_bridge_0_s0_write,                                      --                                          .write
			mm_bridge_0_s0_read                                       => CONNECTED_TO_mm_bridge_0_s0_read,                                       --                                          .read
			mm_bridge_0_s0_byteenable                                 => CONNECTED_TO_mm_bridge_0_s0_byteenable,                                 --                                          .byteenable
			mm_bridge_0_s0_debugaccess                                => CONNECTED_TO_mm_bridge_0_s0_debugaccess,                                --                                          .debugaccess
			nativephy_loopback_cont_0_rx_seriallpbken_rx_seriallpbken => CONNECTED_TO_nativephy_loopback_cont_0_rx_seriallpbken_rx_seriallpbken, -- nativephy_loopback_cont_0_rx_seriallpbken.rx_seriallpbken
			pio_0_external_connection_export                          => CONNECTED_TO_pio_0_external_connection_export,                          --                 pio_0_external_connection.export
			xcvr_st_converter_0_rx_parallel_data_rx_parallel_data     => CONNECTED_TO_xcvr_st_converter_0_rx_parallel_data_rx_parallel_data,     --      xcvr_st_converter_0_rx_parallel_data.rx_parallel_data
			xcvr_st_converter_0_tx_parallel_data_tx_parallel_data     => CONNECTED_TO_xcvr_st_converter_0_tx_parallel_data_tx_parallel_data      --      xcvr_st_converter_0_tx_parallel_data.tx_parallel_data
		);

