`timescale 1ns / 100ps

module  slow_clocks
        (
        input   wire  i_clk             , // reset
        input   wire  i_reset_n         , // clock
        output  wire  o_clk_pls_n       , // 
        output  wire  o_clk_pls_p       , // 
        output  wire  o_clk_pls_p_deley , // 
        output  wire  o_slow_clk        , // 
        output  wire  o_clk_div2        , // 
        output  wire  o_clk_div4          // 
        );

//--------------------------------------------------
// Signal defination
//--------------------------------------------------
reg     [9:0]   ctr;
reg             clk_pls_n;
reg             clk_pls_p;
reg             clk_pls_p_deley;
reg             slow_clk_int;

assign  o_clk_pls_n       = clk_pls_n;
assign  o_clk_pls_p       = clk_pls_p;
assign  o_clk_pls_p_deley = clk_pls_p_deley;
assign  o_slow_clk        = !slow_clk_int;
assign  o_clk_div2        = ctr[0];
assign  o_clk_div4        = ctr[1];

//--------------------------------------------------
// Main function body
//--------------------------------------------------
always @(posedge i_clk or negedge i_reset_n)
begin
  if(!i_reset_n)
     begin
     ctr          <= 10'd0;
     slow_clk_int <= 1'b1;
     end
  else if(ctr == 10'd1023)
     begin
     slow_clk_int <= !slow_clk_int;
     clk_pls_n    <= 1'b1;
     ctr          <= 10'd0;
     clk_pls_p    <= 1'b0;
     end
  else if(ctr == 10'd511)
     begin
     slow_clk_int <= !slow_clk_int;
     ctr          <= ctr + 1'b1;
     clk_pls_p    <= 1'b1;
     end
  else if(ctr == 10'd289)
     begin
     ctr             <= ctr + 1'b1;
     clk_pls_p_deley <= 1'b1;
     end
  else
     begin
     clk_pls_n       <= 1'b0;
     ctr             <= ctr + 1'b1;
     clk_pls_p       <= 1'b0;
     clk_pls_p_deley <= 1'b0;
     end
end

endmodule
//------------------------------------------------------------------------------
// end of file
//------------------------------------------------------------------------------