	component pfl2 is
		port (
			avst_valid               : out   std_logic;                                        -- valid
			avst_ready               : in    std_logic                     := 'X';             -- ready
			avst_data                : out   std_logic_vector(15 downto 0);                    -- data
			avst_clk                 : out   std_logic;                                        -- avst_clk
			flash_addr               : out   std_logic_vector(25 downto 0);                    -- flash_addr
			flash_data               : inout std_logic_vector(15 downto 0) := (others => 'X'); -- flash_data
			flash_nce                : out   std_logic;                                        -- flash_nce
			flash_noe                : out   std_logic;                                        -- flash_noe
			flash_nreset             : out   std_logic;                                        -- flash_nreset
			flash_nwe                : out   std_logic;                                        -- flash_nwe
			fpga_conf_done           : in    std_logic                     := 'X';             -- fpga_conf_done
			fpga_nconfig             : out   std_logic;                                        -- fpga_nconfig
			fpga_nstatus             : in    std_logic                     := 'X';             -- fpga_nstatus
			fpga_pgm                 : in    std_logic_vector(2 downto 0)  := (others => 'X'); -- fpga_pgm
			pfl_clk                  : in    std_logic                     := 'X';             -- clk
			pfl_flash_access_granted : in    std_logic                     := 'X';             -- pfl_flash_access_granted
			pfl_flash_access_request : out   std_logic;                                        -- pfl_flash_access_request
			pfl_nreconfigure         : in    std_logic                     := 'X';             -- pfl_nreconfigure
			pfl_nreset               : in    std_logic                     := 'X'              -- reset_n
		);
	end component pfl2;

	u0 : component pfl2
		port map (
			avst_valid               => CONNECTED_TO_avst_valid,               --            avalon_source.valid
			avst_ready               => CONNECTED_TO_avst_ready,               --                         .ready
			avst_data                => CONNECTED_TO_avst_data,                --                         .data
			avst_clk                 => CONNECTED_TO_avst_clk,                 --                 avst_clk.avst_clk
			flash_addr               => CONNECTED_TO_flash_addr,               --               flash_addr.flash_addr
			flash_data               => CONNECTED_TO_flash_data,               --               flash_data.flash_data
			flash_nce                => CONNECTED_TO_flash_nce,                --                flash_nce.flash_nce
			flash_noe                => CONNECTED_TO_flash_noe,                --                flash_noe.flash_noe
			flash_nreset             => CONNECTED_TO_flash_nreset,             --             flash_nreset.flash_nreset
			flash_nwe                => CONNECTED_TO_flash_nwe,                --                flash_nwe.flash_nwe
			fpga_conf_done           => CONNECTED_TO_fpga_conf_done,           --           fpga_conf_done.fpga_conf_done
			fpga_nconfig             => CONNECTED_TO_fpga_nconfig,             --             fpga_nconfig.fpga_nconfig
			fpga_nstatus             => CONNECTED_TO_fpga_nstatus,             --             fpga_nstatus.fpga_nstatus
			fpga_pgm                 => CONNECTED_TO_fpga_pgm,                 --                 fpga_pgm.fpga_pgm
			pfl_clk                  => CONNECTED_TO_pfl_clk,                  --                  pfl_clk.clk
			pfl_flash_access_granted => CONNECTED_TO_pfl_flash_access_granted, -- pfl_flash_access_granted.pfl_flash_access_granted
			pfl_flash_access_request => CONNECTED_TO_pfl_flash_access_request, -- pfl_flash_access_request.pfl_flash_access_request
			pfl_nreconfigure         => CONNECTED_TO_pfl_nreconfigure,         --         pfl_nreconfigure.pfl_nreconfigure
			pfl_nreset               => CONNECTED_TO_pfl_nreset                --               pfl_nreset.reset_n
		);

