// pfl2.v

// Generated using ACDS version 17.0 595

`timescale 1 ps / 1 ps
module pfl2 (
		output wire        avst_valid,               //            avalon_source.valid
		input  wire        avst_ready,               //                         .ready
		output wire [15:0] avst_data,                //                         .data
		output wire        avst_clk,                 //                 avst_clk.avst_clk
		output wire [25:0] flash_addr,               //               flash_addr.flash_addr
		inout  wire [15:0] flash_data,               //               flash_data.flash_data
		output wire        flash_nce,                //                flash_nce.flash_nce
		output wire        flash_noe,                //                flash_noe.flash_noe
		output wire        flash_nreset,             //             flash_nreset.flash_nreset
		output wire        flash_nwe,                //                flash_nwe.flash_nwe
		input  wire        fpga_conf_done,           //           fpga_conf_done.fpga_conf_done
		output wire        fpga_nconfig,             //             fpga_nconfig.fpga_nconfig
		input  wire        fpga_nstatus,             //             fpga_nstatus.fpga_nstatus
		input  wire [2:0]  fpga_pgm,                 //                 fpga_pgm.fpga_pgm
		input  wire        pfl_clk,                  //                  pfl_clk.clk
		input  wire        pfl_flash_access_granted, // pfl_flash_access_granted.pfl_flash_access_granted
		output wire        pfl_flash_access_request, // pfl_flash_access_request.pfl_flash_access_request
		input  wire        pfl_nreconfigure,         //         pfl_nreconfigure.pfl_nreconfigure
		input  wire        pfl_nreset                //               pfl_nreset.reset_n
	);

	altera_parallel_flash_loader_2 #(
		.ADDR_WIDTH               (26),
		.FLASH_DATA_WIDTH         (16),
		.N_FLASH                  (1),
		.FLASH_NRESET_CHECKBOX    (1),
		.FIFO_SIZE                (16),
		.DISABLE_CRC_CHECKBOX     (0),
		.CLK_DIVISOR              (4),
		.PAGE_CLK_DIVISOR         (1),
		.FLASH_NRESET_COUNTER     (2500),
		.NORMAL_MODE              (1),
		.BURST_MODE               (0),
		.PAGE_MODE                (0),
		.BURST_MODE_SPANSION      (0),
		.BURST_MODE_INTEL         (0),
		.BURST_MODE_LATENCY_COUNT (5),
		.BURST_MODE_NUMONYX       (0),
		.FLASH_BURST_EXTRA_CYCLE  (0),
		.CONF_DATA_WIDTH          (16),
		.OPTION_START_ADDR        (786432),
		.CONF_WAIT_TIMER_WIDTH    (19),
		.SAFE_MODE_HALT           (0),
		.SAFE_MODE_RETRY          (1),
		.SAFE_MODE_REVERT         (0),
		.SAFE_MODE_REVERT_ADDR    (0),
		.READY_SYNC_STAGES        (2)
	) parallel_flash_loader_2_0 (
		.pfl_clk                  (pfl_clk),                  //                  pfl_clk.clk
		.pfl_nreset               (pfl_nreset),               //               pfl_nreset.reset_n
		.avst_valid               (avst_valid),               //            avalon_source.valid
		.avst_ready               (avst_ready),               //                         .ready
		.avst_data                (avst_data),                //                         .data
		.avst_clk                 (avst_clk),                 //                 avst_clk.avst_clk
		.pfl_flash_access_granted (pfl_flash_access_granted), // pfl_flash_access_granted.pfl_flash_access_granted
		.fpga_pgm                 (fpga_pgm),                 //                 fpga_pgm.fpga_pgm
		.fpga_conf_done           (fpga_conf_done),           //           fpga_conf_done.fpga_conf_done
		.fpga_nstatus             (fpga_nstatus),             //             fpga_nstatus.fpga_nstatus
		.pfl_nreconfigure         (pfl_nreconfigure),         //         pfl_nreconfigure.pfl_nreconfigure
		.pfl_flash_access_request (pfl_flash_access_request), // pfl_flash_access_request.pfl_flash_access_request
		.flash_addr               (flash_addr),               //               flash_addr.flash_addr
		.flash_data               (flash_data),               //               flash_data.flash_data
		.flash_nce                (flash_nce),                //                flash_nce.flash_nce
		.flash_nwe                (flash_nwe),                //                flash_nwe.flash_nwe
		.flash_noe                (flash_noe),                //                flash_noe.flash_noe
		.flash_nreset             (flash_nreset),             //             flash_nreset.flash_nreset
		.fpga_nconfig             (fpga_nconfig)              //             fpga_nconfig.fpga_nconfig
	);

endmodule
