// (C) 2001-2017 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module fourteennm_io_12_lane_mdev40_encrypted_abphy (
	input  [1:0] phy_clk,
	input  [7:0] phy_clk_phs,
	input        reset_n,
	input        pll_locked,
	input        dll_ref_clk,
	output [5:0] ioereg_locked,

	input  [47:0] oe_from_core,
	input  [95:0] data_from_core,
	output [95:0] data_to_core,
	input  [15:0] mrnk_read_core,
	input  [15:0] mrnk_write_core,
	input   [3:0] rdata_en_full_core,
	output  [3:0] rdata_valid_core,

	input         core2dbc_rd_data_rdy,
	input         core2dbc_wr_data_vld0,
	input         core2dbc_wr_data_vld1,
	input  [12:0] core2dbc_wr_ecc_info,
	output        dbc2core_rd_data_vld0,
	output        dbc2core_rd_data_vld1,
	output	      dbc2core_rd_type,
	output [11:0] dbc2core_wb_pointer,
	output	      dbc2core_wr_data_rdy,

	input  [95:0] ac_hmc,
	output  [5:0] afi_rlat_core,
	output  [5:0] afi_wlat_core,
	input  [17:0] cfg_dbc,
	input  [50:0] ctl2dbc0,
	input  [50:0] ctl2dbc1,
	output [22:0] dbc2ctl,

	input  [54:0] cal_avl_in,
	output [31:0] cal_avl_readdata_out,
	output [54:0] cal_avl_out,
	input  [31:0] cal_avl_readdata_in,

	input [1:0] dqs_in,
	input [1:0]	broadcast_in_bot,
	input [1:0]	broadcast_in_top,
	output [1:0] broadcast_out_bot,
	output [1:0] broadcast_out_top,

	input  [11:0] data_in,
	output [11:0] data_out,
	output [11:0] data_oe,
	output [11:0] oct_enable,

	input   [2:0] core_dll,
	output [12:0] dll_core,

	input	sync_clk_bot_in,
	output	sync_clk_bot_out,
	input	sync_clk_top_in,
	output	sync_clk_top_out,
	input	sync_data_bot_in,
	output	sync_data_bot_out,
	input	sync_data_top_in,
	output	sync_data_top_out,

	output debug_dqs_gated_a, 
	output debug_dqs_enable_a,
	output debug_dqs_gated_b, 
	output debug_dqs_enable_b,
	output [11:0] debug_dq_delayed,

	output [1:0]	dft_phy_clk
);

  timeunit 1ps;
  timeprecision 1ps;

parameter [7:0] pipe_latency = 8'd0;
parameter [6:0] dbc_wb_reserved_entry = 7'd0;
parameter [9:0] dll_ctl_static = 10'd0;
parameter [6:0] dqs_lgc_count_threshold = 7'd0;
parameter [5:0] db_afi_wlat_vlu = 6'd0;
parameter [5:0] db_afi_rlat_vlu = 6'd0;
parameter [9:0] dqs_lgc_pvt_input_delay_a = 10'd0;
parameter [9:0] dqs_lgc_pvt_input_delay_b = 10'd0;
parameter [12:0] pin_0_output_phase = 13'd0;
parameter [12:0] pin_1_output_phase = 13'd0;
parameter [12:0] pin_2_output_phase = 13'd0;
parameter [12:0] pin_3_output_phase = 13'd0;
parameter [12:0] pin_4_output_phase = 13'd0;
parameter [12:0] pin_5_output_phase = 13'd0;
parameter [12:0] pin_6_output_phase = 13'd0;
parameter [12:0] pin_7_output_phase = 13'd0;
parameter [12:0] pin_8_output_phase = 13'd0;
parameter [12:0] pin_9_output_phase = 13'd0;
parameter [12:0] pin_10_output_phase = 13'd0;
parameter [12:0] pin_11_output_phase = 13'd0;
parameter [12:0] dqs_lgc_phase_shift_b = 13'd0;
parameter [12:0] dqs_lgc_phase_shift_a = 13'd0;
parameter [3:0] oct_size = 4'd0;
parameter [6:0] rd_valid_delay = 7'd0;
parameter [5:0] dqs_enable_delay = 6'd0;
parameter [8:0] avl_base_addr = 9'd0;

parameter a_filter_code = "freq_16ghz";
parameter a_couple_enable = "couple_en";
parameter mode_rate_in = "in_rate_1_4";
parameter mode_rate_out = "out_rate_full";
parameter phy_clk_sel = "phy_clk_sel_uint0";
parameter pair_0_ddr4_mode = "pair0_ddr3_idle";
parameter pair_1_ddr4_mode = "pair1_ddr3_idle";
parameter pair_2_ddr4_mode = "pair2_ddr3_idle";
parameter pair_3_ddr4_mode = "pair3_ddr3_idle";
parameter pair_4_ddr4_mode = "pair4_ddr3_idle";
parameter pair_5_ddr4_mode = "pair5_ddr3_idle";
parameter mrnk_write_mode = "enabled";
parameter pair_0_dcc_split_mode = "pair0_dcc_split_disabled";
parameter pair_1_dcc_split_mode = "pair1_dcc_split_disabled";
parameter pair_2_dcc_split_mode = "pair2_dcc_split_disabled";
parameter pair_3_dcc_split_mode = "pair3_dcc_split_disabled";
parameter pair_4_dcc_split_mode = "pair4_dcc_split_disabled";
parameter pair_5_dcc_split_mode = "pair5_dcc_split_disabled";
parameter pin_0_initial_out = "pin0_initial_out_z";
parameter pin_0_oct_mode = "pin0_static_off";
parameter pin_0_mode_ddr = "pin0_mode_ddr";
parameter pin_0_dqs_mode = "pin0_dqs_sampler_a";
parameter pin_0_data_in_mode = "pin0_ca";
parameter pin_1_initial_out = "pin1_initial_out_z";
parameter pin_1_oct_mode = "pin1_static_off";
parameter pin_1_mode_ddr = "pin1_mode_ddr";
parameter pin_1_dqs_mode = "pin1_dqs_sampler_a";
parameter pin_1_data_in_mode = "pin1_ca";
parameter pin_2_initial_out = "pin2_initial_out_z";
parameter pin_2_oct_mode = "pin2_static_off";
parameter pin_2_mode_ddr = "pin2_mode_ddr";
parameter pin_2_dqs_mode = "pin2_dqs_sampler_a";
parameter pin_2_data_in_mode = "pin2_ca";
parameter pin_3_initial_out = "pin3_initial_out_z";
parameter pin_3_oct_mode = "pin3_static_off";
parameter pin_3_mode_ddr = "pin3_mode_ddr";
parameter pin_3_dqs_mode = "pin3_dqs_sampler_a";
parameter pin_3_data_in_mode = "pin3_ca";
parameter pin_4_initial_out = "pin4_initial_out_z";
parameter pin_4_oct_mode = "pin4_static_off";
parameter pin_4_mode_ddr = "pin4_mode_ddr";
parameter pin_4_dqs_mode = "pin4_dqs_sampler_a";
parameter pin_4_data_in_mode = "pin4_ca";
parameter pin_5_initial_out = "pin5_initial_out_z";
parameter pin_5_oct_mode = "pin5_static_off";
parameter pin_5_mode_ddr = "pin5_mode_ddr";
parameter pin_5_dqs_mode = "pin5_dqs_sampler_a";
parameter pin_5_data_in_mode = "pin5_ca";
parameter pin_6_initial_out = "pin6_initial_out_z";
parameter pin_6_oct_mode = "pin6_static_off";
parameter pin_6_mode_ddr = "pin6_mode_ddr";
parameter pin_6_dqs_mode = "pin6_dqs_sampler_a";
parameter pin_6_data_in_mode = "pin6_ca";
parameter pin_7_initial_out = "pin7_initial_out_z";
parameter pin_7_oct_mode = "pin7_static_off";
parameter pin_7_mode_ddr = "pin7_mode_ddr";
parameter pin_7_dqs_mode = "pin7_dqs_sampler_a";
parameter pin_7_data_in_mode = "pin7_ca";
parameter pin_8_initial_out = "pin8_initial_out_z";
parameter pin_8_oct_mode = "pin8_static_off";
parameter pin_8_mode_ddr = "pin8_mode_ddr";
parameter pin_8_dqs_mode = "pin8_dqs_sampler_a";
parameter pin_8_data_in_mode = "pin8_ca";
parameter pin_9_initial_out = "pin9_initial_out_z";
parameter pin_9_oct_mode = "pin9_static_off";
parameter pin_9_mode_ddr = "pin9_mode_ddr";
parameter pin_9_dqs_mode = "pin9_dqs_sampler_a";
parameter pin_9_data_in_mode = "pin9_ca";
parameter pin_10_initial_out = "pin10_initial_out_z";
parameter pin_10_oct_mode = "pin10_static_off";
parameter pin_10_mode_ddr = "pin10_mode_ddr";
parameter pin_10_dqs_mode = "pin10_dqs_sampler_a";
parameter pin_10_data_in_mode = "pin10_ca";
parameter pin_11_initial_out = "pin11_initial_out_z";
parameter pin_11_oct_mode = "pin11_static_off";
parameter pin_11_mode_ddr = "pin11_mode_ddr";
parameter pin_11_dqs_mode = "pin11_dqs_sampler_a";
parameter pin_11_data_in_mode = "pin11_ca";
parameter db_hmc_or_core = "core";
parameter db_dbi_sel = "db_dbi_sel_uint0";
parameter db_dbi_wr_en = "false";
parameter db_dbi_rd_en = "false";
parameter avl_ena = "false";
parameter db_boardcast_en = "false";
parameter db_pipeline = "pipeline_one_cycle";
parameter db_rwlat_mode = "avl_vlu";
parameter db_ptr_pipeline_depth = "db_ptr_pipeline_depth_uint0";
parameter db_preamble_mode = "preamble_one_cycle";
parameter db_reset_auto_release = "auto_release";
parameter db_data_alignment_mode = "align_disable";
parameter db_db2core_registered = "registered";
parameter dbc_core_clk_sel = "dbc_core_clk_sel_uint0";
parameter db_core_or_hmc2db_registered = "false";
parameter db_seq_rd_en_full_pipeline = "db_seq_rd_en_full_pipeline_uint0";
parameter db_pin_0_mode = "pin0_gpio_mode";
parameter db_pin_1_mode = "pin1_gpio_mode";
parameter db_pin_2_mode = "pin2_gpio_mode";
parameter db_pin_3_mode = "pin3_gpio_mode";
parameter db_pin_4_mode = "pin4_gpio_mode";
parameter db_pin_5_mode = "pin5_gpio_mode";
parameter db_pin_6_mode = "pin6_gpio_mode";
parameter db_pin_7_mode = "pin7_gpio_mode";
parameter db_pin_8_mode = "pin8_gpio_mode";
parameter db_pin_9_mode = "pin9_gpio_mode";
parameter db_pin_10_mode = "pin10_gpio_mode";
parameter db_pin_11_mode = "pin11_gpio_mode";
parameter dll_rst_en = "dll_rst_dis";
parameter dll_en = "dll_en";
parameter dll_core_updnen = "core_updn_en";
parameter dll_ctlsel = "ctl_static";
parameter hps_ctrl_en = "true";
parameter dqs_lgc_enable_toggler = "preamble_track_dqs_enable";
parameter dqs_lgc_dqs_b_interp_en = "dqsb_constant";
parameter dqs_lgc_dqs_a_interp_en = "dqsa_diff_in_1";
parameter dqs_lgc_pack_mode = "packed";
parameter dqs_lgc_pst_preamble_mode = "ddr4_preamble";
parameter dqs_lgc_pst_en_shrink = "shrink_0_0";
parameter vfifo_burst_length = "vburst_length_2";
parameter dqs_lgc_broadcast_enable = "disable_broadcast";
parameter dqs_lgc_burst_length = "burst_length_8";
parameter dqs_lgc_ddr4_search = "ddr4_search";
parameter fast_interpolator_sim = 0;

wire  [1:0] ctl2dbc_cs0;
wire        ctl2dbc_mask_entry0;
wire  [3:0] ctl2dbc_misc0;
wire  [7:0] ctl2dbc_mrnk_read0;
wire        ctl2dbc_nop0;
wire [11:0] ctl2dbc_rb_rdptr0;
wire  [1:0] ctl2dbc_rb_rdptr_vld0;
wire  [5:0] ctl2dbc_rb_wrptr0;
wire        ctl2dbc_rb_wrptr_vld0;
wire        ctl2dbc_rd_type0;
wire  [3:0] ctl2dbc_rdata_en_full0;
wire        ctl2dbc_seq_en0;
wire  [5:0] ctl2dbc_wb_rdptr0;
wire        ctl2dbc_wb_rdptr_vld0;
wire        ctl2dbc_wrdata_vld0;

wire  [1:0] ctl2dbc_cs1;
wire        ctl2dbc_mask_entry1;
wire  [3:0] ctl2dbc_misc1;
wire  [7:0] ctl2dbc_mrnk_read1;
wire        ctl2dbc_nop1;
wire [11:0] ctl2dbc_rb_rdptr1;
wire  [1:0] ctl2dbc_rb_rdptr_vld1;
wire  [5:0] ctl2dbc_rb_wrptr1;
wire        ctl2dbc_rb_wrptr_vld1;
wire        ctl2dbc_rd_type1;
wire  [3:0] ctl2dbc_rdata_en_full1;
wire        ctl2dbc_seq_en1;
wire  [5:0] ctl2dbc_wb_rdptr1;
wire        ctl2dbc_wb_rdptr_vld1;
wire        ctl2dbc_wrdata_vld1;

wire       dbc2ctl_all_rd_done;
wire [5:0] dbc2ctl_rb_retire_ptr;
wire       dbc2ctl_rb_retire_ptr_vld;
wire       dbc2ctl_rd_data_vld;
wire [5:0] dbc2ctl_wb_retire_ptr;
wire	   dbc2ctl_wb_retire_ptr_vld;
wire [5:0] dbc2db_wb_wrptr;
wire       dbc2db_wb_wrptr_vld;

wire [2:0] cfg_cmd_rate;
wire       cfg_dbc_ctrl_sel;
wire       cfg_dbc_dualport_en;
wire       cfg_dbc_in_protocol;
wire [2:0] cfg_dbc_pipe_lat;
wire       cfg_dbc_rc_en;
wire [1:0] cfg_dbc_slot_offset;
wire [2:0] cfg_dbc_slot_rotate_en;
wire       cfg_output_regd;
wire       cfg_reorder_rdata;
wire       cfg_rmw_en;

wire [19:0] avl_address_in;
wire [31:0] avl_writedata_in;
wire        avl_write_in;
wire        avl_read_in;
wire        avl_clk_in;
wire [31:0] avl_readdata_out;

wire [19:0] avl_address_out;
wire [31:0] avl_writedata_out;
wire        avl_write_out;
wire        avl_read_out;
wire        avl_clk_out;
wire [31:0] avl_readdata_in;

wire [23:0] dq_in;
wire [11:0] codin_n;
wire [11:0] codin_nb;
wire [11:0] codin_p;
wire [11:0] codin_pb;
wire frzreg; 


assign  dq_in[23:0] = {  data_in[11],
                        ~data_in[11],
                         data_in[10],
                        ~data_in[10],
                         data_in[9],
                        ~data_in[9],
                         data_in[8],
                        ~data_in[8],
                         data_in[7],
                        ~data_in[7],
                         data_in[6],
                        ~data_in[6],
                         data_in[5],
                        ~data_in[5],
                         data_in[4],
                        ~data_in[4],
                         data_in[3],
                        ~data_in[3],
                         data_in[2],
                        ~data_in[2],
                         data_in[1],
                        ~data_in[1],
                         data_in[0],
                        ~data_in[0] };

assign data_out[0]  = ~codin_p[0];
assign data_out[1]  = ~codin_p[1];
assign data_out[2]  = ~codin_p[2];
assign data_out[3]  = ~codin_p[3];
assign data_out[4]  = ~codin_p[4];
assign data_out[5]  = ~codin_p[5];
assign data_out[6]  = ~codin_p[6];
assign data_out[7]  = ~codin_p[7];
assign data_out[8]  = ~codin_p[8];
assign data_out[9]  = ~codin_p[9];
assign data_out[10] = ~codin_p[10];
assign data_out[11] = ~codin_p[11];

assign data_oe[0]  = (codin_p[0]  == codin_n[0] );
assign data_oe[1]  = (codin_p[1]  == codin_n[1] );
assign data_oe[2]  = (codin_p[2]  == codin_n[2] );
assign data_oe[3]  = (codin_p[3]  == codin_n[3] );
assign data_oe[4]  = (codin_p[4]  == codin_n[4] );
assign data_oe[5]  = (codin_p[5]  == codin_n[5] );
assign data_oe[6]  = (codin_p[6]  == codin_n[6] );
assign data_oe[7]  = (codin_p[7]  == codin_n[7] );
assign data_oe[8]  = (codin_p[8]  == codin_n[8] );
assign data_oe[9]  = (codin_p[9]  == codin_n[9] );
assign data_oe[10] = (codin_p[10] == codin_n[10]);
assign data_oe[11] = (codin_p[11] == codin_n[11]);

assign ctl2dbc_wb_rdptr_vld0 = ctl2dbc0[0];
assign ctl2dbc_wb_rdptr0 = ctl2dbc0[6:1];
assign ctl2dbc_rb_wrptr_vld0 = ctl2dbc0[7];
assign ctl2dbc_rb_wrptr0 = ctl2dbc0[13:8];
assign ctl2dbc_rb_rdptr_vld0 = ctl2dbc0[15:14];
assign ctl2dbc_rb_rdptr0 = ctl2dbc0[27:16];
assign ctl2dbc_wrdata_vld0 = ctl2dbc0[28];
assign ctl2dbc_mask_entry0 = ctl2dbc0[29];
assign ctl2dbc_rdata_en_full0 = ctl2dbc0[33:30];
assign ctl2dbc_mrnk_read0 = ctl2dbc0[41:34];
assign ctl2dbc_seq_en0 = ctl2dbc0[42];
assign ctl2dbc_cs0 = ctl2dbc0[44:43];
assign ctl2dbc_misc0 = ctl2dbc0[48:45];
assign ctl2dbc_nop0 = ctl2dbc0[49];
assign ctl2dbc_rd_type0 = ctl2dbc0[50];

assign ctl2dbc_wb_rdptr_vld1 = ctl2dbc1[0];
assign ctl2dbc_wb_rdptr1 = ctl2dbc1[6:1];
assign ctl2dbc_rb_wrptr_vld1 = ctl2dbc1[7];
assign ctl2dbc_rb_wrptr1 = ctl2dbc1[13:8];
assign ctl2dbc_rb_rdptr_vld1 = ctl2dbc1[15:14];
assign ctl2dbc_rb_rdptr1 = ctl2dbc1[27:16];
assign ctl2dbc_wrdata_vld1 = ctl2dbc1[28];
assign ctl2dbc_mask_entry1 = ctl2dbc1[29];
assign ctl2dbc_rdata_en_full1 = ctl2dbc1[33:30];
assign ctl2dbc_mrnk_read1 = ctl2dbc1[41:34];
assign ctl2dbc_seq_en1 = ctl2dbc1[42];
assign ctl2dbc_cs1 = ctl2dbc1[44:43];
assign ctl2dbc_misc1 = ctl2dbc1[48:45];
assign ctl2dbc_nop1 = ctl2dbc1[49];
assign ctl2dbc_rd_type1 = ctl2dbc1[50];

assign dbc2ctl[0] = dbc2ctl_wb_retire_ptr_vld;
assign dbc2ctl[6:1] = dbc2ctl_wb_retire_ptr;
assign dbc2ctl[7] = dbc2ctl_rb_retire_ptr_vld;
assign dbc2ctl[13:8] = dbc2ctl_rb_retire_ptr;
assign dbc2ctl[14] = dbc2db_wb_wrptr_vld;
assign dbc2ctl[20:15] = dbc2db_wb_wrptr;
assign dbc2ctl[21] = dbc2ctl_rd_data_vld;
assign dbc2ctl[22] = dbc2ctl_all_rd_done;

assign cfg_reorder_rdata      = cfg_dbc[0];
assign cfg_rmw_en             = cfg_dbc[1]; 
assign cfg_output_regd        = cfg_dbc[2];
assign cfg_dbc_ctrl_sel       = cfg_dbc[3];
assign cfg_dbc_in_protocol    = cfg_dbc[4];
assign cfg_dbc_dualport_en    = cfg_dbc[5];
assign cfg_dbc_pipe_lat       = cfg_dbc[8:6];
assign cfg_cmd_rate           = cfg_dbc[11:9];
assign cfg_dbc_rc_en          = cfg_dbc[12];
assign cfg_dbc_slot_rotate_en = cfg_dbc[15:13];
assign cfg_dbc_slot_offset    = cfg_dbc[17:16];



reg cal_avl_rst_override;
reg cal_avl_tmp_clk;

initial begin
	cal_avl_rst_override = 1'b1;
	cal_avl_tmp_clk = 1'b0;
	#1;
	cal_avl_tmp_clk = 1'b1;
	#1;
	cal_avl_rst_override = 1'b0;
end

reg nfrzdrv;

initial begin
	nfrzdrv = 1'b1;
	#10
	nfrzdrv = 1'b0;
	#100 nfrzdrv = 1'b1;
end

assign avl_address_in   = cal_avl_rst_override ? 20'd0           : cal_avl_in[19:0]  ;
assign avl_writedata_in = cal_avl_rst_override ? 32'd0           : cal_avl_in[51:20] ;
assign avl_write_in     = cal_avl_rst_override ? 1'b0            : cal_avl_in[52]    ;
assign avl_read_in      = cal_avl_rst_override ? 1'b0            : cal_avl_in[53]    ;
assign avl_clk_in       = cal_avl_rst_override ? cal_avl_tmp_clk : cal_avl_in[54]    ;
assign cal_avl_readdata_out = avl_readdata_out;

assign cal_avl_out[19:0]  = cal_avl_rst_override ? 20'd0 : avl_address_out   ;
assign cal_avl_out[51:20] = cal_avl_rst_override ? 32'd0 : avl_writedata_out ;
assign cal_avl_out[52]    = cal_avl_rst_override ? 1'b0  : avl_write_out     ;
assign cal_avl_out[53]    = cal_avl_rst_override ? 1'b0  : avl_read_out      ;
assign cal_avl_out[54]    = cal_avl_rst_override ? 1'b0  : avl_clk_out       ;
assign avl_readdata_in = cal_avl_readdata_in;

/* EE
assign debug_dqs_gated_a    = u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_out_a[0];
assign debug_dqs_enable_a   = u_io_12_lane_bcm.xio_dqs_lgc_top.pstamble_reg_a.dqs_en_shrunk;
assign debug_dqs_gated_b    = u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_out_b[0];
assign debug_dqs_enable_b   = u_io_12_lane_bcm.xio_dqs_lgc_top.pstamble_reg_b.dqs_en_shrunk;
assign debug_dq_delayed[0]  = u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.dq_in_tree[1];
assign debug_dq_delayed[1]  = u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.dq_in_tree[3];
assign debug_dq_delayed[2]  = u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.dq_in_tree[1];
assign debug_dq_delayed[3]  = u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.dq_in_tree[3];
assign debug_dq_delayed[4]  = u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.dq_in_tree[1];
assign debug_dq_delayed[5]  = u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.dq_in_tree[3];
assign debug_dq_delayed[6]  = u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.dq_in_tree[1];
assign debug_dq_delayed[7]  = u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.dq_in_tree[3];
assign debug_dq_delayed[8]  = u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.dq_in_tree[1];
assign debug_dq_delayed[9]  = u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.dq_in_tree[3];
assign debug_dq_delayed[10] = u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.dq_in_tree[1];
assign debug_dq_delayed[11] = u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.dq_in_tree[3];
*/

io_12_lane__mdev40_abphy u_io_12_lane_bcm (
	.loopback_en_n (12'hFFF), 
	.ac_hmc( ac_hmc ),	
	.afi_rlat_core( afi_rlat_core ),	
	.afi_wlat_core( afi_wlat_core ),	
	.atbi_0( ), 
	.atbi_1( ), 
	.atpg_en_n        ( 1'b1 ),			
	.avl_address_in( avl_address_in ),		
	.avl_address_out( avl_address_out ),		
	.avl_clk_in( avl_clk_in ),			
	.avl_clk_out( avl_clk_out ),			
	.avl_read_in( avl_read_in ),			
	.avl_read_out( avl_read_out ),			
	.avl_readdata_in( avl_readdata_in ),		
	.avl_readdata_out( avl_readdata_out ),		
	.avl_write_in( avl_write_in ),			
	.avl_write_out( avl_write_out ),		
	.avl_writedata_in( avl_writedata_in ),		
	.avl_writedata_out( avl_writedata_out ),	
	.bhniotri           ( 1'b0         ), 
	.broadcast_in_bot  ( broadcast_in_bot ), 	
	.broadcast_in_top  ( broadcast_in_top ), 	
	.broadcast_out_bot ( broadcast_out_bot ), 
	.broadcast_out_top ( broadcast_out_top ), 
	.cas_csrdin( 5'd0), 
	.cas_csrdout( ), 
	.cfg_cmd_rate( cfg_cmd_rate ),	
	.cfg_dbc_ctrl_sel( cfg_dbc_ctrl_sel ),	
	.cfg_dbc_dualport_en( cfg_dbc_dualport_en ),	
	.cfg_dbc_in_protocol( cfg_dbc_in_protocol ),	
	.cfg_dbc_pipe_lat( cfg_dbc_pipe_lat ),	
	.cfg_dbc_rc_en( cfg_dbc_rc_en ),  
	.cfg_dbc_slot_offset( cfg_dbc_slot_offset ),  
	.cfg_dbc_slot_rotate_en( cfg_dbc_slot_rotate_en ),  
	.cfg_output_regd( cfg_output_regd ),	
	.cfg_reorder_rdata( cfg_reorder_rdata ),	
	.cfg_rmw_en( cfg_rmw_en ),	
	.clk_pll( dll_ref_clk ),	
	.codin_n ( codin_n ),	
	.codin_nb( codin_nb ),	
	.codin_p ( codin_p ),	
	.codin_pb( codin_pb ),	
	.core2dbc_rd_data_rdy ( core2dbc_rd_data_rdy ),	
	.core2dbc_wr_data_vld0( core2dbc_wr_data_vld0 ),	
	.core2dbc_wr_ecc_info( core2dbc_wr_ecc_info ),  
	.core_dll( core_dll ),	

	.csr_en( csr_en ),	


	.csr_shift_n( csr_shift_n ),	

	.ctl2dbc_cs0( ctl2dbc_cs0 ),  
	.ctl2dbc_cs1( ctl2dbc_cs1 ),  
	.ctl2dbc_mask_entry0( ctl2dbc_mask_entry0 ),	
	.ctl2dbc_mask_entry1( ctl2dbc_mask_entry1 ),	
	.ctl2dbc_misc0( ctl2dbc_misc0 ),  
	.ctl2dbc_misc1( ctl2dbc_misc1 ),  
	.ctl2dbc_mrnk_read0( ctl2dbc_mrnk_read0 ),	
	.ctl2dbc_mrnk_read1( ctl2dbc_mrnk_read1 ),	
	.ctl2dbc_nop0( ctl2dbc_nop0 ),  
	.ctl2dbc_nop1( ctl2dbc_nop1 ),  
	.ctl2dbc_rb_rdptr0( ctl2dbc_rb_rdptr0 ),	
	.ctl2dbc_rb_rdptr1( ctl2dbc_rb_rdptr1 ),	
	.ctl2dbc_rb_rdptr_vld0( ctl2dbc_rb_rdptr_vld0 ),	
	.ctl2dbc_rb_rdptr_vld1( ctl2dbc_rb_rdptr_vld1 ),	
	.ctl2dbc_rb_wrptr0( ctl2dbc_rb_wrptr0 ),	
	.ctl2dbc_rb_wrptr1( ctl2dbc_rb_wrptr1 ),	
	.ctl2dbc_rb_wrptr_vld0( ctl2dbc_rb_wrptr_vld0 ),	
	.ctl2dbc_rb_wrptr_vld1( ctl2dbc_rb_wrptr_vld1 ),	
	.ctl2dbc_rd_type0( ctl2dbc_rd_type0 ),  
	.ctl2dbc_rd_type1( ctl2dbc_rd_type1 ),  
	.ctl2dbc_rdata_en_full0( ctl2dbc_rdata_en_full0 ),	
	.ctl2dbc_rdata_en_full1( ctl2dbc_rdata_en_full1 ),	
	.ctl2dbc_seq_en0( ctl2dbc_seq_en0 ),	
	.ctl2dbc_seq_en1( ctl2dbc_seq_en1 ),	
	.ctl2dbc_wb_rdptr0( ctl2dbc_wb_rdptr0 ),	
	.ctl2dbc_wb_rdptr1( ctl2dbc_wb_rdptr1 ),	
	.ctl2dbc_wb_rdptr_vld0( ctl2dbc_wb_rdptr_vld0 ),	
	.ctl2dbc_wb_rdptr_vld1( ctl2dbc_wb_rdptr_vld1 ),	
	.ctl2dbc_wrdata_vld0( ctl2dbc_wrdata_vld0 ),	
	.ctl2dbc_wrdata_vld1( ctl2dbc_wrdata_vld1 ),	
	.data_from_core( data_from_core ),	
	.data_to_core( data_to_core ),	
	.dbc2core_rd_data_vld0( dbc2core_rd_data_vld0 ),	
	.dbc2core_rd_type( dbc2core_rd_type), 
	.dbc2core_wb_pointer( dbc2core_wb_pointer ),  
	.dbc2core_wr_data_rdy ( dbc2core_wr_data_rdy ),	
	.dft_core2db( 8'b0 ),  
	.dft_db2core(  ),  
	.dft_phy_clk(dft_phy_clk  ),  
	.dft_prbs_done(  ),		
	.dft_prbs_pass(  ),		
	.dll_core( dll_core ),	

        .dqs_diff_in_0_0(~dqs_in[1]), 
	.dqs_diff_in_0_1(dqs_in[1]), 
	.dqs_diff_in_1_0(~dqs_in[0]), 
	.dqs_diff_in_1_1(dqs_in[0]), 
	.dqs_diff_in_2_0(~dqs_in[0]), 
	.dqs_diff_in_2_1(dqs_in[0]), 
	.dqs_diff_in_3_0(~dqs_in[0]), 
	.dqs_diff_in_3_1(dqs_in[0]), 
	.dqs_sstl_n_0_0(~dqs_in[1]), 
	.dqs_sstl_n_0_1(~dqs_in[1]), 
	.dqs_sstl_n_1_0(~dqs_in[0]), 
	.dqs_sstl_n_1_1(~dqs_in[0]), 
	.dqs_sstl_n_2_0(~dqs_in[0]), 
	.dqs_sstl_n_2_1(~dqs_in[0]), 
	.dqs_sstl_n_3_0(~dqs_in[0]), 
	.dqs_sstl_n_3_1(~dqs_in[0]), 
	.dqs_sstl_p_0_0(dqs_in[1]), 
	.dqs_sstl_p_0_1(dqs_in[1]), 
	.dqs_sstl_p_1_0(dqs_in[0]), 
	.dqs_sstl_p_1_1(dqs_in[0]), 
	.dqs_sstl_p_2_0(dqs_in[0]), 
	.dqs_sstl_p_2_1(dqs_in[0]), 
	.dqs_sstl_p_3_0(dqs_in[0]), 
	.dqs_sstl_p_3_1(dqs_in[0]), 
   

	.early_bhniotri     ( 1'b0         ), 
	.early_csren        ( 1'b0         ), 
	.early_enrnsl       ( 1'b0         ), 
	.early_frzreg       ( 1'b0         ), 
	.early_nfrzdrv      ( 1'b0         ), 
	.early_niotri       ( 1'b0         ), 
	.early_plniotri     ( 1'b0         ), 
	.early_usrmode      ( 1'b0         ), 
	.enrnsl             ( 1'b0         ), 
	.fb_clkout( ),	
	.fr_in_clk ( 12'd0 ),	
	.fr_out_clk( 12'd0 ),	
	.frzreg             ( frzreg         ), 
	.hps_to_core_ctrl_en(     ), 
	.hr_in_clk ( 12'd0 ),	
	.hr_out_clk( 12'd0 ),	

	.ioereg_locked( ioereg_locked), 
	.jtag_clk   ( 1'b0),	
	.jtag_highz ( 1'b0 ),	
	.jtag_mode  ( 1'b0 ),	
	.jtag_sdin  ( 1'b0 ),	
	.jtag_sdout ( ),	
	.jtag_shftdr( 1'b0 ),	
	.jtag_updtdr( 1'b0 ),	
	.local_bhniotri     (     ), 
	.local_enrnsl       (     ), 
	.local_nfrzdrv      (     ), 
	.local_niotri       (     ), 
	.local_plniotri     (     ), 
	.local_usrmode      (     ), 
	.local_wkpullup     (     ), 
	.mrnk_read_core( mrnk_read_core ),	
	.mrnk_write_core( mrnk_write_core ),	
	.naclr     ( 12'd0 ),	
	.ncein     ( 12'd0 ),	
	.nceout    ( 12'd0 ),	
	.nfrzdrv            ( nfrzdrv         ), 
	.niotri             ( 1'b1         ), 
	.nsclr     ( 12'd0 ),	
	.oct_enable( oct_enable ),	
	.oeb_from_core( ~oe_from_core ),	
	.osc_en_n( 1'b1 ), 
	.osc_enable_in( 1'b0 ), 
	.osc_mode_in( 1'b1 ), 
	.osc_rocount_to_core(), 
	.osc_sel_n( 1'b0 ),

	.phy_clk_0( phy_clk[0] ), 
	.phy_clk_1( phy_clk[1] ), 
	.phy_clk_2(1'b0), 
	.phy_clk_3(1'b0), 
	.phy_clk_4(1'b0), 
	.phy_clk_5(1'b0), 
	.phy_clk_phs_dqs( phy_clk_phs), 

    
	.pipeline_global_en_n( 1'b1 ),	
	.pll_clk   ( 1'b0 ),	
	.pll_locked( pll_locked ),	
	.plniotri           ( 1'b0         ), 
	.progctl( 12'd0 ),	
	.progoe ( 12'd0),	
	.progout( 12'd0 ),	
	.rdata_en_full_core( rdata_en_full_core ),	
	.rdata_valid_core( rdata_valid_core ),	
	.reinit( 1'b0 ),	
	.reset_n     ( reset_n ),	
	.scan_shift_n( 1'b1 ),	
	.scanin( '0 ),	
	.scanout( ),	
	.sync_clk_bot_in( sync_clk_bot_in ),		
	.sync_clk_bot_out( sync_clk_bot_out ),	
	.sync_clk_top_in( sync_clk_top_in ),		
	.sync_clk_top_out( sync_clk_top_out ),	
	.sync_data_bot_in( sync_data_bot_in ),	
	.sync_data_bot_out( sync_data_bot_out ),	
	.sync_data_top_in( sync_data_top_in ),	
	.sync_data_top_out( sync_data_top_out ),	
	.test_db_csr_in( 1'b0 ), 
	.test_dbg_in( ), 	
	.test_dbg_out( 12'd0 ),  	
	.test_dqs_csr_in( 1'b0), 
	.test_ioereg2_csr_out( ), 
	.test_tdf_select_n( 1'b1 ),	
	.test_xor_clk( ),	

	.codatovr(data_in), 
	.codatovrb(~data_in), 

	.tpctl( 12'd0  ),	
	.tpdata( ),	
	.tpin ( 12'd0 ),	
	.usrmode            ( 1'b0         ), 
	.weak_pullup_enable( ), 
	.wkpullup           ( 1'b0         ), 
	.x1024_osc_out( ), 
	.xprio_clk( 1'b0), 
	.xprio_sync( 1'b0), 
	.xprio_xbus( 8'b0), 

	.bslipcntl_pp(), 
	.bslipmax_pp(), 
	.bsliprst_pp(), 
	.csr_scan_shift_n_vref(), 
	.csr_test_clk(), 
	.dpahold_pp(), 
	.dparst_pp(), 
	.dpaswitch_pp(), 
	.dqscodatovr({data_in[10],data_in[8],data_in[6],data_in[4],data_in[2],data_in[0]}), 
	.dqscodatovrb({data_in[11],data_in[9],data_in[7],data_in[5],data_in[3],data_in[1]}), 

	.fiforst_pp(), 
	.lane_test_clr_n(), 
	.lock_pp(), 
	.lvdsin(), 
	.lvdsout(), 
	.par_in_pp0(), 
	.par_in_pp1(), 
	.par_in_pp2(), 
	.par_in_pp3(), 
	.par_in_pp4(), 
	.par_in_pp5(), 
	.par_out_pp0(), 
	.par_out_pp1(), 
	.par_out_pp2(), 
	.par_out_pp3(), 
	.par_out_pp4(), 
	.par_out_pp5(), 
	.pclk_0(), 
	.pclk_1(), 
	.pclk_2(), 
	.pclk_3(), 
	.pclk_4(), 
	.pclk_5(), 
	.pclkdpa(), 

	.phy_clk_dqs(phy_clk), 
	.phy_clk_fb(), 
	.sample_clk_0(), 
	.sample_clk_1(), 
	.sample_clk_2(), 
	.sample_clk_3(), 
	.sample_clk_4(), 
	.sample_clk_5(), 
	.sample_value_iob(), 
	.sample_value_lane(), 
	.sel_vref(), 
	.test_dp_csr_in(), 
	.testin_fclk_pp(), 
	.test_loaden_pp(), 
    .test_clock(), 
    .test_csr_in_spare(), 
    .csr_rclk(), 
    .s2pload_input(), 
    .s2pload_output(), 
    .test_dll_csr_out(), 
    .test_dp_csr_out(), 
    .xor_vref_inbuf(), 
    .xor_vref_outbuf() 
  );

initial begin
    assert (
        a_filter_code == "freq_16ghz" ||
        a_filter_code == "freq_12ghz" ||
        a_filter_code == "freq_10ghz" ||
        a_filter_code == "freq_08ghz"
    ) else $error("Parameter <a_filter_code> is not set to legal value <%s>", a_filter_code);

    assert (
        a_couple_enable == "couple_en" ||
        a_couple_enable == "couple_dis"
    ) else $error("Parameter <a_couple_enable> is not set to legal value <%s>", a_couple_enable);

    assert (
        mode_rate_in == "in_rate_full" ||
        mode_rate_in == "in_rate_1_2" ||
        mode_rate_in == "in_rate_1_4"
    ) else $error("Parameter <mode_rate_in> is not set to legal value <%s>", mode_rate_in);

    assert (
        mode_rate_out == "out_rate_full" ||
        mode_rate_out == "out_rate_1_2" ||
        mode_rate_out == "out_rate_1_4" ||
        mode_rate_out == "out_rate_1_8"
    ) else $error("Parameter <mode_rate_out> is not set to legal value <%s>", mode_rate_out);

    assert (
        phy_clk_sel == "phy_clk_sel_uint0" ||
        phy_clk_sel == "phy_clk_sel_uint1"
    ) else $error("Parameter <phy_clk_sel> is not set to legal value <%s>", phy_clk_sel);

    assert (
        pair_0_ddr4_mode == "pair0_ddr4_idle" ||
        pair_0_ddr4_mode == "pair0_ddr3_idle"
    ) else $error("Parameter <pair_0_ddr4_mode> is not set to legal value <%s>", pair_0_ddr4_mode);

    assert (
        pair_1_ddr4_mode == "pair1_ddr4_idle" ||
        pair_1_ddr4_mode == "pair1_ddr3_idle"
    ) else $error("Parameter <pair_1_ddr4_mode> is not set to legal value <%s>", pair_1_ddr4_mode);

    assert (
        pair_2_ddr4_mode == "pair2_ddr4_idle" ||
        pair_2_ddr4_mode == "pair2_ddr3_idle"
    ) else $error("Parameter <pair_2_ddr4_mode> is not set to legal value <%s>", pair_2_ddr4_mode);

    assert (
        pair_3_ddr4_mode == "pair3_ddr4_idle" ||
        pair_3_ddr4_mode == "pair3_ddr3_idle"
    ) else $error("Parameter <pair_3_ddr4_mode> is not set to legal value <%s>", pair_3_ddr4_mode);

    assert (
        pair_4_ddr4_mode == "pair4_ddr4_idle" ||
        pair_4_ddr4_mode == "pair4_ddr3_idle"
    ) else $error("Parameter <pair_4_ddr4_mode> is not set to legal value <%s>", pair_4_ddr4_mode);

    assert (
        pair_5_ddr4_mode == "pair5_ddr4_idle" ||
        pair_5_ddr4_mode == "pair5_ddr3_idle"
    ) else $error("Parameter <pair_5_ddr4_mode> is not set to legal value <%s>", pair_5_ddr4_mode);
    
    assert (
        mrnk_write_mode == "enabled" ||
        mrnk_write_mode == "disabled"
    ) else $error("Parameter <mrnk_write_mode> is not set to legal value <%s>",  mrnk_write_mode);
    
    assert (
        pair_0_dcc_split_mode == "pair0_dcc_split_enabled" ||
        pair_0_dcc_split_mode == "pair0_dcc_split_disabled"
    ) else $error("Parameter <pair_0_dcc_split_mode> is not set to legal value <%s>", pair_0_dcc_split_mode);

    assert (
        pair_1_dcc_split_mode == "pair1_dcc_split_enabled" ||
        pair_1_dcc_split_mode == "pair1_dcc_split_disabled"
    ) else $error("Parameter <pair_1_dcc_split_mode> is not set to legal value <%s>", pair_1_dcc_split_mode);

    assert (
        pair_2_dcc_split_mode == "pair2_dcc_split_enabled" ||
        pair_2_dcc_split_mode == "pair2_dcc_split_disabled"
    ) else $error("Parameter <pair_2_dcc_split_mode> is not set to legal value <%s>", pair_2_dcc_split_mode);

    assert (
        pair_3_dcc_split_mode == "pair3_dcc_split_enabled" ||
        pair_3_dcc_split_mode == "pair3_dcc_split_disabled"
    ) else $error("Parameter <pair_3_dcc_split_mode> is not set to legal value <%s>", pair_3_dcc_split_mode);

    assert (
        pair_4_dcc_split_mode == "pair4_dcc_split_enabled" ||
        pair_4_dcc_split_mode == "pair4_dcc_split_disabled"
    ) else $error("Parameter <pair_4_dcc_split_mode> is not set to legal value <%s>", pair_4_dcc_split_mode);

    assert (
        pair_5_dcc_split_mode == "pair5_dcc_split_enabled" ||
        pair_5_dcc_split_mode == "pair5_dcc_split_disabled"
    ) else $error("Parameter <pair_5_dcc_split_mode> is not set to legal value <%s>", pair_5_dcc_split_mode);
    
    assert (
        pin_0_initial_out == "pin0_initial_out_z" ||
        pin_0_initial_out == "pin0_initial_out_0" ||
        pin_0_initial_out == "pin0_initial_out_1" ||
        pin_0_initial_out == "pin0_initial_out_x"
    ) else $error("Parameter <pin_0_initial_out> is not set to legal value <%s>", pin_0_initial_out);

    assert (
        pin_0_oct_mode == "pin0_static_off" ||
        pin_0_oct_mode == "pin0_static_on" ||
        pin_0_oct_mode == "pin0_dynamic"
    ) else $error("Parameter <pin_0_oct_mode> is not set to legal value <%s>", pin_0_oct_mode);

    assert (
        pin_0_mode_ddr == "pin0_mode_sdr" ||
        pin_0_mode_ddr == "pin0_mode_ddr"
    ) else $error("Parameter <pin_0_mode_ddr> is not set to legal value <%s>", pin_0_mode_ddr);

    assert (
        pin_0_dqs_mode == "pin0_dqs_sampler_a" ||
        pin_0_dqs_mode == "pin0_dqs_sampler_b" ||
        pin_0_dqs_mode == "pin0_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_0_dqs_mode> is not set to legal value <%s>", pin_0_dqs_mode);

    assert (
        pin_0_data_in_mode == "pin0_ca" ||
        pin_0_data_in_mode == "pin0_clock" ||
        pin_0_data_in_mode == "pin0_dq" ||
        pin_0_data_in_mode == "pin0_dqs" ||
        pin_0_data_in_mode == "pin0_dpa_slave" ||
        pin_0_data_in_mode == "pin0_dpa_master" ||
        pin_0_data_in_mode == "pin0_dq_xor_a_loopback" ||
        pin_0_data_in_mode == "pin0_dq_xor_b_loopback" ||
        pin_0_data_in_mode == "pin0_dqs_xor_loopback"
    ) else $error("Parameter <pin_0_data_in_mode> is not set to legal value <%s>", pin_0_data_in_mode);

    assert (
        pin_1_initial_out == "pin1_initial_out_z" ||
        pin_1_initial_out == "pin1_initial_out_0" ||
        pin_1_initial_out == "pin1_initial_out_1" ||
        pin_1_initial_out == "pin1_initial_out_x"
    ) else $error("Parameter <pin_1_initial_out> is not set to legal value <%s>", pin_1_initial_out);

    assert (
        pin_1_oct_mode == "pin1_static_off" ||
        pin_1_oct_mode == "pin1_static_on" ||
        pin_1_oct_mode == "pin1_dynamic"
    ) else $error("Parameter <pin_1_oct_mode> is not set to legal value <%s>", pin_1_oct_mode);

    assert (
        pin_1_mode_ddr == "pin1_mode_sdr" ||
        pin_1_mode_ddr == "pin1_mode_ddr"
    ) else $error("Parameter <pin_1_mode_ddr> is not set to legal value <%s>", pin_1_mode_ddr);

    assert (
        pin_1_dqs_mode == "pin1_dqs_sampler_a" ||
        pin_1_dqs_mode == "pin1_dqs_sampler_b" ||
        pin_1_dqs_mode == "pin1_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_1_dqs_mode> is not set to legal value <%s>", pin_1_dqs_mode);

    assert (
        pin_1_data_in_mode == "pin1_ca" ||
        pin_1_data_in_mode == "pin1_clock" ||
        pin_1_data_in_mode == "pin1_dq" ||
        pin_1_data_in_mode == "pin1_dqs" ||
        pin_1_data_in_mode == "pin1_dpa_slave" ||
        pin_1_data_in_mode == "pin1_dpa_master" ||
        pin_1_data_in_mode == "pin1_dq_xor_a_loopback" ||
        pin_1_data_in_mode == "pin1_dq_xor_b_loopback" ||
        pin_1_data_in_mode == "pin1_dqs_xor_loopback"
    ) else $error("Parameter <pin_1_data_in_mode> is not set to legal value <%s>", pin_1_data_in_mode);

    assert (
        pin_2_initial_out == "pin2_initial_out_z" ||
        pin_2_initial_out == "pin2_initial_out_0" ||
        pin_2_initial_out == "pin2_initial_out_1" ||
        pin_2_initial_out == "pin2_initial_out_x"
    ) else $error("Parameter <pin_2_initial_out> is not set to legal value <%s>", pin_2_initial_out);

    assert (
        pin_2_oct_mode == "pin2_static_off" ||
        pin_2_oct_mode == "pin2_static_on" ||
        pin_2_oct_mode == "pin2_dynamic"
    ) else $error("Parameter <pin_2_oct_mode> is not set to legal value <%s>", pin_2_oct_mode);

    assert (
        pin_2_mode_ddr == "pin2_mode_sdr" ||
        pin_2_mode_ddr == "pin2_mode_ddr"
    ) else $error("Parameter <pin_2_mode_ddr> is not set to legal value <%s>", pin_2_mode_ddr);

    assert (
        pin_2_dqs_mode == "pin2_dqs_sampler_a" ||
        pin_2_dqs_mode == "pin2_dqs_sampler_b" ||
        pin_2_dqs_mode == "pin2_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_2_dqs_mode> is not set to legal value <%s>", pin_2_dqs_mode);

    assert (
        pin_2_data_in_mode == "pin2_ca" ||
        pin_2_data_in_mode == "pin2_clock" ||
        pin_2_data_in_mode == "pin2_dq" ||
        pin_2_data_in_mode == "pin2_dqs" ||
        pin_2_data_in_mode == "pin2_dpa_slave" ||
        pin_2_data_in_mode == "pin2_dpa_master" ||
        pin_2_data_in_mode == "pin2_dq_xor_a_loopback" ||
        pin_2_data_in_mode == "pin2_dq_xor_b_loopback" ||
        pin_2_data_in_mode == "pin2_dqs_xor_loopback"
    ) else $error("Parameter <pin_2_data_in_mode> is not set to legal value <%s>", pin_2_data_in_mode);

    assert (
        pin_3_initial_out == "pin3_initial_out_z" ||
        pin_3_initial_out == "pin3_initial_out_0" ||
        pin_3_initial_out == "pin3_initial_out_1" ||
        pin_3_initial_out == "pin3_initial_out_x"
    ) else $error("Parameter <pin_3_initial_out> is not set to legal value <%s>", pin_3_initial_out);

    assert (
        pin_3_oct_mode == "pin3_static_off" ||
        pin_3_oct_mode == "pin3_static_on" ||
        pin_3_oct_mode == "pin3_dynamic"
    ) else $error("Parameter <pin_3_oct_mode> is not set to legal value <%s>", pin_3_oct_mode);

    assert (
        pin_3_mode_ddr == "pin3_mode_sdr" ||
        pin_3_mode_ddr == "pin3_mode_ddr"
    ) else $error("Parameter <pin_3_mode_ddr> is not set to legal value <%s>", pin_3_mode_ddr);

    assert (
        pin_3_dqs_mode == "pin3_dqs_sampler_a" ||
        pin_3_dqs_mode == "pin3_dqs_sampler_b" ||
        pin_3_dqs_mode == "pin3_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_3_dqs_mode> is not set to legal value <%s>", pin_3_dqs_mode);

    assert (
        pin_3_data_in_mode == "pin3_ca" ||
        pin_3_data_in_mode == "pin3_clock" ||
        pin_3_data_in_mode == "pin3_dq" ||
        pin_3_data_in_mode == "pin3_dqs" ||
        pin_3_data_in_mode == "pin3_dpa_slave" ||
        pin_3_data_in_mode == "pin3_dpa_master" ||
        pin_3_data_in_mode == "pin3_dq_xor_a_loopback" ||
        pin_3_data_in_mode == "pin3_dq_xor_b_loopback" ||
        pin_3_data_in_mode == "pin3_dqs_xor_loopback"
    ) else $error("Parameter <pin_3_data_in_mode> is not set to legal value <%s>", pin_3_data_in_mode);

    assert (
        pin_4_initial_out == "pin4_initial_out_z" ||
        pin_4_initial_out == "pin4_initial_out_0" ||
        pin_4_initial_out == "pin4_initial_out_1" ||
        pin_4_initial_out == "pin4_initial_out_x"
    ) else $error("Parameter <pin_4_initial_out> is not set to legal value <%s>", pin_4_initial_out);

    assert (
        pin_4_oct_mode == "pin4_static_off" ||
        pin_4_oct_mode == "pin4_static_on" ||
        pin_4_oct_mode == "pin4_dynamic"
    ) else $error("Parameter <pin_4_oct_mode> is not set to legal value <%s>", pin_4_oct_mode);

    assert (
        pin_4_mode_ddr == "pin4_mode_sdr" ||
        pin_4_mode_ddr == "pin4_mode_ddr"
    ) else $error("Parameter <pin_4_mode_ddr> is not set to legal value <%s>", pin_4_mode_ddr);

    assert (
        pin_4_dqs_mode == "pin4_dqs_sampler_a" ||
        pin_4_dqs_mode == "pin4_dqs_sampler_b" ||
        pin_4_dqs_mode == "pin4_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_4_dqs_mode> is not set to legal value <%s>", pin_4_dqs_mode);

    assert (
        pin_4_data_in_mode == "pin4_ca" ||
        pin_4_data_in_mode == "pin4_clock" ||
        pin_4_data_in_mode == "pin4_dq" ||
        pin_4_data_in_mode == "pin4_dqs" ||
        pin_4_data_in_mode == "pin4_dpa_slave" ||
        pin_4_data_in_mode == "pin4_dpa_master" ||
        pin_4_data_in_mode == "pin4_dq_xor_a_loopback" ||
        pin_4_data_in_mode == "pin4_dq_xor_b_loopback" ||
        pin_4_data_in_mode == "pin4_dqs_xor_loopback"
    ) else $error("Parameter <pin_4_data_in_mode> is not set to legal value <%s>", pin_4_data_in_mode);

    assert (
        pin_5_initial_out == "pin5_initial_out_z" ||
        pin_5_initial_out == "pin5_initial_out_0" ||
        pin_5_initial_out == "pin5_initial_out_1" ||
        pin_5_initial_out == "pin5_initial_out_x"
    ) else $error("Parameter <pin_5_initial_out> is not set to legal value <%s>", pin_5_initial_out);

    assert (
        pin_5_oct_mode == "pin5_static_off" ||
        pin_5_oct_mode == "pin5_static_on" ||
        pin_5_oct_mode == "pin5_dynamic"
    ) else $error("Parameter <pin_5_oct_mode> is not set to legal value <%s>", pin_5_oct_mode);

    assert (
        pin_5_mode_ddr == "pin5_mode_sdr" ||
        pin_5_mode_ddr == "pin5_mode_ddr"
    ) else $error("Parameter <pin_5_mode_ddr> is not set to legal value <%s>", pin_5_mode_ddr);

    assert (
        pin_5_dqs_mode == "pin5_dqs_sampler_a" ||
        pin_5_dqs_mode == "pin5_dqs_sampler_b" ||
        pin_5_dqs_mode == "pin5_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_5_dqs_mode> is not set to legal value <%s>", pin_5_dqs_mode);

    assert (
        pin_5_data_in_mode == "pin5_ca" ||
        pin_5_data_in_mode == "pin5_clock" ||
        pin_5_data_in_mode == "pin5_dq" ||
        pin_5_data_in_mode == "pin5_dqs" ||
        pin_5_data_in_mode == "pin5_dpa_slave" ||
        pin_5_data_in_mode == "pin5_dpa_master" ||
        pin_5_data_in_mode == "pin5_dq_xor_a_loopback" ||
        pin_5_data_in_mode == "pin5_dq_xor_b_loopback" ||
        pin_5_data_in_mode == "pin5_dqs_xor_loopback"
    ) else $error("Parameter <pin_5_data_in_mode> is not set to legal value <%s>", pin_5_data_in_mode);

    assert (
        pin_6_initial_out == "pin6_initial_out_z" ||
        pin_6_initial_out == "pin6_initial_out_0" ||
        pin_6_initial_out == "pin6_initial_out_1" ||
        pin_6_initial_out == "pin6_initial_out_x"
    ) else $error("Parameter <pin_6_initial_out> is not set to legal value <%s>", pin_6_initial_out);

    assert (
        pin_6_oct_mode == "pin6_static_off" ||
        pin_6_oct_mode == "pin6_static_on" ||
        pin_6_oct_mode == "pin6_dynamic"
    ) else $error("Parameter <pin_6_oct_mode> is not set to legal value <%s>", pin_6_oct_mode);

    assert (
        pin_6_mode_ddr == "pin6_mode_sdr" ||
        pin_6_mode_ddr == "pin6_mode_ddr"
    ) else $error("Parameter <pin_6_mode_ddr> is not set to legal value <%s>", pin_6_mode_ddr);

    assert (
        pin_6_dqs_mode == "pin6_dqs_sampler_a" ||
        pin_6_dqs_mode == "pin6_dqs_sampler_b" ||
        pin_6_dqs_mode == "pin6_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_6_dqs_mode> is not set to legal value <%s>", pin_6_dqs_mode);

    assert (
        pin_6_data_in_mode == "pin6_ca" ||
        pin_6_data_in_mode == "pin6_clock" ||
        pin_6_data_in_mode == "pin6_dq" ||
        pin_6_data_in_mode == "pin6_dqs" ||
        pin_6_data_in_mode == "pin6_dpa_slave" ||
        pin_6_data_in_mode == "pin6_dpa_master" ||
        pin_6_data_in_mode == "pin6_dq_xor_a_loopback" ||
        pin_6_data_in_mode == "pin6_dq_xor_b_loopback" ||
        pin_6_data_in_mode == "pin6_dqs_xor_loopback"
    ) else $error("Parameter <pin_6_data_in_mode> is not set to legal value <%s>", pin_6_data_in_mode);

    assert (
        pin_7_initial_out == "pin7_initial_out_z" ||
        pin_7_initial_out == "pin7_initial_out_0" ||
        pin_7_initial_out == "pin7_initial_out_1" ||
        pin_7_initial_out == "pin7_initial_out_x"
    ) else $error("Parameter <pin_7_initial_out> is not set to legal value <%s>", pin_7_initial_out);

    assert (
        pin_7_oct_mode == "pin7_static_off" ||
        pin_7_oct_mode == "pin7_static_on" ||
        pin_7_oct_mode == "pin7_dynamic"
    ) else $error("Parameter <pin_7_oct_mode> is not set to legal value <%s>", pin_7_oct_mode);

    assert (
        pin_7_mode_ddr == "pin7_mode_sdr" ||
        pin_7_mode_ddr == "pin7_mode_ddr"
    ) else $error("Parameter <pin_7_mode_ddr> is not set to legal value <%s>", pin_7_mode_ddr);

    assert (
        pin_7_dqs_mode == "pin7_dqs_sampler_a" ||
        pin_7_dqs_mode == "pin7_dqs_sampler_b" ||
        pin_7_dqs_mode == "pin7_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_7_dqs_mode> is not set to legal value <%s>", pin_7_dqs_mode);

    assert (
        pin_7_data_in_mode == "pin7_ca" ||
        pin_7_data_in_mode == "pin7_clock" ||
        pin_7_data_in_mode == "pin7_dq" ||
        pin_7_data_in_mode == "pin7_dqs" ||
        pin_7_data_in_mode == "pin7_dpa_slave" ||
        pin_7_data_in_mode == "pin7_dpa_master" ||
        pin_7_data_in_mode == "pin7_dq_xor_a_loopback" ||
        pin_7_data_in_mode == "pin7_dq_xor_b_loopback" ||
        pin_7_data_in_mode == "pin7_dqs_xor_loopback"
    ) else $error("Parameter <pin_7_data_in_mode> is not set to legal value <%s>", pin_7_data_in_mode);

    assert (
        pin_8_initial_out == "pin8_initial_out_z" ||
        pin_8_initial_out == "pin8_initial_out_0" ||
        pin_8_initial_out == "pin8_initial_out_1" ||
        pin_8_initial_out == "pin8_initial_out_x"
    ) else $error("Parameter <pin_8_initial_out> is not set to legal value <%s>", pin_8_initial_out);

    assert (
        pin_8_oct_mode == "pin8_static_off" ||
        pin_8_oct_mode == "pin8_static_on" ||
        pin_8_oct_mode == "pin8_dynamic"
    ) else $error("Parameter <pin_8_oct_mode> is not set to legal value <%s>", pin_8_oct_mode);

    assert (
        pin_8_mode_ddr == "pin8_mode_sdr" ||
        pin_8_mode_ddr == "pin8_mode_ddr"
    ) else $error("Parameter <pin_8_mode_ddr> is not set to legal value <%s>", pin_8_mode_ddr);

    assert (
        pin_8_dqs_mode == "pin8_dqs_sampler_a" ||
        pin_8_dqs_mode == "pin8_dqs_sampler_b" ||
        pin_8_dqs_mode == "pin8_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_8_dqs_mode> is not set to legal value <%s>", pin_8_dqs_mode);

    assert (
        pin_8_data_in_mode == "pin8_ca" ||
        pin_8_data_in_mode == "pin8_clock" ||
        pin_8_data_in_mode == "pin8_dq" ||
        pin_8_data_in_mode == "pin8_dqs" ||
        pin_8_data_in_mode == "pin8_dpa_slave" ||
        pin_8_data_in_mode == "pin8_dpa_master" ||
        pin_8_data_in_mode == "pin8_dq_xor_a_loopback" ||
        pin_8_data_in_mode == "pin8_dq_xor_b_loopback" ||
        pin_8_data_in_mode == "pin8_dqs_xor_loopback"
    ) else $error("Parameter <pin_8_data_in_mode> is not set to legal value <%s>", pin_8_data_in_mode);

    assert (
        pin_9_initial_out == "pin9_initial_out_z" ||
        pin_9_initial_out == "pin9_initial_out_0" ||
        pin_9_initial_out == "pin9_initial_out_1" ||
        pin_9_initial_out == "pin9_initial_out_x"
    ) else $error("Parameter <pin_9_initial_out> is not set to legal value <%s>", pin_9_initial_out);

    assert (
        pin_9_oct_mode == "pin9_static_off" ||
        pin_9_oct_mode == "pin9_static_on" ||
        pin_9_oct_mode == "pin9_dynamic"
    ) else $error("Parameter <pin_9_oct_mode> is not set to legal value <%s>", pin_9_oct_mode);

    assert (
        pin_9_mode_ddr == "pin9_mode_sdr" ||
        pin_9_mode_ddr == "pin9_mode_ddr"
    ) else $error("Parameter <pin_9_mode_ddr> is not set to legal value <%s>", pin_9_mode_ddr);

    assert (
        pin_9_dqs_mode == "pin9_dqs_sampler_a" ||
        pin_9_dqs_mode == "pin9_dqs_sampler_b" ||
        pin_9_dqs_mode == "pin9_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_9_dqs_mode> is not set to legal value <%s>", pin_9_dqs_mode);

    assert (
        pin_9_data_in_mode == "pin9_ca" ||
        pin_9_data_in_mode == "pin9_clock" ||
        pin_9_data_in_mode == "pin9_dq" ||
        pin_9_data_in_mode == "pin9_dqs" ||
        pin_9_data_in_mode == "pin9_dpa_slave" ||
        pin_9_data_in_mode == "pin9_dpa_master" ||
        pin_9_data_in_mode == "pin9_dq_xor_a_loopback" ||
        pin_9_data_in_mode == "pin9_dq_xor_b_loopback" ||
        pin_9_data_in_mode == "pin9_dqs_xor_loopback"
    ) else $error("Parameter <pin_9_data_in_mode> is not set to legal value <%s>", pin_9_data_in_mode);

    assert (
        pin_10_initial_out == "pin10_initial_out_z" ||
        pin_10_initial_out == "pin10_initial_out_0" ||
        pin_10_initial_out == "pin10_initial_out_1" ||
        pin_10_initial_out == "pin10_initial_out_x"
    ) else $error("Parameter <pin_10_initial_out> is not set to legal value <%s>", pin_10_initial_out);

    assert (
        pin_10_oct_mode == "pin10_static_off" ||
        pin_10_oct_mode == "pin10_static_on" ||
        pin_10_oct_mode == "pin10_dynamic"
    ) else $error("Parameter <pin_10_oct_mode> is not set to legal value <%s>", pin_10_oct_mode);

    assert (
        pin_10_mode_ddr == "pin10_mode_sdr" ||
        pin_10_mode_ddr == "pin10_mode_ddr"
    ) else $error("Parameter <pin_10_mode_ddr> is not set to legal value <%s>", pin_10_mode_ddr);

    assert (
        pin_10_dqs_mode == "pin10_dqs_sampler_a" ||
        pin_10_dqs_mode == "pin10_dqs_sampler_b" ||
        pin_10_dqs_mode == "pin10_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_10_dqs_mode> is not set to legal value <%s>", pin_10_dqs_mode);

    assert (
        pin_10_data_in_mode == "pin10_ca" ||
        pin_10_data_in_mode == "pin10_clock" ||
        pin_10_data_in_mode == "pin10_dq" ||
        pin_10_data_in_mode == "pin10_dqs" ||
        pin_10_data_in_mode == "pin10_dpa_slave" ||
        pin_10_data_in_mode == "pin10_dpa_master" ||
        pin_10_data_in_mode == "pin10_dq_xor_a_loopback" ||
        pin_10_data_in_mode == "pin10_dq_xor_b_loopback" ||
        pin_10_data_in_mode == "pin10_dqs_xor_loopback"
    ) else $error("Parameter <pin_10_data_in_mode> is not set to legal value <%s>", pin_10_data_in_mode);

    assert (
        pin_11_initial_out == "pin11_initial_out_z" ||
        pin_11_initial_out == "pin11_initial_out_0" ||
        pin_11_initial_out == "pin11_initial_out_1" ||
        pin_11_initial_out == "pin11_initial_out_x"
    ) else $error("Parameter <pin_11_initial_out> is not set to legal value <%s>", pin_11_initial_out);

    assert (
        pin_11_oct_mode == "pin11_static_off" ||
        pin_11_oct_mode == "pin11_static_on" ||
        pin_11_oct_mode == "pin11_dynamic"
    ) else $error("Parameter <pin_11_oct_mode> is not set to legal value <%s>", pin_11_oct_mode);

    assert (
        pin_11_mode_ddr == "pin11_mode_sdr" ||
        pin_11_mode_ddr == "pin11_mode_ddr"
    ) else $error("Parameter <pin_11_mode_ddr> is not set to legal value <%s>", pin_11_mode_ddr);

    assert (
        pin_11_dqs_mode == "pin11_dqs_sampler_a" ||
        pin_11_dqs_mode == "pin11_dqs_sampler_b" ||
        pin_11_dqs_mode == "pin11_dqs_sampler_b_a_rise"
    ) else $error("Parameter <pin_11_dqs_mode> is not set to legal value <%s>", pin_11_dqs_mode);

    assert (
        pin_11_data_in_mode == "pin11_ca" ||
        pin_11_data_in_mode == "pin11_clock" ||
        pin_11_data_in_mode == "pin11_dq" ||
        pin_11_data_in_mode == "pin11_dqs" ||
        pin_11_data_in_mode == "pin11_dpa_slave" ||
        pin_11_data_in_mode == "pin11_dpa_master" ||
        pin_11_data_in_mode == "pin11_dq_xor_a_loopback" ||
        pin_11_data_in_mode == "pin11_dq_xor_b_loopback" ||
        pin_11_data_in_mode == "pin11_dqs_xor_loopback"
    ) else $error("Parameter <pin_11_data_in_mode> is not set to legal value <%s>", pin_11_data_in_mode);

    assert (
        db_hmc_or_core == "core" ||
        db_hmc_or_core == "hmc"
    ) else $error("Parameter <db_hmc_or_core> is not set to legal value <%s>", db_hmc_or_core);

    assert (
        db_dbi_sel == "db_dbi_sel_uint0" ||
        db_dbi_sel == "db_dbi_sel_uint1" ||
        db_dbi_sel == "db_dbi_sel_uint2" ||
        db_dbi_sel == "db_dbi_sel_uint3" ||
        db_dbi_sel == "db_dbi_sel_uint4" ||
        db_dbi_sel == "db_dbi_sel_uint5" ||
        db_dbi_sel == "db_dbi_sel_uint6" ||
        db_dbi_sel == "db_dbi_sel_uint7" ||
        db_dbi_sel == "db_dbi_sel_uint8" ||
        db_dbi_sel == "db_dbi_sel_uint9" ||
        db_dbi_sel == "db_dbi_sel_uint10" ||
        db_dbi_sel == "db_dbi_sel_uint11"
    ) else $error("Parameter <db_dbi_sel> is not set to legal value <%s>", db_dbi_sel);

    assert (
        db_dbi_wr_en == "false" ||
        db_dbi_wr_en == "true"
    ) else $error("Parameter <db_dbi_wr_en> is not set to legal value <%s>", db_dbi_wr_en);

    assert (
        db_dbi_rd_en == "false" ||
        db_dbi_rd_en == "true"
    ) else $error("Parameter <db_dbi_rd_en> is not set to legal value <%s>", db_dbi_rd_en);

    assert (
        avl_ena == "true" ||
        avl_ena == "false"
    ) else $error("Parameter <avl_ena> is not set to legal value <%s>", avl_ena);

    assert (
        db_boardcast_en == "true" ||
        db_boardcast_en == "false"
    ) else $error("Parameter <db_boardcast_en> is not set to legal value <%s>", db_boardcast_en);

    assert (
        db_pipeline == "pipeline_bypass" ||
        db_pipeline == "pipeline_one_cycle"
    ) else $error("Parameter <db_pipeline> is not set to legal value <%s>", db_pipeline);

    assert (
        db_rwlat_mode == "csr_vlu" ||
        db_rwlat_mode == "avl_vlu"
    ) else $error("Parameter <db_rwlat_mode> is not set to legal value <%s>", db_rwlat_mode);

    assert (
        db_ptr_pipeline_depth == "db_ptr_pipeline_depth_uint0" ||
        db_ptr_pipeline_depth == "db_ptr_pipeline_depth_uint1" ||
        db_ptr_pipeline_depth == "db_ptr_pipeline_depth_uint2" ||
        db_ptr_pipeline_depth == "db_ptr_pipeline_depth_uint3" ||
        db_ptr_pipeline_depth == "db_ptr_pipeline_depth_uint4"
    ) else $error("Parameter <db_ptr_pipeline_depth> is not set to legal value <%s>", db_ptr_pipeline_depth);

    assert (
        db_preamble_mode == "preamble_one_cycle" ||
        db_preamble_mode == "preamble_two_cycle"
    ) else $error("Parameter <db_preamble_mode> is not set to legal value <%s>", db_preamble_mode);

    assert (
        db_reset_auto_release == "avl_release" ||
        db_reset_auto_release == "auto_release"
    ) else $error("Parameter <db_reset_auto_release> is not set to legal value <%s>", db_reset_auto_release);

    assert (
        db_data_alignment_mode == "align_disable" ||
        db_data_alignment_mode == "align_ena"
    ) else $error("Parameter <db_data_alignment_mode> is not set to legal value <%s>", db_data_alignment_mode);

    assert (
        db_db2core_registered == "registered" ||
        db_db2core_registered == "not_registered"
    ) else $error("Parameter <db_db2core_registered> is not set to legal value <%s>", db_db2core_registered);

    assert (
        dbc_core_clk_sel == "dbc_core_clk_sel_uint0" ||
        dbc_core_clk_sel == "dbc_core_clk_sel_uint1"
    ) else $error("Parameter <dbc_core_clk_sel> is not set to legal value <%s>", dbc_core_clk_sel);

    assert (
        db_core_or_hmc2db_registered == "true" ||
        db_core_or_hmc2db_registered == "false"
    ) else $error("Parameter <db_core_or_hmc2db_registered> is not set to legal value <%s>", db_core_or_hmc2db_registered);

    assert (
        db_seq_rd_en_full_pipeline == "db_seq_rd_en_full_pipeline_uint0" ||
        db_seq_rd_en_full_pipeline == "db_seq_rd_en_full_pipeline_uint1" ||
        db_seq_rd_en_full_pipeline == "db_seq_rd_en_full_pipeline_uint2" ||
        db_seq_rd_en_full_pipeline == "db_seq_rd_en_full_pipeline_uint3" ||
        db_seq_rd_en_full_pipeline == "db_seq_rd_en_full_pipeline_uint4"
    ) else $error("Parameter <db_seq_rd_en_full_pipeline> is not set to legal value <%s>", db_seq_rd_en_full_pipeline);

    assert (
        db_pin_0_mode == "pin0_ac_ddr4_hmc" ||
        db_pin_0_mode == "pin0_dq_wdb_ddr4_mode" ||
        db_pin_0_mode == "pin0_dm_wdb_ddr4_mode" ||
        db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode" ||
        db_pin_0_mode == "pin0_clk_wdb_ddr4_mode" ||
        db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode" ||
        db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode" ||
        db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode" ||
        db_pin_0_mode == "pin0_ac_hmc" ||
        db_pin_0_mode == "pin0_dq_wdb_mode" ||
        db_pin_0_mode == "pin0_dm_wdb_mode" ||
        db_pin_0_mode == "pin0_dbi_wdb_mode" ||
        db_pin_0_mode == "pin0_clk_wdb_mode" ||
        db_pin_0_mode == "pin0_clkb_wdb_mode" ||
        db_pin_0_mode == "pin0_dqs_wdb_mode" ||
        db_pin_0_mode == "pin0_dqsb_wdb_mode" ||
        db_pin_0_mode == "pin0_ac_core" ||
        db_pin_0_mode == "pin0_dq_mode" ||
        db_pin_0_mode == "pin0_dm_mode" ||
        db_pin_0_mode == "pin0_dbi_mode" ||
        db_pin_0_mode == "pin0_clk_mode" ||
        db_pin_0_mode == "pin0_clkb_mode" ||
        db_pin_0_mode == "pin0_dqs_mode" ||
        db_pin_0_mode == "pin0_dqsb_mode" ||
        db_pin_0_mode == "pin0_dqs_ddr4_mode" ||
        db_pin_0_mode == "pin0_dqsb_ddr4_mode" ||
        db_pin_0_mode == "pin0_rdq_mode" ||
        db_pin_0_mode == "pin0_rdqs_mode" ||
        db_pin_0_mode == "pin0_gpio_mode"
    ) else $error("Parameter <db_pin_0_mode> is not set to legal value <%s>", db_pin_0_mode);

    assert (
        db_pin_1_mode == "pin1_ac_ddr4_hmc" ||
        db_pin_1_mode == "pin1_dq_wdb_ddr4_mode" ||
        db_pin_1_mode == "pin1_dm_wdb_ddr4_mode" ||
        db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode" ||
        db_pin_1_mode == "pin1_clk_wdb_ddr4_mode" ||
        db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode" ||
        db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode" ||
        db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode" ||
        db_pin_1_mode == "pin1_ac_hmc" ||
        db_pin_1_mode == "pin1_dq_wdb_mode" ||
        db_pin_1_mode == "pin1_dm_wdb_mode" ||
        db_pin_1_mode == "pin1_dbi_wdb_mode" ||
        db_pin_1_mode == "pin1_clk_wdb_mode" ||
        db_pin_1_mode == "pin1_clkb_wdb_mode" ||
        db_pin_1_mode == "pin1_dqs_wdb_mode" ||
        db_pin_1_mode == "pin1_dqsb_wdb_mode" ||
        db_pin_1_mode == "pin1_ac_core" ||
        db_pin_1_mode == "pin1_dq_mode" ||
        db_pin_1_mode == "pin1_dm_mode" ||
        db_pin_1_mode == "pin1_dbi_mode" ||
        db_pin_1_mode == "pin1_clk_mode" ||
        db_pin_1_mode == "pin1_clkb_mode" ||
        db_pin_1_mode == "pin1_dqs_mode" ||
        db_pin_1_mode == "pin1_dqsb_mode" ||
        db_pin_1_mode == "pin1_dqs_ddr4_mode" ||
        db_pin_1_mode == "pin1_dqsb_ddr4_mode" ||
        db_pin_1_mode == "pin1_rdq_mode" ||
        db_pin_1_mode == "pin1_rdqs_mode" ||
        db_pin_1_mode == "pin1_gpio_mode"
    ) else $error("Parameter <db_pin_1_mode> is not set to legal value <%s>", db_pin_1_mode);

    assert (
        db_pin_2_mode == "pin2_ac_ddr4_hmc" ||
        db_pin_2_mode == "pin2_dq_wdb_ddr4_mode" ||
        db_pin_2_mode == "pin2_dm_wdb_ddr4_mode" ||
        db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode" ||
        db_pin_2_mode == "pin2_clk_wdb_ddr4_mode" ||
        db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode" ||
        db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode" ||
        db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode" ||
        db_pin_2_mode == "pin2_ac_hmc" ||
        db_pin_2_mode == "pin2_dq_wdb_mode" ||
        db_pin_2_mode == "pin2_dm_wdb_mode" ||
        db_pin_2_mode == "pin2_dbi_wdb_mode" ||
        db_pin_2_mode == "pin2_clk_wdb_mode" ||
        db_pin_2_mode == "pin2_clkb_wdb_mode" ||
        db_pin_2_mode == "pin2_dqs_wdb_mode" ||
        db_pin_2_mode == "pin2_dqsb_wdb_mode" ||
        db_pin_2_mode == "pin2_ac_core" ||
        db_pin_2_mode == "pin2_dq_mode" ||
        db_pin_2_mode == "pin2_dm_mode" ||
        db_pin_2_mode == "pin2_dbi_mode" ||
        db_pin_2_mode == "pin2_clk_mode" ||
        db_pin_2_mode == "pin2_clkb_mode" ||
        db_pin_2_mode == "pin2_dqs_mode" ||
        db_pin_2_mode == "pin2_dqsb_mode" ||
        db_pin_2_mode == "pin2_dqs_ddr4_mode" ||
        db_pin_2_mode == "pin2_dqsb_ddr4_mode" ||
        db_pin_2_mode == "pin2_rdq_mode" ||
        db_pin_2_mode == "pin2_rdqs_mode" ||
        db_pin_2_mode == "pin2_gpio_mode"
    ) else $error("Parameter <db_pin_2_mode> is not set to legal value <%s>", db_pin_2_mode);

    assert (
        db_pin_3_mode == "pin3_ac_ddr4_hmc" ||
        db_pin_3_mode == "pin3_dq_wdb_ddr4_mode" ||
        db_pin_3_mode == "pin3_dm_wdb_ddr4_mode" ||
        db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode" ||
        db_pin_3_mode == "pin3_clk_wdb_ddr4_mode" ||
        db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode" ||
        db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode" ||
        db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode" ||
        db_pin_3_mode == "pin3_ac_hmc" ||
        db_pin_3_mode == "pin3_dq_wdb_mode" ||
        db_pin_3_mode == "pin3_dm_wdb_mode" ||
        db_pin_3_mode == "pin3_dbi_wdb_mode" ||
        db_pin_3_mode == "pin3_clk_wdb_mode" ||
        db_pin_3_mode == "pin3_clkb_wdb_mode" ||
        db_pin_3_mode == "pin3_dqs_wdb_mode" ||
        db_pin_3_mode == "pin3_dqsb_wdb_mode" ||
        db_pin_3_mode == "pin3_ac_core" ||
        db_pin_3_mode == "pin3_dq_mode" ||
        db_pin_3_mode == "pin3_dm_mode" ||
        db_pin_3_mode == "pin3_dbi_mode" ||
        db_pin_3_mode == "pin3_clk_mode" ||
        db_pin_3_mode == "pin3_clkb_mode" ||
        db_pin_3_mode == "pin3_dqs_mode" ||
        db_pin_3_mode == "pin3_dqsb_mode" ||
        db_pin_3_mode == "pin3_dqs_ddr4_mode" ||
        db_pin_3_mode == "pin3_dqsb_ddr4_mode" ||
        db_pin_3_mode == "pin3_rdq_mode" ||
        db_pin_3_mode == "pin3_rdqs_mode" ||
        db_pin_3_mode == "pin3_gpio_mode"
    ) else $error("Parameter <db_pin_3_mode> is not set to legal value <%s>", db_pin_3_mode);

    assert (
        db_pin_4_mode == "pin4_ac_ddr4_hmc" ||
        db_pin_4_mode == "pin4_dq_wdb_ddr4_mode" ||
        db_pin_4_mode == "pin4_dm_wdb_ddr4_mode" ||
        db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode" ||
        db_pin_4_mode == "pin4_clk_wdb_ddr4_mode" ||
        db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode" ||
        db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode" ||
        db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode" ||
        db_pin_4_mode == "pin4_ac_hmc" ||
        db_pin_4_mode == "pin4_dq_wdb_mode" ||
        db_pin_4_mode == "pin4_dm_wdb_mode" ||
        db_pin_4_mode == "pin4_dbi_wdb_mode" ||
        db_pin_4_mode == "pin4_clk_wdb_mode" ||
        db_pin_4_mode == "pin4_clkb_wdb_mode" ||
        db_pin_4_mode == "pin4_dqs_wdb_mode" ||
        db_pin_4_mode == "pin4_dqsb_wdb_mode" ||
        db_pin_4_mode == "pin4_ac_core" ||
        db_pin_4_mode == "pin4_dq_mode" ||
        db_pin_4_mode == "pin4_dm_mode" ||
        db_pin_4_mode == "pin4_dbi_mode" ||
        db_pin_4_mode == "pin4_clk_mode" ||
        db_pin_4_mode == "pin4_clkb_mode" ||
        db_pin_4_mode == "pin4_dqs_mode" ||
        db_pin_4_mode == "pin4_dqsb_mode" ||
        db_pin_4_mode == "pin4_dqs_ddr4_mode" ||
        db_pin_4_mode == "pin4_dqsb_ddr4_mode" ||
        db_pin_4_mode == "pin4_rdq_mode" ||
        db_pin_4_mode == "pin4_rdqs_mode" ||
        db_pin_4_mode == "pin4_gpio_mode"
    ) else $error("Parameter <db_pin_4_mode> is not set to legal value <%s>", db_pin_4_mode);

    assert (
        db_pin_5_mode == "pin5_ac_ddr4_hmc" ||
        db_pin_5_mode == "pin5_dq_wdb_ddr4_mode" ||
        db_pin_5_mode == "pin5_dm_wdb_ddr4_mode" ||
        db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode" ||
        db_pin_5_mode == "pin5_clk_wdb_ddr4_mode" ||
        db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode" ||
        db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode" ||
        db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode" ||
        db_pin_5_mode == "pin5_ac_hmc" ||
        db_pin_5_mode == "pin5_dq_wdb_mode" ||
        db_pin_5_mode == "pin5_dm_wdb_mode" ||
        db_pin_5_mode == "pin5_dbi_wdb_mode" ||
        db_pin_5_mode == "pin5_clk_wdb_mode" ||
        db_pin_5_mode == "pin5_clkb_wdb_mode" ||
        db_pin_5_mode == "pin5_dqs_wdb_mode" ||
        db_pin_5_mode == "pin5_dqsb_wdb_mode" ||
        db_pin_5_mode == "pin5_ac_core" ||
        db_pin_5_mode == "pin5_dq_mode" ||
        db_pin_5_mode == "pin5_dm_mode" ||
        db_pin_5_mode == "pin5_dbi_mode" ||
        db_pin_5_mode == "pin5_clk_mode" ||
        db_pin_5_mode == "pin5_clkb_mode" ||
        db_pin_5_mode == "pin5_dqs_mode" ||
        db_pin_5_mode == "pin5_dqsb_mode" ||
        db_pin_5_mode == "pin5_dqs_ddr4_mode" ||
        db_pin_5_mode == "pin5_dqsb_ddr4_mode" ||
        db_pin_5_mode == "pin5_rdq_mode" ||
        db_pin_5_mode == "pin5_rdqs_mode" ||
        db_pin_5_mode == "pin5_gpio_mode"
    ) else $error("Parameter <db_pin_5_mode> is not set to legal value <%s>", db_pin_5_mode);

    assert (
        db_pin_6_mode == "pin6_ac_ddr4_hmc" ||
        db_pin_6_mode == "pin6_dq_wdb_ddr4_mode" ||
        db_pin_6_mode == "pin6_dm_wdb_ddr4_mode" ||
        db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode" ||
        db_pin_6_mode == "pin6_clk_wdb_ddr4_mode" ||
        db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode" ||
        db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode" ||
        db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode" ||
        db_pin_6_mode == "pin6_ac_hmc" ||
        db_pin_6_mode == "pin6_dq_wdb_mode" ||
        db_pin_6_mode == "pin6_dm_wdb_mode" ||
        db_pin_6_mode == "pin6_dbi_wdb_mode" ||
        db_pin_6_mode == "pin6_clk_wdb_mode" ||
        db_pin_6_mode == "pin6_clkb_wdb_mode" ||
        db_pin_6_mode == "pin6_dqs_wdb_mode" ||
        db_pin_6_mode == "pin6_dqsb_wdb_mode" ||
        db_pin_6_mode == "pin6_ac_core" ||
        db_pin_6_mode == "pin6_dq_mode" ||
        db_pin_6_mode == "pin6_dm_mode" ||
        db_pin_6_mode == "pin6_dbi_mode" ||
        db_pin_6_mode == "pin6_clk_mode" ||
        db_pin_6_mode == "pin6_clkb_mode" ||
        db_pin_6_mode == "pin6_dqs_mode" ||
        db_pin_6_mode == "pin6_dqsb_mode" ||
        db_pin_6_mode == "pin6_dqs_ddr4_mode" ||
        db_pin_6_mode == "pin6_dqsb_ddr4_mode" ||
        db_pin_6_mode == "pin6_rdq_mode" ||
        db_pin_6_mode == "pin6_rdqs_mode" ||
        db_pin_6_mode == "pin6_gpio_mode"
    ) else $error("Parameter <db_pin_6_mode> is not set to legal value <%s>", db_pin_6_mode);

    assert (
        db_pin_7_mode == "pin7_ac_ddr4_hmc" ||
        db_pin_7_mode == "pin7_dq_wdb_ddr4_mode" ||
        db_pin_7_mode == "pin7_dm_wdb_ddr4_mode" ||
        db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode" ||
        db_pin_7_mode == "pin7_clk_wdb_ddr4_mode" ||
        db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode" ||
        db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode" ||
        db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode" ||
        db_pin_7_mode == "pin7_ac_hmc" ||
        db_pin_7_mode == "pin7_dq_wdb_mode" ||
        db_pin_7_mode == "pin7_dm_wdb_mode" ||
        db_pin_7_mode == "pin7_dbi_wdb_mode" ||
        db_pin_7_mode == "pin7_clk_wdb_mode" ||
        db_pin_7_mode == "pin7_clkb_wdb_mode" ||
        db_pin_7_mode == "pin7_dqs_wdb_mode" ||
        db_pin_7_mode == "pin7_dqsb_wdb_mode" ||
        db_pin_7_mode == "pin7_ac_core" ||
        db_pin_7_mode == "pin7_dq_mode" ||
        db_pin_7_mode == "pin7_dm_mode" ||
        db_pin_7_mode == "pin7_dbi_mode" ||
        db_pin_7_mode == "pin7_clk_mode" ||
        db_pin_7_mode == "pin7_clkb_mode" ||
        db_pin_7_mode == "pin7_dqs_mode" ||
        db_pin_7_mode == "pin7_dqsb_mode" ||
        db_pin_7_mode == "pin7_dqs_ddr4_mode" ||
        db_pin_7_mode == "pin7_dqsb_ddr4_mode" ||
        db_pin_7_mode == "pin7_rdq_mode" ||
        db_pin_7_mode == "pin7_rdqs_mode" ||
        db_pin_7_mode == "pin7_gpio_mode"
    ) else $error("Parameter <db_pin_7_mode> is not set to legal value <%s>", db_pin_7_mode);

    assert (
        db_pin_8_mode == "pin8_ac_ddr4_hmc" ||
        db_pin_8_mode == "pin8_dq_wdb_ddr4_mode" ||
        db_pin_8_mode == "pin8_dm_wdb_ddr4_mode" ||
        db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode" ||
        db_pin_8_mode == "pin8_clk_wdb_ddr4_mode" ||
        db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode" ||
        db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode" ||
        db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode" ||
        db_pin_8_mode == "pin8_ac_hmc" ||
        db_pin_8_mode == "pin8_dq_wdb_mode" ||
        db_pin_8_mode == "pin8_dm_wdb_mode" ||
        db_pin_8_mode == "pin8_dbi_wdb_mode" ||
        db_pin_8_mode == "pin8_clk_wdb_mode" ||
        db_pin_8_mode == "pin8_clkb_wdb_mode" ||
        db_pin_8_mode == "pin8_dqs_wdb_mode" ||
        db_pin_8_mode == "pin8_dqsb_wdb_mode" ||
        db_pin_8_mode == "pin8_ac_core" ||
        db_pin_8_mode == "pin8_dq_mode" ||
        db_pin_8_mode == "pin8_dm_mode" ||
        db_pin_8_mode == "pin8_dbi_mode" ||
        db_pin_8_mode == "pin8_clk_mode" ||
        db_pin_8_mode == "pin8_clkb_mode" ||
        db_pin_8_mode == "pin8_dqs_mode" ||
        db_pin_8_mode == "pin8_dqsb_mode" ||
        db_pin_8_mode == "pin8_dqs_ddr4_mode" ||
        db_pin_8_mode == "pin8_dqsb_ddr4_mode" ||
        db_pin_8_mode == "pin8_rdq_mode" ||
        db_pin_8_mode == "pin8_rdqs_mode" ||
        db_pin_8_mode == "pin8_gpio_mode"
    ) else $error("Parameter <db_pin_8_mode> is not set to legal value <%s>", db_pin_8_mode);

    assert (
        db_pin_9_mode == "pin9_ac_ddr4_hmc" ||
        db_pin_9_mode == "pin9_dq_wdb_ddr4_mode" ||
        db_pin_9_mode == "pin9_dm_wdb_ddr4_mode" ||
        db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode" ||
        db_pin_9_mode == "pin9_clk_wdb_ddr4_mode" ||
        db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode" ||
        db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode" ||
        db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode" ||
        db_pin_9_mode == "pin9_ac_hmc" ||
        db_pin_9_mode == "pin9_dq_wdb_mode" ||
        db_pin_9_mode == "pin9_dm_wdb_mode" ||
        db_pin_9_mode == "pin9_dbi_wdb_mode" ||
        db_pin_9_mode == "pin9_clk_wdb_mode" ||
        db_pin_9_mode == "pin9_clkb_wdb_mode" ||
        db_pin_9_mode == "pin9_dqs_wdb_mode" ||
        db_pin_9_mode == "pin9_dqsb_wdb_mode" ||
        db_pin_9_mode == "pin9_ac_core" ||
        db_pin_9_mode == "pin9_dq_mode" ||
        db_pin_9_mode == "pin9_dm_mode" ||
        db_pin_9_mode == "pin9_dbi_mode" ||
        db_pin_9_mode == "pin9_clk_mode" ||
        db_pin_9_mode == "pin9_clkb_mode" ||
        db_pin_9_mode == "pin9_dqs_mode" ||
        db_pin_9_mode == "pin9_dqsb_mode" ||
        db_pin_9_mode == "pin9_dqs_ddr4_mode" ||
        db_pin_9_mode == "pin9_dqsb_ddr4_mode" ||
        db_pin_9_mode == "pin9_rdq_mode" ||
        db_pin_9_mode == "pin9_rdqs_mode" ||
        db_pin_9_mode == "pin9_gpio_mode"
    ) else $error("Parameter <db_pin_9_mode> is not set to legal value <%s>", db_pin_9_mode);

    assert (
        db_pin_10_mode == "pin10_ac_ddr4_hmc" ||
        db_pin_10_mode == "pin10_dq_wdb_ddr4_mode" ||
        db_pin_10_mode == "pin10_dm_wdb_ddr4_mode" ||
        db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode" ||
        db_pin_10_mode == "pin10_clk_wdb_ddr4_mode" ||
        db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode" ||
        db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode" ||
        db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode" ||
        db_pin_10_mode == "pin10_ac_hmc" ||
        db_pin_10_mode == "pin10_dq_wdb_mode" ||
        db_pin_10_mode == "pin10_dm_wdb_mode" ||
        db_pin_10_mode == "pin10_dbi_wdb_mode" ||
        db_pin_10_mode == "pin10_clk_wdb_mode" ||
        db_pin_10_mode == "pin10_clkb_wdb_mode" ||
        db_pin_10_mode == "pin10_dqs_wdb_mode" ||
        db_pin_10_mode == "pin10_dqsb_wdb_mode" ||
        db_pin_10_mode == "pin10_ac_core" ||
        db_pin_10_mode == "pin10_dq_mode" ||
        db_pin_10_mode == "pin10_dm_mode" ||
        db_pin_10_mode == "pin10_dbi_mode" ||
        db_pin_10_mode == "pin10_clk_mode" ||
        db_pin_10_mode == "pin10_clkb_mode" ||
        db_pin_10_mode == "pin10_dqs_mode" ||
        db_pin_10_mode == "pin10_dqsb_mode" ||
        db_pin_10_mode == "pin10_dqs_ddr4_mode" ||
        db_pin_10_mode == "pin10_dqsb_ddr4_mode" ||
        db_pin_10_mode == "pin10_rdq_mode" ||
        db_pin_10_mode == "pin10_rdqs_mode" ||
        db_pin_10_mode == "pin10_gpio_mode"
    ) else $error("Parameter <db_pin_10_mode> is not set to legal value <%s>", db_pin_10_mode);

    assert (
        db_pin_11_mode == "pin11_ac_ddr4_hmc" ||
        db_pin_11_mode == "pin11_dq_wdb_ddr4_mode" ||
        db_pin_11_mode == "pin11_dm_wdb_ddr4_mode" ||
        db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode" ||
        db_pin_11_mode == "pin11_clk_wdb_ddr4_mode" ||
        db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode" ||
        db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode" ||
        db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode" ||
        db_pin_11_mode == "pin11_ac_hmc" ||
        db_pin_11_mode == "pin11_dq_wdb_mode" ||
        db_pin_11_mode == "pin11_dm_wdb_mode" ||
        db_pin_11_mode == "pin11_dbi_wdb_mode" ||
        db_pin_11_mode == "pin11_clk_wdb_mode" ||
        db_pin_11_mode == "pin11_clkb_wdb_mode" ||
        db_pin_11_mode == "pin11_dqs_wdb_mode" ||
        db_pin_11_mode == "pin11_dqsb_wdb_mode" ||
        db_pin_11_mode == "pin11_ac_core" ||
        db_pin_11_mode == "pin11_dq_mode" ||
        db_pin_11_mode == "pin11_dm_mode" ||
        db_pin_11_mode == "pin11_dbi_mode" ||
        db_pin_11_mode == "pin11_clk_mode" ||
        db_pin_11_mode == "pin11_clkb_mode" ||
        db_pin_11_mode == "pin11_dqs_mode" ||
        db_pin_11_mode == "pin11_dqsb_mode" ||
        db_pin_11_mode == "pin11_dqs_ddr4_mode" ||
        db_pin_11_mode == "pin11_dqsb_ddr4_mode" ||
        db_pin_11_mode == "pin11_rdq_mode" ||
        db_pin_11_mode == "pin11_rdqs_mode" ||
        db_pin_11_mode == "pin11_gpio_mode"
    ) else $error("Parameter <db_pin_11_mode> is not set to legal value <%s>", db_pin_11_mode);

    assert (
        dll_rst_en == "dll_rst_dis" ||
        dll_rst_en == "dll_rst_en"
    ) else $error("Parameter <dll_rst_en> is not set to legal value <%s>", dll_rst_en);

    assert (
        dll_en == "dll_dis" ||
        dll_en == "dll_en"
    ) else $error("Parameter <dll_en> is not set to legal value <%s>", dll_en);

    assert (
        dll_core_updnen == "core_updn_dis" ||
        dll_core_updnen == "core_updn_en"
    ) else $error("Parameter <dll_core_updnen> is not set to legal value <%s>", dll_core_updnen);

    assert (
        dll_ctlsel == "ctl_dynamic" ||
        dll_ctlsel == "ctl_static"
    ) else $error("Parameter <dll_ctlsel> is not set to legal value <%s>", dll_ctlsel);

    assert (
        hps_ctrl_en == "true" ||
        hps_ctrl_en == "false"
    ) else $error("Parameter <hps_ctrl_en> is not set to legal value <%s>", hps_ctrl_en);

    assert (
        dqs_lgc_enable_toggler == "preamble_track_dqs_enable" ||
        dqs_lgc_enable_toggler == "preamble_track_toggler"
    ) else $error("Parameter <dqs_lgc_enable_toggler> is not set to legal value <%s>", dqs_lgc_enable_toggler);

    assert (
        dqs_lgc_dqs_b_interp_en == "dqsb_sstl_p_0" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_sstl_p_1" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_sstl_p_2" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_sstl_p_3" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_sstl_n_0" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_sstl_n_1" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_sstl_n_2" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_sstl_n_3" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_diff_in_0" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_diff_in_1" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_diff_in_2" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_diff_in_3" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_interpolator" ||
        dqs_lgc_dqs_b_interp_en == "dqsb_constant"
    ) else $error("Parameter <dqs_lgc_dqs_b_interp_en> is not set to legal value <%s>", dqs_lgc_dqs_b_interp_en);

    assert (
        dqs_lgc_dqs_a_interp_en == "dqsa_sstl_p_0" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_sstl_p_1" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_sstl_p_2" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_sstl_p_3" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_sstl_n_0" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_sstl_n_1" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_sstl_n_2" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_sstl_n_3" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_diff_in_0" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_diff_in_1" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_diff_in_2" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_diff_in_3" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_interpolator" ||
        dqs_lgc_dqs_a_interp_en == "dqsa_constant"
    ) else $error("Parameter <dqs_lgc_dqs_a_interp_en> is not set to legal value <%s>", dqs_lgc_dqs_a_interp_en);

    assert (
        dqs_lgc_pack_mode == "packed" ||
        dqs_lgc_pack_mode == "not_packed"
    ) else $error("Parameter <dqs_lgc_pack_mode> is not set to legal value <%s>", dqs_lgc_pack_mode);

    assert (
        dqs_lgc_pst_preamble_mode == "ddr3_preamble" ||
        dqs_lgc_pst_preamble_mode == "ddr4_preamble"
    ) else $error("Parameter <dqs_lgc_pst_preamble_mode> is not set to legal value <%s>", dqs_lgc_pst_preamble_mode);

    assert (
        dqs_lgc_pst_en_shrink == "shrink_0_0" ||
        dqs_lgc_pst_en_shrink == "shrink_0_1" ||
        dqs_lgc_pst_en_shrink == "shrink_1_0" ||
        dqs_lgc_pst_en_shrink == "shrink_1_1"
    ) else $error("Parameter <dqs_lgc_pst_en_shrink> is not set to legal value <%s>", dqs_lgc_pst_en_shrink);

    assert (
        vfifo_burst_length == "vburst_length_2" ||
        vfifo_burst_length == "vburst_length_4" ||
        vfifo_burst_length == "vburst_length_8"
    ) else $error("Parameter <vfifo_burst_length> is not set to legal value <%s>", vfifo_burst_length);

    assert (
        dqs_lgc_broadcast_enable == "disable_broadcast" ||
        dqs_lgc_broadcast_enable == "generate_broadcast" ||
        dqs_lgc_broadcast_enable == "top_in_broadcast" ||
        dqs_lgc_broadcast_enable == "bottom_in_broadcast"
    ) else $error("Parameter <dqs_lgc_broadcast_enable> is not set to legal value <%s>", dqs_lgc_broadcast_enable);

    assert (
        dqs_lgc_burst_length == "burst_length_10" ||
        dqs_lgc_burst_length == "burst_length_8" ||
        dqs_lgc_burst_length == "burst_length_4" ||
        dqs_lgc_burst_length == "burst_length_2"
    ) else $error("Parameter <dqs_lgc_burst_length> is not set to legal value <%s>", dqs_lgc_burst_length);

    assert (
        dqs_lgc_ddr4_search == "ddr3_search" ||
        dqs_lgc_ddr4_search == "ddr4_search"
    ) else $error("Parameter <dqs_lgc_ddr4_search> is not set to legal value <%s>", dqs_lgc_ddr4_search);

end

localparam io_ioereg_custom_0__xio_interpolator_1__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam xio_dqs_custom__xio_interpolator_b__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam io_ioereg_custom_1__xio_interpolator_1__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam io_ioereg_custom_4__xio_interpolator_1__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam io_ioereg_custom_2__xio_interpolator_1__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam io_ioereg_custom_5__xio_interpolator_1__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam xio_dqs_custom__xio_interpolator_a__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam io_ioereg_custom_3__xio_interpolator_1__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam io_ioereg_custom_4__xio_interpolator_0__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam xio_dqs_custom__xio_min_inter_3__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam io_ioereg_custom_2__xio_interpolator_0__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam io_ioereg_custom_0__xio_interpolator_0__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam io_ioereg_custom_5__xio_interpolator_0__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam io_ioereg_custom_3__xio_interpolator_0__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam io_ioereg_custom_1__xio_interpolator_0__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")
localparam xio_dqs_custom__xio_min_inter_1__a_filter_code = 
    (a_filter_code == "freq_16ghz")? "freq_16ghz" : 
    (a_filter_code == "freq_12ghz")? "freq_12ghz" : 
    (a_filter_code == "freq_10ghz")? "freq_10ghz" : 
    "freq_08ghz"; //(a_filter_code == "freq_08ghz")

localparam io_ioereg_custom_3__xio_interpolator_0__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam xio_dqs_custom__xio_interpolator_a__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam io_ioereg_custom_3__xio_interpolator_1__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam xio_dqs_custom__xio_interpolator_b__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam io_ioereg_custom_0__xio_interpolator_0__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam xio_dqs_custom__xio_min_inter_3__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam io_ioereg_custom_2__xio_interpolator_1__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam io_ioereg_custom_1__xio_interpolator_1__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam io_ioereg_custom_4__xio_interpolator_1__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam io_ioereg_custom_5__xio_interpolator_1__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam xio_dqs_custom__xio_min_inter_1__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam io_ioereg_custom_2__xio_interpolator_0__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam io_ioereg_custom_5__xio_interpolator_0__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam io_ioereg_custom_0__xio_interpolator_1__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam io_ioereg_custom_4__xio_interpolator_0__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")
localparam io_ioereg_custom_1__xio_interpolator_0__a_couple_enable = 
    (a_couple_enable == "couple_en")? "couple_en" : 
    "couple_dis"; //(a_couple_enable == "couple_dis")

localparam data_buffer__rdwr_buffer_inst_3__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__rdwr_buffer_inst_7__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__rdwr_buffer_inst_11__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__rdwr_buffer_inst_0__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__rdwr_buffer_inst_10__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__rdwr_buffer_inst_8__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__rdwr_buffer_inst_2__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__rdwr_buffer_inst_9__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__rdwr_buffer_inst_6__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__rdwr_buffer_inst_5__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__rdwr_buffer_inst_1__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_mode_rate_in = 
    (mode_rate_in == "in_rate_full")? "in_rate_full" : 
    (mode_rate_in == "in_rate_1_2")? "in_rate_1_2" : 
    "in_rate_1_4"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__rdwr_buffer_inst_4__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_rb_qr_or_hr = 
    (mode_rate_in == "in_rate_full")? "hr" : 
    (mode_rate_in == "in_rate_1_2")? "hr" : 
    "qr"; //(mode_rate_in == "in_rate_1_4")

localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_mode_rate_out = 
    (mode_rate_out == "out_rate_full")? "out_rate_full" : 
    (mode_rate_out == "out_rate_1_2")? "out_rate_1_2" : 
    (mode_rate_out == "out_rate_1_4")? "out_rate_1_4" : 
    "out_rate_1_8"; //(mode_rate_out == "out_rate_1_8")

localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam ioereg_top_3___ioereg_pnr_x2__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam ioereg_top_2___ioereg_pnr_x2__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam data_buffer__data_buffer_clk_gen_inst__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam ioereg_top_4___ioereg_pnr_x2__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam ioereg_top_1___ioereg_pnr_x2__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam ioereg_top_0___ioereg_pnr_x2__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam ioereg_top_5___ioereg_pnr_x2__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_phy_clk_mode = 
    (phy_clk_sel == "phy_clk_sel_uint0")? "phy_clk_0" : 
    "phy_clk_1"; //(phy_clk_sel == "phy_clk_sel_uint1")

localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_ddr4_mode = 
    (pair_0_ddr4_mode == "pair0_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_0_ddr4_mode == "pair0_ddr3_idle")
localparam ioereg_top_0___ioereg_pnr_x2__a_ddr4_mode = 
    (pair_0_ddr4_mode == "pair0_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_0_ddr4_mode == "pair0_ddr3_idle")

localparam ioereg_top_1___ioereg_pnr_x2__a_ddr4_mode = 
    (pair_1_ddr4_mode == "pair1_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_1_ddr4_mode == "pair1_ddr3_idle")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_ddr4_mode = 
    (pair_1_ddr4_mode == "pair1_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_1_ddr4_mode == "pair1_ddr3_idle")

localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_ddr4_mode = 
    (pair_2_ddr4_mode == "pair2_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_2_ddr4_mode == "pair2_ddr3_idle")
localparam ioereg_top_2___ioereg_pnr_x2__a_ddr4_mode = 
    (pair_2_ddr4_mode == "pair2_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_2_ddr4_mode == "pair2_ddr3_idle")

localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_ddr4_mode = 
    (pair_3_ddr4_mode == "pair3_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_3_ddr4_mode == "pair3_ddr3_idle")
localparam ioereg_top_3___ioereg_pnr_x2__a_ddr4_mode = 
    (pair_3_ddr4_mode == "pair3_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_3_ddr4_mode == "pair3_ddr3_idle")

localparam ioereg_top_4___ioereg_pnr_x2__a_ddr4_mode = 
    (pair_4_ddr4_mode == "pair4_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_4_ddr4_mode == "pair4_ddr3_idle")
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_ddr4_mode = 
    (pair_4_ddr4_mode == "pair4_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_4_ddr4_mode == "pair4_ddr3_idle")

localparam ioereg_top_5___ioereg_pnr_x2__a_ddr4_mode = 
    (pair_5_ddr4_mode == "pair5_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_5_ddr4_mode == "pair5_ddr3_idle")
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_ddr4_mode = 
    (pair_5_ddr4_mode == "pair5_ddr4_idle")? "ddr4_idle" : 
    "ddr3_idle"; //(pair_5_ddr4_mode == "pair5_ddr3_idle")

localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split = 
    (pair_0_dcc_split_mode == "pair0_dcc_split_disabled")? "dcc_split_disabled" : 
    "dcc_split_enabled"; //(pair_0_dcc_split_mode == "pair0_dcc_split_enabled")

localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split = 
    (pair_1_dcc_split_mode == "pair1_dcc_split_disabled")? "dcc_split_disabled" : 
    "dcc_split_enabled"; //(pair_1_dcc_split_mode == "pair1_dcc_split_enabled")

localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split = 
    (pair_2_dcc_split_mode == "pair2_dcc_split_disabled")? "dcc_split_disabled" : 
    "dcc_split_enabled"; //(pair_2_dcc_split_mode == "pair2_dcc_split_enabled")

localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split = 
    (pair_3_dcc_split_mode == "pair3_dcc_split_disabled")? "dcc_split_disabled" : 
    "dcc_split_enabled"; //(pair_3_dcc_split_mode == "pair3_dcc_split_enabled")

localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split = 
    (pair_4_dcc_split_mode == "pair4_dcc_split_disabled")? "dcc_split_disabled" : 
    "dcc_split_enabled"; //(pair_4_dcc_split_mode == "pair4_dcc_split_enabled")

localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split = 
    (pair_5_dcc_split_mode == "pair5_dcc_split_disabled")? "dcc_split_disabled" : 
    "dcc_split_enabled"; //(pair_5_dcc_split_mode == "pair5_dcc_split_enabled")
	
localparam data_buffer__iodbccmn_dbc_inst__a_rb_disable_mrnk_write = 
    (mrnk_write_mode == "enabled")? "mrnk_write_enable" : 
    "mrnk_write_disable"; //(mrnk_write_mode == "disabled")

localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_initial_out = 
    (pin_0_initial_out == "pin0_initial_out_z")? "pin0_initial_out_z" : 
    (pin_0_initial_out == "pin0_initial_out_0")? "pin0_initial_out_0" : 
    (pin_0_initial_out == "pin0_initial_out_1")? "pin0_initial_out_1" : 
    "pin0_initial_out_x"; //(pin_0_initial_out == "pin0_initial_out_x")
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out = 
    (pin_0_initial_out == "pin0_initial_out_z")? "initial_out_z" : 
    (pin_0_initial_out == "pin0_initial_out_0")? "initial_out_0" : 
    (pin_0_initial_out == "pin0_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_0_initial_out == "pin0_initial_out_x")

localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct = 
    (pin_0_oct_mode == "pin0_static_off")? "oct_disabled" : 
    (pin_0_oct_mode == "pin0_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_0_oct_mode == "pin0_dynamic")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_dynoct = 
    (pin_0_oct_mode == "pin0_static_off")? "pin0_oct_disabled" : 
    (pin_0_oct_mode == "pin0_static_on")? "pin0_oct_disabled" : 
    "pin0_oct_enabled"; //(pin_0_oct_mode == "pin0_dynamic")

localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_mode_ddr = 
    (pin_0_mode_ddr == "pin0_mode_sdr")? "pin0_mode_sdr" : 
    "pin0_mode_ddr"; //(pin_0_mode_ddr == "pin0_mode_ddr")
localparam ioereg_struct_0_0__a_mode_ddr = 
    (pin_0_mode_ddr == "pin0_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_0_mode_ddr == "pin0_mode_ddr")
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr = 
    (pin_0_mode_ddr == "pin0_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_0_mode_ddr == "pin0_mode_ddr")

localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select = 
    (pin_0_dqs_mode == "pin0_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_0_dqs_mode == "pin0_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_0_dqs_mode == "pin0_dqs_sampler_b_a_rise")
localparam ioereg_top_0___ioereg_pnr_x2__read_path_0__a_dqs_select = 
    (pin_0_dqs_mode == "pin0_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_0_dqs_mode == "pin0_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_0_dqs_mode == "pin0_dqs_sampler_b_a_rise")

localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode = 
    (pin_0_data_in_mode == "pin0_ca")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_clock")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dq")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dqs")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dpa_slave")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dpa_master")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_0_data_in_mode == "pin0_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_dfx_mode = 
    (pin_0_data_in_mode == "pin0_ca")? "pin0_dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_clock")? "pin0_dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dq")? "pin0_dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dqs")? "pin0_dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dpa_slave")? "pin0_dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dpa_master")? "pin0_dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dq_xor_a_loopback")? "pin0_dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dq_xor_b_loopback")? "pin0_dfx_disabled" : 
    "pin0_dfx_disabled"; //(pin_0_data_in_mode == "pin0_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_octrt = 
    (pin_0_data_in_mode == "pin0_ca")? "static_oct_off" : 
    (pin_0_data_in_mode == "pin0_clock")? "static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dq")? "static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dqs")? "static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dpa_slave")? "static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dpa_master")? "static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_0_data_in_mode == "pin0_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode = 
    (pin_0_data_in_mode == "pin0_ca")? "pin0_x1_calibration" : 
    (pin_0_data_in_mode == "pin0_clock")? "pin0_x1_calibration" : 
    (pin_0_data_in_mode == "pin0_dq")? "pin0_x1_calibration" : 
    (pin_0_data_in_mode == "pin0_dqs")? "pin0_x12_calibration" : 
    (pin_0_data_in_mode == "pin0_dpa_slave")? "pin0_x1_calibration" : 
    (pin_0_data_in_mode == "pin0_dpa_master")? "pin0_x1_calibration" : 
    (pin_0_data_in_mode == "pin0_dq_xor_a_loopback")? "pin0_x1_calibration" : 
    (pin_0_data_in_mode == "pin0_dq_xor_b_loopback")? "pin0_x1_calibration" : 
    "pin0_x1_calibration"; //(pin_0_data_in_mode == "pin0_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode = 
    (pin_0_data_in_mode == "pin0_ca")? "pin0_shadow_write_disabled" : 
    (pin_0_data_in_mode == "pin0_clock")? "pin0_shadow_write_enabled" : 
    (pin_0_data_in_mode == "pin0_dq")? "pin0_shadow_write_disabled" : 
    (pin_0_data_in_mode == "pin0_dqs")? "pin0_shadow_write_enabled" : 
    (pin_0_data_in_mode == "pin0_dpa_slave")? "pin0_shadow_write_disabled" : 
    (pin_0_data_in_mode == "pin0_dpa_master")? "pin0_shadow_write_disabled" : 
    (pin_0_data_in_mode == "pin0_dq_xor_a_loopback")? "pin0_shadow_write_disabled" : 
    (pin_0_data_in_mode == "pin0_dq_xor_b_loopback")? "pin0_shadow_write_disabled" : 
    "pin0_shadow_write_disabled"; //(pin_0_data_in_mode == "pin0_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode = 
    (pin_0_data_in_mode == "pin0_ca")? "shadow_write_disabled" : 
    (pin_0_data_in_mode == "pin0_clock")? "shadow_write_enabled" : 
    (pin_0_data_in_mode == "pin0_dq")? "shadow_write_disabled" : 
    (pin_0_data_in_mode == "pin0_dqs")? "shadow_write_enabled" : 
    (pin_0_data_in_mode == "pin0_dpa_slave")? "shadow_write_disabled" : 
    (pin_0_data_in_mode == "pin0_dpa_master")? "shadow_write_disabled" : 
    (pin_0_data_in_mode == "pin0_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_0_data_in_mode == "pin0_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_0_data_in_mode == "pin0_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode = 
    (pin_0_data_in_mode == "pin0_ca")? "x1_calibration" : 
    (pin_0_data_in_mode == "pin0_clock")? "x1_calibration" : 
    (pin_0_data_in_mode == "pin0_dq")? "x1_calibration" : 
    (pin_0_data_in_mode == "pin0_dqs")? "x12_calibration" : 
    (pin_0_data_in_mode == "pin0_dpa_slave")? "x1_calibration" : 
    (pin_0_data_in_mode == "pin0_dpa_master")? "x1_calibration" : 
    (pin_0_data_in_mode == "pin0_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_0_data_in_mode == "pin0_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_0_data_in_mode == "pin0_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__read_path_0__a_dfx_mode = 
    (pin_0_data_in_mode == "pin0_ca")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_clock")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dq")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dqs")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dpa_slave")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dpa_master")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_0_data_in_mode == "pin0_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_0_data_in_mode == "pin0_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_octrt = 
    (pin_0_data_in_mode == "pin0_ca")? "pin0_static_oct_off" : 
    (pin_0_data_in_mode == "pin0_clock")? "pin0_static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dq")? "pin0_static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dqs")? "pin0_static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dpa_slave")? "pin0_static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dpa_master")? "pin0_static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dq_xor_a_loopback")? "pin0_static_oct_off" : 
    (pin_0_data_in_mode == "pin0_dq_xor_b_loopback")? "pin0_static_oct_off" : 
    "pin0_static_oct_off"; //(pin_0_data_in_mode == "pin0_dqs_xor_loopback")

localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out = 
    (pin_1_initial_out == "pin1_initial_out_z")? "initial_out_z" : 
    (pin_1_initial_out == "pin1_initial_out_0")? "initial_out_0" : 
    (pin_1_initial_out == "pin1_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_1_initial_out == "pin1_initial_out_x")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_initial_out = 
    (pin_1_initial_out == "pin1_initial_out_z")? "pin1_initial_out_z" : 
    (pin_1_initial_out == "pin1_initial_out_0")? "pin1_initial_out_0" : 
    (pin_1_initial_out == "pin1_initial_out_1")? "pin1_initial_out_1" : 
    "pin1_initial_out_x"; //(pin_1_initial_out == "pin1_initial_out_x")

localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct = 
    (pin_1_oct_mode == "pin1_static_off")? "oct_disabled" : 
    (pin_1_oct_mode == "pin1_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_1_oct_mode == "pin1_dynamic")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_dynoct = 
    (pin_1_oct_mode == "pin1_static_off")? "pin1_oct_disabled" : 
    (pin_1_oct_mode == "pin1_static_on")? "pin1_oct_disabled" : 
    "pin1_oct_enabled"; //(pin_1_oct_mode == "pin1_dynamic")

localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr = 
    (pin_1_mode_ddr == "pin1_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_1_mode_ddr == "pin1_mode_ddr")
localparam ioereg_struct_0_1__a_mode_ddr = 
    (pin_1_mode_ddr == "pin1_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_1_mode_ddr == "pin1_mode_ddr")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_mode_ddr = 
    (pin_1_mode_ddr == "pin1_mode_sdr")? "pin1_mode_sdr" : 
    "pin1_mode_ddr"; //(pin_1_mode_ddr == "pin1_mode_ddr")

localparam ioereg_top_0___ioereg_pnr_x2__read_path_1__a_dqs_select = 
    (pin_1_dqs_mode == "pin1_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_1_dqs_mode == "pin1_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_1_dqs_mode == "pin1_dqs_sampler_b_a_rise")
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select = 
    (pin_1_dqs_mode == "pin1_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_1_dqs_mode == "pin1_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_1_dqs_mode == "pin1_dqs_sampler_b_a_rise")

localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode = 
    (pin_1_data_in_mode == "pin1_ca")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_clock")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dq")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dqs")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dpa_slave")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dpa_master")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_1_data_in_mode == "pin1_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode = 
    (pin_1_data_in_mode == "pin1_ca")? "shadow_write_disabled" : 
    (pin_1_data_in_mode == "pin1_clock")? "shadow_write_enabled" : 
    (pin_1_data_in_mode == "pin1_dq")? "shadow_write_disabled" : 
    (pin_1_data_in_mode == "pin1_dqs")? "shadow_write_enabled" : 
    (pin_1_data_in_mode == "pin1_dpa_slave")? "shadow_write_disabled" : 
    (pin_1_data_in_mode == "pin1_dpa_master")? "shadow_write_disabled" : 
    (pin_1_data_in_mode == "pin1_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_1_data_in_mode == "pin1_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_1_data_in_mode == "pin1_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode = 
    (pin_1_data_in_mode == "pin1_ca")? "pin1_shadow_write_disabled" : 
    (pin_1_data_in_mode == "pin1_clock")? "pin1_shadow_write_enabled" : 
    (pin_1_data_in_mode == "pin1_dq")? "pin1_shadow_write_disabled" : 
    (pin_1_data_in_mode == "pin1_dqs")? "pin1_shadow_write_enabled" : 
    (pin_1_data_in_mode == "pin1_dpa_slave")? "pin1_shadow_write_disabled" : 
    (pin_1_data_in_mode == "pin1_dpa_master")? "pin1_shadow_write_disabled" : 
    (pin_1_data_in_mode == "pin1_dq_xor_a_loopback")? "pin1_shadow_write_disabled" : 
    (pin_1_data_in_mode == "pin1_dq_xor_b_loopback")? "pin1_shadow_write_disabled" : 
    "pin1_shadow_write_disabled"; //(pin_1_data_in_mode == "pin1_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_octrt = 
    (pin_1_data_in_mode == "pin1_ca")? "static_oct_off" : 
    (pin_1_data_in_mode == "pin1_clock")? "static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dq")? "static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dqs")? "static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dpa_slave")? "static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dpa_master")? "static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_1_data_in_mode == "pin1_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode = 
    (pin_1_data_in_mode == "pin1_ca")? "pin1_x1_calibration" : 
    (pin_1_data_in_mode == "pin1_clock")? "pin1_x1_calibration" : 
    (pin_1_data_in_mode == "pin1_dq")? "pin1_x1_calibration" : 
    (pin_1_data_in_mode == "pin1_dqs")? "pin1_x12_calibration" : 
    (pin_1_data_in_mode == "pin1_dpa_slave")? "pin1_x1_calibration" : 
    (pin_1_data_in_mode == "pin1_dpa_master")? "pin1_x1_calibration" : 
    (pin_1_data_in_mode == "pin1_dq_xor_a_loopback")? "pin1_x1_calibration" : 
    (pin_1_data_in_mode == "pin1_dq_xor_b_loopback")? "pin1_x1_calibration" : 
    "pin1_x1_calibration"; //(pin_1_data_in_mode == "pin1_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode = 
    (pin_1_data_in_mode == "pin1_ca")? "x1_calibration" : 
    (pin_1_data_in_mode == "pin1_clock")? "x1_calibration" : 
    (pin_1_data_in_mode == "pin1_dq")? "x1_calibration" : 
    (pin_1_data_in_mode == "pin1_dqs")? "x12_calibration" : 
    (pin_1_data_in_mode == "pin1_dpa_slave")? "x1_calibration" : 
    (pin_1_data_in_mode == "pin1_dpa_master")? "x1_calibration" : 
    (pin_1_data_in_mode == "pin1_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_1_data_in_mode == "pin1_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_1_data_in_mode == "pin1_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_dfx_mode = 
    (pin_1_data_in_mode == "pin1_ca")? "pin1_dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_clock")? "pin1_dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dq")? "pin1_dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dqs")? "pin1_dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dpa_slave")? "pin1_dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dpa_master")? "pin1_dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dq_xor_a_loopback")? "pin1_dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dq_xor_b_loopback")? "pin1_dfx_disabled" : 
    "pin1_dfx_disabled"; //(pin_1_data_in_mode == "pin1_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_octrt = 
    (pin_1_data_in_mode == "pin1_ca")? "pin1_static_oct_off" : 
    (pin_1_data_in_mode == "pin1_clock")? "pin1_static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dq")? "pin1_static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dqs")? "pin1_static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dpa_slave")? "pin1_static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dpa_master")? "pin1_static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dq_xor_a_loopback")? "pin1_static_oct_off" : 
    (pin_1_data_in_mode == "pin1_dq_xor_b_loopback")? "pin1_static_oct_off" : 
    "pin1_static_oct_off"; //(pin_1_data_in_mode == "pin1_dqs_xor_loopback")
localparam ioereg_top_0___ioereg_pnr_x2__read_path_1__a_dfx_mode = 
    (pin_1_data_in_mode == "pin1_ca")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_clock")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dq")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dqs")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dpa_slave")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dpa_master")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_1_data_in_mode == "pin1_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_1_data_in_mode == "pin1_dqs_xor_loopback")

localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out = 
    (pin_2_initial_out == "pin2_initial_out_z")? "initial_out_z" : 
    (pin_2_initial_out == "pin2_initial_out_0")? "initial_out_0" : 
    (pin_2_initial_out == "pin2_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_2_initial_out == "pin2_initial_out_x")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_initial_out = 
    (pin_2_initial_out == "pin2_initial_out_z")? "pin0_initial_out_z" : 
    (pin_2_initial_out == "pin2_initial_out_0")? "pin0_initial_out_0" : 
    (pin_2_initial_out == "pin2_initial_out_1")? "pin0_initial_out_1" : 
    "pin0_initial_out_x"; //(pin_2_initial_out == "pin2_initial_out_x")

localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct = 
    (pin_2_oct_mode == "pin2_static_off")? "oct_disabled" : 
    (pin_2_oct_mode == "pin2_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_2_oct_mode == "pin2_dynamic")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_dynoct = 
    (pin_2_oct_mode == "pin2_static_off")? "pin0_oct_disabled" : 
    (pin_2_oct_mode == "pin2_static_on")? "pin0_oct_disabled" : 
    "pin0_oct_enabled"; //(pin_2_oct_mode == "pin2_dynamic")

localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr = 
    (pin_2_mode_ddr == "pin2_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_2_mode_ddr == "pin2_mode_ddr")
localparam ioereg_struct_1_0__a_mode_ddr = 
    (pin_2_mode_ddr == "pin2_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_2_mode_ddr == "pin2_mode_ddr")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_mode_ddr = 
    (pin_2_mode_ddr == "pin2_mode_sdr")? "pin0_mode_sdr" : 
    "pin0_mode_ddr"; //(pin_2_mode_ddr == "pin2_mode_ddr")

localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select = 
    (pin_2_dqs_mode == "pin2_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_2_dqs_mode == "pin2_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_2_dqs_mode == "pin2_dqs_sampler_b_a_rise")
localparam ioereg_top_1___ioereg_pnr_x2__read_path_0__a_dqs_select = 
    (pin_2_dqs_mode == "pin2_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_2_dqs_mode == "pin2_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_2_dqs_mode == "pin2_dqs_sampler_b_a_rise")

localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode = 
    (pin_2_data_in_mode == "pin2_ca")? "pin0_x1_calibration" : 
    (pin_2_data_in_mode == "pin2_clock")? "pin0_x1_calibration" : 
    (pin_2_data_in_mode == "pin2_dq")? "pin0_x1_calibration" : 
    (pin_2_data_in_mode == "pin2_dqs")? "pin0_x12_calibration" : 
    (pin_2_data_in_mode == "pin2_dpa_slave")? "pin0_x1_calibration" : 
    (pin_2_data_in_mode == "pin2_dpa_master")? "pin0_x1_calibration" : 
    (pin_2_data_in_mode == "pin2_dq_xor_a_loopback")? "pin0_x1_calibration" : 
    (pin_2_data_in_mode == "pin2_dq_xor_b_loopback")? "pin0_x1_calibration" : 
    "pin0_x1_calibration"; //(pin_2_data_in_mode == "pin2_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__read_path_0__a_dfx_mode = 
    (pin_2_data_in_mode == "pin2_ca")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_clock")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dq")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dqs")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dpa_slave")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dpa_master")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_2_data_in_mode == "pin2_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_dfx_mode = 
    (pin_2_data_in_mode == "pin2_ca")? "pin0_dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_clock")? "pin0_dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dq")? "pin0_dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dqs")? "pin0_dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dpa_slave")? "pin0_dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dpa_master")? "pin0_dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dq_xor_a_loopback")? "pin0_dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dq_xor_b_loopback")? "pin0_dfx_disabled" : 
    "pin0_dfx_disabled"; //(pin_2_data_in_mode == "pin2_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_octrt = 
    (pin_2_data_in_mode == "pin2_ca")? "pin0_static_oct_off" : 
    (pin_2_data_in_mode == "pin2_clock")? "pin0_static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dq")? "pin0_static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dqs")? "pin0_static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dpa_slave")? "pin0_static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dpa_master")? "pin0_static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dq_xor_a_loopback")? "pin0_static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dq_xor_b_loopback")? "pin0_static_oct_off" : 
    "pin0_static_oct_off"; //(pin_2_data_in_mode == "pin2_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode = 
    (pin_2_data_in_mode == "pin2_ca")? "pin0_shadow_write_disabled" : 
    (pin_2_data_in_mode == "pin2_clock")? "pin0_shadow_write_enabled" : 
    (pin_2_data_in_mode == "pin2_dq")? "pin0_shadow_write_disabled" : 
    (pin_2_data_in_mode == "pin2_dqs")? "pin0_shadow_write_enabled" : 
    (pin_2_data_in_mode == "pin2_dpa_slave")? "pin0_shadow_write_disabled" : 
    (pin_2_data_in_mode == "pin2_dpa_master")? "pin0_shadow_write_disabled" : 
    (pin_2_data_in_mode == "pin2_dq_xor_a_loopback")? "pin0_shadow_write_disabled" : 
    (pin_2_data_in_mode == "pin2_dq_xor_b_loopback")? "pin0_shadow_write_disabled" : 
    "pin0_shadow_write_disabled"; //(pin_2_data_in_mode == "pin2_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode = 
    (pin_2_data_in_mode == "pin2_ca")? "shadow_write_disabled" : 
    (pin_2_data_in_mode == "pin2_clock")? "shadow_write_enabled" : 
    (pin_2_data_in_mode == "pin2_dq")? "shadow_write_disabled" : 
    (pin_2_data_in_mode == "pin2_dqs")? "shadow_write_enabled" : 
    (pin_2_data_in_mode == "pin2_dpa_slave")? "shadow_write_disabled" : 
    (pin_2_data_in_mode == "pin2_dpa_master")? "shadow_write_disabled" : 
    (pin_2_data_in_mode == "pin2_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_2_data_in_mode == "pin2_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_2_data_in_mode == "pin2_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode = 
    (pin_2_data_in_mode == "pin2_ca")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_clock")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dq")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dqs")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dpa_slave")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dpa_master")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_2_data_in_mode == "pin2_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_2_data_in_mode == "pin2_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode = 
    (pin_2_data_in_mode == "pin2_ca")? "x1_calibration" : 
    (pin_2_data_in_mode == "pin2_clock")? "x1_calibration" : 
    (pin_2_data_in_mode == "pin2_dq")? "x1_calibration" : 
    (pin_2_data_in_mode == "pin2_dqs")? "x12_calibration" : 
    (pin_2_data_in_mode == "pin2_dpa_slave")? "x1_calibration" : 
    (pin_2_data_in_mode == "pin2_dpa_master")? "x1_calibration" : 
    (pin_2_data_in_mode == "pin2_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_2_data_in_mode == "pin2_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_2_data_in_mode == "pin2_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_octrt = 
    (pin_2_data_in_mode == "pin2_ca")? "static_oct_off" : 
    (pin_2_data_in_mode == "pin2_clock")? "static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dq")? "static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dqs")? "static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dpa_slave")? "static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dpa_master")? "static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_2_data_in_mode == "pin2_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_2_data_in_mode == "pin2_dqs_xor_loopback")

localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_initial_out = 
    (pin_3_initial_out == "pin3_initial_out_z")? "pin1_initial_out_z" : 
    (pin_3_initial_out == "pin3_initial_out_0")? "pin1_initial_out_0" : 
    (pin_3_initial_out == "pin3_initial_out_1")? "pin1_initial_out_1" : 
    "pin1_initial_out_x"; //(pin_3_initial_out == "pin3_initial_out_x")
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out = 
    (pin_3_initial_out == "pin3_initial_out_z")? "initial_out_z" : 
    (pin_3_initial_out == "pin3_initial_out_0")? "initial_out_0" : 
    (pin_3_initial_out == "pin3_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_3_initial_out == "pin3_initial_out_x")

localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct = 
    (pin_3_oct_mode == "pin3_static_off")? "oct_disabled" : 
    (pin_3_oct_mode == "pin3_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_3_oct_mode == "pin3_dynamic")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_dynoct = 
    (pin_3_oct_mode == "pin3_static_off")? "pin1_oct_disabled" : 
    (pin_3_oct_mode == "pin3_static_on")? "pin1_oct_disabled" : 
    "pin1_oct_enabled"; //(pin_3_oct_mode == "pin3_dynamic")

localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_mode_ddr = 
    (pin_3_mode_ddr == "pin3_mode_sdr")? "pin1_mode_sdr" : 
    "pin1_mode_ddr"; //(pin_3_mode_ddr == "pin3_mode_ddr")
localparam ioereg_struct_1_1__a_mode_ddr = 
    (pin_3_mode_ddr == "pin3_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_3_mode_ddr == "pin3_mode_ddr")
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr = 
    (pin_3_mode_ddr == "pin3_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_3_mode_ddr == "pin3_mode_ddr")

localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select = 
    (pin_3_dqs_mode == "pin3_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_3_dqs_mode == "pin3_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_3_dqs_mode == "pin3_dqs_sampler_b_a_rise")
localparam ioereg_top_1___ioereg_pnr_x2__read_path_1__a_dqs_select = 
    (pin_3_dqs_mode == "pin3_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_3_dqs_mode == "pin3_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_3_dqs_mode == "pin3_dqs_sampler_b_a_rise")

localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_octrt = 
    (pin_3_data_in_mode == "pin3_ca")? "pin1_static_oct_off" : 
    (pin_3_data_in_mode == "pin3_clock")? "pin1_static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dq")? "pin1_static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dqs")? "pin1_static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dpa_slave")? "pin1_static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dpa_master")? "pin1_static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dq_xor_a_loopback")? "pin1_static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dq_xor_b_loopback")? "pin1_static_oct_off" : 
    "pin1_static_oct_off"; //(pin_3_data_in_mode == "pin3_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode = 
    (pin_3_data_in_mode == "pin3_ca")? "x1_calibration" : 
    (pin_3_data_in_mode == "pin3_clock")? "x1_calibration" : 
    (pin_3_data_in_mode == "pin3_dq")? "x1_calibration" : 
    (pin_3_data_in_mode == "pin3_dqs")? "x12_calibration" : 
    (pin_3_data_in_mode == "pin3_dpa_slave")? "x1_calibration" : 
    (pin_3_data_in_mode == "pin3_dpa_master")? "x1_calibration" : 
    (pin_3_data_in_mode == "pin3_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_3_data_in_mode == "pin3_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_3_data_in_mode == "pin3_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_dfx_mode = 
    (pin_3_data_in_mode == "pin3_ca")? "pin1_dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_clock")? "pin1_dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dq")? "pin1_dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dqs")? "pin1_dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dpa_slave")? "pin1_dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dpa_master")? "pin1_dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dq_xor_a_loopback")? "pin1_dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dq_xor_b_loopback")? "pin1_dfx_disabled" : 
    "pin1_dfx_disabled"; //(pin_3_data_in_mode == "pin3_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__read_path_1__a_dfx_mode = 
    (pin_3_data_in_mode == "pin3_ca")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_clock")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dq")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dqs")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dpa_slave")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dpa_master")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_3_data_in_mode == "pin3_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode = 
    (pin_3_data_in_mode == "pin3_ca")? "pin1_x1_calibration" : 
    (pin_3_data_in_mode == "pin3_clock")? "pin1_x1_calibration" : 
    (pin_3_data_in_mode == "pin3_dq")? "pin1_x1_calibration" : 
    (pin_3_data_in_mode == "pin3_dqs")? "pin1_x12_calibration" : 
    (pin_3_data_in_mode == "pin3_dpa_slave")? "pin1_x1_calibration" : 
    (pin_3_data_in_mode == "pin3_dpa_master")? "pin1_x1_calibration" : 
    (pin_3_data_in_mode == "pin3_dq_xor_a_loopback")? "pin1_x1_calibration" : 
    (pin_3_data_in_mode == "pin3_dq_xor_b_loopback")? "pin1_x1_calibration" : 
    "pin1_x1_calibration"; //(pin_3_data_in_mode == "pin3_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode = 
    (pin_3_data_in_mode == "pin3_ca")? "shadow_write_disabled" : 
    (pin_3_data_in_mode == "pin3_clock")? "shadow_write_enabled" : 
    (pin_3_data_in_mode == "pin3_dq")? "shadow_write_disabled" : 
    (pin_3_data_in_mode == "pin3_dqs")? "shadow_write_enabled" : 
    (pin_3_data_in_mode == "pin3_dpa_slave")? "shadow_write_disabled" : 
    (pin_3_data_in_mode == "pin3_dpa_master")? "shadow_write_disabled" : 
    (pin_3_data_in_mode == "pin3_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_3_data_in_mode == "pin3_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_3_data_in_mode == "pin3_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode = 
    (pin_3_data_in_mode == "pin3_ca")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_clock")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dq")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dqs")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dpa_slave")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dpa_master")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_3_data_in_mode == "pin3_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_3_data_in_mode == "pin3_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_octrt = 
    (pin_3_data_in_mode == "pin3_ca")? "static_oct_off" : 
    (pin_3_data_in_mode == "pin3_clock")? "static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dq")? "static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dqs")? "static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dpa_slave")? "static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dpa_master")? "static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_3_data_in_mode == "pin3_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_3_data_in_mode == "pin3_dqs_xor_loopback")
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode = 
    (pin_3_data_in_mode == "pin3_ca")? "pin1_shadow_write_disabled" : 
    (pin_3_data_in_mode == "pin3_clock")? "pin1_shadow_write_enabled" : 
    (pin_3_data_in_mode == "pin3_dq")? "pin1_shadow_write_disabled" : 
    (pin_3_data_in_mode == "pin3_dqs")? "pin1_shadow_write_enabled" : 
    (pin_3_data_in_mode == "pin3_dpa_slave")? "pin1_shadow_write_disabled" : 
    (pin_3_data_in_mode == "pin3_dpa_master")? "pin1_shadow_write_disabled" : 
    (pin_3_data_in_mode == "pin3_dq_xor_a_loopback")? "pin1_shadow_write_disabled" : 
    (pin_3_data_in_mode == "pin3_dq_xor_b_loopback")? "pin1_shadow_write_disabled" : 
    "pin1_shadow_write_disabled"; //(pin_3_data_in_mode == "pin3_dqs_xor_loopback")

localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_initial_out = 
    (pin_4_initial_out == "pin4_initial_out_z")? "pin0_initial_out_z" : 
    (pin_4_initial_out == "pin4_initial_out_0")? "pin0_initial_out_0" : 
    (pin_4_initial_out == "pin4_initial_out_1")? "pin0_initial_out_1" : 
    "pin0_initial_out_x"; //(pin_4_initial_out == "pin4_initial_out_x")
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out = 
    (pin_4_initial_out == "pin4_initial_out_z")? "initial_out_z" : 
    (pin_4_initial_out == "pin4_initial_out_0")? "initial_out_0" : 
    (pin_4_initial_out == "pin4_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_4_initial_out == "pin4_initial_out_x")

localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct = 
    (pin_4_oct_mode == "pin4_static_off")? "oct_disabled" : 
    (pin_4_oct_mode == "pin4_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_4_oct_mode == "pin4_dynamic")
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_dynoct = 
    (pin_4_oct_mode == "pin4_static_off")? "pin0_oct_disabled" : 
    (pin_4_oct_mode == "pin4_static_on")? "pin0_oct_disabled" : 
    "pin0_oct_enabled"; //(pin_4_oct_mode == "pin4_dynamic")

localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr = 
    (pin_4_mode_ddr == "pin4_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_4_mode_ddr == "pin4_mode_ddr")
localparam ioereg_struct_2_0__a_mode_ddr = 
    (pin_4_mode_ddr == "pin4_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_4_mode_ddr == "pin4_mode_ddr")
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_mode_ddr = 
    (pin_4_mode_ddr == "pin4_mode_sdr")? "pin0_mode_sdr" : 
    "pin0_mode_ddr"; //(pin_4_mode_ddr == "pin4_mode_ddr")

localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select = 
    (pin_4_dqs_mode == "pin4_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_4_dqs_mode == "pin4_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_4_dqs_mode == "pin4_dqs_sampler_b_a_rise")
localparam ioereg_top_2___ioereg_pnr_x2__read_path_0__a_dqs_select = 
    (pin_4_dqs_mode == "pin4_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_4_dqs_mode == "pin4_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_4_dqs_mode == "pin4_dqs_sampler_b_a_rise")

localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode = 
    (pin_4_data_in_mode == "pin4_ca")? "pin0_x1_calibration" : 
    (pin_4_data_in_mode == "pin4_clock")? "pin0_x1_calibration" : 
    (pin_4_data_in_mode == "pin4_dq")? "pin0_x1_calibration" : 
    (pin_4_data_in_mode == "pin4_dqs")? "pin0_x12_calibration" : 
    (pin_4_data_in_mode == "pin4_dpa_slave")? "pin0_x1_calibration" : 
    (pin_4_data_in_mode == "pin4_dpa_master")? "pin0_x1_calibration" : 
    (pin_4_data_in_mode == "pin4_dq_xor_a_loopback")? "pin0_x1_calibration" : 
    (pin_4_data_in_mode == "pin4_dq_xor_b_loopback")? "pin0_x1_calibration" : 
    "pin0_x1_calibration"; //(pin_4_data_in_mode == "pin4_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode = 
    (pin_4_data_in_mode == "pin4_ca")? "x1_calibration" : 
    (pin_4_data_in_mode == "pin4_clock")? "x1_calibration" : 
    (pin_4_data_in_mode == "pin4_dq")? "x1_calibration" : 
    (pin_4_data_in_mode == "pin4_dqs")? "x12_calibration" : 
    (pin_4_data_in_mode == "pin4_dpa_slave")? "x1_calibration" : 
    (pin_4_data_in_mode == "pin4_dpa_master")? "x1_calibration" : 
    (pin_4_data_in_mode == "pin4_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_4_data_in_mode == "pin4_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_4_data_in_mode == "pin4_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode = 
    (pin_4_data_in_mode == "pin4_ca")? "shadow_write_disabled" : 
    (pin_4_data_in_mode == "pin4_clock")? "shadow_write_enabled" : 
    (pin_4_data_in_mode == "pin4_dq")? "shadow_write_disabled" : 
    (pin_4_data_in_mode == "pin4_dqs")? "shadow_write_enabled" : 
    (pin_4_data_in_mode == "pin4_dpa_slave")? "shadow_write_disabled" : 
    (pin_4_data_in_mode == "pin4_dpa_master")? "shadow_write_disabled" : 
    (pin_4_data_in_mode == "pin4_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_4_data_in_mode == "pin4_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_4_data_in_mode == "pin4_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_octrt = 
    (pin_4_data_in_mode == "pin4_ca")? "pin0_static_oct_off" : 
    (pin_4_data_in_mode == "pin4_clock")? "pin0_static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dq")? "pin0_static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dqs")? "pin0_static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dpa_slave")? "pin0_static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dpa_master")? "pin0_static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dq_xor_a_loopback")? "pin0_static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dq_xor_b_loopback")? "pin0_static_oct_off" : 
    "pin0_static_oct_off"; //(pin_4_data_in_mode == "pin4_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode = 
    (pin_4_data_in_mode == "pin4_ca")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_clock")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dq")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dqs")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dpa_slave")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dpa_master")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_4_data_in_mode == "pin4_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_dfx_mode = 
    (pin_4_data_in_mode == "pin4_ca")? "pin0_dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_clock")? "pin0_dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dq")? "pin0_dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dqs")? "pin0_dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dpa_slave")? "pin0_dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dpa_master")? "pin0_dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dq_xor_a_loopback")? "pin0_dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dq_xor_b_loopback")? "pin0_dfx_disabled" : 
    "pin0_dfx_disabled"; //(pin_4_data_in_mode == "pin4_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode = 
    (pin_4_data_in_mode == "pin4_ca")? "pin0_shadow_write_disabled" : 
    (pin_4_data_in_mode == "pin4_clock")? "pin0_shadow_write_enabled" : 
    (pin_4_data_in_mode == "pin4_dq")? "pin0_shadow_write_disabled" : 
    (pin_4_data_in_mode == "pin4_dqs")? "pin0_shadow_write_enabled" : 
    (pin_4_data_in_mode == "pin4_dpa_slave")? "pin0_shadow_write_disabled" : 
    (pin_4_data_in_mode == "pin4_dpa_master")? "pin0_shadow_write_disabled" : 
    (pin_4_data_in_mode == "pin4_dq_xor_a_loopback")? "pin0_shadow_write_disabled" : 
    (pin_4_data_in_mode == "pin4_dq_xor_b_loopback")? "pin0_shadow_write_disabled" : 
    "pin0_shadow_write_disabled"; //(pin_4_data_in_mode == "pin4_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_octrt = 
    (pin_4_data_in_mode == "pin4_ca")? "static_oct_off" : 
    (pin_4_data_in_mode == "pin4_clock")? "static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dq")? "static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dqs")? "static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dpa_slave")? "static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dpa_master")? "static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_4_data_in_mode == "pin4_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_4_data_in_mode == "pin4_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__read_path_0__a_dfx_mode = 
    (pin_4_data_in_mode == "pin4_ca")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_clock")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dq")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dqs")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dpa_slave")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dpa_master")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_4_data_in_mode == "pin4_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_4_data_in_mode == "pin4_dqs_xor_loopback")

localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out = 
    (pin_5_initial_out == "pin5_initial_out_z")? "initial_out_z" : 
    (pin_5_initial_out == "pin5_initial_out_0")? "initial_out_0" : 
    (pin_5_initial_out == "pin5_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_5_initial_out == "pin5_initial_out_x")
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_initial_out = 
    (pin_5_initial_out == "pin5_initial_out_z")? "pin1_initial_out_z" : 
    (pin_5_initial_out == "pin5_initial_out_0")? "pin1_initial_out_0" : 
    (pin_5_initial_out == "pin5_initial_out_1")? "pin1_initial_out_1" : 
    "pin1_initial_out_x"; //(pin_5_initial_out == "pin5_initial_out_x")

localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_dynoct = 
    (pin_5_oct_mode == "pin5_static_off")? "pin1_oct_disabled" : 
    (pin_5_oct_mode == "pin5_static_on")? "pin1_oct_disabled" : 
    "pin1_oct_enabled"; //(pin_5_oct_mode == "pin5_dynamic")
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct = 
    (pin_5_oct_mode == "pin5_static_off")? "oct_disabled" : 
    (pin_5_oct_mode == "pin5_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_5_oct_mode == "pin5_dynamic")

localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr = 
    (pin_5_mode_ddr == "pin5_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_5_mode_ddr == "pin5_mode_ddr")
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_mode_ddr = 
    (pin_5_mode_ddr == "pin5_mode_sdr")? "pin1_mode_sdr" : 
    "pin1_mode_ddr"; //(pin_5_mode_ddr == "pin5_mode_ddr")
localparam ioereg_struct_2_1__a_mode_ddr = 
    (pin_5_mode_ddr == "pin5_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_5_mode_ddr == "pin5_mode_ddr")

localparam ioereg_top_2___ioereg_pnr_x2__read_path_1__a_dqs_select = 
    (pin_5_dqs_mode == "pin5_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_5_dqs_mode == "pin5_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_5_dqs_mode == "pin5_dqs_sampler_b_a_rise")
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select = 
    (pin_5_dqs_mode == "pin5_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_5_dqs_mode == "pin5_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_5_dqs_mode == "pin5_dqs_sampler_b_a_rise")

localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode = 
    (pin_5_data_in_mode == "pin5_ca")? "x1_calibration" : 
    (pin_5_data_in_mode == "pin5_clock")? "x1_calibration" : 
    (pin_5_data_in_mode == "pin5_dq")? "x1_calibration" : 
    (pin_5_data_in_mode == "pin5_dqs")? "x12_calibration" : 
    (pin_5_data_in_mode == "pin5_dpa_slave")? "x1_calibration" : 
    (pin_5_data_in_mode == "pin5_dpa_master")? "x1_calibration" : 
    (pin_5_data_in_mode == "pin5_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_5_data_in_mode == "pin5_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_5_data_in_mode == "pin5_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode = 
    (pin_5_data_in_mode == "pin5_ca")? "pin1_shadow_write_disabled" : 
    (pin_5_data_in_mode == "pin5_clock")? "pin1_shadow_write_enabled" : 
    (pin_5_data_in_mode == "pin5_dq")? "pin1_shadow_write_disabled" : 
    (pin_5_data_in_mode == "pin5_dqs")? "pin1_shadow_write_enabled" : 
    (pin_5_data_in_mode == "pin5_dpa_slave")? "pin1_shadow_write_disabled" : 
    (pin_5_data_in_mode == "pin5_dpa_master")? "pin1_shadow_write_disabled" : 
    (pin_5_data_in_mode == "pin5_dq_xor_a_loopback")? "pin1_shadow_write_disabled" : 
    (pin_5_data_in_mode == "pin5_dq_xor_b_loopback")? "pin1_shadow_write_disabled" : 
    "pin1_shadow_write_disabled"; //(pin_5_data_in_mode == "pin5_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_octrt = 
    (pin_5_data_in_mode == "pin5_ca")? "static_oct_off" : 
    (pin_5_data_in_mode == "pin5_clock")? "static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dq")? "static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dqs")? "static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dpa_slave")? "static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dpa_master")? "static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_5_data_in_mode == "pin5_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_octrt = 
    (pin_5_data_in_mode == "pin5_ca")? "pin1_static_oct_off" : 
    (pin_5_data_in_mode == "pin5_clock")? "pin1_static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dq")? "pin1_static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dqs")? "pin1_static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dpa_slave")? "pin1_static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dpa_master")? "pin1_static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dq_xor_a_loopback")? "pin1_static_oct_off" : 
    (pin_5_data_in_mode == "pin5_dq_xor_b_loopback")? "pin1_static_oct_off" : 
    "pin1_static_oct_off"; //(pin_5_data_in_mode == "pin5_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode = 
    (pin_5_data_in_mode == "pin5_ca")? "pin1_x1_calibration" : 
    (pin_5_data_in_mode == "pin5_clock")? "pin1_x1_calibration" : 
    (pin_5_data_in_mode == "pin5_dq")? "pin1_x1_calibration" : 
    (pin_5_data_in_mode == "pin5_dqs")? "pin1_x12_calibration" : 
    (pin_5_data_in_mode == "pin5_dpa_slave")? "pin1_x1_calibration" : 
    (pin_5_data_in_mode == "pin5_dpa_master")? "pin1_x1_calibration" : 
    (pin_5_data_in_mode == "pin5_dq_xor_a_loopback")? "pin1_x1_calibration" : 
    (pin_5_data_in_mode == "pin5_dq_xor_b_loopback")? "pin1_x1_calibration" : 
    "pin1_x1_calibration"; //(pin_5_data_in_mode == "pin5_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode = 
    (pin_5_data_in_mode == "pin5_ca")? "shadow_write_disabled" : 
    (pin_5_data_in_mode == "pin5_clock")? "shadow_write_enabled" : 
    (pin_5_data_in_mode == "pin5_dq")? "shadow_write_disabled" : 
    (pin_5_data_in_mode == "pin5_dqs")? "shadow_write_enabled" : 
    (pin_5_data_in_mode == "pin5_dpa_slave")? "shadow_write_disabled" : 
    (pin_5_data_in_mode == "pin5_dpa_master")? "shadow_write_disabled" : 
    (pin_5_data_in_mode == "pin5_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_5_data_in_mode == "pin5_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_5_data_in_mode == "pin5_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode = 
    (pin_5_data_in_mode == "pin5_ca")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_clock")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dq")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dqs")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dpa_slave")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dpa_master")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_5_data_in_mode == "pin5_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__read_path_1__a_dfx_mode = 
    (pin_5_data_in_mode == "pin5_ca")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_clock")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dq")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dqs")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dpa_slave")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dpa_master")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_5_data_in_mode == "pin5_dqs_xor_loopback")
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_dfx_mode = 
    (pin_5_data_in_mode == "pin5_ca")? "pin1_dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_clock")? "pin1_dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dq")? "pin1_dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dqs")? "pin1_dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dpa_slave")? "pin1_dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dpa_master")? "pin1_dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dq_xor_a_loopback")? "pin1_dfx_disabled" : 
    (pin_5_data_in_mode == "pin5_dq_xor_b_loopback")? "pin1_dfx_disabled" : 
    "pin1_dfx_disabled"; //(pin_5_data_in_mode == "pin5_dqs_xor_loopback")

localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out = 
    (pin_6_initial_out == "pin6_initial_out_z")? "initial_out_z" : 
    (pin_6_initial_out == "pin6_initial_out_0")? "initial_out_0" : 
    (pin_6_initial_out == "pin6_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_6_initial_out == "pin6_initial_out_x")
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_initial_out = 
    (pin_6_initial_out == "pin6_initial_out_z")? "pin0_initial_out_z" : 
    (pin_6_initial_out == "pin6_initial_out_0")? "pin0_initial_out_0" : 
    (pin_6_initial_out == "pin6_initial_out_1")? "pin0_initial_out_1" : 
    "pin0_initial_out_x"; //(pin_6_initial_out == "pin6_initial_out_x")

localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_dynoct = 
    (pin_6_oct_mode == "pin6_static_off")? "pin0_oct_disabled" : 
    (pin_6_oct_mode == "pin6_static_on")? "pin0_oct_disabled" : 
    "pin0_oct_enabled"; //(pin_6_oct_mode == "pin6_dynamic")
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct = 
    (pin_6_oct_mode == "pin6_static_off")? "oct_disabled" : 
    (pin_6_oct_mode == "pin6_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_6_oct_mode == "pin6_dynamic")

localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr = 
    (pin_6_mode_ddr == "pin6_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_6_mode_ddr == "pin6_mode_ddr")
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_mode_ddr = 
    (pin_6_mode_ddr == "pin6_mode_sdr")? "pin0_mode_sdr" : 
    "pin0_mode_ddr"; //(pin_6_mode_ddr == "pin6_mode_ddr")
localparam ioereg_struct_3_0__a_mode_ddr = 
    (pin_6_mode_ddr == "pin6_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_6_mode_ddr == "pin6_mode_ddr")

localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select = 
    (pin_6_dqs_mode == "pin6_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_6_dqs_mode == "pin6_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_6_dqs_mode == "pin6_dqs_sampler_b_a_rise")
localparam ioereg_top_3___ioereg_pnr_x2__read_path_0__a_dqs_select = 
    (pin_6_dqs_mode == "pin6_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_6_dqs_mode == "pin6_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_6_dqs_mode == "pin6_dqs_sampler_b_a_rise")

localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode = 
    (pin_6_data_in_mode == "pin6_ca")? "pin0_shadow_write_disabled" : 
    (pin_6_data_in_mode == "pin6_clock")? "pin0_shadow_write_enabled" : 
    (pin_6_data_in_mode == "pin6_dq")? "pin0_shadow_write_disabled" : 
    (pin_6_data_in_mode == "pin6_dqs")? "pin0_shadow_write_enabled" : 
    (pin_6_data_in_mode == "pin6_dpa_slave")? "pin0_shadow_write_disabled" : 
    (pin_6_data_in_mode == "pin6_dpa_master")? "pin0_shadow_write_disabled" : 
    (pin_6_data_in_mode == "pin6_dq_xor_a_loopback")? "pin0_shadow_write_disabled" : 
    (pin_6_data_in_mode == "pin6_dq_xor_b_loopback")? "pin0_shadow_write_disabled" : 
    "pin0_shadow_write_disabled"; //(pin_6_data_in_mode == "pin6_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode = 
    (pin_6_data_in_mode == "pin6_ca")? "x1_calibration" : 
    (pin_6_data_in_mode == "pin6_clock")? "x1_calibration" : 
    (pin_6_data_in_mode == "pin6_dq")? "x1_calibration" : 
    (pin_6_data_in_mode == "pin6_dqs")? "x12_calibration" : 
    (pin_6_data_in_mode == "pin6_dpa_slave")? "x1_calibration" : 
    (pin_6_data_in_mode == "pin6_dpa_master")? "x1_calibration" : 
    (pin_6_data_in_mode == "pin6_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_6_data_in_mode == "pin6_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_6_data_in_mode == "pin6_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode = 
    (pin_6_data_in_mode == "pin6_ca")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_clock")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dq")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dqs")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dpa_slave")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dpa_master")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_6_data_in_mode == "pin6_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_octrt = 
    (pin_6_data_in_mode == "pin6_ca")? "pin0_static_oct_off" : 
    (pin_6_data_in_mode == "pin6_clock")? "pin0_static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dq")? "pin0_static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dqs")? "pin0_static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dpa_slave")? "pin0_static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dpa_master")? "pin0_static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dq_xor_a_loopback")? "pin0_static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dq_xor_b_loopback")? "pin0_static_oct_off" : 
    "pin0_static_oct_off"; //(pin_6_data_in_mode == "pin6_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode = 
    (pin_6_data_in_mode == "pin6_ca")? "pin0_x1_calibration" : 
    (pin_6_data_in_mode == "pin6_clock")? "pin0_x1_calibration" : 
    (pin_6_data_in_mode == "pin6_dq")? "pin0_x1_calibration" : 
    (pin_6_data_in_mode == "pin6_dqs")? "pin0_x12_calibration" : 
    (pin_6_data_in_mode == "pin6_dpa_slave")? "pin0_x1_calibration" : 
    (pin_6_data_in_mode == "pin6_dpa_master")? "pin0_x1_calibration" : 
    (pin_6_data_in_mode == "pin6_dq_xor_a_loopback")? "pin0_x1_calibration" : 
    (pin_6_data_in_mode == "pin6_dq_xor_b_loopback")? "pin0_x1_calibration" : 
    "pin0_x1_calibration"; //(pin_6_data_in_mode == "pin6_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__read_path_0__a_dfx_mode = 
    (pin_6_data_in_mode == "pin6_ca")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_clock")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dq")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dqs")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dpa_slave")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dpa_master")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_6_data_in_mode == "pin6_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_octrt = 
    (pin_6_data_in_mode == "pin6_ca")? "static_oct_off" : 
    (pin_6_data_in_mode == "pin6_clock")? "static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dq")? "static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dqs")? "static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dpa_slave")? "static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dpa_master")? "static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_6_data_in_mode == "pin6_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_6_data_in_mode == "pin6_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode = 
    (pin_6_data_in_mode == "pin6_ca")? "shadow_write_disabled" : 
    (pin_6_data_in_mode == "pin6_clock")? "shadow_write_enabled" : 
    (pin_6_data_in_mode == "pin6_dq")? "shadow_write_disabled" : 
    (pin_6_data_in_mode == "pin6_dqs")? "shadow_write_enabled" : 
    (pin_6_data_in_mode == "pin6_dpa_slave")? "shadow_write_disabled" : 
    (pin_6_data_in_mode == "pin6_dpa_master")? "shadow_write_disabled" : 
    (pin_6_data_in_mode == "pin6_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_6_data_in_mode == "pin6_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_6_data_in_mode == "pin6_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_dfx_mode = 
    (pin_6_data_in_mode == "pin6_ca")? "pin0_dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_clock")? "pin0_dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dq")? "pin0_dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dqs")? "pin0_dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dpa_slave")? "pin0_dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dpa_master")? "pin0_dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dq_xor_a_loopback")? "pin0_dfx_disabled" : 
    (pin_6_data_in_mode == "pin6_dq_xor_b_loopback")? "pin0_dfx_disabled" : 
    "pin0_dfx_disabled"; //(pin_6_data_in_mode == "pin6_dqs_xor_loopback")

localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_initial_out = 
    (pin_7_initial_out == "pin7_initial_out_z")? "pin1_initial_out_z" : 
    (pin_7_initial_out == "pin7_initial_out_0")? "pin1_initial_out_0" : 
    (pin_7_initial_out == "pin7_initial_out_1")? "pin1_initial_out_1" : 
    "pin1_initial_out_x"; //(pin_7_initial_out == "pin7_initial_out_x")
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out = 
    (pin_7_initial_out == "pin7_initial_out_z")? "initial_out_z" : 
    (pin_7_initial_out == "pin7_initial_out_0")? "initial_out_0" : 
    (pin_7_initial_out == "pin7_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_7_initial_out == "pin7_initial_out_x")

localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct = 
    (pin_7_oct_mode == "pin7_static_off")? "oct_disabled" : 
    (pin_7_oct_mode == "pin7_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_7_oct_mode == "pin7_dynamic")
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_dynoct = 
    (pin_7_oct_mode == "pin7_static_off")? "pin1_oct_disabled" : 
    (pin_7_oct_mode == "pin7_static_on")? "pin1_oct_disabled" : 
    "pin1_oct_enabled"; //(pin_7_oct_mode == "pin7_dynamic")

localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr = 
    (pin_7_mode_ddr == "pin7_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_7_mode_ddr == "pin7_mode_ddr")
localparam ioereg_struct_3_1__a_mode_ddr = 
    (pin_7_mode_ddr == "pin7_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_7_mode_ddr == "pin7_mode_ddr")
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_mode_ddr = 
    (pin_7_mode_ddr == "pin7_mode_sdr")? "pin1_mode_sdr" : 
    "pin1_mode_ddr"; //(pin_7_mode_ddr == "pin7_mode_ddr")

localparam ioereg_top_3___ioereg_pnr_x2__read_path_1__a_dqs_select = 
    (pin_7_dqs_mode == "pin7_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_7_dqs_mode == "pin7_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_7_dqs_mode == "pin7_dqs_sampler_b_a_rise")
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select = 
    (pin_7_dqs_mode == "pin7_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_7_dqs_mode == "pin7_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_7_dqs_mode == "pin7_dqs_sampler_b_a_rise")

localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_dfx_mode = 
    (pin_7_data_in_mode == "pin7_ca")? "pin1_dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_clock")? "pin1_dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dq")? "pin1_dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dqs")? "pin1_dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dpa_slave")? "pin1_dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dpa_master")? "pin1_dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dq_xor_a_loopback")? "pin1_dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dq_xor_b_loopback")? "pin1_dfx_disabled" : 
    "pin1_dfx_disabled"; //(pin_7_data_in_mode == "pin7_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode = 
    (pin_7_data_in_mode == "pin7_ca")? "pin1_x1_calibration" : 
    (pin_7_data_in_mode == "pin7_clock")? "pin1_x1_calibration" : 
    (pin_7_data_in_mode == "pin7_dq")? "pin1_x1_calibration" : 
    (pin_7_data_in_mode == "pin7_dqs")? "pin1_x12_calibration" : 
    (pin_7_data_in_mode == "pin7_dpa_slave")? "pin1_x1_calibration" : 
    (pin_7_data_in_mode == "pin7_dpa_master")? "pin1_x1_calibration" : 
    (pin_7_data_in_mode == "pin7_dq_xor_a_loopback")? "pin1_x1_calibration" : 
    (pin_7_data_in_mode == "pin7_dq_xor_b_loopback")? "pin1_x1_calibration" : 
    "pin1_x1_calibration"; //(pin_7_data_in_mode == "pin7_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode = 
    (pin_7_data_in_mode == "pin7_ca")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_clock")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dq")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dqs")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dpa_slave")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dpa_master")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_7_data_in_mode == "pin7_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__read_path_1__a_dfx_mode = 
    (pin_7_data_in_mode == "pin7_ca")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_clock")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dq")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dqs")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dpa_slave")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dpa_master")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_7_data_in_mode == "pin7_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_7_data_in_mode == "pin7_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_octrt = 
    (pin_7_data_in_mode == "pin7_ca")? "pin1_static_oct_off" : 
    (pin_7_data_in_mode == "pin7_clock")? "pin1_static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dq")? "pin1_static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dqs")? "pin1_static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dpa_slave")? "pin1_static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dpa_master")? "pin1_static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dq_xor_a_loopback")? "pin1_static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dq_xor_b_loopback")? "pin1_static_oct_off" : 
    "pin1_static_oct_off"; //(pin_7_data_in_mode == "pin7_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode = 
    (pin_7_data_in_mode == "pin7_ca")? "x1_calibration" : 
    (pin_7_data_in_mode == "pin7_clock")? "x1_calibration" : 
    (pin_7_data_in_mode == "pin7_dq")? "x1_calibration" : 
    (pin_7_data_in_mode == "pin7_dqs")? "x12_calibration" : 
    (pin_7_data_in_mode == "pin7_dpa_slave")? "x1_calibration" : 
    (pin_7_data_in_mode == "pin7_dpa_master")? "x1_calibration" : 
    (pin_7_data_in_mode == "pin7_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_7_data_in_mode == "pin7_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_7_data_in_mode == "pin7_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_octrt = 
    (pin_7_data_in_mode == "pin7_ca")? "static_oct_off" : 
    (pin_7_data_in_mode == "pin7_clock")? "static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dq")? "static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dqs")? "static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dpa_slave")? "static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dpa_master")? "static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_7_data_in_mode == "pin7_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_7_data_in_mode == "pin7_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode = 
    (pin_7_data_in_mode == "pin7_ca")? "pin1_shadow_write_disabled" : 
    (pin_7_data_in_mode == "pin7_clock")? "pin1_shadow_write_enabled" : 
    (pin_7_data_in_mode == "pin7_dq")? "pin1_shadow_write_disabled" : 
    (pin_7_data_in_mode == "pin7_dqs")? "pin1_shadow_write_enabled" : 
    (pin_7_data_in_mode == "pin7_dpa_slave")? "pin1_shadow_write_disabled" : 
    (pin_7_data_in_mode == "pin7_dpa_master")? "pin1_shadow_write_disabled" : 
    (pin_7_data_in_mode == "pin7_dq_xor_a_loopback")? "pin1_shadow_write_disabled" : 
    (pin_7_data_in_mode == "pin7_dq_xor_b_loopback")? "pin1_shadow_write_disabled" : 
    "pin1_shadow_write_disabled"; //(pin_7_data_in_mode == "pin7_dqs_xor_loopback")
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode = 
    (pin_7_data_in_mode == "pin7_ca")? "shadow_write_disabled" : 
    (pin_7_data_in_mode == "pin7_clock")? "shadow_write_enabled" : 
    (pin_7_data_in_mode == "pin7_dq")? "shadow_write_disabled" : 
    (pin_7_data_in_mode == "pin7_dqs")? "shadow_write_enabled" : 
    (pin_7_data_in_mode == "pin7_dpa_slave")? "shadow_write_disabled" : 
    (pin_7_data_in_mode == "pin7_dpa_master")? "shadow_write_disabled" : 
    (pin_7_data_in_mode == "pin7_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_7_data_in_mode == "pin7_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_7_data_in_mode == "pin7_dqs_xor_loopback")

localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_initial_out = 
    (pin_8_initial_out == "pin8_initial_out_z")? "pin0_initial_out_z" : 
    (pin_8_initial_out == "pin8_initial_out_0")? "pin0_initial_out_0" : 
    (pin_8_initial_out == "pin8_initial_out_1")? "pin0_initial_out_1" : 
    "pin0_initial_out_x"; //(pin_8_initial_out == "pin8_initial_out_x")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out = 
    (pin_8_initial_out == "pin8_initial_out_z")? "initial_out_z" : 
    (pin_8_initial_out == "pin8_initial_out_0")? "initial_out_0" : 
    (pin_8_initial_out == "pin8_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_8_initial_out == "pin8_initial_out_x")

localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_dynoct = 
    (pin_8_oct_mode == "pin8_static_off")? "pin0_oct_disabled" : 
    (pin_8_oct_mode == "pin8_static_on")? "pin0_oct_disabled" : 
    "pin0_oct_enabled"; //(pin_8_oct_mode == "pin8_dynamic")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct = 
    (pin_8_oct_mode == "pin8_static_off")? "oct_disabled" : 
    (pin_8_oct_mode == "pin8_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_8_oct_mode == "pin8_dynamic")

localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_mode_ddr = 
    (pin_8_mode_ddr == "pin8_mode_sdr")? "pin0_mode_sdr" : 
    "pin0_mode_ddr"; //(pin_8_mode_ddr == "pin8_mode_ddr")
localparam ioereg_struct_4_0__a_mode_ddr = 
    (pin_8_mode_ddr == "pin8_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_8_mode_ddr == "pin8_mode_ddr")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr = 
    (pin_8_mode_ddr == "pin8_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_8_mode_ddr == "pin8_mode_ddr")

localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select = 
    (pin_8_dqs_mode == "pin8_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_8_dqs_mode == "pin8_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_8_dqs_mode == "pin8_dqs_sampler_b_a_rise")
localparam ioereg_top_4___ioereg_pnr_x2__read_path_0__a_dqs_select = 
    (pin_8_dqs_mode == "pin8_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_8_dqs_mode == "pin8_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_8_dqs_mode == "pin8_dqs_sampler_b_a_rise")

localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode = 
    (pin_8_data_in_mode == "pin8_ca")? "pin0_shadow_write_disabled" : 
    (pin_8_data_in_mode == "pin8_clock")? "pin0_shadow_write_enabled" : 
    (pin_8_data_in_mode == "pin8_dq")? "pin0_shadow_write_disabled" : 
    (pin_8_data_in_mode == "pin8_dqs")? "pin0_shadow_write_enabled" : 
    (pin_8_data_in_mode == "pin8_dpa_slave")? "pin0_shadow_write_disabled" : 
    (pin_8_data_in_mode == "pin8_dpa_master")? "pin0_shadow_write_disabled" : 
    (pin_8_data_in_mode == "pin8_dq_xor_a_loopback")? "pin0_shadow_write_disabled" : 
    (pin_8_data_in_mode == "pin8_dq_xor_b_loopback")? "pin0_shadow_write_disabled" : 
    "pin0_shadow_write_disabled"; //(pin_8_data_in_mode == "pin8_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode = 
    (pin_8_data_in_mode == "pin8_ca")? "x1_calibration" : 
    (pin_8_data_in_mode == "pin8_clock")? "x1_calibration" : 
    (pin_8_data_in_mode == "pin8_dq")? "x1_calibration" : 
    (pin_8_data_in_mode == "pin8_dqs")? "x12_calibration" : 
    (pin_8_data_in_mode == "pin8_dpa_slave")? "x1_calibration" : 
    (pin_8_data_in_mode == "pin8_dpa_master")? "x1_calibration" : 
    (pin_8_data_in_mode == "pin8_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_8_data_in_mode == "pin8_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_8_data_in_mode == "pin8_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode = 
    (pin_8_data_in_mode == "pin8_ca")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_clock")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dq")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dqs")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dpa_slave")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dpa_master")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_8_data_in_mode == "pin8_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_octrt = 
    (pin_8_data_in_mode == "pin8_ca")? "static_oct_off" : 
    (pin_8_data_in_mode == "pin8_clock")? "static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dq")? "static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dqs")? "static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dpa_slave")? "static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dpa_master")? "static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_8_data_in_mode == "pin8_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_octrt = 
    (pin_8_data_in_mode == "pin8_ca")? "pin0_static_oct_off" : 
    (pin_8_data_in_mode == "pin8_clock")? "pin0_static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dq")? "pin0_static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dqs")? "pin0_static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dpa_slave")? "pin0_static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dpa_master")? "pin0_static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dq_xor_a_loopback")? "pin0_static_oct_off" : 
    (pin_8_data_in_mode == "pin8_dq_xor_b_loopback")? "pin0_static_oct_off" : 
    "pin0_static_oct_off"; //(pin_8_data_in_mode == "pin8_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__read_path_0__a_dfx_mode = 
    (pin_8_data_in_mode == "pin8_ca")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_clock")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dq")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dqs")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dpa_slave")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dpa_master")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_8_data_in_mode == "pin8_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode = 
    (pin_8_data_in_mode == "pin8_ca")? "shadow_write_disabled" : 
    (pin_8_data_in_mode == "pin8_clock")? "shadow_write_enabled" : 
    (pin_8_data_in_mode == "pin8_dq")? "shadow_write_disabled" : 
    (pin_8_data_in_mode == "pin8_dqs")? "shadow_write_enabled" : 
    (pin_8_data_in_mode == "pin8_dpa_slave")? "shadow_write_disabled" : 
    (pin_8_data_in_mode == "pin8_dpa_master")? "shadow_write_disabled" : 
    (pin_8_data_in_mode == "pin8_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_8_data_in_mode == "pin8_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_8_data_in_mode == "pin8_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode = 
    (pin_8_data_in_mode == "pin8_ca")? "pin0_x1_calibration" : 
    (pin_8_data_in_mode == "pin8_clock")? "pin0_x1_calibration" : 
    (pin_8_data_in_mode == "pin8_dq")? "pin0_x1_calibration" : 
    (pin_8_data_in_mode == "pin8_dqs")? "pin0_x12_calibration" : 
    (pin_8_data_in_mode == "pin8_dpa_slave")? "pin0_x1_calibration" : 
    (pin_8_data_in_mode == "pin8_dpa_master")? "pin0_x1_calibration" : 
    (pin_8_data_in_mode == "pin8_dq_xor_a_loopback")? "pin0_x1_calibration" : 
    (pin_8_data_in_mode == "pin8_dq_xor_b_loopback")? "pin0_x1_calibration" : 
    "pin0_x1_calibration"; //(pin_8_data_in_mode == "pin8_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_dfx_mode = 
    (pin_8_data_in_mode == "pin8_ca")? "pin0_dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_clock")? "pin0_dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dq")? "pin0_dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dqs")? "pin0_dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dpa_slave")? "pin0_dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dpa_master")? "pin0_dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dq_xor_a_loopback")? "pin0_dfx_disabled" : 
    (pin_8_data_in_mode == "pin8_dq_xor_b_loopback")? "pin0_dfx_disabled" : 
    "pin0_dfx_disabled"; //(pin_8_data_in_mode == "pin8_dqs_xor_loopback")

localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_initial_out = 
    (pin_9_initial_out == "pin9_initial_out_z")? "pin1_initial_out_z" : 
    (pin_9_initial_out == "pin9_initial_out_0")? "pin1_initial_out_0" : 
    (pin_9_initial_out == "pin9_initial_out_1")? "pin1_initial_out_1" : 
    "pin1_initial_out_x"; //(pin_9_initial_out == "pin9_initial_out_x")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out = 
    (pin_9_initial_out == "pin9_initial_out_z")? "initial_out_z" : 
    (pin_9_initial_out == "pin9_initial_out_0")? "initial_out_0" : 
    (pin_9_initial_out == "pin9_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_9_initial_out == "pin9_initial_out_x")

localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_dynoct = 
    (pin_9_oct_mode == "pin9_static_off")? "pin1_oct_disabled" : 
    (pin_9_oct_mode == "pin9_static_on")? "pin1_oct_disabled" : 
    "pin1_oct_enabled"; //(pin_9_oct_mode == "pin9_dynamic")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct = 
    (pin_9_oct_mode == "pin9_static_off")? "oct_disabled" : 
    (pin_9_oct_mode == "pin9_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_9_oct_mode == "pin9_dynamic")

localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_mode_ddr = 
    (pin_9_mode_ddr == "pin9_mode_sdr")? "pin1_mode_sdr" : 
    "pin1_mode_ddr"; //(pin_9_mode_ddr == "pin9_mode_ddr")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr = 
    (pin_9_mode_ddr == "pin9_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_9_mode_ddr == "pin9_mode_ddr")
localparam ioereg_struct_4_1__a_mode_ddr = 
    (pin_9_mode_ddr == "pin9_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_9_mode_ddr == "pin9_mode_ddr")

localparam ioereg_top_4___ioereg_pnr_x2__read_path_1__a_dqs_select = 
    (pin_9_dqs_mode == "pin9_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_9_dqs_mode == "pin9_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_9_dqs_mode == "pin9_dqs_sampler_b_a_rise")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select = 
    (pin_9_dqs_mode == "pin9_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_9_dqs_mode == "pin9_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_9_dqs_mode == "pin9_dqs_sampler_b_a_rise")

localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_octrt = 
    (pin_9_data_in_mode == "pin9_ca")? "static_oct_off" : 
    (pin_9_data_in_mode == "pin9_clock")? "static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dq")? "static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dqs")? "static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dpa_slave")? "static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dpa_master")? "static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_9_data_in_mode == "pin9_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__read_path_1__a_dfx_mode = 
    (pin_9_data_in_mode == "pin9_ca")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_clock")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dq")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dqs")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dpa_slave")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dpa_master")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_9_data_in_mode == "pin9_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode = 
    (pin_9_data_in_mode == "pin9_ca")? "pin1_shadow_write_disabled" : 
    (pin_9_data_in_mode == "pin9_clock")? "pin1_shadow_write_enabled" : 
    (pin_9_data_in_mode == "pin9_dq")? "pin1_shadow_write_disabled" : 
    (pin_9_data_in_mode == "pin9_dqs")? "pin1_shadow_write_enabled" : 
    (pin_9_data_in_mode == "pin9_dpa_slave")? "pin1_shadow_write_disabled" : 
    (pin_9_data_in_mode == "pin9_dpa_master")? "pin1_shadow_write_disabled" : 
    (pin_9_data_in_mode == "pin9_dq_xor_a_loopback")? "pin1_shadow_write_disabled" : 
    (pin_9_data_in_mode == "pin9_dq_xor_b_loopback")? "pin1_shadow_write_disabled" : 
    "pin1_shadow_write_disabled"; //(pin_9_data_in_mode == "pin9_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode = 
    (pin_9_data_in_mode == "pin9_ca")? "pin1_x1_calibration" : 
    (pin_9_data_in_mode == "pin9_clock")? "pin1_x1_calibration" : 
    (pin_9_data_in_mode == "pin9_dq")? "pin1_x1_calibration" : 
    (pin_9_data_in_mode == "pin9_dqs")? "pin1_x12_calibration" : 
    (pin_9_data_in_mode == "pin9_dpa_slave")? "pin1_x1_calibration" : 
    (pin_9_data_in_mode == "pin9_dpa_master")? "pin1_x1_calibration" : 
    (pin_9_data_in_mode == "pin9_dq_xor_a_loopback")? "pin1_x1_calibration" : 
    (pin_9_data_in_mode == "pin9_dq_xor_b_loopback")? "pin1_x1_calibration" : 
    "pin1_x1_calibration"; //(pin_9_data_in_mode == "pin9_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_dfx_mode = 
    (pin_9_data_in_mode == "pin9_ca")? "pin1_dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_clock")? "pin1_dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dq")? "pin1_dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dqs")? "pin1_dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dpa_slave")? "pin1_dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dpa_master")? "pin1_dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dq_xor_a_loopback")? "pin1_dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dq_xor_b_loopback")? "pin1_dfx_disabled" : 
    "pin1_dfx_disabled"; //(pin_9_data_in_mode == "pin9_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_octrt = 
    (pin_9_data_in_mode == "pin9_ca")? "pin1_static_oct_off" : 
    (pin_9_data_in_mode == "pin9_clock")? "pin1_static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dq")? "pin1_static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dqs")? "pin1_static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dpa_slave")? "pin1_static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dpa_master")? "pin1_static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dq_xor_a_loopback")? "pin1_static_oct_off" : 
    (pin_9_data_in_mode == "pin9_dq_xor_b_loopback")? "pin1_static_oct_off" : 
    "pin1_static_oct_off"; //(pin_9_data_in_mode == "pin9_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode = 
    (pin_9_data_in_mode == "pin9_ca")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_clock")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dq")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dqs")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dpa_slave")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dpa_master")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_9_data_in_mode == "pin9_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_9_data_in_mode == "pin9_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode = 
    (pin_9_data_in_mode == "pin9_ca")? "shadow_write_disabled" : 
    (pin_9_data_in_mode == "pin9_clock")? "shadow_write_enabled" : 
    (pin_9_data_in_mode == "pin9_dq")? "shadow_write_disabled" : 
    (pin_9_data_in_mode == "pin9_dqs")? "shadow_write_enabled" : 
    (pin_9_data_in_mode == "pin9_dpa_slave")? "shadow_write_disabled" : 
    (pin_9_data_in_mode == "pin9_dpa_master")? "shadow_write_disabled" : 
    (pin_9_data_in_mode == "pin9_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_9_data_in_mode == "pin9_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_9_data_in_mode == "pin9_dqs_xor_loopback")
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode = 
    (pin_9_data_in_mode == "pin9_ca")? "x1_calibration" : 
    (pin_9_data_in_mode == "pin9_clock")? "x1_calibration" : 
    (pin_9_data_in_mode == "pin9_dq")? "x1_calibration" : 
    (pin_9_data_in_mode == "pin9_dqs")? "x12_calibration" : 
    (pin_9_data_in_mode == "pin9_dpa_slave")? "x1_calibration" : 
    (pin_9_data_in_mode == "pin9_dpa_master")? "x1_calibration" : 
    (pin_9_data_in_mode == "pin9_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_9_data_in_mode == "pin9_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_9_data_in_mode == "pin9_dqs_xor_loopback")

localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_initial_out = 
    (pin_10_initial_out == "pin10_initial_out_z")? "pin0_initial_out_z" : 
    (pin_10_initial_out == "pin10_initial_out_0")? "pin0_initial_out_0" : 
    (pin_10_initial_out == "pin10_initial_out_1")? "pin0_initial_out_1" : 
    "pin0_initial_out_x"; //(pin_10_initial_out == "pin10_initial_out_x")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out = 
    (pin_10_initial_out == "pin10_initial_out_z")? "initial_out_z" : 
    (pin_10_initial_out == "pin10_initial_out_0")? "initial_out_0" : 
    (pin_10_initial_out == "pin10_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_10_initial_out == "pin10_initial_out_x")

localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_dynoct = 
    (pin_10_oct_mode == "pin10_static_off")? "pin0_oct_disabled" : 
    (pin_10_oct_mode == "pin10_static_on")? "pin0_oct_disabled" : 
    "pin0_oct_enabled"; //(pin_10_oct_mode == "pin10_dynamic")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct = 
    (pin_10_oct_mode == "pin10_static_off")? "oct_disabled" : 
    (pin_10_oct_mode == "pin10_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_10_oct_mode == "pin10_dynamic")

localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_mode_ddr = 
    (pin_10_mode_ddr == "pin10_mode_sdr")? "pin0_mode_sdr" : 
    "pin0_mode_ddr"; //(pin_10_mode_ddr == "pin10_mode_ddr")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr = 
    (pin_10_mode_ddr == "pin10_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_10_mode_ddr == "pin10_mode_ddr")
localparam ioereg_struct_5_0__a_mode_ddr = 
    (pin_10_mode_ddr == "pin10_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_10_mode_ddr == "pin10_mode_ddr")

localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select = 
    (pin_10_dqs_mode == "pin10_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_10_dqs_mode == "pin10_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_10_dqs_mode == "pin10_dqs_sampler_b_a_rise")
localparam ioereg_top_5___ioereg_pnr_x2__read_path_0__a_dqs_select = 
    (pin_10_dqs_mode == "pin10_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_10_dqs_mode == "pin10_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_10_dqs_mode == "pin10_dqs_sampler_b_a_rise")

localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode = 
    (pin_10_data_in_mode == "pin10_ca")? "pin0_shadow_write_disabled" : 
    (pin_10_data_in_mode == "pin10_clock")? "pin0_shadow_write_enabled" : 
    (pin_10_data_in_mode == "pin10_dq")? "pin0_shadow_write_disabled" : 
    (pin_10_data_in_mode == "pin10_dqs")? "pin0_shadow_write_enabled" : 
    (pin_10_data_in_mode == "pin10_dpa_slave")? "pin0_shadow_write_disabled" : 
    (pin_10_data_in_mode == "pin10_dpa_master")? "pin0_shadow_write_disabled" : 
    (pin_10_data_in_mode == "pin10_dq_xor_a_loopback")? "pin0_shadow_write_disabled" : 
    (pin_10_data_in_mode == "pin10_dq_xor_b_loopback")? "pin0_shadow_write_disabled" : 
    "pin0_shadow_write_disabled"; //(pin_10_data_in_mode == "pin10_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode = 
    (pin_10_data_in_mode == "pin10_ca")? "pin0_x1_calibration" : 
    (pin_10_data_in_mode == "pin10_clock")? "pin0_x1_calibration" : 
    (pin_10_data_in_mode == "pin10_dq")? "pin0_x1_calibration" : 
    (pin_10_data_in_mode == "pin10_dqs")? "pin0_x12_calibration" : 
    (pin_10_data_in_mode == "pin10_dpa_slave")? "pin0_x1_calibration" : 
    (pin_10_data_in_mode == "pin10_dpa_master")? "pin0_x1_calibration" : 
    (pin_10_data_in_mode == "pin10_dq_xor_a_loopback")? "pin0_x1_calibration" : 
    (pin_10_data_in_mode == "pin10_dq_xor_b_loopback")? "pin0_x1_calibration" : 
    "pin0_x1_calibration"; //(pin_10_data_in_mode == "pin10_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_dfx_mode = 
    (pin_10_data_in_mode == "pin10_ca")? "pin0_dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_clock")? "pin0_dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dq")? "pin0_dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dqs")? "pin0_dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dpa_slave")? "pin0_dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dpa_master")? "pin0_dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dq_xor_a_loopback")? "pin0_dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dq_xor_b_loopback")? "pin0_dfx_disabled" : 
    "pin0_dfx_disabled"; //(pin_10_data_in_mode == "pin10_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_octrt = 
    (pin_10_data_in_mode == "pin10_ca")? "pin0_static_oct_off" : 
    (pin_10_data_in_mode == "pin10_clock")? "pin0_static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dq")? "pin0_static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dqs")? "pin0_static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dpa_slave")? "pin0_static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dpa_master")? "pin0_static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dq_xor_a_loopback")? "pin0_static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dq_xor_b_loopback")? "pin0_static_oct_off" : 
    "pin0_static_oct_off"; //(pin_10_data_in_mode == "pin10_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode = 
    (pin_10_data_in_mode == "pin10_ca")? "x1_calibration" : 
    (pin_10_data_in_mode == "pin10_clock")? "x1_calibration" : 
    (pin_10_data_in_mode == "pin10_dq")? "x1_calibration" : 
    (pin_10_data_in_mode == "pin10_dqs")? "x12_calibration" : 
    (pin_10_data_in_mode == "pin10_dpa_slave")? "x1_calibration" : 
    (pin_10_data_in_mode == "pin10_dpa_master")? "x1_calibration" : 
    (pin_10_data_in_mode == "pin10_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_10_data_in_mode == "pin10_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_10_data_in_mode == "pin10_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode = 
    (pin_10_data_in_mode == "pin10_ca")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_clock")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dq")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dqs")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dpa_slave")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dpa_master")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_10_data_in_mode == "pin10_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_octrt = 
    (pin_10_data_in_mode == "pin10_ca")? "static_oct_off" : 
    (pin_10_data_in_mode == "pin10_clock")? "static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dq")? "static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dqs")? "static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dpa_slave")? "static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dpa_master")? "static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_10_data_in_mode == "pin10_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_10_data_in_mode == "pin10_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__read_path_0__a_dfx_mode = 
    (pin_10_data_in_mode == "pin10_ca")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_clock")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dq")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dqs")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dpa_slave")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dpa_master")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_10_data_in_mode == "pin10_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_10_data_in_mode == "pin10_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode = 
    (pin_10_data_in_mode == "pin10_ca")? "shadow_write_disabled" : 
    (pin_10_data_in_mode == "pin10_clock")? "shadow_write_enabled" : 
    (pin_10_data_in_mode == "pin10_dq")? "shadow_write_disabled" : 
    (pin_10_data_in_mode == "pin10_dqs")? "shadow_write_enabled" : 
    (pin_10_data_in_mode == "pin10_dpa_slave")? "shadow_write_disabled" : 
    (pin_10_data_in_mode == "pin10_dpa_master")? "shadow_write_disabled" : 
    (pin_10_data_in_mode == "pin10_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_10_data_in_mode == "pin10_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_10_data_in_mode == "pin10_dqs_xor_loopback")

localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_initial_out = 
    (pin_11_initial_out == "pin11_initial_out_z")? "pin1_initial_out_z" : 
    (pin_11_initial_out == "pin11_initial_out_0")? "pin1_initial_out_0" : 
    (pin_11_initial_out == "pin11_initial_out_1")? "pin1_initial_out_1" : 
    "pin1_initial_out_x"; //(pin_11_initial_out == "pin11_initial_out_x")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out = 
    (pin_11_initial_out == "pin11_initial_out_z")? "initial_out_z" : 
    (pin_11_initial_out == "pin11_initial_out_0")? "initial_out_0" : 
    (pin_11_initial_out == "pin11_initial_out_1")? "initial_out_1" : 
    "initial_out_x"; //(pin_11_initial_out == "pin11_initial_out_x")

localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_dynoct = 
    (pin_11_oct_mode == "pin11_static_off")? "pin1_oct_disabled" : 
    (pin_11_oct_mode == "pin11_static_on")? "pin1_oct_disabled" : 
    "pin1_oct_enabled"; //(pin_11_oct_mode == "pin11_dynamic")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct = 
    (pin_11_oct_mode == "pin11_static_off")? "oct_disabled" : 
    (pin_11_oct_mode == "pin11_static_on")? "oct_disabled" : 
    "oct_enabled"; //(pin_11_oct_mode == "pin11_dynamic")

localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_mode_ddr = 
    (pin_11_mode_ddr == "pin11_mode_sdr")? "pin1_mode_sdr" : 
    "pin1_mode_ddr"; //(pin_11_mode_ddr == "pin11_mode_ddr")
localparam ioereg_struct_5_1__a_mode_ddr = 
    (pin_11_mode_ddr == "pin11_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_11_mode_ddr == "pin11_mode_ddr")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr = 
    (pin_11_mode_ddr == "pin11_mode_sdr")? "mode_sdr" : 
    "mode_ddr"; //(pin_11_mode_ddr == "pin11_mode_ddr")

localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select = 
    (pin_11_dqs_mode == "pin11_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_11_dqs_mode == "pin11_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_11_dqs_mode == "pin11_dqs_sampler_b_a_rise")
localparam ioereg_top_5___ioereg_pnr_x2__read_path_1__a_dqs_select = 
    (pin_11_dqs_mode == "pin11_dqs_sampler_a")? "dqs_sampler_a" : 
    (pin_11_dqs_mode == "pin11_dqs_sampler_b")? "dqs_sampler_b" : 
    "dqs_sampler_b_a_rise"; //(pin_11_dqs_mode == "pin11_dqs_sampler_b_a_rise")

localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_octrt = 
    (pin_11_data_in_mode == "pin11_ca")? "pin1_static_oct_off" : 
    (pin_11_data_in_mode == "pin11_clock")? "pin1_static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dq")? "pin1_static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dqs")? "pin1_static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dpa_slave")? "pin1_static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dpa_master")? "pin1_static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dq_xor_a_loopback")? "pin1_static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dq_xor_b_loopback")? "pin1_static_oct_off" : 
    "pin1_static_oct_off"; //(pin_11_data_in_mode == "pin11_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode = 
    (pin_11_data_in_mode == "pin11_ca")? "shadow_write_disabled" : 
    (pin_11_data_in_mode == "pin11_clock")? "shadow_write_enabled" : 
    (pin_11_data_in_mode == "pin11_dq")? "shadow_write_disabled" : 
    (pin_11_data_in_mode == "pin11_dqs")? "shadow_write_enabled" : 
    (pin_11_data_in_mode == "pin11_dpa_slave")? "shadow_write_disabled" : 
    (pin_11_data_in_mode == "pin11_dpa_master")? "shadow_write_disabled" : 
    (pin_11_data_in_mode == "pin11_dq_xor_a_loopback")? "shadow_write_disabled" : 
    (pin_11_data_in_mode == "pin11_dq_xor_b_loopback")? "shadow_write_disabled" : 
    "shadow_write_disabled"; //(pin_11_data_in_mode == "pin11_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode = 
    (pin_11_data_in_mode == "pin11_ca")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_clock")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dq")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dqs")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dpa_slave")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dpa_master")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_11_data_in_mode == "pin11_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_octrt = 
    (pin_11_data_in_mode == "pin11_ca")? "static_oct_off" : 
    (pin_11_data_in_mode == "pin11_clock")? "static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dq")? "static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dqs")? "static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dpa_slave")? "static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dpa_master")? "static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dq_xor_a_loopback")? "static_oct_off" : 
    (pin_11_data_in_mode == "pin11_dq_xor_b_loopback")? "static_oct_off" : 
    "static_oct_off"; //(pin_11_data_in_mode == "pin11_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode = 
    (pin_11_data_in_mode == "pin11_ca")? "pin1_x1_calibration" : 
    (pin_11_data_in_mode == "pin11_clock")? "pin1_x1_calibration" : 
    (pin_11_data_in_mode == "pin11_dq")? "pin1_x1_calibration" : 
    (pin_11_data_in_mode == "pin11_dqs")? "pin1_x12_calibration" : 
    (pin_11_data_in_mode == "pin11_dpa_slave")? "pin1_x1_calibration" : 
    (pin_11_data_in_mode == "pin11_dpa_master")? "pin1_x1_calibration" : 
    (pin_11_data_in_mode == "pin11_dq_xor_a_loopback")? "pin1_x1_calibration" : 
    (pin_11_data_in_mode == "pin11_dq_xor_b_loopback")? "pin1_x1_calibration" : 
    "pin1_x1_calibration"; //(pin_11_data_in_mode == "pin11_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_dfx_mode = 
    (pin_11_data_in_mode == "pin11_ca")? "pin1_dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_clock")? "pin1_dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dq")? "pin1_dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dqs")? "pin1_dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dpa_slave")? "pin1_dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dpa_master")? "pin1_dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dq_xor_a_loopback")? "pin1_dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dq_xor_b_loopback")? "pin1_dfx_disabled" : 
    "pin1_dfx_disabled"; //(pin_11_data_in_mode == "pin11_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode = 
    (pin_11_data_in_mode == "pin11_ca")? "x1_calibration" : 
    (pin_11_data_in_mode == "pin11_clock")? "x1_calibration" : 
    (pin_11_data_in_mode == "pin11_dq")? "x1_calibration" : 
    (pin_11_data_in_mode == "pin11_dqs")? "x12_calibration" : 
    (pin_11_data_in_mode == "pin11_dpa_slave")? "x1_calibration" : 
    (pin_11_data_in_mode == "pin11_dpa_master")? "x1_calibration" : 
    (pin_11_data_in_mode == "pin11_dq_xor_a_loopback")? "x1_calibration" : 
    (pin_11_data_in_mode == "pin11_dq_xor_b_loopback")? "x1_calibration" : 
    "x1_calibration"; //(pin_11_data_in_mode == "pin11_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__read_path_1__a_dfx_mode = 
    (pin_11_data_in_mode == "pin11_ca")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_clock")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dq")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dqs")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dpa_slave")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dpa_master")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dq_xor_a_loopback")? "dfx_disabled" : 
    (pin_11_data_in_mode == "pin11_dq_xor_b_loopback")? "dfx_disabled" : 
    "dfx_disabled"; //(pin_11_data_in_mode == "pin11_dqs_xor_loopback")
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode = 
    (pin_11_data_in_mode == "pin11_ca")? "pin1_shadow_write_disabled" : 
    (pin_11_data_in_mode == "pin11_clock")? "pin1_shadow_write_enabled" : 
    (pin_11_data_in_mode == "pin11_dq")? "pin1_shadow_write_disabled" : 
    (pin_11_data_in_mode == "pin11_dqs")? "pin1_shadow_write_enabled" : 
    (pin_11_data_in_mode == "pin11_dpa_slave")? "pin1_shadow_write_disabled" : 
    (pin_11_data_in_mode == "pin11_dpa_master")? "pin1_shadow_write_disabled" : 
    (pin_11_data_in_mode == "pin11_dq_xor_a_loopback")? "pin1_shadow_write_disabled" : 
    (pin_11_data_in_mode == "pin11_dq_xor_b_loopback")? "pin1_shadow_write_disabled" : 
    "pin1_shadow_write_disabled"; //(pin_11_data_in_mode == "pin11_dqs_xor_loopback")

localparam data_buffer__io_data_buffer_data2core_inst_11__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_wdb_rdb_map_inst__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_data2core_inst_3__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_rdata_en_mrnk_sel_inst__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_data2core_inst_2__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_data2core_inst_8__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_data2core_inst_6__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_data2core_inst_4__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_data2core_inst_9__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_data2core_inst_0__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_data2core_inst_1__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_data2core_inst_7__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_data2core_inst_5__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")
localparam data_buffer__io_data_buffer_data2core_inst_10__a_rb_hmc_or_core = 
    (db_hmc_or_core == "core")? "core" : 
    "hmc"; //(db_hmc_or_core == "hmc")

localparam data_buffer__dbi_top_inst__a_rb_dbi_sel = 
    (db_dbi_sel == "db_dbi_sel_uint0")? "dbi_dq0" : 
    (db_dbi_sel == "db_dbi_sel_uint1")? "dbi_dq1" : 
    (db_dbi_sel == "db_dbi_sel_uint2")? "dbi_dq2" : 
    (db_dbi_sel == "db_dbi_sel_uint3")? "dbi_dq3" : 
    (db_dbi_sel == "db_dbi_sel_uint4")? "dbi_dq4" : 
    (db_dbi_sel == "db_dbi_sel_uint5")? "dbi_dq5" : 
    (db_dbi_sel == "db_dbi_sel_uint6")? "dbi_dq6" : 
    (db_dbi_sel == "db_dbi_sel_uint7")? "dbi_dq7" : 
    (db_dbi_sel == "db_dbi_sel_uint8")? "dbi_dq8" : 
    (db_dbi_sel == "db_dbi_sel_uint9")? "dbi_dq9" : 
    (db_dbi_sel == "db_dbi_sel_uint10")? "dbi_dq10" : 
    "dbi_dq11"; //(db_dbi_sel == "db_dbi_sel_uint11")

localparam data_buffer__dbi_top_inst__a_rb_dbi_wr_en = 
    (db_dbi_wr_en == "false")? "dbi_wr_disable" : 
    "dbi_wr_enable"; //(db_dbi_wr_en == "true")

localparam data_buffer__dbi_top_inst__a_rb_dbi_rd_en = 
    (db_dbi_rd_en == "false")? "dbi_rd_disable" : 
    "dbi_rd_enable"; //(db_dbi_rd_en == "true")

localparam data_buffer__avl_lane_inst__a_rb_avl_ena = 
    (avl_ena == "true")? "avl_enable" : 
    "avl_disable"; //(avl_ena == "false")

localparam data_buffer__avl_lane_inst__a_rb_bc_id_ena = 
    (db_boardcast_en == "true")? "bc_enable" : 
    "bc_disable"; //(db_boardcast_en == "false")

localparam data_buffer__rdwr_buffer_inst_7__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_5__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_11__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_4__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_10__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_1__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_8__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_2__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_5__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_3__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_7__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_11__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_3__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_6__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_1__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_8__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_6__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_0__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_10__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_2__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_9__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_4__a_wr_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "wr_datapath_bypass" : 
    "wr_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_0__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")
localparam data_buffer__rdwr_buffer_inst_9__a_oe_datapath_mod = 
    (db_pipeline == "pipeline_bypass")? "oe_datapath_bypass" : 
    "oe_datapath_one_cycle"; //(db_pipeline == "pipeline_one_cycle")

localparam data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_rwlat_mode = 
    (db_rwlat_mode == "csr_vlu")? "csr_vlu" : 
    "avl_vlu"; //(db_rwlat_mode == "avl_vlu")

localparam data_buffer__io_data_buffer_ptr_pipeline_inst__a_rb_ptr_pipeline = 
    (db_ptr_pipeline_depth == "db_ptr_pipeline_depth_uint0")? "ptr_bypass" : 
    (db_ptr_pipeline_depth == "db_ptr_pipeline_depth_uint1")? "ptr_one_cycle" : 
    (db_ptr_pipeline_depth == "db_ptr_pipeline_depth_uint2")? "ptr_two_cycle" : 
    (db_ptr_pipeline_depth == "db_ptr_pipeline_depth_uint3")? "ptr_three_cycle" : 
    "ptr_four_cycle"; //(db_ptr_pipeline_depth == "db_ptr_pipeline_depth_uint4")

localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_rb_preamble_mode = 
    (db_preamble_mode == "preamble_one_cycle")? "preamble_one_cycle" : 
    "preamble_two_cycle"; //(db_preamble_mode == "preamble_two_cycle")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_rb_preamble_mode = 
    (db_preamble_mode == "preamble_one_cycle")? "preamble_one_cycle" : 
    "preamble_two_cycle"; //(db_preamble_mode == "preamble_two_cycle")
localparam data_buffer__iodbccmn_dbc_inst__a_rb_preamble_mode = 
    (db_preamble_mode == "preamble_one_cycle")? "preamble_one_cycle" : 
    "preamble_two_cycle"; //(db_preamble_mode == "preamble_two_cycle")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_rb_preamble_mode = 
    (db_preamble_mode == "preamble_one_cycle")? "preamble_one_cycle" : 
    "preamble_two_cycle"; //(db_preamble_mode == "preamble_two_cycle")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_rb_preamble_mode = 
    (db_preamble_mode == "preamble_one_cycle")? "preamble_one_cycle" : 
    "preamble_two_cycle"; //(db_preamble_mode == "preamble_two_cycle")

localparam data_buffer__reset_lane__a_rb_reset_auto_release = 
    (db_reset_auto_release == "avl_release")? "avl_release" : 
    "auto_release"; //(db_reset_auto_release == "auto_release")

localparam data_buffer__rdwr_buffer_inst_5__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")
localparam data_buffer__rdwr_buffer_inst_3__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")
localparam data_buffer__rdwr_buffer_inst_9__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")
localparam data_buffer__rdwr_buffer_inst_2__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")
localparam data_buffer__rdwr_buffer_inst_1__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")
localparam data_buffer__rdwr_buffer_inst_4__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")
localparam data_buffer__rdwr_buffer_inst_8__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")
localparam data_buffer__rdwr_buffer_inst_10__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")
localparam data_buffer__rdwr_buffer_inst_7__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")
localparam data_buffer__rdwr_buffer_inst_0__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")
localparam data_buffer__rdwr_buffer_inst_6__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")
localparam data_buffer__rdwr_buffer_inst_11__a_rb_data_alignment_mode = 
    (db_data_alignment_mode == "align_disable")? "align_disable" : 
    "align_ena"; //(db_data_alignment_mode == "align_ena")

localparam data_buffer__io_data_buffer_data2core_inst_1__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_data2core_inst_0__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_rdata_valid_inst__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_data2core_inst_9__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_data2core_inst_2__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_data2core_inst_7__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_data2core_inst_8__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_data2core_inst_4__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_data2core_inst_6__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_data2core_inst_11__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_data2core_inst_10__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_data2core_inst_5__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")
localparam data_buffer__io_data_buffer_data2core_inst_3__a_rb_db2core_registered = 
    (db_db2core_registered == "registered")? "registered" : 
    "not_registered"; //(db_db2core_registered == "not_registered")

localparam data_buffer__data_buffer_clk_gen_inst__a_rb_sel_core_clk = 
    (dbc_core_clk_sel == "dbc_core_clk_sel_uint0")? "phy_clk0" : 
    "phy_clk1"; //(dbc_core_clk_sel == "dbc_core_clk_sel_uint1")

localparam data_buffer__io_data_buffer_rdata_en_mrnk_sel_inst__a_rb_mrnk_write_registered = 
    (db_core_or_hmc2db_registered == "true")? "mrnk_write_registered" : 
    "mrnk_write_bypass"; //(db_core_or_hmc2db_registered == "false")
localparam data_buffer__io_data_buffer_rdata_en_mrnk_sel_inst__a_rb_rdata_en_full_registered = 
    (db_core_or_hmc2db_registered == "true")? "rdata_en_full_registered" : 
    "rdata_en_full_bypass"; //(db_core_or_hmc2db_registered == "false")
localparam data_buffer__io_data_buffer_rdata_en_mrnk_sel_inst__a_rb_mrnk_read_registered = 
    (db_core_or_hmc2db_registered == "true")? "mrnk_read_registered" : 
    "mrnk_read_bypass"; //(db_core_or_hmc2db_registered == "false")

localparam data_buffer__io_data_buffer_ptr_pipeline_inst__a_rb_seq_rd_en_full_pipeline = 
    (db_seq_rd_en_full_pipeline == "db_seq_rd_en_full_pipeline_uint0")? "rd_one_cycle" : 
    (db_seq_rd_en_full_pipeline == "db_seq_rd_en_full_pipeline_uint1")? "rd_two_cycle" : 
    (db_seq_rd_en_full_pipeline == "db_seq_rd_en_full_pipeline_uint2")? "rd_three_cycle" : 
    (db_seq_rd_en_full_pipeline == "db_seq_rd_en_full_pipeline_uint3")? "rd_four_cycle" : 
    "rd_five_cycle"; //(db_seq_rd_en_full_pipeline == "db_seq_rd_en_full_pipeline_uint4")

localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_0 = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "pin0_ac_type" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "pin0_dq_type" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "pin0_dq_type" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "pin0_dq_type" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "pin0_ac_type" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "pin0_dq_type" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "pin0_dq_type" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "pin0_dq_type" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_ac_core")? "pin0_ac_type" : 
    (db_pin_0_mode == "pin0_dq_mode")? "pin0_dq_type" : 
    (db_pin_0_mode == "pin0_dm_mode")? "pin0_dq_type" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "pin0_dq_type" : 
    (db_pin_0_mode == "pin0_clk_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "pin0_dqs_type" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "pin0_dq_type" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "pin0_dqs_type" : 
    "pin0_ac_type"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_oe_datapath_prgmnvrt = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_ac_core")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dq_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dm_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_clk_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_wr_datapath_prgmnvrt = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_0_mode == "pin0_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dm_mode")? "wr_datapath_invert" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_clk_mode")? "wr_datapath_invert" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_0__a_wdb_bypass = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_0_mode == "pin0_ac_core")? "wdb_bypass" : 
    (db_pin_0_mode == "pin0_dq_mode")? "wdb_bypass" : 
    (db_pin_0_mode == "pin0_dm_mode")? "wdb_bypass" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "wdb_bypass" : 
    (db_pin_0_mode == "pin0_clk_mode")? "wdb_bypass" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "wdb_bypass" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "wdb_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "wdb_bypass" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "wdb_bypass" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_db_oe_bypass = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_ac_core")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_dq_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_dm_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_clk_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "db_oe_bypass" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_rb_gpio = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_ac_core")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dq_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dm_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_clk_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "gpio_false" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_dbc_sel = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_ac_core")? "sel_core" : 
    (db_pin_0_mode == "pin0_dq_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dm_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_clk_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_db_out_bypass = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_ac_core")? "db_out_bypass" : 
    (db_pin_0_mode == "pin0_dq_mode")? "db_out_bypass" : 
    (db_pin_0_mode == "pin0_dm_mode")? "db_out_bypass" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_clk_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "db_out_bypass" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_ac_dqs_dm_dq = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "ac_type" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_ac_core")? "ac_type" : 
    (db_pin_0_mode == "pin0_dq_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dm_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_clk_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_0__a_db_in_bypass = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_ac_core")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dq_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dm_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_clk_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_rb_sel_ac_hmc_ena = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_0__a_ac_dqs_dm_dq = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "ac_type" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_ac_core")? "ac_type" : 
    (db_pin_0_mode == "pin0_dq_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dm_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_clk_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "dq_type" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_0_mode == "pin0_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_0__a_dbc_sel = 
    (db_pin_0_mode == "pin0_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_ac_hmc")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_0_mode == "pin0_ac_core")? "sel_core" : 
    (db_pin_0_mode == "pin0_dq_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dm_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dbi_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_clk_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_clkb_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dqs_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dqsb_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_rdq_mode")? "sel_core" : 
    (db_pin_0_mode == "pin0_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_0_mode == "pin0_gpio_mode")

localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_1 = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "pin1_ac_type" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "pin1_dq_type" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "pin1_dq_type" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "pin1_dq_type" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "pin1_ac_type" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "pin1_dq_type" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "pin1_dq_type" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "pin1_dq_type" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_ac_core")? "pin1_ac_type" : 
    (db_pin_1_mode == "pin1_dq_mode")? "pin1_dq_type" : 
    (db_pin_1_mode == "pin1_dm_mode")? "pin1_dq_type" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "pin1_dq_type" : 
    (db_pin_1_mode == "pin1_clk_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "pin1_dqs_type" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "pin1_dq_type" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "pin1_dqs_type" : 
    "pin1_ac_type"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_rb_gpio = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_ac_core")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dq_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dm_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_clk_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "gpio_false" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_db_oe_bypass = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_ac_core")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_dq_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_dm_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_clk_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "db_oe_bypass" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_db_out_bypass = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_ac_core")? "db_out_bypass" : 
    (db_pin_1_mode == "pin1_dq_mode")? "db_out_bypass" : 
    (db_pin_1_mode == "pin1_dm_mode")? "db_out_bypass" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_clk_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "db_out_bypass" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_wr_datapath_prgmnvrt = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_1_mode == "pin1_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dm_mode")? "wr_datapath_invert" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_clk_mode")? "wr_datapath_invert" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_1__a_ac_dqs_dm_dq = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "ac_type" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_ac_core")? "ac_type" : 
    (db_pin_1_mode == "pin1_dq_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dm_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_clk_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_1__a_wdb_bypass = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_1_mode == "pin1_ac_core")? "wdb_bypass" : 
    (db_pin_1_mode == "pin1_dq_mode")? "wdb_bypass" : 
    (db_pin_1_mode == "pin1_dm_mode")? "wdb_bypass" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "wdb_bypass" : 
    (db_pin_1_mode == "pin1_clk_mode")? "wdb_bypass" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "wdb_bypass" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "wdb_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "wdb_bypass" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "wdb_bypass" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_1__a_db_in_bypass = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_ac_core")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dq_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dm_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_clk_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_1__a_dbc_sel = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_ac_core")? "sel_core" : 
    (db_pin_1_mode == "pin1_dq_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dm_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_clk_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_oe_datapath_prgmnvrt = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_ac_core")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dq_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dm_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_clk_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_dbc_sel = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_1_mode == "pin1_ac_core")? "sel_core" : 
    (db_pin_1_mode == "pin1_dq_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dm_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_clk_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "sel_core" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_rb_sel_ac_hmc_ena = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_1_mode == "pin1_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_ac_dqs_dm_dq = 
    (db_pin_1_mode == "pin1_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_1_mode == "pin1_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_ac_hmc")? "ac_type" : 
    (db_pin_1_mode == "pin1_dq_wdb_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dm_wdb_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dbi_wdb_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_clk_wdb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_ac_core")? "ac_type" : 
    (db_pin_1_mode == "pin1_dq_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dm_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_dbi_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_clk_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_clkb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_1_mode == "pin1_rdq_mode")? "dq_type" : 
    (db_pin_1_mode == "pin1_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_1_mode == "pin1_gpio_mode")

localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_db_out_bypass = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_ac_core")? "db_out_bypass" : 
    (db_pin_2_mode == "pin2_dq_mode")? "db_out_bypass" : 
    (db_pin_2_mode == "pin2_dm_mode")? "db_out_bypass" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_clk_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "db_out_bypass" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_rb_sel_ac_hmc_ena = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_2 = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "pin2_ac_type" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "pin2_dq_type" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "pin2_dq_type" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "pin2_dq_type" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "pin2_ac_type" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "pin2_dq_type" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "pin2_dq_type" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "pin2_dq_type" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_ac_core")? "pin2_ac_type" : 
    (db_pin_2_mode == "pin2_dq_mode")? "pin2_dq_type" : 
    (db_pin_2_mode == "pin2_dm_mode")? "pin2_dq_type" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "pin2_dq_type" : 
    (db_pin_2_mode == "pin2_clk_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "pin2_dqs_type" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "pin2_dq_type" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "pin2_dqs_type" : 
    "pin2_ac_type"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_dbc_sel = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_ac_core")? "sel_core" : 
    (db_pin_2_mode == "pin2_dq_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dm_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_clk_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_2__a_ac_dqs_dm_dq = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "ac_type" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_ac_core")? "ac_type" : 
    (db_pin_2_mode == "pin2_dq_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dm_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_clk_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_rb_gpio = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_ac_core")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dq_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dm_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_clk_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "gpio_false" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_2__a_wdb_bypass = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_2_mode == "pin2_ac_core")? "wdb_bypass" : 
    (db_pin_2_mode == "pin2_dq_mode")? "wdb_bypass" : 
    (db_pin_2_mode == "pin2_dm_mode")? "wdb_bypass" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "wdb_bypass" : 
    (db_pin_2_mode == "pin2_clk_mode")? "wdb_bypass" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "wdb_bypass" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "wdb_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "wdb_bypass" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "wdb_bypass" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_wr_datapath_prgmnvrt = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_2_mode == "pin2_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dm_mode")? "wr_datapath_invert" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_clk_mode")? "wr_datapath_invert" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_oe_datapath_prgmnvrt = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_ac_core")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dq_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dm_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_clk_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_2__a_db_in_bypass = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_ac_core")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dq_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dm_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_clk_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_ac_dqs_dm_dq = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "ac_type" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_ac_core")? "ac_type" : 
    (db_pin_2_mode == "pin2_dq_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dm_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_clk_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "dq_type" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_db_oe_bypass = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_ac_core")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_dq_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_dm_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_clk_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "db_oe_bypass" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_2_mode == "pin2_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_2__a_dbc_sel = 
    (db_pin_2_mode == "pin2_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_ac_hmc")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_2_mode == "pin2_ac_core")? "sel_core" : 
    (db_pin_2_mode == "pin2_dq_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dm_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dbi_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_clk_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_clkb_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dqs_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dqsb_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_rdq_mode")? "sel_core" : 
    (db_pin_2_mode == "pin2_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_2_mode == "pin2_gpio_mode")

localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_db_oe_bypass = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_ac_core")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_dq_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_dm_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_clk_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "db_oe_bypass" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_rb_gpio = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_ac_core")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dq_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dm_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_clk_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "gpio_false" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_3 = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "pin3_ac_type" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "pin3_dq_type" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "pin3_dq_type" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "pin3_dq_type" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "pin3_ac_type" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "pin3_dq_type" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "pin3_dq_type" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "pin3_dq_type" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_ac_core")? "pin3_ac_type" : 
    (db_pin_3_mode == "pin3_dq_mode")? "pin3_dq_type" : 
    (db_pin_3_mode == "pin3_dm_mode")? "pin3_dq_type" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "pin3_dq_type" : 
    (db_pin_3_mode == "pin3_clk_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "pin3_dqs_type" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "pin3_dq_type" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "pin3_dqs_type" : 
    "pin3_ac_type"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_3__a_ac_dqs_dm_dq = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "ac_type" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_ac_core")? "ac_type" : 
    (db_pin_3_mode == "pin3_dq_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dm_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_clk_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_3__a_db_in_bypass = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_ac_core")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dq_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dm_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_clk_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_db_out_bypass = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_ac_core")? "db_out_bypass" : 
    (db_pin_3_mode == "pin3_dq_mode")? "db_out_bypass" : 
    (db_pin_3_mode == "pin3_dm_mode")? "db_out_bypass" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_clk_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "db_out_bypass" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_dbc_sel = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_ac_core")? "sel_core" : 
    (db_pin_3_mode == "pin3_dq_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dm_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_clk_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_oe_datapath_prgmnvrt = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_ac_core")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dq_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dm_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_clk_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_rb_sel_ac_hmc_ena = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_3__a_dbc_sel = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_3_mode == "pin3_ac_core")? "sel_core" : 
    (db_pin_3_mode == "pin3_dq_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dm_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_clk_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "sel_core" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_ac_dqs_dm_dq = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "ac_type" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_ac_core")? "ac_type" : 
    (db_pin_3_mode == "pin3_dq_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dm_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_clk_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "dq_type" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_wr_datapath_prgmnvrt = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_3_mode == "pin3_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dm_mode")? "wr_datapath_invert" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_clk_mode")? "wr_datapath_invert" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_3_mode == "pin3_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_3__a_wdb_bypass = 
    (db_pin_3_mode == "pin3_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_3_mode == "pin3_ac_core")? "wdb_bypass" : 
    (db_pin_3_mode == "pin3_dq_mode")? "wdb_bypass" : 
    (db_pin_3_mode == "pin3_dm_mode")? "wdb_bypass" : 
    (db_pin_3_mode == "pin3_dbi_mode")? "wdb_bypass" : 
    (db_pin_3_mode == "pin3_clk_mode")? "wdb_bypass" : 
    (db_pin_3_mode == "pin3_clkb_mode")? "wdb_bypass" : 
    (db_pin_3_mode == "pin3_dqs_mode")? "wdb_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_mode")? "wdb_bypass" : 
    (db_pin_3_mode == "pin3_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_3_mode == "pin3_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_3_mode == "pin3_rdq_mode")? "wdb_bypass" : 
    (db_pin_3_mode == "pin3_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_3_mode == "pin3_gpio_mode")

localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_rb_gpio = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_ac_core")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dq_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dm_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_clk_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "gpio_false" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_4 = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "pin4_ac_type" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "pin4_dq_type" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "pin4_dq_type" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "pin4_dq_type" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "pin4_ac_type" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "pin4_dq_type" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "pin4_dq_type" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "pin4_dq_type" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_ac_core")? "pin4_ac_type" : 
    (db_pin_4_mode == "pin4_dq_mode")? "pin4_dq_type" : 
    (db_pin_4_mode == "pin4_dm_mode")? "pin4_dq_type" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "pin4_dq_type" : 
    (db_pin_4_mode == "pin4_clk_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "pin4_dqs_type" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "pin4_dq_type" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "pin4_dqs_type" : 
    "pin4_ac_type"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_rb_sel_ac_hmc_ena = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_4__a_dbc_sel = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_ac_core")? "sel_core" : 
    (db_pin_4_mode == "pin4_dq_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dm_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_clk_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_db_out_bypass = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_ac_core")? "db_out_bypass" : 
    (db_pin_4_mode == "pin4_dq_mode")? "db_out_bypass" : 
    (db_pin_4_mode == "pin4_dm_mode")? "db_out_bypass" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_clk_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "db_out_bypass" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_4__a_wdb_bypass = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_4_mode == "pin4_ac_core")? "wdb_bypass" : 
    (db_pin_4_mode == "pin4_dq_mode")? "wdb_bypass" : 
    (db_pin_4_mode == "pin4_dm_mode")? "wdb_bypass" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "wdb_bypass" : 
    (db_pin_4_mode == "pin4_clk_mode")? "wdb_bypass" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "wdb_bypass" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "wdb_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "wdb_bypass" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "wdb_bypass" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_4__a_ac_dqs_dm_dq = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "ac_type" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_ac_core")? "ac_type" : 
    (db_pin_4_mode == "pin4_dq_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dm_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_clk_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_4__a_db_in_bypass = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_ac_core")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dq_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dm_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_clk_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_oe_datapath_prgmnvrt = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_ac_core")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dq_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dm_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_clk_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_ac_dqs_dm_dq = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "ac_type" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_ac_core")? "ac_type" : 
    (db_pin_4_mode == "pin4_dq_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dm_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_clk_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "dq_type" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_wr_datapath_prgmnvrt = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_4_mode == "pin4_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dm_mode")? "wr_datapath_invert" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_clk_mode")? "wr_datapath_invert" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_db_oe_bypass = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_ac_core")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_dq_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_dm_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_clk_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "db_oe_bypass" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_4_mode == "pin4_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_dbc_sel = 
    (db_pin_4_mode == "pin4_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_ac_hmc")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_4_mode == "pin4_ac_core")? "sel_core" : 
    (db_pin_4_mode == "pin4_dq_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dm_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dbi_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_clk_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_clkb_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dqs_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dqsb_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_rdq_mode")? "sel_core" : 
    (db_pin_4_mode == "pin4_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_4_mode == "pin4_gpio_mode")

localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_wr_datapath_prgmnvrt = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_5_mode == "pin5_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dm_mode")? "wr_datapath_invert" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_clk_mode")? "wr_datapath_invert" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_dbc_sel = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_ac_core")? "sel_core" : 
    (db_pin_5_mode == "pin5_dq_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dm_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_clk_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_5 = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "pin5_ac_type" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "pin5_dq_type" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "pin5_dq_type" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "pin5_dq_type" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "pin5_ac_type" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "pin5_dq_type" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "pin5_dq_type" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "pin5_dq_type" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_ac_core")? "pin5_ac_type" : 
    (db_pin_5_mode == "pin5_dq_mode")? "pin5_dq_type" : 
    (db_pin_5_mode == "pin5_dm_mode")? "pin5_dq_type" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "pin5_dq_type" : 
    (db_pin_5_mode == "pin5_clk_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "pin5_dqs_type" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "pin5_dq_type" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "pin5_dqs_type" : 
    "pin5_ac_type"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_5__a_wdb_bypass = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_5_mode == "pin5_ac_core")? "wdb_bypass" : 
    (db_pin_5_mode == "pin5_dq_mode")? "wdb_bypass" : 
    (db_pin_5_mode == "pin5_dm_mode")? "wdb_bypass" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "wdb_bypass" : 
    (db_pin_5_mode == "pin5_clk_mode")? "wdb_bypass" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "wdb_bypass" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "wdb_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "wdb_bypass" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "wdb_bypass" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_5__a_db_in_bypass = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_ac_core")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dq_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dm_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_clk_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_5__a_dbc_sel = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_5_mode == "pin5_ac_core")? "sel_core" : 
    (db_pin_5_mode == "pin5_dq_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dm_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_clk_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "sel_core" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_ac_dqs_dm_dq = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "ac_type" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_ac_core")? "ac_type" : 
    (db_pin_5_mode == "pin5_dq_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dm_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_clk_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_oe_datapath_prgmnvrt = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_ac_core")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dq_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dm_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_clk_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_5__a_ac_dqs_dm_dq = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "ac_type" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_ac_core")? "ac_type" : 
    (db_pin_5_mode == "pin5_dq_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dm_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_clk_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "dq_type" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_db_oe_bypass = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_ac_core")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_dq_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_dm_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_clk_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "db_oe_bypass" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_rb_gpio = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_ac_core")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dq_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dm_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_clk_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "gpio_false" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_db_out_bypass = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_ac_core")? "db_out_bypass" : 
    (db_pin_5_mode == "pin5_dq_mode")? "db_out_bypass" : 
    (db_pin_5_mode == "pin5_dm_mode")? "db_out_bypass" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_clk_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "db_out_bypass" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_5_mode == "pin5_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_rb_sel_ac_hmc_ena = 
    (db_pin_5_mode == "pin5_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_5_mode == "pin5_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_5_mode == "pin5_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_5_mode == "pin5_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_5_mode == "pin5_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_5_mode == "pin5_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_5_mode == "pin5_gpio_mode")

localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_dbc_sel = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_ac_core")? "sel_core" : 
    (db_pin_6_mode == "pin6_dq_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dm_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_clk_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_6 = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "pin6_ac_type" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "pin6_dq_type" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "pin6_dq_type" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "pin6_dq_type" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "pin6_ac_type" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "pin6_dq_type" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "pin6_dq_type" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "pin6_dq_type" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_ac_core")? "pin6_ac_type" : 
    (db_pin_6_mode == "pin6_dq_mode")? "pin6_dq_type" : 
    (db_pin_6_mode == "pin6_dm_mode")? "pin6_dq_type" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "pin6_dq_type" : 
    (db_pin_6_mode == "pin6_clk_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "pin6_dqs_type" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "pin6_dq_type" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "pin6_dqs_type" : 
    "pin6_ac_type"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_6__a_wdb_bypass = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_6_mode == "pin6_ac_core")? "wdb_bypass" : 
    (db_pin_6_mode == "pin6_dq_mode")? "wdb_bypass" : 
    (db_pin_6_mode == "pin6_dm_mode")? "wdb_bypass" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "wdb_bypass" : 
    (db_pin_6_mode == "pin6_clk_mode")? "wdb_bypass" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "wdb_bypass" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "wdb_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "wdb_bypass" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "wdb_bypass" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_ac_dqs_dm_dq = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "ac_type" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_ac_core")? "ac_type" : 
    (db_pin_6_mode == "pin6_dq_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dm_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_clk_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_6__a_ac_dqs_dm_dq = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "ac_type" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_ac_core")? "ac_type" : 
    (db_pin_6_mode == "pin6_dq_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dm_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_clk_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "dq_type" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_6__a_dbc_sel = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_6_mode == "pin6_ac_core")? "sel_core" : 
    (db_pin_6_mode == "pin6_dq_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dm_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_clk_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "sel_core" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_oe_datapath_prgmnvrt = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_ac_core")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dq_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dm_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_clk_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_rb_sel_ac_hmc_ena = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_6__a_db_in_bypass = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_ac_core")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dq_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dm_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_clk_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_wr_datapath_prgmnvrt = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_6_mode == "pin6_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dm_mode")? "wr_datapath_invert" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_clk_mode")? "wr_datapath_invert" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_db_oe_bypass = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_ac_core")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_dq_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_dm_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_clk_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "db_oe_bypass" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_db_out_bypass = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_ac_core")? "db_out_bypass" : 
    (db_pin_6_mode == "pin6_dq_mode")? "db_out_bypass" : 
    (db_pin_6_mode == "pin6_dm_mode")? "db_out_bypass" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_clk_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "db_out_bypass" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_6_mode == "pin6_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_rb_gpio = 
    (db_pin_6_mode == "pin6_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_ac_hmc")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dq_wdb_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dm_wdb_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_clk_wdb_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_ac_core")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dq_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dm_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dbi_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_clk_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_clkb_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dqs_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dqsb_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_rdq_mode")? "gpio_false" : 
    (db_pin_6_mode == "pin6_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_6_mode == "pin6_gpio_mode")

localparam data_buffer__rdwr_buffer_inst_7__a_ac_dqs_dm_dq = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "ac_type" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_ac_core")? "ac_type" : 
    (db_pin_7_mode == "pin7_dq_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dm_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_clk_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_ac_dqs_dm_dq = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "ac_type" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_ac_core")? "ac_type" : 
    (db_pin_7_mode == "pin7_dq_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dm_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_clk_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "dq_type" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_rb_sel_ac_hmc_ena = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_dbc_sel = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_ac_core")? "sel_core" : 
    (db_pin_7_mode == "pin7_dq_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dm_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_clk_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_db_oe_bypass = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_ac_core")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_dq_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_dm_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_clk_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "db_oe_bypass" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_oe_datapath_prgmnvrt = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_ac_core")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dq_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dm_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_clk_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_7 = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "pin7_ac_type" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "pin7_dq_type" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "pin7_dq_type" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "pin7_dq_type" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "pin7_ac_type" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "pin7_dq_type" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "pin7_dq_type" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "pin7_dq_type" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_ac_core")? "pin7_ac_type" : 
    (db_pin_7_mode == "pin7_dq_mode")? "pin7_dq_type" : 
    (db_pin_7_mode == "pin7_dm_mode")? "pin7_dq_type" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "pin7_dq_type" : 
    (db_pin_7_mode == "pin7_clk_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "pin7_dqs_type" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "pin7_dq_type" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "pin7_dqs_type" : 
    "pin7_ac_type"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_wr_datapath_prgmnvrt = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_7_mode == "pin7_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dm_mode")? "wr_datapath_invert" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_clk_mode")? "wr_datapath_invert" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_db_out_bypass = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_ac_core")? "db_out_bypass" : 
    (db_pin_7_mode == "pin7_dq_mode")? "db_out_bypass" : 
    (db_pin_7_mode == "pin7_dm_mode")? "db_out_bypass" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_clk_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "db_out_bypass" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_7__a_wdb_bypass = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_7_mode == "pin7_ac_core")? "wdb_bypass" : 
    (db_pin_7_mode == "pin7_dq_mode")? "wdb_bypass" : 
    (db_pin_7_mode == "pin7_dm_mode")? "wdb_bypass" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "wdb_bypass" : 
    (db_pin_7_mode == "pin7_clk_mode")? "wdb_bypass" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "wdb_bypass" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "wdb_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "wdb_bypass" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "wdb_bypass" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_rb_gpio = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_ac_core")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dq_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dm_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_clk_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "gpio_false" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_7__a_db_in_bypass = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_ac_core")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dq_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dm_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_clk_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_7_mode == "pin7_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_7__a_dbc_sel = 
    (db_pin_7_mode == "pin7_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_ac_hmc")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_7_mode == "pin7_ac_core")? "sel_core" : 
    (db_pin_7_mode == "pin7_dq_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dm_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dbi_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_clk_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_clkb_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dqs_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dqsb_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_rdq_mode")? "sel_core" : 
    (db_pin_7_mode == "pin7_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_7_mode == "pin7_gpio_mode")

localparam data_buffer__rdwr_buffer_inst_8__a_wdb_bypass = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_8_mode == "pin8_ac_core")? "wdb_bypass" : 
    (db_pin_8_mode == "pin8_dq_mode")? "wdb_bypass" : 
    (db_pin_8_mode == "pin8_dm_mode")? "wdb_bypass" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "wdb_bypass" : 
    (db_pin_8_mode == "pin8_clk_mode")? "wdb_bypass" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "wdb_bypass" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "wdb_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "wdb_bypass" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "wdb_bypass" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_db_oe_bypass = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_ac_core")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_dq_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_dm_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_clk_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "db_oe_bypass" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_8__a_dbc_sel = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_ac_core")? "sel_core" : 
    (db_pin_8_mode == "pin8_dq_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dm_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_clk_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_oe_datapath_prgmnvrt = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_ac_core")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dq_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dm_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_clk_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_8 = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "pin8_ac_type" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "pin8_dq_type" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "pin8_dq_type" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "pin8_dq_type" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "pin8_ac_type" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "pin8_dq_type" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "pin8_dq_type" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "pin8_dq_type" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_ac_core")? "pin8_ac_type" : 
    (db_pin_8_mode == "pin8_dq_mode")? "pin8_dq_type" : 
    (db_pin_8_mode == "pin8_dm_mode")? "pin8_dq_type" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "pin8_dq_type" : 
    (db_pin_8_mode == "pin8_clk_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "pin8_dqs_type" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "pin8_dq_type" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "pin8_dqs_type" : 
    "pin8_ac_type"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_ac_dqs_dm_dq = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "ac_type" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_ac_core")? "ac_type" : 
    (db_pin_8_mode == "pin8_dq_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dm_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_clk_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_8__a_db_in_bypass = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_ac_core")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dq_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dm_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_clk_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_wr_datapath_prgmnvrt = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_8_mode == "pin8_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dm_mode")? "wr_datapath_invert" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_clk_mode")? "wr_datapath_invert" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_rb_sel_ac_hmc_ena = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_8__a_ac_dqs_dm_dq = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "ac_type" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_ac_core")? "ac_type" : 
    (db_pin_8_mode == "pin8_dq_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dm_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_clk_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "dq_type" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_rb_gpio = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_ac_core")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dq_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dm_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_clk_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "gpio_false" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_db_out_bypass = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_ac_core")? "db_out_bypass" : 
    (db_pin_8_mode == "pin8_dq_mode")? "db_out_bypass" : 
    (db_pin_8_mode == "pin8_dm_mode")? "db_out_bypass" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_clk_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "db_out_bypass" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_8_mode == "pin8_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_dbc_sel = 
    (db_pin_8_mode == "pin8_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_ac_hmc")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_8_mode == "pin8_ac_core")? "sel_core" : 
    (db_pin_8_mode == "pin8_dq_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dm_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dbi_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_clk_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_clkb_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dqs_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dqsb_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_rdq_mode")? "sel_core" : 
    (db_pin_8_mode == "pin8_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_8_mode == "pin8_gpio_mode")

localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_rb_gpio = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_ac_core")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dq_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dm_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_clk_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "gpio_false" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_wr_datapath_prgmnvrt = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_9_mode == "pin9_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dm_mode")? "wr_datapath_invert" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_clk_mode")? "wr_datapath_invert" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_9__a_wdb_bypass = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_9_mode == "pin9_ac_core")? "wdb_bypass" : 
    (db_pin_9_mode == "pin9_dq_mode")? "wdb_bypass" : 
    (db_pin_9_mode == "pin9_dm_mode")? "wdb_bypass" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "wdb_bypass" : 
    (db_pin_9_mode == "pin9_clk_mode")? "wdb_bypass" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "wdb_bypass" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "wdb_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "wdb_bypass" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "wdb_bypass" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_9 = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "pin9_ac_type" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "pin9_dq_type" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "pin9_dq_type" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "pin9_dq_type" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "pin9_ac_type" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "pin9_dq_type" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "pin9_dq_type" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "pin9_dq_type" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_ac_core")? "pin9_ac_type" : 
    (db_pin_9_mode == "pin9_dq_mode")? "pin9_dq_type" : 
    (db_pin_9_mode == "pin9_dm_mode")? "pin9_dq_type" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "pin9_dq_type" : 
    (db_pin_9_mode == "pin9_clk_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "pin9_dqs_type" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "pin9_dq_type" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "pin9_dqs_type" : 
    "pin9_ac_type"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_9__a_ac_dqs_dm_dq = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "ac_type" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_ac_core")? "ac_type" : 
    (db_pin_9_mode == "pin9_dq_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dm_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_clk_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_oe_datapath_prgmnvrt = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_ac_core")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dq_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dm_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_clk_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_dbc_sel = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_ac_core")? "sel_core" : 
    (db_pin_9_mode == "pin9_dq_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dm_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_clk_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_rb_sel_ac_hmc_ena = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_ac_dqs_dm_dq = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "ac_type" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_ac_core")? "ac_type" : 
    (db_pin_9_mode == "pin9_dq_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dm_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_clk_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "dq_type" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_9__a_db_in_bypass = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_ac_core")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dq_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dm_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_clk_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_db_out_bypass = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_ac_core")? "db_out_bypass" : 
    (db_pin_9_mode == "pin9_dq_mode")? "db_out_bypass" : 
    (db_pin_9_mode == "pin9_dm_mode")? "db_out_bypass" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_clk_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "db_out_bypass" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_9__a_dbc_sel = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_9_mode == "pin9_ac_core")? "sel_core" : 
    (db_pin_9_mode == "pin9_dq_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dm_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_clk_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "sel_core" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_9_mode == "pin9_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_db_oe_bypass = 
    (db_pin_9_mode == "pin9_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_ac_hmc")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_ac_core")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_dq_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_dm_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_clk_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_clkb_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_dqs_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_9_mode == "pin9_rdq_mode")? "db_oe_bypass" : 
    (db_pin_9_mode == "pin9_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_9_mode == "pin9_gpio_mode")

localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_wr_datapath_prgmnvrt = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_10_mode == "pin10_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dm_mode")? "wr_datapath_invert" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_clk_mode")? "wr_datapath_invert" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_ac_dqs_dm_dq = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "ac_type" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_ac_core")? "ac_type" : 
    (db_pin_10_mode == "pin10_dq_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dm_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_clk_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_10 = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "pin10_ac_type" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "pin10_dq_type" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "pin10_dq_type" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "pin10_dq_type" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "pin10_ac_type" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "pin10_dq_type" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "pin10_dq_type" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "pin10_dq_type" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_ac_core")? "pin10_ac_type" : 
    (db_pin_10_mode == "pin10_dq_mode")? "pin10_dq_type" : 
    (db_pin_10_mode == "pin10_dm_mode")? "pin10_dq_type" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "pin10_dq_type" : 
    (db_pin_10_mode == "pin10_clk_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "pin10_dqs_type" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "pin10_dq_type" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "pin10_dqs_type" : 
    "pin10_ac_type"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_db_oe_bypass = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_ac_core")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_dq_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_dm_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_clk_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "db_oe_bypass" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_10__a_db_in_bypass = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_ac_core")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dq_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dm_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_clk_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_10__a_wdb_bypass = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_10_mode == "pin10_ac_core")? "wdb_bypass" : 
    (db_pin_10_mode == "pin10_dq_mode")? "wdb_bypass" : 
    (db_pin_10_mode == "pin10_dm_mode")? "wdb_bypass" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "wdb_bypass" : 
    (db_pin_10_mode == "pin10_clk_mode")? "wdb_bypass" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "wdb_bypass" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "wdb_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "wdb_bypass" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "wdb_bypass" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_rb_sel_ac_hmc_ena = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_oe_datapath_prgmnvrt = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_ac_core")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dq_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dm_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_clk_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_rb_gpio = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_ac_core")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dq_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dm_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_clk_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "gpio_false" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_10__a_ac_dqs_dm_dq = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "ac_type" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_ac_core")? "ac_type" : 
    (db_pin_10_mode == "pin10_dq_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dm_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_clk_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "dq_type" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_db_out_bypass = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_ac_core")? "db_out_bypass" : 
    (db_pin_10_mode == "pin10_dq_mode")? "db_out_bypass" : 
    (db_pin_10_mode == "pin10_dm_mode")? "db_out_bypass" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_clk_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "db_out_bypass" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_dbc_sel = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_ac_core")? "sel_core" : 
    (db_pin_10_mode == "pin10_dq_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dm_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_clk_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_10_mode == "pin10_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_10__a_dbc_sel = 
    (db_pin_10_mode == "pin10_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_ac_hmc")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_10_mode == "pin10_ac_core")? "sel_core" : 
    (db_pin_10_mode == "pin10_dq_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dm_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dbi_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_clk_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_clkb_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dqs_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dqsb_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_rdq_mode")? "sel_core" : 
    (db_pin_10_mode == "pin10_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_10_mode == "pin10_gpio_mode")

localparam data_buffer__rdwr_buffer_inst_11__a_ac_dqs_dm_dq = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "ac_type" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_ac_core")? "ac_type" : 
    (db_pin_11_mode == "pin11_dq_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dm_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_clk_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_11 = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "pin11_ac_type" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "pin11_dq_type" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "pin11_dq_type" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "pin11_dq_type" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "pin11_ac_type" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "pin11_dq_type" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "pin11_dq_type" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "pin11_dq_type" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_ac_core")? "pin11_ac_type" : 
    (db_pin_11_mode == "pin11_dq_mode")? "pin11_dq_type" : 
    (db_pin_11_mode == "pin11_dm_mode")? "pin11_dq_type" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "pin11_dq_type" : 
    (db_pin_11_mode == "pin11_clk_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "pin11_dqs_type" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "pin11_dq_type" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "pin11_dqs_type" : 
    "pin11_ac_type"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_rb_sel_ac_hmc_ena = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "sel_ac_hmc_ena" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "sel_ac_hmc_ena" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_ac_core")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dm_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_clk_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "sel_ac_hmc_disable" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "sel_ac_hmc_disable" : 
    "sel_ac_hmc_disable"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_db_oe_bypass = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_ac_core")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_dq_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_dm_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_clk_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "db_oe_not_bypass" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "db_oe_bypass" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "db_oe_bypass" : 
    "db_oe_bypass"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_ac_dqs_dm_dq = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "ac_type" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "ac_type" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_ac_core")? "ac_type" : 
    (db_pin_11_mode == "pin11_dq_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dm_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_clk_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "dqs_type" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "dq_type" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "dqs_type" : 
    "ac_type"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_dbc_sel = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_ac_core")? "sel_core" : 
    (db_pin_11_mode == "pin11_dq_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dm_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_clk_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_oe_datapath_prgmnvrt = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_ac_core")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dq_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dm_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_clk_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "oe_datapath_invert" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "oe_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "oe_datapath_non_invert" : 
    "oe_datapath_non_invert"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_wr_datapath_prgmnvrt = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "wr_datapath_invert" : 
    (db_pin_11_mode == "pin11_ac_core")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dq_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dm_mode")? "wr_datapath_invert" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_clk_mode")? "wr_datapath_invert" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "wr_datapath_invert" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "wr_datapath_invert" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "wr_datapath_non_invert" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "wr_datapath_non_invert" : 
    "wr_datapath_non_invert"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_rb_gpio = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_ac_core")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dq_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dm_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_clk_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "gpio_false" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "gpio_false" : 
    "gpio_true"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_11__a_dbc_sel = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "sel_dbc" : 
    (db_pin_11_mode == "pin11_ac_core")? "sel_core" : 
    (db_pin_11_mode == "pin11_dq_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dm_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_clk_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "sel_core" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "sel_core" : 
    "sel_core"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_db_out_bypass = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_ac_core")? "db_out_bypass" : 
    (db_pin_11_mode == "pin11_dq_mode")? "db_out_bypass" : 
    (db_pin_11_mode == "pin11_dm_mode")? "db_out_bypass" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_clk_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "db_out_not_bypass" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "db_out_bypass" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "db_out_not_bypass" : 
    "db_out_bypass"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__io_data_buffer_data2core_inst_11__a_db_in_bypass = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_ac_core")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dq_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dm_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_clk_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "db_in_not_bypass" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "db_in_not_bypass" : 
    "db_in_bypass"; //(db_pin_11_mode == "pin11_gpio_mode")
localparam data_buffer__rdwr_buffer_inst_11__a_wdb_bypass = 
    (db_pin_11_mode == "pin11_ac_ddr4_hmc")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_dq_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_dm_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_dbi_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_clk_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_clkb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_dqs_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_ddr4_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_ac_hmc")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_dq_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_dm_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_dbi_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_clk_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_clkb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_dqs_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_wdb_mode")? "wdb_not_bypass" : 
    (db_pin_11_mode == "pin11_ac_core")? "wdb_bypass" : 
    (db_pin_11_mode == "pin11_dq_mode")? "wdb_bypass" : 
    (db_pin_11_mode == "pin11_dm_mode")? "wdb_bypass" : 
    (db_pin_11_mode == "pin11_dbi_mode")? "wdb_bypass" : 
    (db_pin_11_mode == "pin11_clk_mode")? "wdb_bypass" : 
    (db_pin_11_mode == "pin11_clkb_mode")? "wdb_bypass" : 
    (db_pin_11_mode == "pin11_dqs_mode")? "wdb_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_mode")? "wdb_bypass" : 
    (db_pin_11_mode == "pin11_dqs_ddr4_mode")? "wdb_bypass" : 
    (db_pin_11_mode == "pin11_dqsb_ddr4_mode")? "wdb_bypass" : 
    (db_pin_11_mode == "pin11_rdq_mode")? "wdb_bypass" : 
    (db_pin_11_mode == "pin11_rdqs_mode")? "wdb_bypass" : 
    "wdb_bypass"; //(db_pin_11_mode == "pin11_gpio_mode")

localparam xio_dll_top__xio_dll_pnr__a_rb_dll_rst_en = 
    (dll_rst_en == "dll_rst_dis")? "dll_rst_dis" : 
    "dll_rst_en"; //(dll_rst_en == "dll_rst_en")

localparam xio_dll_top__xio_dll_pnr__a_rb_dll_en = 
    (dll_en == "dll_dis")? "dll_dis" : 
    "dll_en"; //(dll_en == "dll_en")

localparam xio_dll_top__xio_dll_pnr__a_rb_core_updnen = 
    (dll_core_updnen == "core_updn_dis")? "core_updn_dis" : 
    "core_updn_en"; //(dll_core_updnen == "core_updn_en")

localparam xio_dll_top__xio_dll_pnr__a_rb_ctlsel = 
    (dll_ctlsel == "ctl_dynamic")? "ctl_dynamic" : 
    "ctl_static"; //(dll_ctlsel == "ctl_static")

localparam xio_dll_top__xio_dll_pnr__a_rb_hps_ctrl_en = 
    (hps_ctrl_en == "true")? "hps_ctrl_dis" : 
    "hps_ctrl_en"; //(hps_ctrl_en == "false")

localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_enable_toggler = 
    (dqs_lgc_enable_toggler == "preamble_track_dqs_enable")? "preamble_track_dqs_enable" : 
    "preamble_track_toggler"; //(dqs_lgc_enable_toggler == "preamble_track_toggler")

localparam xio_dqs_lgc_top__pstamble_reg_b__a_dqs_select = 
    (dqs_lgc_dqs_b_interp_en == "dqsb_sstl_p_0")? "dqs_sstl_p_0" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_sstl_p_1")? "dqs_sstl_p_1" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_sstl_p_2")? "dqs_sstl_p_2" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_sstl_p_3")? "dqs_sstl_p_3" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_sstl_n_0")? "dqs_sstl_n_0" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_sstl_n_1")? "dqs_sstl_n_1" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_sstl_n_2")? "dqs_sstl_n_2" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_sstl_n_3")? "dqs_sstl_n_3" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_diff_in_0")? "dqs_diff_in_0" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_diff_in_1")? "dqs_diff_in_1" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_diff_in_2")? "dqs_diff_in_2" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_diff_in_3")? "dqs_diff_in_3" : 
    (dqs_lgc_dqs_b_interp_en == "dqsb_interpolator")? "dqs_interpolator" : 
    "dqs_constant"; //(dqs_lgc_dqs_b_interp_en == "dqsb_constant")

localparam xio_dqs_lgc_top__pstamble_reg_a__a_dqs_select = 
    (dqs_lgc_dqs_a_interp_en == "dqsa_sstl_p_0")? "dqs_sstl_p_0" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_sstl_p_1")? "dqs_sstl_p_1" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_sstl_p_2")? "dqs_sstl_p_2" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_sstl_p_3")? "dqs_sstl_p_3" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_sstl_n_0")? "dqs_sstl_n_0" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_sstl_n_1")? "dqs_sstl_n_1" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_sstl_n_2")? "dqs_sstl_n_2" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_sstl_n_3")? "dqs_sstl_n_3" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_diff_in_0")? "dqs_diff_in_0" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_diff_in_1")? "dqs_diff_in_1" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_diff_in_2")? "dqs_diff_in_2" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_diff_in_3")? "dqs_diff_in_3" : 
    (dqs_lgc_dqs_a_interp_en == "dqsa_interpolator")? "dqs_interpolator" : 
    "dqs_constant"; //(dqs_lgc_dqs_a_interp_en == "dqsa_constant")

localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_pack_mode = 
    (dqs_lgc_pack_mode == "packed")? "packed" : 
    "not_packed"; //(dqs_lgc_pack_mode == "not_packed")

localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_pst_preamble_mode = 
    (dqs_lgc_pst_preamble_mode == "ddr3_preamble")? "ddr3_preamble" : 
    "ddr4_preamble"; //(dqs_lgc_pst_preamble_mode == "ddr4_preamble")

localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_pst_en_shrink = 
    (dqs_lgc_pst_en_shrink == "shrink_0_0")? "shrink_0_0" : 
    (dqs_lgc_pst_en_shrink == "shrink_0_1")? "shrink_0_1" : 
    (dqs_lgc_pst_en_shrink == "shrink_1_0")? "shrink_1_0" : 
    "shrink_1_1"; //(dqs_lgc_pst_en_shrink == "shrink_1_1")

localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_vfifo_burst_length = 
    (vfifo_burst_length == "vburst_length_2")? "vburst_length_2" : 
    (vfifo_burst_length == "vburst_length_4")? "vburst_length_4" : 
    "vburst_length_8"; //(vfifo_burst_length == "vburst_length_8")

localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_broadcast_enable = 
    (dqs_lgc_broadcast_enable == "disable_broadcast")? "disable_broadcast" : 
    (dqs_lgc_broadcast_enable == "generate_broadcast")? "generate_broadcast" : 
    (dqs_lgc_broadcast_enable == "top_in_broadcast")? "top_in_broadcast" : 
    "bottom_in_broadcast"; //(dqs_lgc_broadcast_enable == "bottom_in_broadcast")

localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_burst_length = 
    (dqs_lgc_burst_length == "burst_length_10")? "burst_length_10" : 
    (dqs_lgc_burst_length == "burst_length_8")? "burst_length_8" : 
    (dqs_lgc_burst_length == "burst_length_4")? "burst_length_4" : 
    "burst_length_2"; //(dqs_lgc_burst_length == "burst_length_2")

localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_ddr4_search = 
    (dqs_lgc_ddr4_search == "ddr3_search")? "ddr3_search" : 
    "ddr4_search"; //(dqs_lgc_ddr4_search == "ddr4_search")


localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase = pin_0_output_phase;
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase = pin_1_output_phase;
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase = pin_2_output_phase;
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase = pin_3_output_phase;
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase = pin_4_output_phase;
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase = pin_5_output_phase;
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase = pin_6_output_phase;
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase = pin_7_output_phase;
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase = pin_8_output_phase;
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase = pin_9_output_phase;
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase = pin_10_output_phase;
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase = pin_11_output_phase;
localparam [12:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b = dqs_lgc_phase_shift_b;
localparam [12:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a = dqs_lgc_phase_shift_a;
localparam [3:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_oct_size = oct_size;
localparam [5:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_enable_delay = dqs_enable_delay;
localparam [8:0] data_buffer__avl_lane_inst__a_rb_tile_id = avl_base_addr;

parameter silicon_rev = "fourteennm5"; 
parameter pingpong_primary = "false"; 
parameter pingpong_secondary = "false"; 
parameter memory_protocol = "protocol_ddr3"; 
localparam ioserdesdpa_0__mode = "off_mode"; 
localparam ioserdesdpa_0__powermode_ac = "rx_dyn_fifo_j3"; 
localparam ioserdesdpa_0__powermode_dc = "powerup"; 
localparam ioserdesdpa_0__loopback_mode = "non_loopback"; 
localparam ioserdesdpa_0__dpa_top__dpa_cdr_en = "dpa_cdr_disabled"; 
localparam ioserdesdpa_0__dpa_top__dpa_loopback2_en = "dpa_loopback2_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_fifolock_en = "dpa_fifolock_enabled";
localparam ioserdesdpa_0__dpa_top__dpa_pd_edge_sel = "dpa_pd_edge_sel_both";
localparam ioserdesdpa_0__dpa_top__dpa_test_1_src = "dpa_test_1_src_data";
localparam ioserdesdpa_0__dpa_top__dpa_dpa_lose_locken = "dpa_dpa_nrm";
localparam ioserdesdpa_0__dpa_top__dpa_rx_dly = "dpa_rx_dly_0ps";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt9_en = "dpa_rienopt9_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt10_en = "dpa_rienopt10_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt11_en = "dpa_rienopt11_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt0_en = "dpa_dz_data_enabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt1_en = "dpa_dz_slow_enabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt2_en = "dpa_rienopt2_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt3_en = "dpa_rienopt3_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt4_en = "dpa_rienopt4_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt5_en = "dpa_rienopt5_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt6_en = "dpa_rienopt6_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt7_en = "dpa_rienopt7_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt8_en = "dpa_rienopt8_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rienopt12_en = "dpa_rienopt12_enabled";
localparam ioserdesdpa_0__dpa_top__dpa_rdg_dzdsoff_en = "dpa_dz_pd_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rdg_dzden_en = "dpa_dz_enabled";
localparam ioserdesdpa_0__dpa_top__dpa_rdpaswitch_rs_en = "dpa_test_eng_opt9_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_rcount64_en = "dpa_rcount64_disabled";
localparam ioserdesdpa_0__dpa_top__dpa_lock_new = "old_lock";
localparam ioserdesdpa_0__dpa_top__mode = "off_mode";
localparam ioserdesdpa_0__dpa_top__dpa_up_ph_enhance = "en_up_ph_enhance";
localparam ioserdesdpa_0__dpa_top__dpa_switch_enhance = "en_switch_enhance";
localparam ioserdesdpa_0__dpa_top__dpa_dft_crnt_clk = "en_dft_crnt_clk";
localparam ioserdesdpa_0__dpa_top__loopback2_in_dir = "lb2_in_left";
localparam ioserdesdpa_0__dpa_top__dpa_rst_ext_enhance = "en_rst_ext_enhance";
localparam ioserdesdpa_0__dpa_top__dz_lock_sync_enhance = "en_dz_lock_sync_enhance";
localparam ioserdesdpa_0__serdes_top__serdestop_function = "off_mode"; 
localparam ioserdesdpa_0__serdes_top__mode = "user_mode"; 
localparam ioserdesdpa_0__serdes_top__loopback2b_l2r_en = "lp2b_l2r_dis";
localparam ioserdesdpa_0__serdes_top__loopback2b_r2l_en = "lp2b_r2l_dis";
localparam ioserdesdpa_0__serdes_top__loopback13_in_dir = "lb13_in_left";
localparam ioserdesdpa_0__serdes_top__clock_source__mode = "off_mode";
localparam ioserdesdpa_0__serdes_top__clock_source__clk_gen__serdes_factor = "factor3";
localparam ioserdesdpa_0__serdes_top__clock_source__clk_gen__clk_factor = "odd_clk";
localparam ioserdesdpa_0__serdes_top__clock_source__clk_gen__lclkdist_en = "lclk_disable"; 
localparam ioserdesdpa_0__serdes_top__clock_source__clk_gen__clock_output = "no_clock"; 
localparam ioserdesdpa_0__serdes_top__clock_source__clk_gen__lloaden = "lloaden_dis"; 
localparam ioserdesdpa_0__serdes_top__clock_source__clk_gen__ldgenfast = "ldgenfast_dis";
localparam ioserdesdpa_0__serdes_top__clock_source__clk_gen__mode = "off_mode"; 
localparam ioserdesdpa_0__serdes_top__clock_source__serdes_clk_mux__fclk_src = "fclk_in0"; 
localparam ioserdesdpa_0__serdes_top__clock_source__serdes_clk_mux__loaden_src = "loaden_in0"; 
localparam ioserdesdpa_0__serdes_top__clock_source__serdes_clk_mux__fclk_enable = "fclk_dis"; 
localparam ioserdesdpa_0__serdes_top__clock_source__serdes_clk_mux__loaden_enable = "loaden_dis"; 
localparam ioserdesdpa_0__serdes_top__clock_source__serdes_clk_mux__mode = "power_down"; 
localparam ioserdesdpa_0__serdes_top__serdes__serdes_function = "ser_txdat";
localparam ioserdesdpa_0__serdes_top__serdes__tx_mux_src = "tx_mux_src_txdat"; 
localparam ioserdesdpa_0__serdes_top__serdes__tx_ph = "tx_ph_pos"; 
localparam ioserdesdpa_0__serdes_top__serdes__dpa_tx_dpaclk_en = "dpa_tx_dpaclk_disabled";
localparam ioserdesdpa_0__serdes_top__serdes__ser_des_configuration = "serializer_enable"; 
localparam ioserdesdpa_0__serdes_top__serdes__serial_out_enable = "serout_enable"; 
localparam ioserdesdpa_0__serdes_top__serdes__parallel_out_enable = "parout_disable"; 
localparam ioserdesdpa_0__serdes_top__serdes__mode = "user_mode"; 
localparam ioserdesdpa_0__serdes_top__serdes__loopback2_setting = "lp2_disable";
localparam ioserdesdpa_0__serdes_top__bslip__bslip_config = "bslip_0";
localparam ioserdesdpa_0__serdes_top__bslip__dpa_enable = "dpa_dis"; 
localparam ioserdesdpa_0__serdes_top__bslip__loopback1_enable = "loopback1_dis";
localparam ioserdesdpa_0__serdes_top__bslip__data_in = "phase_pos"; 
localparam ioserdesdpa_0__serdes_top__bslip__bslip_function = "non_dpa_mode_pos_ph";
localparam ioserdesdpa_0__serdes_top__bslip__bslip_mode = "user_mode"; 
localparam ioserdesdpa_0__testout_mux__test_enable = "test_dis";
localparam ioserdesdpa_0__testout_mux__test_bitslipmax_enable = "test_bs_dis";
localparam ioserdesdpa_0__testout_mux__test_lock_enable = "test_lk_dis";
localparam ioserdesdpa_0__testout_mux__mode = "usermode"; 
localparam ioserdesdpa_0__testout_mux__test_pclk = "test_pclk_dis";
localparam ioserdesdpa_0__rst_ctrl_sync__dpa_dpahold_en = "dpa_dpahold_enabled"; 
localparam ioserdesdpa_0__rst_ctrl_sync__dpa_dparst_en = "dpa_dparst_enabled"; 
localparam ioserdesdpa_0__rst_ctrl_sync__dpa_dpaen = "dpa_dpa_enabled"; 
localparam ioserdesdpa_0__rst_ctrl_sync__mode = "off_mode";
localparam ioserdesdpa_1__mode = "off_mode"; 
localparam ioserdesdpa_1__powermode_ac = "rx_dyn_fifo_j3"; 
localparam ioserdesdpa_1__powermode_dc = "powerup"; 
localparam ioserdesdpa_1__loopback_mode = "non_loopback"; 
localparam ioserdesdpa_1__dpa_top__dpa_cdr_en = "dpa_cdr_disabled"; 
localparam ioserdesdpa_1__dpa_top__dpa_loopback2_en = "dpa_loopback2_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_fifolock_en = "dpa_fifolock_enabled";
localparam ioserdesdpa_1__dpa_top__dpa_pd_edge_sel = "dpa_pd_edge_sel_both";
localparam ioserdesdpa_1__dpa_top__dpa_test_1_src = "dpa_test_1_src_data";
localparam ioserdesdpa_1__dpa_top__dpa_dpa_lose_locken = "dpa_dpa_nrm";
localparam ioserdesdpa_1__dpa_top__dpa_rx_dly = "dpa_rx_dly_0ps";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt9_en = "dpa_rienopt9_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt10_en = "dpa_rienopt10_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt11_en = "dpa_rienopt11_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt0_en = "dpa_dz_data_enabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt1_en = "dpa_dz_slow_enabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt2_en = "dpa_rienopt2_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt3_en = "dpa_rienopt3_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt4_en = "dpa_rienopt4_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt5_en = "dpa_rienopt5_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt6_en = "dpa_rienopt6_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt7_en = "dpa_rienopt7_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt8_en = "dpa_rienopt8_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rienopt12_en = "dpa_rienopt12_enabled";
localparam ioserdesdpa_1__dpa_top__dpa_rdg_dzdsoff_en = "dpa_dz_pd_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rdg_dzden_en = "dpa_dz_enabled";
localparam ioserdesdpa_1__dpa_top__dpa_rdpaswitch_rs_en = "dpa_test_eng_opt9_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_rcount64_en = "dpa_rcount64_disabled";
localparam ioserdesdpa_1__dpa_top__dpa_lock_new = "old_lock";
localparam ioserdesdpa_1__dpa_top__mode = "off_mode";
localparam ioserdesdpa_1__dpa_top__dpa_up_ph_enhance = "en_up_ph_enhance";
localparam ioserdesdpa_1__dpa_top__dpa_switch_enhance = "en_switch_enhance";
localparam ioserdesdpa_1__dpa_top__dpa_dft_crnt_clk = "en_dft_crnt_clk";
localparam ioserdesdpa_1__dpa_top__loopback2_in_dir = "lb2_in_left";
localparam ioserdesdpa_1__dpa_top__dpa_rst_ext_enhance = "en_rst_ext_enhance";
localparam ioserdesdpa_1__dpa_top__dz_lock_sync_enhance = "en_dz_lock_sync_enhance";
localparam ioserdesdpa_1__serdes_top__serdestop_function = "off_mode"; 
localparam ioserdesdpa_1__serdes_top__mode = "user_mode"; 
localparam ioserdesdpa_1__serdes_top__loopback2b_l2r_en = "lp2b_l2r_dis";
localparam ioserdesdpa_1__serdes_top__loopback2b_r2l_en = "lp2b_r2l_dis";
localparam ioserdesdpa_1__serdes_top__loopback13_in_dir = "lb13_in_left";
localparam ioserdesdpa_1__serdes_top__clock_source__mode = "off_mode";
localparam ioserdesdpa_1__serdes_top__clock_source__clk_gen__serdes_factor = "factor3";
localparam ioserdesdpa_1__serdes_top__clock_source__clk_gen__clk_factor = "odd_clk";
localparam ioserdesdpa_1__serdes_top__clock_source__clk_gen__lclkdist_en = "lclk_disable"; 
localparam ioserdesdpa_1__serdes_top__clock_source__clk_gen__clock_output = "no_clock"; 
localparam ioserdesdpa_1__serdes_top__clock_source__clk_gen__lloaden = "lloaden_dis"; 
localparam ioserdesdpa_1__serdes_top__clock_source__clk_gen__ldgenfast = "ldgenfast_dis";
localparam ioserdesdpa_1__serdes_top__clock_source__clk_gen__mode = "off_mode"; 
localparam ioserdesdpa_1__serdes_top__clock_source__serdes_clk_mux__fclk_src = "fclk_in0"; 
localparam ioserdesdpa_1__serdes_top__clock_source__serdes_clk_mux__loaden_src = "loaden_in0"; 
localparam ioserdesdpa_1__serdes_top__clock_source__serdes_clk_mux__fclk_enable = "fclk_dis"; 
localparam ioserdesdpa_1__serdes_top__clock_source__serdes_clk_mux__loaden_enable = "loaden_dis"; 
localparam ioserdesdpa_1__serdes_top__clock_source__serdes_clk_mux__mode = "power_down"; 
localparam ioserdesdpa_1__serdes_top__serdes__serdes_function = "ser_txdat";
localparam ioserdesdpa_1__serdes_top__serdes__tx_mux_src = "tx_mux_src_txdat"; 
localparam ioserdesdpa_1__serdes_top__serdes__tx_ph = "tx_ph_pos"; 
localparam ioserdesdpa_1__serdes_top__serdes__dpa_tx_dpaclk_en = "dpa_tx_dpaclk_disabled";
localparam ioserdesdpa_1__serdes_top__serdes__ser_des_configuration = "serializer_enable"; 
localparam ioserdesdpa_1__serdes_top__serdes__serial_out_enable = "serout_enable"; 
localparam ioserdesdpa_1__serdes_top__serdes__parallel_out_enable = "parout_disable"; 
localparam ioserdesdpa_1__serdes_top__serdes__mode = "user_mode"; 
localparam ioserdesdpa_1__serdes_top__serdes__loopback2_setting = "lp2_disable";
localparam ioserdesdpa_1__serdes_top__bslip__bslip_config = "bslip_0";
localparam ioserdesdpa_1__serdes_top__bslip__dpa_enable = "dpa_dis"; 
localparam ioserdesdpa_1__serdes_top__bslip__loopback1_enable = "loopback1_dis";
localparam ioserdesdpa_1__serdes_top__bslip__data_in = "phase_pos"; 
localparam ioserdesdpa_1__serdes_top__bslip__bslip_function = "non_dpa_mode_pos_ph";
localparam ioserdesdpa_1__serdes_top__bslip__bslip_mode = "user_mode"; 
localparam ioserdesdpa_1__testout_mux__test_enable = "test_dis";
localparam ioserdesdpa_1__testout_mux__test_bitslipmax_enable = "test_bs_dis";
localparam ioserdesdpa_1__testout_mux__test_lock_enable = "test_lk_dis";
localparam ioserdesdpa_1__testout_mux__mode = "usermode"; 
localparam ioserdesdpa_1__testout_mux__test_pclk = "test_pclk_dis";
localparam ioserdesdpa_1__rst_ctrl_sync__dpa_dpahold_en = "dpa_dpahold_enabled"; 
localparam ioserdesdpa_1__rst_ctrl_sync__dpa_dparst_en = "dpa_dparst_enabled"; 
localparam ioserdesdpa_1__rst_ctrl_sync__dpa_dpaen = "dpa_dpa_enabled"; 
localparam ioserdesdpa_1__rst_ctrl_sync__mode = "off_mode";
localparam ioserdesdpa_2__mode = "off_mode"; 
localparam ioserdesdpa_2__powermode_ac = "rx_dyn_fifo_j3"; 
localparam ioserdesdpa_2__powermode_dc = "powerup"; 
localparam ioserdesdpa_2__loopback_mode = "non_loopback"; 
localparam ioserdesdpa_2__dpa_top__dpa_cdr_en = "dpa_cdr_disabled"; 
localparam ioserdesdpa_2__dpa_top__dpa_loopback2_en = "dpa_loopback2_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_fifolock_en = "dpa_fifolock_enabled";
localparam ioserdesdpa_2__dpa_top__dpa_pd_edge_sel = "dpa_pd_edge_sel_both";
localparam ioserdesdpa_2__dpa_top__dpa_test_1_src = "dpa_test_1_src_data";
localparam ioserdesdpa_2__dpa_top__dpa_dpa_lose_locken = "dpa_dpa_nrm";
localparam ioserdesdpa_2__dpa_top__dpa_rx_dly = "dpa_rx_dly_0ps";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt9_en = "dpa_rienopt9_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt10_en = "dpa_rienopt10_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt11_en = "dpa_rienopt11_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt0_en = "dpa_dz_data_enabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt1_en = "dpa_dz_slow_enabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt2_en = "dpa_rienopt2_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt3_en = "dpa_rienopt3_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt4_en = "dpa_rienopt4_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt5_en = "dpa_rienopt5_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt6_en = "dpa_rienopt6_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt7_en = "dpa_rienopt7_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt8_en = "dpa_rienopt8_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rienopt12_en = "dpa_rienopt12_enabled";
localparam ioserdesdpa_2__dpa_top__dpa_rdg_dzdsoff_en = "dpa_dz_pd_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rdg_dzden_en = "dpa_dz_enabled";
localparam ioserdesdpa_2__dpa_top__dpa_rdpaswitch_rs_en = "dpa_test_eng_opt9_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_rcount64_en = "dpa_rcount64_disabled";
localparam ioserdesdpa_2__dpa_top__dpa_lock_new = "old_lock";
localparam ioserdesdpa_2__dpa_top__mode = "off_mode";
localparam ioserdesdpa_2__dpa_top__dpa_up_ph_enhance = "en_up_ph_enhance";
localparam ioserdesdpa_2__dpa_top__dpa_switch_enhance = "en_switch_enhance";
localparam ioserdesdpa_2__dpa_top__dpa_dft_crnt_clk = "en_dft_crnt_clk";
localparam ioserdesdpa_2__dpa_top__loopback2_in_dir = "lb2_in_left";
localparam ioserdesdpa_2__dpa_top__dpa_rst_ext_enhance = "en_rst_ext_enhance";
localparam ioserdesdpa_2__dpa_top__dz_lock_sync_enhance = "en_dz_lock_sync_enhance";
localparam ioserdesdpa_2__serdes_top__serdestop_function = "off_mode"; 
localparam ioserdesdpa_2__serdes_top__mode = "user_mode"; 
localparam ioserdesdpa_2__serdes_top__loopback2b_l2r_en = "lp2b_l2r_dis";
localparam ioserdesdpa_2__serdes_top__loopback2b_r2l_en = "lp2b_r2l_dis";
localparam ioserdesdpa_2__serdes_top__loopback13_in_dir = "lb13_in_left";
localparam ioserdesdpa_2__serdes_top__clock_source__mode = "off_mode";
localparam ioserdesdpa_2__serdes_top__clock_source__clk_gen__serdes_factor = "factor3";
localparam ioserdesdpa_2__serdes_top__clock_source__clk_gen__clk_factor = "odd_clk";
localparam ioserdesdpa_2__serdes_top__clock_source__clk_gen__lclkdist_en = "lclk_disable"; 
localparam ioserdesdpa_2__serdes_top__clock_source__clk_gen__clock_output = "no_clock"; 
localparam ioserdesdpa_2__serdes_top__clock_source__clk_gen__lloaden = "lloaden_dis"; 
localparam ioserdesdpa_2__serdes_top__clock_source__clk_gen__ldgenfast = "ldgenfast_dis";
localparam ioserdesdpa_2__serdes_top__clock_source__clk_gen__mode = "off_mode"; 
localparam ioserdesdpa_2__serdes_top__clock_source__serdes_clk_mux__fclk_src = "fclk_in0"; 
localparam ioserdesdpa_2__serdes_top__clock_source__serdes_clk_mux__loaden_src = "loaden_in0"; 
localparam ioserdesdpa_2__serdes_top__clock_source__serdes_clk_mux__fclk_enable = "fclk_dis"; 
localparam ioserdesdpa_2__serdes_top__clock_source__serdes_clk_mux__loaden_enable = "loaden_dis"; 
localparam ioserdesdpa_2__serdes_top__clock_source__serdes_clk_mux__mode = "power_down"; 
localparam ioserdesdpa_2__serdes_top__serdes__serdes_function = "ser_txdat";
localparam ioserdesdpa_2__serdes_top__serdes__tx_mux_src = "tx_mux_src_txdat"; 
localparam ioserdesdpa_2__serdes_top__serdes__tx_ph = "tx_ph_pos"; 
localparam ioserdesdpa_2__serdes_top__serdes__dpa_tx_dpaclk_en = "dpa_tx_dpaclk_disabled";
localparam ioserdesdpa_2__serdes_top__serdes__ser_des_configuration = "serializer_enable"; 
localparam ioserdesdpa_2__serdes_top__serdes__serial_out_enable = "serout_enable"; 
localparam ioserdesdpa_2__serdes_top__serdes__parallel_out_enable = "parout_disable"; 
localparam ioserdesdpa_2__serdes_top__serdes__mode = "user_mode"; 
localparam ioserdesdpa_2__serdes_top__serdes__loopback2_setting = "lp2_disable";
localparam ioserdesdpa_2__serdes_top__bslip__bslip_config = "bslip_0";
localparam ioserdesdpa_2__serdes_top__bslip__dpa_enable = "dpa_dis"; 
localparam ioserdesdpa_2__serdes_top__bslip__loopback1_enable = "loopback1_dis";
localparam ioserdesdpa_2__serdes_top__bslip__data_in = "phase_pos"; 
localparam ioserdesdpa_2__serdes_top__bslip__bslip_function = "non_dpa_mode_pos_ph";
localparam ioserdesdpa_2__serdes_top__bslip__bslip_mode = "user_mode"; 
localparam ioserdesdpa_2__testout_mux__test_enable = "test_dis";
localparam ioserdesdpa_2__testout_mux__test_bitslipmax_enable = "test_bs_dis";
localparam ioserdesdpa_2__testout_mux__test_lock_enable = "test_lk_dis";
localparam ioserdesdpa_2__testout_mux__mode = "usermode"; 
localparam ioserdesdpa_2__testout_mux__test_pclk = "test_pclk_dis";
localparam ioserdesdpa_2__rst_ctrl_sync__dpa_dpahold_en = "dpa_dpahold_enabled"; 
localparam ioserdesdpa_2__rst_ctrl_sync__dpa_dparst_en = "dpa_dparst_enabled"; 
localparam ioserdesdpa_2__rst_ctrl_sync__dpa_dpaen = "dpa_dpa_enabled"; 
localparam ioserdesdpa_2__rst_ctrl_sync__mode = "off_mode";
localparam ioserdesdpa_3__mode = "off_mode"; 
localparam ioserdesdpa_3__powermode_ac = "rx_dyn_fifo_j3"; 
localparam ioserdesdpa_3__powermode_dc = "powerup"; 
localparam ioserdesdpa_3__loopback_mode = "non_loopback"; 
localparam ioserdesdpa_3__dpa_top__dpa_cdr_en = "dpa_cdr_disabled"; 
localparam ioserdesdpa_3__dpa_top__dpa_loopback2_en = "dpa_loopback2_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_fifolock_en = "dpa_fifolock_enabled";
localparam ioserdesdpa_3__dpa_top__dpa_pd_edge_sel = "dpa_pd_edge_sel_both";
localparam ioserdesdpa_3__dpa_top__dpa_test_1_src = "dpa_test_1_src_data";
localparam ioserdesdpa_3__dpa_top__dpa_dpa_lose_locken = "dpa_dpa_nrm";
localparam ioserdesdpa_3__dpa_top__dpa_rx_dly = "dpa_rx_dly_0ps";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt9_en = "dpa_rienopt9_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt10_en = "dpa_rienopt10_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt11_en = "dpa_rienopt11_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt0_en = "dpa_dz_data_enabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt1_en = "dpa_dz_slow_enabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt2_en = "dpa_rienopt2_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt3_en = "dpa_rienopt3_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt4_en = "dpa_rienopt4_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt5_en = "dpa_rienopt5_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt6_en = "dpa_rienopt6_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt7_en = "dpa_rienopt7_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt8_en = "dpa_rienopt8_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rienopt12_en = "dpa_rienopt12_enabled";
localparam ioserdesdpa_3__dpa_top__dpa_rdg_dzdsoff_en = "dpa_dz_pd_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rdg_dzden_en = "dpa_dz_enabled";
localparam ioserdesdpa_3__dpa_top__dpa_rdpaswitch_rs_en = "dpa_test_eng_opt9_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_rcount64_en = "dpa_rcount64_disabled";
localparam ioserdesdpa_3__dpa_top__dpa_lock_new = "old_lock";
localparam ioserdesdpa_3__dpa_top__mode = "off_mode";
localparam ioserdesdpa_3__dpa_top__dpa_up_ph_enhance = "en_up_ph_enhance";
localparam ioserdesdpa_3__dpa_top__dpa_switch_enhance = "en_switch_enhance";
localparam ioserdesdpa_3__dpa_top__dpa_dft_crnt_clk = "en_dft_crnt_clk";
localparam ioserdesdpa_3__dpa_top__loopback2_in_dir = "lb2_in_left";
localparam ioserdesdpa_3__dpa_top__dpa_rst_ext_enhance = "en_rst_ext_enhance";
localparam ioserdesdpa_3__dpa_top__dz_lock_sync_enhance = "en_dz_lock_sync_enhance";
localparam ioserdesdpa_3__serdes_top__serdestop_function = "off_mode"; 
localparam ioserdesdpa_3__serdes_top__mode = "user_mode"; 
localparam ioserdesdpa_3__serdes_top__loopback2b_l2r_en = "lp2b_l2r_dis";
localparam ioserdesdpa_3__serdes_top__loopback2b_r2l_en = "lp2b_r2l_dis";
localparam ioserdesdpa_3__serdes_top__loopback13_in_dir = "lb13_in_left";
localparam ioserdesdpa_3__serdes_top__clock_source__mode = "off_mode";
localparam ioserdesdpa_3__serdes_top__clock_source__clk_gen__serdes_factor = "factor3";
localparam ioserdesdpa_3__serdes_top__clock_source__clk_gen__clk_factor = "odd_clk";
localparam ioserdesdpa_3__serdes_top__clock_source__clk_gen__lclkdist_en = "lclk_disable"; 
localparam ioserdesdpa_3__serdes_top__clock_source__clk_gen__clock_output = "no_clock"; 
localparam ioserdesdpa_3__serdes_top__clock_source__clk_gen__lloaden = "lloaden_dis"; 
localparam ioserdesdpa_3__serdes_top__clock_source__clk_gen__ldgenfast = "ldgenfast_dis";
localparam ioserdesdpa_3__serdes_top__clock_source__clk_gen__mode = "off_mode"; 
localparam ioserdesdpa_3__serdes_top__clock_source__serdes_clk_mux__fclk_src = "fclk_in0"; 
localparam ioserdesdpa_3__serdes_top__clock_source__serdes_clk_mux__loaden_src = "loaden_in0"; 
localparam ioserdesdpa_3__serdes_top__clock_source__serdes_clk_mux__fclk_enable = "fclk_dis"; 
localparam ioserdesdpa_3__serdes_top__clock_source__serdes_clk_mux__loaden_enable = "loaden_dis"; 
localparam ioserdesdpa_3__serdes_top__clock_source__serdes_clk_mux__mode = "power_down"; 
localparam ioserdesdpa_3__serdes_top__serdes__serdes_function = "ser_txdat";
localparam ioserdesdpa_3__serdes_top__serdes__tx_mux_src = "tx_mux_src_txdat"; 
localparam ioserdesdpa_3__serdes_top__serdes__tx_ph = "tx_ph_pos"; 
localparam ioserdesdpa_3__serdes_top__serdes__dpa_tx_dpaclk_en = "dpa_tx_dpaclk_disabled";
localparam ioserdesdpa_3__serdes_top__serdes__ser_des_configuration = "serializer_enable"; 
localparam ioserdesdpa_3__serdes_top__serdes__serial_out_enable = "serout_enable"; 
localparam ioserdesdpa_3__serdes_top__serdes__parallel_out_enable = "parout_disable"; 
localparam ioserdesdpa_3__serdes_top__serdes__mode = "user_mode"; 
localparam ioserdesdpa_3__serdes_top__serdes__loopback2_setting = "lp2_disable";
localparam ioserdesdpa_3__serdes_top__bslip__bslip_config = "bslip_0";
localparam ioserdesdpa_3__serdes_top__bslip__dpa_enable = "dpa_dis"; 
localparam ioserdesdpa_3__serdes_top__bslip__loopback1_enable = "loopback1_dis";
localparam ioserdesdpa_3__serdes_top__bslip__data_in = "phase_pos"; 
localparam ioserdesdpa_3__serdes_top__bslip__bslip_function = "non_dpa_mode_pos_ph";
localparam ioserdesdpa_3__serdes_top__bslip__bslip_mode = "user_mode"; 
localparam ioserdesdpa_3__testout_mux__test_enable = "test_dis";
localparam ioserdesdpa_3__testout_mux__test_bitslipmax_enable = "test_bs_dis";
localparam ioserdesdpa_3__testout_mux__test_lock_enable = "test_lk_dis";
localparam ioserdesdpa_3__testout_mux__mode = "usermode"; 
localparam ioserdesdpa_3__testout_mux__test_pclk = "test_pclk_dis";
localparam ioserdesdpa_3__rst_ctrl_sync__dpa_dpahold_en = "dpa_dpahold_enabled"; 
localparam ioserdesdpa_3__rst_ctrl_sync__dpa_dparst_en = "dpa_dparst_enabled"; 
localparam ioserdesdpa_3__rst_ctrl_sync__dpa_dpaen = "dpa_dpa_enabled"; 
localparam ioserdesdpa_3__rst_ctrl_sync__mode = "off_mode";
localparam ioserdesdpa_4__mode = "off_mode"; 
localparam ioserdesdpa_4__powermode_ac = "rx_dyn_fifo_j3"; 
localparam ioserdesdpa_4__powermode_dc = "powerup"; 
localparam ioserdesdpa_4__loopback_mode = "non_loopback"; 
localparam ioserdesdpa_4__dpa_top__dpa_cdr_en = "dpa_cdr_disabled"; 
localparam ioserdesdpa_4__dpa_top__dpa_loopback2_en = "dpa_loopback2_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_fifolock_en = "dpa_fifolock_enabled";
localparam ioserdesdpa_4__dpa_top__dpa_pd_edge_sel = "dpa_pd_edge_sel_both";
localparam ioserdesdpa_4__dpa_top__dpa_test_1_src = "dpa_test_1_src_data";
localparam ioserdesdpa_4__dpa_top__dpa_dpa_lose_locken = "dpa_dpa_nrm";
localparam ioserdesdpa_4__dpa_top__dpa_rx_dly = "dpa_rx_dly_0ps";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt9_en = "dpa_rienopt9_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt10_en = "dpa_rienopt10_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt11_en = "dpa_rienopt11_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt0_en = "dpa_dz_data_enabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt1_en = "dpa_dz_slow_enabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt2_en = "dpa_rienopt2_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt3_en = "dpa_rienopt3_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt4_en = "dpa_rienopt4_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt5_en = "dpa_rienopt5_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt6_en = "dpa_rienopt6_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt7_en = "dpa_rienopt7_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt8_en = "dpa_rienopt8_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rienopt12_en = "dpa_rienopt12_enabled";
localparam ioserdesdpa_4__dpa_top__dpa_rdg_dzdsoff_en = "dpa_dz_pd_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rdg_dzden_en = "dpa_dz_enabled";
localparam ioserdesdpa_4__dpa_top__dpa_rdpaswitch_rs_en = "dpa_test_eng_opt9_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_rcount64_en = "dpa_rcount64_disabled";
localparam ioserdesdpa_4__dpa_top__dpa_lock_new = "old_lock";
localparam ioserdesdpa_4__dpa_top__mode = "off_mode";
localparam ioserdesdpa_4__dpa_top__dpa_up_ph_enhance = "en_up_ph_enhance";
localparam ioserdesdpa_4__dpa_top__dpa_switch_enhance = "en_switch_enhance";
localparam ioserdesdpa_4__dpa_top__dpa_dft_crnt_clk = "en_dft_crnt_clk";
localparam ioserdesdpa_4__dpa_top__loopback2_in_dir = "lb2_in_left";
localparam ioserdesdpa_4__dpa_top__dpa_rst_ext_enhance = "en_rst_ext_enhance";
localparam ioserdesdpa_4__dpa_top__dz_lock_sync_enhance = "en_dz_lock_sync_enhance";
localparam ioserdesdpa_4__serdes_top__serdestop_function = "off_mode"; 
localparam ioserdesdpa_4__serdes_top__mode = "user_mode"; 
localparam ioserdesdpa_4__serdes_top__loopback2b_l2r_en = "lp2b_l2r_dis";
localparam ioserdesdpa_4__serdes_top__loopback2b_r2l_en = "lp2b_r2l_dis";
localparam ioserdesdpa_4__serdes_top__loopback13_in_dir = "lb13_in_left";
localparam ioserdesdpa_4__serdes_top__clock_source__mode = "off_mode";
localparam ioserdesdpa_4__serdes_top__clock_source__clk_gen__serdes_factor = "factor3";
localparam ioserdesdpa_4__serdes_top__clock_source__clk_gen__clk_factor = "odd_clk";
localparam ioserdesdpa_4__serdes_top__clock_source__clk_gen__lclkdist_en = "lclk_disable"; 
localparam ioserdesdpa_4__serdes_top__clock_source__clk_gen__clock_output = "no_clock"; 
localparam ioserdesdpa_4__serdes_top__clock_source__clk_gen__lloaden = "lloaden_dis"; 
localparam ioserdesdpa_4__serdes_top__clock_source__clk_gen__ldgenfast = "ldgenfast_dis";
localparam ioserdesdpa_4__serdes_top__clock_source__clk_gen__mode = "off_mode"; 
localparam ioserdesdpa_4__serdes_top__clock_source__serdes_clk_mux__fclk_src = "fclk_in0"; 
localparam ioserdesdpa_4__serdes_top__clock_source__serdes_clk_mux__loaden_src = "loaden_in0"; 
localparam ioserdesdpa_4__serdes_top__clock_source__serdes_clk_mux__fclk_enable = "fclk_dis"; 
localparam ioserdesdpa_4__serdes_top__clock_source__serdes_clk_mux__loaden_enable = "loaden_dis"; 
localparam ioserdesdpa_4__serdes_top__clock_source__serdes_clk_mux__mode = "power_down"; 
localparam ioserdesdpa_4__serdes_top__serdes__serdes_function = "ser_txdat";
localparam ioserdesdpa_4__serdes_top__serdes__tx_mux_src = "tx_mux_src_txdat"; 
localparam ioserdesdpa_4__serdes_top__serdes__tx_ph = "tx_ph_pos"; 
localparam ioserdesdpa_4__serdes_top__serdes__dpa_tx_dpaclk_en = "dpa_tx_dpaclk_disabled";
localparam ioserdesdpa_4__serdes_top__serdes__ser_des_configuration = "serializer_enable"; 
localparam ioserdesdpa_4__serdes_top__serdes__serial_out_enable = "serout_enable"; 
localparam ioserdesdpa_4__serdes_top__serdes__parallel_out_enable = "parout_disable"; 
localparam ioserdesdpa_4__serdes_top__serdes__mode = "user_mode"; 
localparam ioserdesdpa_4__serdes_top__serdes__loopback2_setting = "lp2_disable";
localparam ioserdesdpa_4__serdes_top__bslip__bslip_config = "bslip_0";
localparam ioserdesdpa_4__serdes_top__bslip__dpa_enable = "dpa_dis"; 
localparam ioserdesdpa_4__serdes_top__bslip__loopback1_enable = "loopback1_dis";
localparam ioserdesdpa_4__serdes_top__bslip__data_in = "phase_pos"; 
localparam ioserdesdpa_4__serdes_top__bslip__bslip_function = "non_dpa_mode_pos_ph";
localparam ioserdesdpa_4__serdes_top__bslip__bslip_mode = "user_mode"; 
localparam ioserdesdpa_4__testout_mux__test_enable = "test_dis";
localparam ioserdesdpa_4__testout_mux__test_bitslipmax_enable = "test_bs_dis";
localparam ioserdesdpa_4__testout_mux__test_lock_enable = "test_lk_dis";
localparam ioserdesdpa_4__testout_mux__mode = "usermode"; 
localparam ioserdesdpa_4__testout_mux__test_pclk = "test_pclk_dis";
localparam ioserdesdpa_4__rst_ctrl_sync__dpa_dpahold_en = "dpa_dpahold_enabled"; 
localparam ioserdesdpa_4__rst_ctrl_sync__dpa_dparst_en = "dpa_dparst_enabled"; 
localparam ioserdesdpa_4__rst_ctrl_sync__dpa_dpaen = "dpa_dpa_enabled"; 
localparam ioserdesdpa_4__rst_ctrl_sync__mode = "off_mode";
localparam ioserdesdpa_5__mode = "off_mode"; 
localparam ioserdesdpa_5__powermode_ac = "rx_dyn_fifo_j3"; 
localparam ioserdesdpa_5__powermode_dc = "powerup"; 
localparam ioserdesdpa_5__loopback_mode = "non_loopback"; 
localparam ioserdesdpa_5__dpa_top__dpa_cdr_en = "dpa_cdr_disabled"; 
localparam ioserdesdpa_5__dpa_top__dpa_loopback2_en = "dpa_loopback2_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_fifolock_en = "dpa_fifolock_enabled";
localparam ioserdesdpa_5__dpa_top__dpa_pd_edge_sel = "dpa_pd_edge_sel_both";
localparam ioserdesdpa_5__dpa_top__dpa_test_1_src = "dpa_test_1_src_data";
localparam ioserdesdpa_5__dpa_top__dpa_dpa_lose_locken = "dpa_dpa_nrm";
localparam ioserdesdpa_5__dpa_top__dpa_rx_dly = "dpa_rx_dly_0ps";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt9_en = "dpa_rienopt9_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt10_en = "dpa_rienopt10_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt11_en = "dpa_rienopt11_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt0_en = "dpa_dz_data_enabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt1_en = "dpa_dz_slow_enabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt2_en = "dpa_rienopt2_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt3_en = "dpa_rienopt3_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt4_en = "dpa_rienopt4_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt5_en = "dpa_rienopt5_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt6_en = "dpa_rienopt6_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt7_en = "dpa_rienopt7_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt8_en = "dpa_rienopt8_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rienopt12_en = "dpa_rienopt12_enabled";
localparam ioserdesdpa_5__dpa_top__dpa_rdg_dzdsoff_en = "dpa_dz_pd_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rdg_dzden_en = "dpa_dz_enabled";
localparam ioserdesdpa_5__dpa_top__dpa_rdpaswitch_rs_en = "dpa_test_eng_opt9_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_rcount64_en = "dpa_rcount64_disabled";
localparam ioserdesdpa_5__dpa_top__dpa_lock_new = "old_lock";
localparam ioserdesdpa_5__dpa_top__mode = "off_mode";
localparam ioserdesdpa_5__dpa_top__dpa_up_ph_enhance = "en_up_ph_enhance";
localparam ioserdesdpa_5__dpa_top__dpa_switch_enhance = "en_switch_enhance";
localparam ioserdesdpa_5__dpa_top__dpa_dft_crnt_clk = "en_dft_crnt_clk";
localparam ioserdesdpa_5__dpa_top__loopback2_in_dir = "lb2_in_left";
localparam ioserdesdpa_5__dpa_top__dpa_rst_ext_enhance = "en_rst_ext_enhance";
localparam ioserdesdpa_5__dpa_top__dz_lock_sync_enhance = "en_dz_lock_sync_enhance";
localparam ioserdesdpa_5__serdes_top__serdestop_function = "off_mode"; 
localparam ioserdesdpa_5__serdes_top__mode = "user_mode"; 
localparam ioserdesdpa_5__serdes_top__loopback2b_l2r_en = "lp2b_l2r_dis";
localparam ioserdesdpa_5__serdes_top__loopback2b_r2l_en = "lp2b_r2l_dis";
localparam ioserdesdpa_5__serdes_top__loopback13_in_dir = "lb13_in_left";
localparam ioserdesdpa_5__serdes_top__clock_source__mode = "off_mode";
localparam ioserdesdpa_5__serdes_top__clock_source__clk_gen__serdes_factor = "factor3";
localparam ioserdesdpa_5__serdes_top__clock_source__clk_gen__clk_factor = "odd_clk";
localparam ioserdesdpa_5__serdes_top__clock_source__clk_gen__lclkdist_en = "lclk_disable"; 
localparam ioserdesdpa_5__serdes_top__clock_source__clk_gen__clock_output = "no_clock"; 
localparam ioserdesdpa_5__serdes_top__clock_source__clk_gen__lloaden = "lloaden_dis"; 
localparam ioserdesdpa_5__serdes_top__clock_source__clk_gen__ldgenfast = "ldgenfast_dis";
localparam ioserdesdpa_5__serdes_top__clock_source__clk_gen__mode = "off_mode"; 
localparam ioserdesdpa_5__serdes_top__clock_source__serdes_clk_mux__fclk_src = "fclk_in0"; 
localparam ioserdesdpa_5__serdes_top__clock_source__serdes_clk_mux__loaden_src = "loaden_in0"; 
localparam ioserdesdpa_5__serdes_top__clock_source__serdes_clk_mux__fclk_enable = "fclk_dis"; 
localparam ioserdesdpa_5__serdes_top__clock_source__serdes_clk_mux__loaden_enable = "loaden_dis"; 
localparam ioserdesdpa_5__serdes_top__clock_source__serdes_clk_mux__mode = "power_down"; 
localparam ioserdesdpa_5__serdes_top__serdes__serdes_function = "ser_txdat";
localparam ioserdesdpa_5__serdes_top__serdes__tx_mux_src = "tx_mux_src_txdat"; 
localparam ioserdesdpa_5__serdes_top__serdes__tx_ph = "tx_ph_pos"; 
localparam ioserdesdpa_5__serdes_top__serdes__dpa_tx_dpaclk_en = "dpa_tx_dpaclk_disabled";
localparam ioserdesdpa_5__serdes_top__serdes__ser_des_configuration = "serializer_enable"; 
localparam ioserdesdpa_5__serdes_top__serdes__serial_out_enable = "serout_enable"; 
localparam ioserdesdpa_5__serdes_top__serdes__parallel_out_enable = "parout_disable"; 
localparam ioserdesdpa_5__serdes_top__serdes__mode = "user_mode"; 
localparam ioserdesdpa_5__serdes_top__serdes__loopback2_setting = "lp2_disable";
localparam ioserdesdpa_5__serdes_top__bslip__bslip_config = "bslip_0";
localparam ioserdesdpa_5__serdes_top__bslip__dpa_enable = "dpa_dis"; 
localparam ioserdesdpa_5__serdes_top__bslip__loopback1_enable = "loopback1_dis";
localparam ioserdesdpa_5__serdes_top__bslip__data_in = "phase_pos"; 
localparam ioserdesdpa_5__serdes_top__bslip__bslip_function = "non_dpa_mode_pos_ph";
localparam ioserdesdpa_5__serdes_top__bslip__bslip_mode = "user_mode"; 
localparam ioserdesdpa_5__testout_mux__test_enable = "test_dis";
localparam ioserdesdpa_5__testout_mux__test_bitslipmax_enable = "test_bs_dis";
localparam ioserdesdpa_5__testout_mux__test_lock_enable = "test_lk_dis";
localparam ioserdesdpa_5__testout_mux__mode = "usermode"; 
localparam ioserdesdpa_5__testout_mux__test_pclk = "test_pclk_dis";
localparam ioserdesdpa_5__rst_ctrl_sync__dpa_dpahold_en = "dpa_dpahold_enabled"; 
localparam ioserdesdpa_5__rst_ctrl_sync__dpa_dparst_en = "dpa_dparst_enabled"; 
localparam ioserdesdpa_5__rst_ctrl_sync__dpa_dpaen = "dpa_dpa_enabled"; 
localparam ioserdesdpa_5__rst_ctrl_sync__mode = "off_mode";
localparam data_buffer__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__a_memory_standard = "ddr4"; 
localparam [7:0] data_buffer__a_wl_latency = 8'd0; 
localparam [7:0] data_buffer__a_pipe_latency = 8'd0; 
localparam [7:0] data_buffer__a_phy_wlat = 8'd0; 
localparam data_buffer__a_mode_rate_out = "out_rate_full"; 
localparam data_buffer__a_mode_rate_in = "in_rate_full"; 
localparam data_buffer__a_dft_mode = "dft_disable"; 
localparam data_buffer__a_rb_dbi_wr_en_v = "dbi_wr_disable_v"; 
localparam data_buffer__a_ac_lane = "ac_lane_false"; 
localparam data_buffer__a_calibration = "skip"; 
localparam data_buffer__rdwr_buffer_inst_0__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_0__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_0__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_0__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_0__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_0__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_0__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__rdwr_buffer_inst_1__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_1__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_1__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_1__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_1__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_1__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_1__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__rdwr_buffer_inst_2__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_2__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_2__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_2__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_2__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_2__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_2__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__rdwr_buffer_inst_3__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_3__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_3__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_3__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_3__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_3__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_3__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__rdwr_buffer_inst_4__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_4__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_4__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_4__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_4__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_4__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_4__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__rdwr_buffer_inst_5__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_5__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_5__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_5__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_5__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_5__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_5__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__rdwr_buffer_inst_6__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_6__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_6__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_6__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_6__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_6__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_6__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__rdwr_buffer_inst_7__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_7__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_7__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_7__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_7__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_7__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_7__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__rdwr_buffer_inst_8__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_8__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_8__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_8__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_8__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_8__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_8__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__rdwr_buffer_inst_9__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_9__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_9__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_9__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_9__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_9__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_9__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__rdwr_buffer_inst_10__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_10__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_10__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_10__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_10__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_10__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_10__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__rdwr_buffer_inst_11__a_prbs = "not_sel_prbs";
localparam data_buffer__rdwr_buffer_inst_11__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__rdwr_buffer_inst_11__a_pipeline = "pipeline_bypass"; 
localparam data_buffer__rdwr_buffer_inst_11__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__rdwr_buffer_inst_11__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__rdwr_buffer_inst_11__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__rdwr_buffer_inst_11__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_memory_standard = "ddr4"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_memory_standard = "ddr4"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_memory_standard = "ddr4"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_memory_standard = "ddr4"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_memory_standard = "ddr4"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_memory_standard = "ddr4"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_memory_standard = "ddr4"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_memory_standard = "ddr4"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_memory_standard = "ddr4"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_memory_standard = "ddr4"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_memory_standard = "ddr4"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_data_buffer_ctrl = "no_dbc"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_db_pin_type = "ac_pin"; 
localparam data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_memory_standard = "ddr4"; 
localparam [5:0] data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_wlat_vlu = db_afi_wlat_vlu;
localparam [5:0] data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_rlat_vlu = db_afi_rlat_vlu;
localparam data_buffer__data_buffer_clk_gen_inst__a_rb_phy_clk0_ena = "phy_clk0_ena";
localparam data_buffer__data_buffer_clk_gen_inst__a_rb_phy_clk1_ena = "phy_clk1_ena";
localparam data_buffer__avl_lane_inst__a_rb_tdf_gate_off = "not_gate_off";
localparam data_buffer__io_data_buffer_rdata_en_mrnk_sel_inst__a_rb_dft_prbs_mode = "oe_0_dq_0";
localparam data_buffer__iodbccmn_dbc_inst__a_rb_burst_length_mode = "bl8";
localparam [6:0] data_buffer__iodbccmn_dbc_inst__a_rb_dbc_wb_reserved_entry = dbc_wb_reserved_entry;
localparam data_buffer__iodbccmn_dbc_inst__a_rb_dft_speed_test = "sel_speed_test_disable";
localparam data_buffer__iodbccmn_dbc_inst__a_rb_dft_hmc_phy = "lbk_hmc_disable";
localparam data_buffer__iodbccmn_dbc_inst__a_rb_tdf_gate_off = "not_gate_off";
localparam data_buffer__iodbccmn_dbc_inst__cfg_ctrl_rc_en_scalar = "disable";
localparam data_buffer__io_data_buffer_dft_inst__a_rb_dft_lbk_phy = "lbk_phy_disable";
localparam data_buffer__io_data_buffer_dft_inst__a_rb_dft_mux_speed_in = "sel_speed_in0";
localparam data_buffer__io_data_buffer_dft_inst__a_rb_dft_mux_speed_out = "sel_speed_out0";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_0___ioereg_pnr_x2__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_0___ioereg_pnr_x2__a_sync_control = "sync_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__a_power_down_0 = "power_on_0";
localparam ioereg_top_0___ioereg_pnr_x2__a_power_down_1 = "power_on_1";
localparam ioereg_top_0___ioereg_pnr_x2__a_power_down_2 = "power_on_2";
localparam ioereg_top_0___ioereg_pnr_x2__a_power_down = "power_on";
localparam ioereg_top_0___ioereg_pnr_x2__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_0___ioereg_pnr_x2__a_lock_speed = 3'd7;
localparam ioereg_top_0___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_0___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n = "test_global_clk_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n = "test_interp_clk_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n = "test_int_clk_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n = "test_clk_ph_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n = "test_datovr_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_test_iocsr = "test_sync_data_enabled";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n = "test_xpr_clk_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term = "idle_term_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp = "bypass_mcp_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode = "phy_clk_0";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_power_down = "power_on";
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_0___ioereg_pnr_x2__write_path__a_lock_speed = 3'd7;
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_gpio_differential = "pin0_gpio_single_ended";
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_output_phase = 13'd0;
localparam ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_gpio_differential = "pin1_gpio_single_ended";
localparam [12:0] ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_output_phase = 13'd0;
localparam ioereg_top_0___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_0___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0 = "gpio_sel_0";
localparam ioereg_top_0___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1 = "gpio_sel_1";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_1___ioereg_pnr_x2__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_1___ioereg_pnr_x2__a_sync_control = "sync_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__a_power_down_0 = "power_on_0";
localparam ioereg_top_1___ioereg_pnr_x2__a_power_down_1 = "power_on_1";
localparam ioereg_top_1___ioereg_pnr_x2__a_power_down_2 = "power_on_2";
localparam ioereg_top_1___ioereg_pnr_x2__a_power_down = "power_on";
localparam ioereg_top_1___ioereg_pnr_x2__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_1___ioereg_pnr_x2__a_lock_speed = 3'd7;
localparam ioereg_top_1___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_1___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n = "test_global_clk_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n = "test_interp_clk_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n = "test_int_clk_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n = "test_clk_ph_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n = "test_datovr_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_test_iocsr = "test_sync_data_enabled";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n = "test_xpr_clk_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term = "idle_term_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp = "bypass_mcp_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode = "phy_clk_0";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_power_down = "power_on";
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_1___ioereg_pnr_x2__write_path__a_lock_speed = 3'd7;
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_gpio_differential = "pin0_gpio_single_ended";
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_output_phase = 13'd0;
localparam ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_gpio_differential = "pin1_gpio_single_ended";
localparam [12:0] ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_output_phase = 13'd0;
localparam ioereg_top_1___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_1___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0 = "gpio_sel_0";
localparam ioereg_top_1___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1 = "gpio_sel_1";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_2___ioereg_pnr_x2__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_2___ioereg_pnr_x2__a_sync_control = "sync_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__a_power_down_0 = "power_on_0";
localparam ioereg_top_2___ioereg_pnr_x2__a_power_down_1 = "power_on_1";
localparam ioereg_top_2___ioereg_pnr_x2__a_power_down_2 = "power_on_2";
localparam ioereg_top_2___ioereg_pnr_x2__a_power_down = "power_on";
localparam ioereg_top_2___ioereg_pnr_x2__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_2___ioereg_pnr_x2__a_lock_speed = 3'd7;
localparam ioereg_top_2___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_2___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n = "test_global_clk_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n = "test_interp_clk_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n = "test_int_clk_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n = "test_clk_ph_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n = "test_datovr_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_test_iocsr = "test_sync_data_enabled";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n = "test_xpr_clk_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term = "idle_term_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp = "bypass_mcp_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode = "phy_clk_0";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_power_down = "power_on";
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_2___ioereg_pnr_x2__write_path__a_lock_speed = 3'd7;
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_gpio_differential = "pin0_gpio_single_ended";
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_output_phase = 13'd0;
localparam ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_gpio_differential = "pin1_gpio_single_ended";
localparam [12:0] ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_output_phase = 13'd0;
localparam ioereg_top_2___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_2___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0 = "gpio_sel_0";
localparam ioereg_top_2___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1 = "gpio_sel_1";
localparam [15:0] xio_dqs_lgc_top__a_clock_period = 16'd0; 
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_align = "align_c_count";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_en = "dqs_gated";
localparam [3:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_probe_sel = 4'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_0_delay_step = "dq0_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_0_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_1_delay_step = "dq1_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_1_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_2_delay_step = "dq2_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_2_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_3_delay_step = "dq3_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_3_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_4_delay_step = "dq4_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_4_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_5_delay_step = "dq5_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_5_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_6_delay_step = "dq6_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_6_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_7_delay_step = "dq7_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_7_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_8_delay_step = "dq8_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_8_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_9_delay_step = "dq9_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_9_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_10_delay_step = "dq10_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_10_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_11_delay_step = "dq11_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_11_delay_fine = 3'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dqs_delay_step = "dqs_delay_0";
localparam [2:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dqs_delay_fine = 3'd0;
localparam [9:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_a = dqs_lgc_pvt_input_delay_a;
localparam [9:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_b = dqs_lgc_pvt_input_delay_b;
localparam [1:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_kicker_size = 2'd0;
localparam [3:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_track_speed = 4'd0;
localparam [6:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_rd_valid_delay = rd_valid_delay;
localparam [6:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_min_rd_valid_delay = 7'd0; 
localparam [6:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_count_threshold = dqs_lgc_count_threshold;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_lock_edge = "preamble_lock_rising_edge";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_mrnk_delay = "mrnk_short";
localparam [15:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_cmd_latency = 16'd0; 
localparam [15:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_output_phase = 16'd0; 
localparam [15:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_io_out_delay = 16'd0; 
localparam [7:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_cas_latency = 8'd0; 
localparam [15:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_board_delay = 16'd0; 
localparam [15:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_io_in_delay = 16'd0; 
localparam [15:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_en_latency = 16'd0; 
localparam [15:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_time_en_full_to_shrunk_a = 16'd0; 
localparam [15:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_time_en_full_to_shrunk_b = 16'd0; 
localparam [15:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_shrink_delay = 16'd0; 
localparam [15:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_adjust = 16'd0; 
localparam [15:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_shrink_gate_delay = 16'd0; 
localparam [7:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_pipe_latency = 8'd0; 
localparam [7:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_rd_valid_delay_adjust = 8'd0; 
localparam [7:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_rlat = 8'd0; 
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_memory_standard = "ddr4"; 
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_memory_width = "x8"; 
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_memory_burst_length = "bl8"; 
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_memory_rank_size = "rank1"; 
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_memory_dqs_type = "differential"; 
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_multi_rank_enable = "rank_disabled"; 
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_power_down_0 = "power_on_0";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_power_down_1 = "power_on_1";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_power_down_2 = "power_on_2";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_power_down = "power_on";
localparam [4:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_calsel = 5'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_cal_en = "cal_dis";
localparam [1:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_atbsel = 2'd0;
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_pdb = "vreg_on";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_ovrride = "ovrride_off";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_avl_clk_in_en_n = "test_avl_clk_disabled";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_clk_ph_buf_en_n = "test_ph_clk_disabled";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_interp_clk_en_n = "test_interp_clk_disabled";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_int_clk_en_n = "test_int_clk_disabled";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_phy_clk_lane_en_n = "test_phy_clk_disabled";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_pst_clk_en_n_b = "test_pst_clk_b_disabled";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_pst_clk_en_n_a = "test_pst_clk_a_disabled";
localparam xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_struct_en_n = "test_struct_disabled";
localparam [3:0] xio_dqs_lgc_top__dqs_lgc_pnr__a_spare = 4'd0;
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_3___ioereg_pnr_x2__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_3___ioereg_pnr_x2__a_sync_control = "sync_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__a_power_down_0 = "power_on_0";
localparam ioereg_top_3___ioereg_pnr_x2__a_power_down_1 = "power_on_1";
localparam ioereg_top_3___ioereg_pnr_x2__a_power_down_2 = "power_on_2";
localparam ioereg_top_3___ioereg_pnr_x2__a_power_down = "power_on";
localparam ioereg_top_3___ioereg_pnr_x2__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_3___ioereg_pnr_x2__a_lock_speed = 3'd7;
localparam ioereg_top_3___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_3___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n = "test_global_clk_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n = "test_interp_clk_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n = "test_int_clk_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n = "test_clk_ph_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n = "test_datovr_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_test_iocsr = "test_sync_data_enabled";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n = "test_xpr_clk_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term = "idle_term_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp = "bypass_mcp_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode = "phy_clk_0";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_power_down = "power_on";
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_3___ioereg_pnr_x2__write_path__a_lock_speed = 3'd7;
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_gpio_differential = "pin0_gpio_single_ended";
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_output_phase = 13'd0;
localparam ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_gpio_differential = "pin1_gpio_single_ended";
localparam [12:0] ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_output_phase = 13'd0;
localparam ioereg_top_3___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_3___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0 = "gpio_sel_0";
localparam ioereg_top_3___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1 = "gpio_sel_1";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_4___ioereg_pnr_x2__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_4___ioereg_pnr_x2__a_sync_control = "sync_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__a_power_down_0 = "power_on_0";
localparam ioereg_top_4___ioereg_pnr_x2__a_power_down_1 = "power_on_1";
localparam ioereg_top_4___ioereg_pnr_x2__a_power_down_2 = "power_on_2";
localparam ioereg_top_4___ioereg_pnr_x2__a_power_down = "power_on";
localparam ioereg_top_4___ioereg_pnr_x2__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_4___ioereg_pnr_x2__a_lock_speed = 3'd7;
localparam ioereg_top_4___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_4___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n = "test_global_clk_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n = "test_interp_clk_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n = "test_int_clk_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n = "test_clk_ph_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n = "test_datovr_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_test_iocsr = "test_sync_data_enabled";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n = "test_xpr_clk_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term = "idle_term_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp = "bypass_mcp_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode = "phy_clk_0";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_power_down = "power_on";
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_4___ioereg_pnr_x2__write_path__a_lock_speed = 3'd7;
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_gpio_differential = "pin0_gpio_single_ended";
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_output_phase = 13'd0;
localparam ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_gpio_differential = "pin1_gpio_single_ended";
localparam [12:0] ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_output_phase = 13'd0;
localparam ioereg_top_4___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_4___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0 = "gpio_sel_0";
localparam ioereg_top_4___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1 = "gpio_sel_1";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__mode = "power_down_mode"; 
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel = "ddr_sel";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__powermode_dc = "powerup"; 
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__mode = "power_down_mode"; 
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena = "naclr_ireg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena = "nsclr_ireg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel = "ireg_nclr_sel";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena = "ncein_ireg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena = "hr_in_clk_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena = "fr_in_clk_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val = "sclr_val_low";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val = "oreg_tieoff_val_low";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__mode = "power_down_mode"; 
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val = "oreg_sclr_val_low";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena = "oreg_ddr_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena = "nceout_oreg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena = "naclr_oreg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena = "nsclr_oreg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel = "oreg_nclr_sel";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena = "fr_out_clk_oreg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena = "hr_out_clk_oreg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val = "ereg_tieoff_val_low";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__mode = "power_down_mode"; 
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena = "nceout_ereg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena = "naclr_ereg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena = "nsclr_ereg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel = "ereg_nclr_sel";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena = "hr_out_clk_ereg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena = "fr_out_clk_ereg_dis";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp = "hr_reg_sel";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val = "ereg_sclr_val_low";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel = "sel0";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel = "outdly_0";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel = "outdly_0";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel = "dly_setting_0";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel = "buffer_input";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug = "jtag_debug_off";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel = "jtag_din_sel";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel = "non_bypass";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel = "in_buf";
localparam ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel = "non_bypass";
localparam ioereg_top_5___ioereg_pnr_x2__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_5___ioereg_pnr_x2__a_sync_control = "sync_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__a_power_down_0 = "power_on_0";
localparam ioereg_top_5___ioereg_pnr_x2__a_power_down_1 = "power_on_1";
localparam ioereg_top_5___ioereg_pnr_x2__a_power_down_2 = "power_on_2";
localparam ioereg_top_5___ioereg_pnr_x2__a_power_down = "power_on";
localparam ioereg_top_5___ioereg_pnr_x2__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_5___ioereg_pnr_x2__a_lock_speed = 3'd7;
localparam ioereg_top_5___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_5___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential = "gpio_single_ended";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_pin_usage = "pin_cmd_address"; 
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_out = "out_rate_full"; 
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_mode_rate_in = "in_rate_full"; 
localparam [9:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_wl_latency = 10'd0; 
localparam [11:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_ck_cmd = 12'd0; 
localparam [11:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_dqss = 12'd0; 
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_time_core_to_codin = 13'd0; 
localparam [11:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_struct_gate_delay = 12'd0; 
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_add_phy_delay = 13'd0; 
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_dq_wl_remainder = 13'd0; 
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_dq_min_output_phase = 13'd0; 
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_cmd_min_output_phase = 13'd0; 
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n = "test_hr_clk_disable";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n = "test_fr_clk_disable";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n = "test_updtdr_en_disable";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n = "test_jtag_clk_disable";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n = "test_global_clk_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n = "test_interp_clk_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n = "test_int_clk_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n = "test_clk_ph_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n = "test_datovr_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_test_iocsr = "test_sync_data_enabled";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n = "test_xpr_clk_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term = "idle_term_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp = "bypass_mcp_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode = "phy_clk_0";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_power_down = "power_on";
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_ddr2_oeb = "ddr3_preamble";
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_dpa_edge_mode = "track_both_edge";
localparam [2:0] ioereg_top_5___ioereg_pnr_x2__write_path__a_lock_speed = 3'd7;
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0 = "ddr_sel_0";
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1 = "ddr_sel_1";
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_gpio_differential = "pin0_gpio_single_ended";
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_output_phase = 13'd0;
localparam ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_gpio_differential = "pin1_gpio_single_ended";
localparam [12:0] ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_output_phase = 13'd0;
localparam ioereg_top_5___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable = "dpa_disabled";
localparam ioereg_top_5___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0 = "gpio_sel_0";
localparam ioereg_top_5___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1 = "gpio_sel_1";
localparam xio_dll_top__powermode_dc = "powerup"; 
localparam xio_dll_top__dll_func_mode = "dll_basic"; 
localparam xio_dll_top__powermode_ac = "ac_dll"; 
localparam xio_dll_top__xio_dll_pnr__powerdown_mode = "powerup"; 
localparam xio_dll_top__xio_dll_pnr__a_rb_ndllrst_prgmnvrt = "off";
localparam xio_dll_top__xio_dll_pnr__a_rb_core_up_prgmnvrt = "off";
localparam xio_dll_top__xio_dll_pnr__a_rb_core_dn_prgmnvrt = "off";
localparam [9:0] xio_dll_top__xio_dll_pnr__a_rb_ctl_static = dll_ctl_static;
localparam xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel0 = "pvt_gry_0";
localparam xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel1 = "pvt_gry_1";
localparam xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel2 = "pvt_gry_2";
localparam xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel3 = "pvt_gry_3";
localparam xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel4 = "pvt_gry_4";
localparam xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel5 = "pvt_gry_5";
localparam xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel6 = "pvt_gry_6";
localparam xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel7 = "pvt_gry_7";
localparam xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel8 = "pvt_gry_8";
localparam xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel9 = "pvt_gry_9";
localparam xio_dll_top__xio_dll_pnr__a_rb_test_clk_pll_en_n = "test_clk_pll_en";
localparam [1:0] xio_dll_top__xio_dll_pnr__a_rb_new_dll = 2'd0;
localparam io_ioereg_custom_0__xio_nand_x64_delay_line_0__a_delay_step = "delay_0";
localparam io_ioereg_custom_0__xio_nand_x64_delay_line_1__a_delay_step = "delay_0";
localparam io_ioereg_custom_1__xio_nand_x64_delay_line_0__a_delay_step = "delay_0";
localparam io_ioereg_custom_1__xio_nand_x64_delay_line_1__a_delay_step = "delay_0";
localparam io_ioereg_custom_2__xio_nand_x64_delay_line_0__a_delay_step = "delay_0";
localparam io_ioereg_custom_2__xio_nand_x64_delay_line_1__a_delay_step = "delay_0";
localparam io_ioereg_custom_3__xio_nand_x64_delay_line_0__a_delay_step = "delay_0";
localparam io_ioereg_custom_3__xio_nand_x64_delay_line_1__a_delay_step = "delay_0";
localparam io_ioereg_custom_4__xio_nand_x64_delay_line_0__a_delay_step = "delay_0";
localparam io_ioereg_custom_4__xio_nand_x64_delay_line_1__a_delay_step = "delay_0";
localparam io_ioereg_custom_5__xio_nand_x64_delay_line_0__a_delay_step = "delay_0";
localparam io_ioereg_custom_5__xio_nand_x64_delay_line_1__a_delay_step = "delay_0";
localparam xio_dqs_custom__xio_nand_x128_delay_line_a__a_delay_step = "delay_0";
localparam xio_dqs_custom__xio_nand_x128_delay_line_b__a_delay_step = "delay_0";
localparam ioereg_struct_0_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_0_0__a_rb_gpio_or_ddr_sel = "gpio_sel";
localparam ioereg_struct_0_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_0_1__a_rb_gpio_or_ddr_sel = "gpio_sel";
localparam ioereg_struct_1_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_1_0__a_rb_gpio_or_ddr_sel = "gpio_sel";
localparam ioereg_struct_1_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_1_1__a_rb_gpio_or_ddr_sel = "gpio_sel";
localparam ioereg_struct_2_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_2_0__a_rb_gpio_or_ddr_sel = "gpio_sel";
localparam ioereg_struct_2_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_2_1__a_rb_gpio_or_ddr_sel = "gpio_sel";
localparam ioereg_struct_3_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_3_0__a_rb_gpio_or_ddr_sel = "gpio_sel";
localparam ioereg_struct_3_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_3_1__a_rb_gpio_or_ddr_sel = "gpio_sel";
localparam ioereg_struct_4_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_4_0__a_rb_gpio_or_ddr_sel = "gpio_sel";
localparam ioereg_struct_4_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_4_1__a_rb_gpio_or_ddr_sel = "gpio_sel";
localparam ioereg_struct_5_0__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_5_0__a_rb_gpio_or_ddr_sel = "gpio_sel";
localparam ioereg_struct_5_1__a_dq_in_select = "dq_sstl_in";
localparam ioereg_struct_5_1__a_rb_gpio_or_ddr_sel = "gpio_sel";

 initial
 begin
     #6 force frzreg=1'b0;
     #112 force frzreg=1'b1;
     #115 force frzreg=1'b0;
     
 end


initial
begin

/* EE */
force csr_en = 1'b0;
force csr_shift_n = 1'b0;  

    case (ioserdesdpa_0__dpa_top__dpa_loopback2_en)
        "dpa_loopback2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_loopback2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_fifolock_en)
        "dpa_fifolock_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_fifolock_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_pd_edge_sel)
        "dpa_pd_edge_sel_both" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_pd_edge_sel_rising" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_test_1_src)
        "dpa_test_1_src_data" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_1_src_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_dpa_lose_locken)
        "dpa_dpa_nrm" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dpa_lose_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rx_dly)
        "dpa_rx_dly_0ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_50ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_rx_dly_100ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_150ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt9_en)
        "dpa_rienopt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt10_en)
        "dpa_rienopt10_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt10_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt11_en)
        "dpa_rienopt11_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt11_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt0_en)
        "dpa_dz_data_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_phase_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt1_en)
        "dpa_dz_slow_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_fast_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt2_en)
        "dpa_rienopt2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt3_en)
        "dpa_rienopt3_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt3_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt4_en)
        "dpa_rienopt4_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt4_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt5_en)
        "dpa_rienopt5_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt5_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt6_en)
        "dpa_rienopt6_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt6_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt7_en)
        "dpa_rienopt7_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt7_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt8_en)
        "dpa_rienopt8_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt8_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rienopt12_en)
        "dpa_rienopt12_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt12_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rdg_dzdsoff_en)
        "dpa_dz_pd_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_pd_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rdg_dzden_en)
        "dpa_dz_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_dz_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rdpaswitch_rs_en)
        "dpa_test_eng_opt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_eng_opt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rcount64_en)
        "dpa_rcount64_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rcount64_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_lock_new)
        "old_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "new_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_up_ph_enhance)
        "dis_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_switch_enhance)
        "dis_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_dft_crnt_clk)
        "dis_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__loopback2_in_dir)
        "lb2_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb2_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dpa_rst_ext_enhance)
        "dis_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__dpa_top__dz_lock_sync_enhance)
        "dis_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__loopback2b_l2r_en)
        "lp2b_l2r_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_l2r_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__loopback2b_r2l_en)
        "lp2b_r2l_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_r2l_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__loopback13_in_dir)
        "lb13_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb13_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__clock_source__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_off_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_off_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_misc" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_off" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__clock_source__clk_gen__serdes_factor)
        "factor3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__clock_source__clk_gen__clk_factor)
        "odd_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "even_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__clock_source__clk_gen__ldgenfast)
        "ldgenfast_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "ldgenfast_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__serdes__serdes_function)
        "ser_txdat" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ser_txdat_neg" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "des" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "loopback_user" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__serdes__dpa_tx_dpaclk_en)
        "dpa_tx_dpaclk_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_tx_dpaclk_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__serdes__loopback2_setting)
        "lp2_disable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__bslip__bslip_config)
        "bslip_0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_2" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_11" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__bslip__loopback1_enable)
        "loopback1_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback1_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_0__serdes_top__bslip__bslip_function)
        "dpa_mode_fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_mode_cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "non_dpa_mode_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "non_dpa_mode_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_0__testout_mux__test_enable)
        "test_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_0__testout_mux__test_bitslipmax_enable)
        "test_bs_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_bs_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_0__testout_mux__test_lock_enable)
        "test_lk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_lk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_0__testout_mux__test_pclk)
        "test_pclk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_pclk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_0__rst_ctrl_sync__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_0.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_loopback2_en)
        "dpa_loopback2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_loopback2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_fifolock_en)
        "dpa_fifolock_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_fifolock_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_pd_edge_sel)
        "dpa_pd_edge_sel_both" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_pd_edge_sel_rising" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_test_1_src)
        "dpa_test_1_src_data" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_1_src_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_dpa_lose_locken)
        "dpa_dpa_nrm" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dpa_lose_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rx_dly)
        "dpa_rx_dly_0ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_50ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_rx_dly_100ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_150ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt9_en)
        "dpa_rienopt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt10_en)
        "dpa_rienopt10_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt10_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt11_en)
        "dpa_rienopt11_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt11_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt0_en)
        "dpa_dz_data_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_phase_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt1_en)
        "dpa_dz_slow_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_fast_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt2_en)
        "dpa_rienopt2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt3_en)
        "dpa_rienopt3_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt3_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt4_en)
        "dpa_rienopt4_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt4_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt5_en)
        "dpa_rienopt5_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt5_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt6_en)
        "dpa_rienopt6_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt6_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt7_en)
        "dpa_rienopt7_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt7_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt8_en)
        "dpa_rienopt8_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt8_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rienopt12_en)
        "dpa_rienopt12_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt12_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rdg_dzdsoff_en)
        "dpa_dz_pd_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_pd_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rdg_dzden_en)
        "dpa_dz_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_dz_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rdpaswitch_rs_en)
        "dpa_test_eng_opt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_eng_opt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rcount64_en)
        "dpa_rcount64_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rcount64_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_lock_new)
        "old_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "new_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_up_ph_enhance)
        "dis_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_switch_enhance)
        "dis_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_dft_crnt_clk)
        "dis_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__loopback2_in_dir)
        "lb2_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb2_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dpa_rst_ext_enhance)
        "dis_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__dpa_top__dz_lock_sync_enhance)
        "dis_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__loopback2b_l2r_en)
        "lp2b_l2r_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_l2r_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__loopback2b_r2l_en)
        "lp2b_r2l_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_r2l_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__loopback13_in_dir)
        "lb13_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb13_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__clock_source__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_off_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_off_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_misc" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_off" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__clock_source__clk_gen__serdes_factor)
        "factor3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__clock_source__clk_gen__clk_factor)
        "odd_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "even_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__clock_source__clk_gen__ldgenfast)
        "ldgenfast_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "ldgenfast_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__serdes__serdes_function)
        "ser_txdat" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ser_txdat_neg" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "des" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "loopback_user" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__serdes__dpa_tx_dpaclk_en)
        "dpa_tx_dpaclk_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_tx_dpaclk_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__serdes__loopback2_setting)
        "lp2_disable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__bslip__bslip_config)
        "bslip_0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_2" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_11" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__bslip__loopback1_enable)
        "loopback1_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback1_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_1__serdes_top__bslip__bslip_function)
        "dpa_mode_fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_mode_cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "non_dpa_mode_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "non_dpa_mode_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_1__testout_mux__test_enable)
        "test_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_1__testout_mux__test_bitslipmax_enable)
        "test_bs_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_bs_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_1__testout_mux__test_lock_enable)
        "test_lk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_lk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_1__testout_mux__test_pclk)
        "test_pclk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_pclk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_1__rst_ctrl_sync__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_1.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_loopback2_en)
        "dpa_loopback2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_loopback2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_fifolock_en)
        "dpa_fifolock_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_fifolock_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_pd_edge_sel)
        "dpa_pd_edge_sel_both" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_pd_edge_sel_rising" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_test_1_src)
        "dpa_test_1_src_data" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_1_src_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_dpa_lose_locken)
        "dpa_dpa_nrm" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dpa_lose_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rx_dly)
        "dpa_rx_dly_0ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_50ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_rx_dly_100ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_150ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt9_en)
        "dpa_rienopt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt10_en)
        "dpa_rienopt10_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt10_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt11_en)
        "dpa_rienopt11_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt11_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt0_en)
        "dpa_dz_data_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_phase_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt1_en)
        "dpa_dz_slow_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_fast_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt2_en)
        "dpa_rienopt2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt3_en)
        "dpa_rienopt3_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt3_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt4_en)
        "dpa_rienopt4_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt4_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt5_en)
        "dpa_rienopt5_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt5_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt6_en)
        "dpa_rienopt6_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt6_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt7_en)
        "dpa_rienopt7_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt7_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt8_en)
        "dpa_rienopt8_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt8_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rienopt12_en)
        "dpa_rienopt12_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt12_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rdg_dzdsoff_en)
        "dpa_dz_pd_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_pd_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rdg_dzden_en)
        "dpa_dz_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_dz_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rdpaswitch_rs_en)
        "dpa_test_eng_opt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_eng_opt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rcount64_en)
        "dpa_rcount64_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rcount64_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_lock_new)
        "old_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "new_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_up_ph_enhance)
        "dis_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_switch_enhance)
        "dis_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_dft_crnt_clk)
        "dis_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__loopback2_in_dir)
        "lb2_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb2_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dpa_rst_ext_enhance)
        "dis_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__dpa_top__dz_lock_sync_enhance)
        "dis_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__loopback2b_l2r_en)
        "lp2b_l2r_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_l2r_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__loopback2b_r2l_en)
        "lp2b_r2l_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_r2l_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__loopback13_in_dir)
        "lb13_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb13_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__clock_source__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_off_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_off_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_misc" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_off" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__clock_source__clk_gen__serdes_factor)
        "factor3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__clock_source__clk_gen__clk_factor)
        "odd_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "even_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__clock_source__clk_gen__ldgenfast)
        "ldgenfast_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "ldgenfast_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__serdes__serdes_function)
        "ser_txdat" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ser_txdat_neg" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "des" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "loopback_user" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__serdes__dpa_tx_dpaclk_en)
        "dpa_tx_dpaclk_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_tx_dpaclk_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__serdes__loopback2_setting)
        "lp2_disable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__bslip__bslip_config)
        "bslip_0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_2" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_11" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__bslip__loopback1_enable)
        "loopback1_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback1_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_2__serdes_top__bslip__bslip_function)
        "dpa_mode_fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_mode_cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "non_dpa_mode_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "non_dpa_mode_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_2__testout_mux__test_enable)
        "test_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_2__testout_mux__test_bitslipmax_enable)
        "test_bs_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_bs_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_2__testout_mux__test_lock_enable)
        "test_lk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_lk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_2__testout_mux__test_pclk)
        "test_pclk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_pclk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_2__rst_ctrl_sync__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_2.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_loopback2_en)
        "dpa_loopback2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_loopback2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_fifolock_en)
        "dpa_fifolock_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_fifolock_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_pd_edge_sel)
        "dpa_pd_edge_sel_both" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_pd_edge_sel_rising" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_test_1_src)
        "dpa_test_1_src_data" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_1_src_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_dpa_lose_locken)
        "dpa_dpa_nrm" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dpa_lose_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rx_dly)
        "dpa_rx_dly_0ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_50ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_rx_dly_100ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_150ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt9_en)
        "dpa_rienopt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt10_en)
        "dpa_rienopt10_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt10_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt11_en)
        "dpa_rienopt11_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt11_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt0_en)
        "dpa_dz_data_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_phase_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt1_en)
        "dpa_dz_slow_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_fast_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt2_en)
        "dpa_rienopt2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt3_en)
        "dpa_rienopt3_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt3_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt4_en)
        "dpa_rienopt4_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt4_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt5_en)
        "dpa_rienopt5_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt5_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt6_en)
        "dpa_rienopt6_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt6_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt7_en)
        "dpa_rienopt7_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt7_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt8_en)
        "dpa_rienopt8_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt8_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rienopt12_en)
        "dpa_rienopt12_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt12_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rdg_dzdsoff_en)
        "dpa_dz_pd_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_pd_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rdg_dzden_en)
        "dpa_dz_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_dz_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rdpaswitch_rs_en)
        "dpa_test_eng_opt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_eng_opt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rcount64_en)
        "dpa_rcount64_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rcount64_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_lock_new)
        "old_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "new_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_up_ph_enhance)
        "dis_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_switch_enhance)
        "dis_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_dft_crnt_clk)
        "dis_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__loopback2_in_dir)
        "lb2_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb2_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dpa_rst_ext_enhance)
        "dis_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__dpa_top__dz_lock_sync_enhance)
        "dis_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__loopback2b_l2r_en)
        "lp2b_l2r_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_l2r_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__loopback2b_r2l_en)
        "lp2b_r2l_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_r2l_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__loopback13_in_dir)
        "lb13_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb13_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__clock_source__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_off_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_off_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_misc" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_off" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__clock_source__clk_gen__serdes_factor)
        "factor3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__clock_source__clk_gen__clk_factor)
        "odd_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "even_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__clock_source__clk_gen__ldgenfast)
        "ldgenfast_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "ldgenfast_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__serdes__serdes_function)
        "ser_txdat" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ser_txdat_neg" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "des" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "loopback_user" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__serdes__dpa_tx_dpaclk_en)
        "dpa_tx_dpaclk_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_tx_dpaclk_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__serdes__loopback2_setting)
        "lp2_disable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__bslip__bslip_config)
        "bslip_0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_2" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_11" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__bslip__loopback1_enable)
        "loopback1_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback1_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_3__serdes_top__bslip__bslip_function)
        "dpa_mode_fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_mode_cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "non_dpa_mode_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "non_dpa_mode_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_3__testout_mux__test_enable)
        "test_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_3__testout_mux__test_bitslipmax_enable)
        "test_bs_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_bs_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_3__testout_mux__test_lock_enable)
        "test_lk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_lk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_3__testout_mux__test_pclk)
        "test_pclk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_pclk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_3__rst_ctrl_sync__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_3.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_loopback2_en)
        "dpa_loopback2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_loopback2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_fifolock_en)
        "dpa_fifolock_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_fifolock_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_pd_edge_sel)
        "dpa_pd_edge_sel_both" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_pd_edge_sel_rising" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_test_1_src)
        "dpa_test_1_src_data" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_1_src_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_dpa_lose_locken)
        "dpa_dpa_nrm" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dpa_lose_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rx_dly)
        "dpa_rx_dly_0ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_50ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_rx_dly_100ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_150ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt9_en)
        "dpa_rienopt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt10_en)
        "dpa_rienopt10_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt10_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt11_en)
        "dpa_rienopt11_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt11_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt0_en)
        "dpa_dz_data_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_phase_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt1_en)
        "dpa_dz_slow_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_fast_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt2_en)
        "dpa_rienopt2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt3_en)
        "dpa_rienopt3_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt3_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt4_en)
        "dpa_rienopt4_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt4_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt5_en)
        "dpa_rienopt5_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt5_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt6_en)
        "dpa_rienopt6_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt6_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt7_en)
        "dpa_rienopt7_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt7_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt8_en)
        "dpa_rienopt8_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt8_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rienopt12_en)
        "dpa_rienopt12_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt12_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rdg_dzdsoff_en)
        "dpa_dz_pd_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_pd_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rdg_dzden_en)
        "dpa_dz_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_dz_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rdpaswitch_rs_en)
        "dpa_test_eng_opt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_eng_opt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rcount64_en)
        "dpa_rcount64_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rcount64_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_lock_new)
        "old_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "new_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_up_ph_enhance)
        "dis_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_switch_enhance)
        "dis_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_dft_crnt_clk)
        "dis_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__loopback2_in_dir)
        "lb2_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb2_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dpa_rst_ext_enhance)
        "dis_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__dpa_top__dz_lock_sync_enhance)
        "dis_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__loopback2b_l2r_en)
        "lp2b_l2r_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_l2r_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__loopback2b_r2l_en)
        "lp2b_r2l_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_r2l_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__loopback13_in_dir)
        "lb13_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb13_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__clock_source__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_off_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_off_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_misc" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_off" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__clock_source__clk_gen__serdes_factor)
        "factor3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__clock_source__clk_gen__clk_factor)
        "odd_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "even_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__clock_source__clk_gen__ldgenfast)
        "ldgenfast_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "ldgenfast_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__serdes__serdes_function)
        "ser_txdat" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ser_txdat_neg" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "des" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "loopback_user" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__serdes__dpa_tx_dpaclk_en)
        "dpa_tx_dpaclk_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_tx_dpaclk_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__serdes__loopback2_setting)
        "lp2_disable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__bslip__bslip_config)
        "bslip_0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_2" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_11" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__bslip__loopback1_enable)
        "loopback1_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback1_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_4__serdes_top__bslip__bslip_function)
        "dpa_mode_fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_mode_cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "non_dpa_mode_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "non_dpa_mode_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_4__testout_mux__test_enable)
        "test_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_4__testout_mux__test_bitslipmax_enable)
        "test_bs_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_bs_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_4__testout_mux__test_lock_enable)
        "test_lk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_lk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_4__testout_mux__test_pclk)
        "test_pclk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_pclk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_4__rst_ctrl_sync__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_4.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_loopback2_en)
        "dpa_loopback2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_loopback2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_fifolock_en)
        "dpa_fifolock_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_fifolock_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_pd_edge_sel)
        "dpa_pd_edge_sel_both" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_pd_edge_sel_rising" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_test_1_src)
        "dpa_test_1_src_data" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_1_src_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_dpa_lose_locken)
        "dpa_dpa_nrm" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dpa_lose_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rx_dly)
        "dpa_rx_dly_0ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_50ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_rx_dly_100ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rx_dly_150ps" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt9_en)
        "dpa_rienopt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt10_en)
        "dpa_rienopt10_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt10_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt11_en)
        "dpa_rienopt11_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt11_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt0_en)
        "dpa_dz_data_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_phase_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt1_en)
        "dpa_dz_slow_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_fast_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt2_en)
        "dpa_rienopt2_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt2_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt3_en)
        "dpa_rienopt3_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt3_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt4_en)
        "dpa_rienopt4_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt4_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt5_en)
        "dpa_rienopt5_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt5_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt6_en)
        "dpa_rienopt6_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt6_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt7_en)
        "dpa_rienopt7_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt7_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt8_en)
        "dpa_rienopt8_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt8_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rienopt12_en)
        "dpa_rienopt12_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rienopt12_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rdg_dzdsoff_en)
        "dpa_dz_pd_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_dz_pd_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rdg_dzden_en)
        "dpa_dz_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dpa_dz_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rdpaswitch_rs_en)
        "dpa_test_eng_opt9_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_test_eng_opt9_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rcount64_en)
        "dpa_rcount64_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_rcount64_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_lock_new)
        "old_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "new_lock" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_up_ph_enhance)
        "dis_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_up_ph_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_switch_enhance)
        "dis_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_switch_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_dft_crnt_clk)
        "dis_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dft_crnt_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__loopback2_in_dir)
        "lb2_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb2_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dpa_rst_ext_enhance)
        "dis_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_rst_ext_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__dpa_top__dz_lock_sync_enhance)
        "dis_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "en_dz_lock_sync_enhance" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__loopback2b_l2r_en)
        "lp2b_l2r_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_l2r_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__loopback2b_r2l_en)
        "lp2b_r2l_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2b_r2l_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__loopback13_in_dir)
        "lb13_in_left" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lb13_in_right" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__clock_source__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "cdr_off_pll0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_off_pll1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_misc" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "other_off" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cdr_dpa_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__clock_source__clk_gen__serdes_factor)
        "factor3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "factor8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "factor10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__clock_source__clk_gen__clk_factor)
        "odd_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "even_clk" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__clock_source__clk_gen__ldgenfast)
        "ldgenfast_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "ldgenfast_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__serdes__serdes_function)
        "ser_txdat" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ser_txdat_neg" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "des" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "txclk_out_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "loopback_user" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback_test" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__serdes__dpa_tx_dpaclk_en)
        "dpa_tx_dpaclk_disabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_tx_dpaclk_enabled" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__serdes__loopback2_setting)
        "lp2_disable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lp2_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__bslip__bslip_config)
        "bslip_0" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_1" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_2" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_3" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_4" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_5" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_6" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_7" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_8" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_9" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bslip_10" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bslip_11" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__bslip__loopback1_enable)
        "loopback1_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "loopback1_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_5__serdes_top__bslip__bslip_function)
        "dpa_mode_fifo" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_mode_cdr" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "non_dpa_mode_pos_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "non_dpa_mode_neg_ph" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_5__testout_mux__test_enable)
        "test_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_5__testout_mux__test_bitslipmax_enable)
        "test_bs_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_bs_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_5__testout_mux__test_lock_enable)
        "test_lk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "test_lk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioserdesdpa_5__testout_mux__test_pclk)
        "test_pclk_dis" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_pclk_en" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioserdesdpa_5__rst_ctrl_sync__mode)
        "off_mode" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enable" : begin 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioserdesdpa_5.iocsr_top.xcsr_reg.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_0__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[202].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[202].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_1__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[203].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[203].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_2__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[204].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[204].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_3__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_4__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_5__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_6__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_7__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_8__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_9__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[211].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[211].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_10__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_wr_datapath_mod)
        "wr_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_oe_datapath_mod)
        "oe_datapath_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_prbs)
        "not_sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[212].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[212].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_wdb_bypass)
        "wdb_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wdb_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_rb_data_alignment_mode)
        "align_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__rdwr_buffer_inst_11__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[132].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[132].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[213].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[213].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[252].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[252].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[281].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[281].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_0__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[253].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[253].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[282].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[282].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_1__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[254].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[254].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[283].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[283].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_2__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[255].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[255].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[284].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[284].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_3__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[112].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[112].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[285].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[285].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_rb_preamble_mode)
        "preamble_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[246].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "preamble_two_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[246].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_4__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[256].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[256].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[113].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[113].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[286].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[286].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_rb_preamble_mode)
        "preamble_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[246].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "preamble_two_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[246].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_5__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[257].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[257].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[114].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[114].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[258].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[258].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[287].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[287].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_6__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[139].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[139].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[220].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[220].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[259].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[259].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[288].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[288].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_7__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[140].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[140].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[221].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[221].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[289].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[289].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_rb_preamble_mode)
        "preamble_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[246].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "preamble_two_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[246].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_8__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[260].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[260].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[141].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[141].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[222].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[222].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[290].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[290].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_rb_preamble_mode)
        "preamble_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[246].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "preamble_two_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[246].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_9__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[261].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[261].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[223].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[223].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[262].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[262].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[291].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[291].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_10__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_wr_datapath_prgmnvrt)
        "wr_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "wr_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_oe_datapath_prgmnvrt)
        "oe_datapath_non_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_datapath_invert" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_db_out_bypass)
        "db_out_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_out_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_db_oe_bypass)
        "db_oe_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[224].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_oe_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[224].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_rb_sel_ac_hmc_ena)
        "sel_ac_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[263].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_ac_hmc_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[263].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_ac_dqs_dm_dq)
        "dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_rb_gpio)
        "gpio_false" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[292].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_true" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[292].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_dbc_sel)
        "sel_core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_dbc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_out_if_inst__io_data_buffer_out_mux_inst_11__a_rb_qr_or_hr)
        "hr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "qr" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_rdata_valid_inst__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_rwlat_mode)
        "csr_vlu" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[230].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "avl_vlu" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[230].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[236].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_wlat_vlu[5:5]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[235].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_wlat_vlu[4:4]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[234].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_wlat_vlu[3:3]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[233].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_wlat_vlu[2:2]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[232].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_wlat_vlu[1:1]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[231].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_wlat_vlu[0:0]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[242].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_rlat_vlu[5:5]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[241].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_rlat_vlu[4:4]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[240].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_rlat_vlu[3:3]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[239].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_rlat_vlu[2:2]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[238].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_rlat_vlu[1:1]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[237].csr_reg_bit.csr_ns_reg.dout = data_buffer__io_data_buffer_wlat_rlat_avl_ovrd_inst__a_rb_afi_rlat_vlu[0:0]; 
    case (data_buffer__data_buffer_clk_gen_inst__a_rb_phy_clk0_ena)
        "phy_clk0_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[249].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "phy_clk0_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[249].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_clk_gen_inst__a_rb_phy_clk1_ena)
        "phy_clk1_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[250].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "phy_clk1_ena" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[250].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_clk_gen_inst__a_rb_sel_core_clk)
        "phy_clk0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[264].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "phy_clk1" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[264].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__data_buffer_clk_gen_inst__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = data_buffer__avl_lane_inst__a_rb_tile_id[8:8]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = data_buffer__avl_lane_inst__a_rb_tile_id[7:7]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[159].csr_reg_bit.csr_ns_reg.dout = data_buffer__avl_lane_inst__a_rb_tile_id[6:6]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[158].csr_reg_bit.csr_ns_reg.dout = data_buffer__avl_lane_inst__a_rb_tile_id[5:5]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[157].csr_reg_bit.csr_ns_reg.dout = data_buffer__avl_lane_inst__a_rb_tile_id[4:4]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = data_buffer__avl_lane_inst__a_rb_tile_id[3:3]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = data_buffer__avl_lane_inst__a_rb_tile_id[2:2]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = data_buffer__avl_lane_inst__a_rb_tile_id[1:1]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = data_buffer__avl_lane_inst__a_rb_tile_id[0:0]; 
    case (data_buffer__avl_lane_inst__a_rb_bc_id_ena)
        "bc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__avl_lane_inst__a_rb_avl_ena)
        "avl_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "avl_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__avl_lane_inst__a_rb_tdf_gate_off)
        "gate_off" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[296].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "not_gate_off" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[296].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_ptr_pipeline_inst__a_rb_ptr_pipeline)
        "ptr_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[245].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[244].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[243].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ptr_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[245].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[244].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[243].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "ptr_two_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[245].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[244].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[243].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ptr_three_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[245].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[244].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[243].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "ptr_four_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[245].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[244].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[243].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (data_buffer__io_data_buffer_ptr_pipeline_inst__a_rb_seq_rd_en_full_pipeline)
        "rd_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[295].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[294].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[293].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "rd_two_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[295].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[294].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[293].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "rd_three_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[295].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[294].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[293].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "rd_four_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[295].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[294].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[293].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "rd_five_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[295].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[294].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[293].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (data_buffer__io_data_buffer_wdb_rdb_map_inst__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_0__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_0__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_0__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_1__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_1__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[121].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[121].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_1__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_2__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_2__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[122].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[122].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_2__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_3__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_3__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[123].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[123].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_3__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_4__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_4__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_4__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_5__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_5__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_5__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_6__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_6__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_6__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_7__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_7__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_7__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_8__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_8__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_8__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_9__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_9__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_9__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_10__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_10__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[130].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[130].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_10__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_11__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_11__a_db_in_bypass)
        "db_in_not_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[131].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "db_in_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[131].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_data2core_inst_11__a_rb_db2core_registered)
        "not_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_rdata_en_mrnk_sel_inst__a_rb_hmc_or_core)
        "core" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hmc" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_rdata_en_mrnk_sel_inst__a_rb_rdata_en_full_registered)
        "rdata_en_full_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[278].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "rdata_en_full_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[278].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_rdata_en_mrnk_sel_inst__a_rb_mrnk_read_registered)
        "mrnk_read_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[279].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mrnk_read_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[279].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_rdata_en_mrnk_sel_inst__a_rb_mrnk_write_registered)
        "mrnk_write_bypass" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[280].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mrnk_write_registered" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[280].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_rdata_en_mrnk_sel_inst__a_rb_dft_prbs_mode)
        "oe_0_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_1_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_1_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_prbs_dq_0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_prbs_dq_prbs" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "oe_0_dq_01" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oe_0_dq_10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_rb_dbi_sel)
        "dbi_dq0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dbi_dq1" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dbi_dq2" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dbi_dq3" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dbi_dq4" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dbi_dq5" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dbi_dq6" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dbi_dq7" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dbi_dq8" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dbi_dq9" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dbi_dq10" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dbi_dq11" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_rb_dbi_wr_en)
        "dbi_wr_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[149].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dbi_wr_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[149].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_rb_dbi_rd_en)
        "dbi_rd_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[268].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dbi_rd_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[268].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_0)
        "pin0_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_1)
        "pin1_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_2)
        "pin2_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin2_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin2_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin2_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_3)
        "pin3_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin3_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin3_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin3_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_4)
        "pin4_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin4_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin4_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin4_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_5)
        "pin5_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin5_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin5_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin5_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_6)
        "pin6_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin6_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin6_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin6_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_7)
        "pin7_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin7_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin7_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin7_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_8)
        "pin8_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin8_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin8_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin8_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_9)
        "pin9_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin9_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin9_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin9_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_10)
        "pin10_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin10_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin10_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin10_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__dbi_top_inst__a_ac_dqs_dm_dq_11)
        "pin11_dq_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin11_dm_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin11_dqs_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin11_ac_type" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__iodbccmn_dbc_inst__a_rb_preamble_mode)
        "preamble_one_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[246].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "preamble_two_cycle" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[246].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__iodbccmn_dbc_inst__a_rb_burst_length_mode)
        "bl8" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[277].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[276].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bl4" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[277].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[276].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "bl2" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[277].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[276].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bl_reserved" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[277].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[276].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[275].csr_reg_bit.csr_ns_reg.dout = data_buffer__iodbccmn_dbc_inst__a_rb_dbc_wb_reserved_entry[6:6]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[274].csr_reg_bit.csr_ns_reg.dout = data_buffer__iodbccmn_dbc_inst__a_rb_dbc_wb_reserved_entry[5:5]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[273].csr_reg_bit.csr_ns_reg.dout = data_buffer__iodbccmn_dbc_inst__a_rb_dbc_wb_reserved_entry[4:4]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[272].csr_reg_bit.csr_ns_reg.dout = data_buffer__iodbccmn_dbc_inst__a_rb_dbc_wb_reserved_entry[3:3]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[271].csr_reg_bit.csr_ns_reg.dout = data_buffer__iodbccmn_dbc_inst__a_rb_dbc_wb_reserved_entry[2:2]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[270].csr_reg_bit.csr_ns_reg.dout = data_buffer__iodbccmn_dbc_inst__a_rb_dbc_wb_reserved_entry[1:1]; 
    force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[269].csr_reg_bit.csr_ns_reg.dout = data_buffer__iodbccmn_dbc_inst__a_rb_dbc_wb_reserved_entry[0:0]; 
    case (data_buffer__iodbccmn_dbc_inst__a_rb_dft_speed_test)
        "sel_speed_test_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_test_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[267].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__iodbccmn_dbc_inst__a_rb_dft_hmc_phy)
        "lbk_hmc_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_hmc_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__iodbccmn_dbc_inst__a_rb_tdf_gate_off)
        "gate_off" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[296].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "not_gate_off" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[296].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__iodbccmn_dbc_inst__a_rb_disable_mrnk_write)
        "mrnk_write_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[297].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mrnk_write_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[297].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__reset_lane__a_rb_reset_auto_release)
        "avl_release" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[247].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "auto_release" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[247].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_dft_inst__a_rb_dft_lbk_phy)
        "lbk_phy_disable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "lbk_phy_enable" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_dft_inst__a_rb_dft_mux_speed_in)
        "sel_speed_in0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[265].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_in1" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[265].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (data_buffer__io_data_buffer_dft_inst__a_rb_dft_mux_speed_out)
        "sel_speed_out0" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[266].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel_speed_out1" : begin 
            force u_io_12_lane_bcm.data_buffer.data_buffer_cnfg_inst.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[266].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__a_sync_control)
        "sync_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sync_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__a_power_down_0)
        "power_on_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__a_power_down_1)
        "power_on_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__a_power_down_2)
        "power_on_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__a_power_down)
        "power_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__a_lock_speed[0:0]; 
    case (ioereg_top_0___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[0:0]; 
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[0:0]; 
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n)
        "test_global_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_global_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n)
        "test_interp_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_interp_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n)
        "test_int_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_int_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n)
        "test_clk_ph_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_clk_ph_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n)
        "test_datovr_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_datovr_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_test_iocsr)
        "test_sync_data_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_sync_data_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n)
        "test_xpr_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_xpr_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term)
        "idle_term_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "idle_term_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split)
        "dcc_split_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dcc_split_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp)
        "bypass_mcp_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass_mcp_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__ioereg_misc__a_power_down)
        "power_on" : begin 
        end
        "power_off" : begin 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__write_path__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__write_path__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_0___ioereg_pnr_x2__write_path__a_lock_speed[0:0]; 
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode)
        "pin0_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode)
        "pin0_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_octrt)
        "pin0_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_initial_out)
        "pin0_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_gpio_differential)
        "pin0_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_dynoct)
        "pin0_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_mode_ddr)
        "pin0_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin0_dfx_mode)
        "pin0_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode)
        "pin1_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode)
        "pin1_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_octrt)
        "pin1_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_initial_out)
        "pin1_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_gpio_differential)
        "pin1_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_dynoct)
        "pin1_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_mode_ddr)
        "pin1_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__write_path__a_pin1_dfx_mode)
        "pin1_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__read_path_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__read_path_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__read_path_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__read_path_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_0_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
        end
        "ddr_sel_0" : begin 
        end
    endcase
    case (ioereg_top_0___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
        end
        "ddr_sel_1" : begin 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__a_sync_control)
        "sync_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sync_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__a_power_down_0)
        "power_on_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__a_power_down_1)
        "power_on_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__a_power_down_2)
        "power_on_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__a_power_down)
        "power_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__a_lock_speed[0:0]; 
    case (ioereg_top_1___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[0:0]; 
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[0:0]; 
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n)
        "test_global_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_global_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n)
        "test_interp_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_interp_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n)
        "test_int_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_int_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n)
        "test_clk_ph_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_clk_ph_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n)
        "test_datovr_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_datovr_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_test_iocsr)
        "test_sync_data_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_sync_data_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n)
        "test_xpr_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_xpr_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term)
        "idle_term_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "idle_term_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split)
        "dcc_split_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dcc_split_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp)
        "bypass_mcp_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass_mcp_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__ioereg_misc__a_power_down)
        "power_on" : begin 
        end
        "power_off" : begin 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__write_path__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__write_path__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_1___ioereg_pnr_x2__write_path__a_lock_speed[0:0]; 
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode)
        "pin0_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode)
        "pin0_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_octrt)
        "pin0_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_initial_out)
        "pin0_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_gpio_differential)
        "pin0_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_dynoct)
        "pin0_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_mode_ddr)
        "pin0_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin0_dfx_mode)
        "pin0_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode)
        "pin1_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode)
        "pin1_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_octrt)
        "pin1_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_initial_out)
        "pin1_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_gpio_differential)
        "pin1_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_dynoct)
        "pin1_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_mode_ddr)
        "pin1_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__write_path__a_pin1_dfx_mode)
        "pin1_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__read_path_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__read_path_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__read_path_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__read_path_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_1_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
        end
        "ddr_sel_0" : begin 
        end
    endcase
    case (ioereg_top_1___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
        end
        "ddr_sel_1" : begin 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__a_sync_control)
        "sync_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sync_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__a_power_down_0)
        "power_on_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__a_power_down_1)
        "power_on_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__a_power_down_2)
        "power_on_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__a_power_down)
        "power_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__a_lock_speed[0:0]; 
    case (ioereg_top_2___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[0:0]; 
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[0:0]; 
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n)
        "test_global_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_global_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n)
        "test_interp_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_interp_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n)
        "test_int_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_int_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n)
        "test_clk_ph_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_clk_ph_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n)
        "test_datovr_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_datovr_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_test_iocsr)
        "test_sync_data_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_sync_data_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n)
        "test_xpr_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_xpr_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term)
        "idle_term_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "idle_term_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split)
        "dcc_split_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dcc_split_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp)
        "bypass_mcp_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass_mcp_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__ioereg_misc__a_power_down)
        "power_on" : begin 
        end
        "power_off" : begin 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__write_path__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__write_path__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_2___ioereg_pnr_x2__write_path__a_lock_speed[0:0]; 
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode)
        "pin0_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode)
        "pin0_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_octrt)
        "pin0_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_initial_out)
        "pin0_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_gpio_differential)
        "pin0_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_dynoct)
        "pin0_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_mode_ddr)
        "pin0_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin0_dfx_mode)
        "pin0_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode)
        "pin1_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode)
        "pin1_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_octrt)
        "pin1_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_initial_out)
        "pin1_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_gpio_differential)
        "pin1_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_dynoct)
        "pin1_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_mode_ddr)
        "pin1_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__write_path__a_pin1_dfx_mode)
        "pin1_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__read_path_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__read_path_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__read_path_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__read_path_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_2_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
        end
        "ddr_sel_0" : begin 
        end
    endcase
    case (ioereg_top_2___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
        end
        "ddr_sel_1" : begin 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_align)
        "align_c_count" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "align_cpa" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[225].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_en)
        "dqs_gated" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[224].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_pass" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[224].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[223].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_probe_sel[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[222].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_probe_sel[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[221].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_probe_sel[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[220].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_probe_sel[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_0_delay_step)
        "dq0_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq0_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq0_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[210].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[209].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[208].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[207].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[206].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[205].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[204].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_0_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[203].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_0_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[202].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_0_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_1_delay_step)
        "dq1_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq1_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq1_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[219].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[218].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[217].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[216].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[215].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[214].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[213].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_1_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[212].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_1_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[211].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_1_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_2_delay_step)
        "dq2_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq2_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq2_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[201].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[200].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[199].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[198].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[197].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[196].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[195].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_2_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[194].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_2_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[193].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_2_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_3_delay_step)
        "dq3_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq3_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq3_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[192].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[191].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[190].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[189].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[188].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[187].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[186].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_3_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[185].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_3_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[184].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_3_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_4_delay_step)
        "dq4_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq4_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq4_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[183].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[182].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[181].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[180].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[179].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[178].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[177].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_4_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[176].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_4_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[175].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_4_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_5_delay_step)
        "dq5_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq5_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq5_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[174].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[173].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[172].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[171].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[170].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[169].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[168].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_5_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[167].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_5_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[166].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_5_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_6_delay_step)
        "dq6_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq6_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq6_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[165].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[164].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[163].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[162].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[161].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[160].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[159].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_6_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[158].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_6_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[157].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_6_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_7_delay_step)
        "dq7_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq7_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq7_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[156].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[155].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[154].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[153].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[152].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[151].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[150].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_7_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[149].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_7_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[148].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_7_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_8_delay_step)
        "dq8_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq8_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq8_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[147].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[146].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[145].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[144].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[143].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[142].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[141].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_8_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[140].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_8_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[139].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_8_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_9_delay_step)
        "dq9_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq9_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq9_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[138].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[137].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[136].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[135].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[134].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[133].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[132].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_9_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[131].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_9_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[130].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_9_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_10_delay_step)
        "dq10_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq10_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq10_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[129].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[128].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[127].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[126].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[125].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[124].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[123].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_10_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[122].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_10_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[121].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_10_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_11_delay_step)
        "dq11_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq11_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq11_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[120].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[119].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[118].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[117].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[116].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[115].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[114].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_11_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[113].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_11_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[112].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dq_11_delay_fine[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dqs_delay_step)
        "dqs_delay_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_5" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_6" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_7" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_9" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_11" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_12" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_13" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_14" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_15" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_16" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_17" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_18" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_19" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_20" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_21" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_22" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_23" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_24" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_25" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_26" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_27" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_28" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_29" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_30" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_31" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_32" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_33" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_34" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_35" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_36" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_37" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_38" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_39" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_40" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_41" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_42" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_43" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_44" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_45" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_46" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_47" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_48" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_49" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_50" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_51" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_52" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_53" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_54" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_55" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_56" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_57" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_58" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_59" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_60" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_61" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_62" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_63" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_64" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_65" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_66" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_67" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_68" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_69" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_70" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_71" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_72" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_73" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_74" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_75" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_76" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_77" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_78" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_79" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_80" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_81" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_82" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_83" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_84" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_85" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_86" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_87" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_88" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_89" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_90" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_91" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_92" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_93" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_94" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_95" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_96" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_97" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_98" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_99" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_100" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_101" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_102" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_103" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_104" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_105" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_106" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_107" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_108" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_109" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_110" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_111" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_112" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_113" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_114" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_115" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_116" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_117" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_118" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_119" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_120" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_121" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_122" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_123" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_delay_124" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_delay_125" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[111].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[110].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[109].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dqs_delay_fine[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dqs_delay_fine[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_non_pvt_dqs_delay_fine[0:0]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_a[9:9]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_a[8:8]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_a[7:7]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_a[6:6]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_a[5:5]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_a[4:4]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_a[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_a[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_a[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_a[0:0]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_b[9:9]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_b[8:8]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_b[7:7]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_b[6:6]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_b[5:5]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_b[4:4]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_b[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_b[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_b[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_pvt_input_delay_b[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_enable_toggler)
        "preamble_track_dqs_enable" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "preamble_track_toggler" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[12:12]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[11:11]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[10:10]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[9:9]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[8:8]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[7:7]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[6:6]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[5:5]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[4:4]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_b[0:0]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[12:12]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[11:11]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[10:10]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[9:9]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[8:8]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[7:7]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[6:6]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[5:5]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[4:4]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_phase_shift_a[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_phy_clk_mode)
        "phy_clk_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "phy_clk_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_oct_size[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_oct_size[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_oct_size[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_oct_size[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_pack_mode)
        "packed" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "not_packed" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_kicker_size[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_kicker_size[0:0]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_track_speed[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_track_speed[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_track_speed[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_track_speed[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_pst_preamble_mode)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_preamble" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_pst_en_shrink)
        "shrink_0_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shrink_0_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "shrink_1_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shrink_1_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_filter_code)
        "freq_08ghz" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "freq_10ghz" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "freq_12ghz" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "freq_16ghz" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_couple_enable)
        "couple_en" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[231].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "couple_dis" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[231].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_broadcast_enable)
        "disable_broadcast" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "generate_broadcast" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "top_in_broadcast" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bottom_in_broadcast" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rd_valid_delay[6:6]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rd_valid_delay[5:5]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rd_valid_delay[4:4]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rd_valid_delay[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rd_valid_delay[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rd_valid_delay[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rd_valid_delay[0:0]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_enable_delay[5:5]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_enable_delay[4:4]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_enable_delay[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_enable_delay[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_enable_delay[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_dqs_enable_delay[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_burst_length)
        "burst_length_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "burst_length_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "burst_length_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "burst_length_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_vfifo_burst_length)
        "vburst_length_10" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[233].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[232].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "vburst_length_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[233].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[232].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "vburst_length_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[233].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[232].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "vburst_length_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[233].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[232].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_mode_rate_out)
        "out_rate_full" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "out_rate_1_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "out_rate_1_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "out_rate_1_8" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_mode_rate_in)
        "in_rate_full" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "in_rate_1_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_rate_1_4" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_ddr4_search)
        "ddr3_search" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_search" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_count_threshold[6:6]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_count_threshold[5:5]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_count_threshold[4:4]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_count_threshold[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_count_threshold[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_count_threshold[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_count_threshold[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_lock_edge)
        "preamble_lock_rising_edge" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "preamble_lock_falling_edge" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_mrnk_delay)
        "mrnk_short" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[230].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mrnk_long" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[230].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_power_down_0)
        "power_on_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[226].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_power_down_1)
        "power_on_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[227].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_power_down_2)
        "power_on_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[228].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_power_down)
        "power_on" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[229].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[246].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_calsel[4:4]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[245].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_calsel[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[244].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_calsel[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[243].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_calsel[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[242].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_calsel[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_cal_en)
        "cal_dis" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[241].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "cal_en" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[241].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[240].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_atbsel[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[239].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_atbsel[0:0]; 
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_pdb)
        "vreg_off" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[238].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "vreg_on" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[238].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_vreg_ovrride)
        "ovrride_off" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[237].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ovrride_on" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[237].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_avl_clk_in_en_n)
        "test_avl_clk_enabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[247].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_avl_clk_disabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[247].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_clk_ph_buf_en_n)
        "test_ph_clk_enabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_ph_clk_disabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[248].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_interp_clk_en_n)
        "test_interp_clk_enabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[249].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_interp_clk_disabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[249].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_int_clk_en_n)
        "test_int_clk_enabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[250].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_int_clk_disabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[250].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_phy_clk_lane_en_n)
        "test_phy_clk_enabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_phy_clk_disabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[251].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_pst_clk_en_n_b)
        "test_pst_clk_b_enabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[236].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_pst_clk_b_disabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[236].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_pst_clk_en_n_a)
        "test_pst_clk_a_enabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[235].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_pst_clk_a_disabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[235].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__dqs_lgc_pnr__a_rb_test_struct_en_n)
        "test_struct_enabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[234].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_struct_disabled" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[234].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[255].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_spare[3:3]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[254].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_spare[2:2]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[253].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_spare[1:1]; 
    force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[252].csr_reg_bit.csr_ns_reg.dout = xio_dqs_lgc_top__dqs_lgc_pnr__a_spare[0:0]; 
    case (xio_dqs_lgc_top__pstamble_reg_a__a_dqs_select)
        "dqs_diff_in_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_diff_in_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_diff_in_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_diff_in_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sstl_p_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sstl_p_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sstl_p_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sstl_p_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sstl_n_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sstl_n_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sstl_n_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sstl_n_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_loop_back0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_loop_back1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_constant" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_interpolator" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dqs_lgc_top__pstamble_reg_b__a_dqs_select)
        "dqs_diff_in_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_diff_in_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_diff_in_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_diff_in_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sstl_p_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sstl_p_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sstl_p_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sstl_p_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sstl_n_0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sstl_n_1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sstl_n_2" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sstl_n_3" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_loop_back0" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_loop_back1" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_constant" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_interpolator" : begin 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dqs_lgc_top.dqs_lgc_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__a_sync_control)
        "sync_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sync_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__a_power_down_0)
        "power_on_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__a_power_down_1)
        "power_on_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__a_power_down_2)
        "power_on_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__a_power_down)
        "power_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__a_lock_speed[0:0]; 
    case (ioereg_top_3___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[0:0]; 
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[0:0]; 
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n)
        "test_global_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_global_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n)
        "test_interp_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_interp_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n)
        "test_int_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_int_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n)
        "test_clk_ph_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_clk_ph_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n)
        "test_datovr_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_datovr_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_test_iocsr)
        "test_sync_data_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_sync_data_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n)
        "test_xpr_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_xpr_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term)
        "idle_term_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "idle_term_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split)
        "dcc_split_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dcc_split_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp)
        "bypass_mcp_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass_mcp_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__ioereg_misc__a_power_down)
        "power_on" : begin 
        end
        "power_off" : begin 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__write_path__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__write_path__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_3___ioereg_pnr_x2__write_path__a_lock_speed[0:0]; 
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode)
        "pin0_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode)
        "pin0_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_octrt)
        "pin0_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_initial_out)
        "pin0_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_gpio_differential)
        "pin0_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_dynoct)
        "pin0_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_mode_ddr)
        "pin0_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin0_dfx_mode)
        "pin0_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode)
        "pin1_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode)
        "pin1_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_octrt)
        "pin1_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_initial_out)
        "pin1_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_gpio_differential)
        "pin1_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_dynoct)
        "pin1_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_mode_ddr)
        "pin1_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__write_path__a_pin1_dfx_mode)
        "pin1_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__read_path_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__read_path_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__read_path_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__read_path_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_3_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
        end
        "ddr_sel_0" : begin 
        end
    endcase
    case (ioereg_top_3___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
        end
        "ddr_sel_1" : begin 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__a_sync_control)
        "sync_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sync_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__a_power_down_0)
        "power_on_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__a_power_down_1)
        "power_on_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__a_power_down_2)
        "power_on_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__a_power_down)
        "power_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__a_lock_speed[0:0]; 
    case (ioereg_top_4___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[0:0]; 
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[0:0]; 
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n)
        "test_global_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_global_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n)
        "test_interp_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_interp_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n)
        "test_int_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_int_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n)
        "test_clk_ph_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_clk_ph_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n)
        "test_datovr_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_datovr_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_test_iocsr)
        "test_sync_data_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_sync_data_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n)
        "test_xpr_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_xpr_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term)
        "idle_term_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "idle_term_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split)
        "dcc_split_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dcc_split_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp)
        "bypass_mcp_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass_mcp_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__ioereg_misc__a_power_down)
        "power_on" : begin 
        end
        "power_off" : begin 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__write_path__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__write_path__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_4___ioereg_pnr_x2__write_path__a_lock_speed[0:0]; 
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode)
        "pin0_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode)
        "pin0_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_octrt)
        "pin0_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_initial_out)
        "pin0_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_gpio_differential)
        "pin0_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_dynoct)
        "pin0_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_mode_ddr)
        "pin0_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin0_dfx_mode)
        "pin0_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode)
        "pin1_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode)
        "pin1_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_octrt)
        "pin1_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_initial_out)
        "pin1_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_gpio_differential)
        "pin1_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_dynoct)
        "pin1_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_mode_ddr)
        "pin1_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__write_path__a_pin1_dfx_mode)
        "pin1_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__read_path_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__read_path_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__read_path_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__read_path_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_4_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
        end
        "ddr_sel_0" : begin 
        end
    endcase
    case (ioereg_top_4___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
        end
        "ddr_sel_1" : begin 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_0__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_ena)
        "naclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[70].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_nsclr_ireg_ena)
        "nsclr_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[69].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_naclr_ireg_sel)
        "ireg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ireg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[68].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_ncein_ireg_ena)
        "ncein_ireg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ncein_ireg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[59].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_hr_in_clk_ena)
        "hr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[58].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_in_clk_rst_gen__a_rb_fr_in_clk_ena)
        "fr_in_clk_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_in_clk_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[57].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux0__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[67].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[66].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux1__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[65].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[64].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux2__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[63].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[62].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_4to1_mux3__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[61].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[60].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ireg__xio_gpio_ddio_in__a_rb_sclr_val)
        "sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[56].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__a_rb_oreg_tieoff_val)
        "oreg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_0__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_halfrate_oreg_ereg_1__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_sclr_val)
        "oreg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_ddio_out__a_rb_oreg_ddr_ena)
        "oreg_ddr_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_ddr_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nceout_oreg_ena)
        "nceout_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[43].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_ena)
        "naclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[42].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_nsclr_oreg_ena)
        "nsclr_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[41].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_naclr_oreg_sel)
        "oreg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oreg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[40].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_fr_out_clk_oreg_ena)
        "fr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[74].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oreg__xio_gpio_out_clk_rst_gen__a_rb_hr_out_clk_oreg_ena)
        "hr_out_clk_oreg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_oreg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[75].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__a_rb_ereg_tieoff_val)
        "ereg_tieoff_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_tieoff_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nceout_ereg_ena)
        "nceout_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nceout_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_ena)
        "naclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "naclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_nsclr_ereg_ena)
        "nsclr_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "nsclr_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_naclr_ereg_sel)
        "ereg_nclr_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_npre_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_hr_out_clk_ereg_ena)
        "hr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_clk_rst_gen__a_rb_fr_out_clk_ereg_ena)
        "fr_out_clk_ereg_dis" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "fr_out_clk_ereg_ena" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_halfrate_oreg_ereg__a_rb_hr_reg_byp)
        "hr_reg_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hr_reg_bypass_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_oe_reg__a_rb_ereg_sclr_val)
        "ereg_sclr_val_low" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ereg_sclr_val_high" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_ereg__xio_gpio_4to1_mux__a_rb_mux_sel)
        "sel0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "sel2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sel3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_oe_dly_chn__a_rb_ereg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_gpio_out_dly_chn__a_rb_oreg_dlychn_sel)
        "outdly_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "outdly_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "outdly_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xin_dlychn0__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[55].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[54].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[53].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[52].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[51].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[50].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xin_dlychn1__a_rb_ireg_dlychn_sel)
        "dly_setting_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_3" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_4" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_5" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_6" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_7" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_8" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_9" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_10" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_11" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_12" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_13" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_14" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_15" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_16" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_17" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_18" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_19" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_20" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_21" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_22" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_23" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_24" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_25" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_26" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_27" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_28" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_29" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_30" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_31" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_32" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_33" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_34" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_35" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_36" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_37" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_38" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_39" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_40" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_41" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_42" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_43" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_44" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_45" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_46" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_47" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_48" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_49" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_50" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_51" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_52" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_53" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_54" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_55" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_56" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_57" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_58" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_59" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_60" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_61" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dly_setting_62" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dly_setting_63" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[49].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[48].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[47].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[46].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[45].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[44].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_dfm__a_rb_ireg_or_oreg_sel)
        "outreg_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "buffer_input" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[73].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_debug)
        "jtag_debug_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_debug_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[71].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_din_or_pll_sel)
        "jtag_din_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "jtag_pll_sel" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[72].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_jtag__a_rb_bypass_or_nonbypass_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_hr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_fr_in_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_ncein__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_iodout0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_iodout1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_iodout2__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_iodout3__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_naclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_nsclr__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_nceout__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_noe0__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_noe1__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_hr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xinv_fr_out_clk__a_rb_sel)
        "in_buf" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "in_inv" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___gpio_wrapper_1__gpio_reg__xio_bypmux_cdatain0__bypass_mux_sel)
        "non_bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__a_sync_control)
        "sync_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "sync_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__a_power_down_0)
        "power_on_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__a_power_down_1)
        "power_on_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__a_power_down_2)
        "power_on_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off_2" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__a_power_down)
        "power_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "power_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__a_lock_speed[0:0]; 
    case (ioereg_top_5___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_output_phase[0:0]; 
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_0__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_avalon_mode)
        "shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_pin_output_calibration_mode)
        "x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_octrt)
        "static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_initial_out)
        "initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_gpio_differential)
        "gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_dynoct)
        "oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_dq_in_select)
        "dq_sstl_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dq_xor_loopback_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dq_differential_in" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[91].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[90].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[89].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_mode_ddr)
        "mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[88].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[12:12]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[87].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[11:11]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[86].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[10:10]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[85].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[9:9]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[84].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[8:8]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[83].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[7:7]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[82].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[6:6]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[81].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[5:5]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[80].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[4:4]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[79].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[3:3]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[78].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[77].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[76].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_output_phase[0:0]; 
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_hr_clk_en_n)
        "test_hr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_hr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[105].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_fr_clk_en_n)
        "test_fr_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_fr_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[106].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_rb_test_updtdr_en_n)
        "test_updtdr_en_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_updtdr_en_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[107].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_pnr_1__a_rb_jtag_clk_en_n)
        "test_jtag_clk_enable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_jtag_clk_disable" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[108].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_global_clk_en_n)
        "test_global_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_global_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_interp_clk_en_n)
        "test_interp_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_interp_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_int_clk_en_n)
        "test_int_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_int_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_clk_ph_buf_en_n)
        "test_clk_ph_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_clk_ph_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_datovr_en_n)
        "test_datovr_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_datovr_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_test_iocsr)
        "test_sync_data_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_sync_data_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_test_xpr_clk_en_n)
        "test_xpr_clk_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_xpr_clk_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_idle_term)
        "idle_term_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "idle_term_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_dcc_split)
        "dcc_split_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dcc_split_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_rb_bypass_mcp)
        "bypass_mcp_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "bypass_mcp_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__ioereg_misc__a_power_down)
        "power_on" : begin 
        end
        "power_off" : begin 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_ddr4_mode)
        "ddr3_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr4_idle" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_ddr2_oeb)
        "ddr3_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr2_preamble" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_dpa_enable)
        "dpa_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dpa_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_dpa_edge_mode)
        "track_both_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "track_single_edge" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__write_path__a_lock_speed[2:2]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__write_path__a_lock_speed[1:1]; 
    force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_misc.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = ioereg_top_5___ioereg_pnr_x2__write_path__a_lock_speed[0:0]; 
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ddr_sel_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_phy_clk_mode)
        "phy_clk_0" : begin 
        end
        "phy_clk_1" : begin 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_output_avalon_mode)
        "pin0_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_output_calibration_mode)
        "pin0_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_octrt)
        "pin0_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_initial_out)
        "pin0_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_gpio_differential)
        "pin0_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_dynoct)
        "pin0_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_mode_ddr)
        "pin0_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin0_dfx_mode)
        "pin0_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin0_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin0_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_output_avalon_mode)
        "pin1_shadow_write_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_shadow_write_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[104].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_output_calibration_mode)
        "pin1_x1_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_x12_calibration" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[103].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_octrt)
        "pin1_static_oct_off" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_static_oct_on" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[102].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_initial_out)
        "pin1_initial_out_z" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_0" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_initial_out_1" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_initial_out_x" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[101].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[100].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_gpio_differential)
        "pin1_gpio_single_ended" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_gpio_differential" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[99].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_dynoct)
        "pin1_oct_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_oct_enabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[98].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_mode_ddr)
        "pin1_mode_sdr" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_mode_ddr" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[94].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__write_path__a_pin1_dfx_mode)
        "pin1_dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "pin1_dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pin1_dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__read_path_0__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__read_path_0__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_0.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__read_path_1__a_dqs_select)
        "dqs_sampler_b_a_rise" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b_a_fall" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_a" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_b" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_over" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dqs_sampler_b_a_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dqs_sampler_a_b_rank" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[97].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[96].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[95].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__read_path_1__a_dfx_mode)
        "dfx_disabled" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_mcu_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "dfx_dqs_gate_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dfx_dq_dqs_probe" : begin 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[93].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.ioereg_top_5_.ioereg_pnr_x2.ioereg_pnr_1.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[92].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_dpa_enable)
        "dpa_disabled" : begin 
        end
        "dpa_enabled" : begin 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_0)
        "gpio_sel_0" : begin 
        end
        "ddr_sel_0" : begin 
        end
    endcase
    case (ioereg_top_5___ioereg_pnr_x2__io_ioereg_pnr_x2_misc_inst__a_rb_gpio_or_ddr_sel_1)
        "gpio_sel_1" : begin 
        end
        "ddr_sel_1" : begin 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_dll_rst_en)
        "dll_rst_dis" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dll_rst_en" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_dll_en)
        "dll_dis" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dll_en" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[1].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_ndllrst_prgmnvrt)
        "off" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "on" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[2].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_core_up_prgmnvrt)
        "off" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "on" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[3].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_core_dn_prgmnvrt)
        "off" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "on" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[4].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_core_updnen)
        "core_updn_dis" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "core_updn_en" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[5].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_ctlsel)
        "ctl_dynamic" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "ctl_static" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[6].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[16].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_ctl_static[9:9]; 
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[15].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_ctl_static[8:8]; 
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[14].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_ctl_static[7:7]; 
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[13].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_ctl_static[6:6]; 
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[12].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_ctl_static[5:5]; 
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[11].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_ctl_static[4:4]; 
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[10].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_ctl_static[3:3]; 
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[9].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_ctl_static[2:2]; 
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[8].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_ctl_static[1:1]; 
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[7].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_ctl_static[0:0]; 
    case (xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel0)
        "pvt_gry_0" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pvt_binary_0" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "int_binary_0" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dft_dll_reset" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[18].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[17].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel1)
        "pvt_gry_1" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pvt_binary_1" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "int_binary_1" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dft_overflow" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[20].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[19].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel2)
        "pvt_gry_2" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pvt_binary_2" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "int_binary_2" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gate_state_0" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[22].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[21].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel3)
        "pvt_gry_3" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pvt_binary_3" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "int_binary_3" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gate_state_1" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[24].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[23].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel4)
        "pvt_gry_4" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pvt_binary_4" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "int_binary_4" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gate_state_2" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[26].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[25].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel5)
        "pvt_gry_5" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pvt_binary_5" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "int_binary_5" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gate_state_3" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[28].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[27].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel6)
        "pvt_gry_6" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pvt_binary_6" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "int_binary_6" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "gate_state_4" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[30].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[29].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel7)
        "pvt_gry_7" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pvt_binary_7" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "int_binary_7" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dft_unused1" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[32].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[31].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel8)
        "pvt_gry_8" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pvt_binary_8" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "int_binary_8" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dft_unused2" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[34].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[33].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_dftmuxsel9)
        "pvt_gry_9" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "pvt_binary_9" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
        "int_binary_9" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "dft_ctrl_to_core" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[36].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[35].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_hps_ctrl_en)
        "hps_ctrl_dis" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs_2.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "hps_ctrl_en" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs_2.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[0].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    case (xio_dll_top__xio_dll_pnr__a_rb_test_clk_pll_en_n)
        "test_clk_pll_en" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b0; 
        end
        "test_clk_pll_dis" : begin 
            force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[37].csr_reg_bit.csr_ns_reg.dout = 1'b1; 
        end
    endcase
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[39].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_new_dll[1:1]; 
    force u_io_12_lane_bcm.xio_dll_top.xio_dll_pnr.csr_reg_nregs.csr_reg_nregs[0].csr_reg_nbits.csr_reg_bit[38].csr_reg_bit.csr_ns_reg.dout = xio_dll_top__xio_dll_pnr__a_rb_new_dll[0:0]; 
    case (io_ioereg_custom_0__xio_nand_x64_delay_line_0__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_0__xio_nand_x64_delay_line_1__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_0__xio_interpolator_0__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_0__xio_interpolator_0__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (io_ioereg_custom_0__xio_interpolator_1__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_0__xio_interpolator_1__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (io_ioereg_custom_1__xio_nand_x64_delay_line_0__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_1__xio_nand_x64_delay_line_1__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_1__xio_interpolator_0__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_1__xio_interpolator_0__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (io_ioereg_custom_1__xio_interpolator_1__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_1__xio_interpolator_1__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (io_ioereg_custom_2__xio_nand_x64_delay_line_0__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_2__xio_nand_x64_delay_line_1__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_2__xio_interpolator_0__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_2__xio_interpolator_0__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (io_ioereg_custom_2__xio_interpolator_1__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_2__xio_interpolator_1__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (io_ioereg_custom_3__xio_nand_x64_delay_line_0__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_3__xio_nand_x64_delay_line_1__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_3__xio_interpolator_0__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_3__xio_interpolator_0__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (io_ioereg_custom_3__xio_interpolator_1__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_3__xio_interpolator_1__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (io_ioereg_custom_4__xio_nand_x64_delay_line_0__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_4__xio_nand_x64_delay_line_1__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_4__xio_interpolator_0__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_4__xio_interpolator_0__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (io_ioereg_custom_4__xio_interpolator_1__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_4__xio_interpolator_1__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (io_ioereg_custom_5__xio_nand_x64_delay_line_0__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_5__xio_nand_x64_delay_line_1__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
    endcase
    case (io_ioereg_custom_5__xio_interpolator_0__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_5__xio_interpolator_0__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (io_ioereg_custom_5__xio_interpolator_1__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (io_ioereg_custom_5__xio_interpolator_1__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (xio_dqs_custom__xio_nand_x128_delay_line_a__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
        "delay_64" : begin 
        end
        "delay_65" : begin 
        end
        "delay_66" : begin 
        end
        "delay_67" : begin 
        end
        "delay_68" : begin 
        end
        "delay_69" : begin 
        end
        "delay_70" : begin 
        end
        "delay_71" : begin 
        end
        "delay_72" : begin 
        end
        "delay_73" : begin 
        end
        "delay_74" : begin 
        end
        "delay_75" : begin 
        end
        "delay_76" : begin 
        end
        "delay_77" : begin 
        end
        "delay_78" : begin 
        end
        "delay_79" : begin 
        end
        "delay_80" : begin 
        end
        "delay_81" : begin 
        end
        "delay_82" : begin 
        end
        "delay_83" : begin 
        end
        "delay_84" : begin 
        end
        "delay_85" : begin 
        end
        "delay_86" : begin 
        end
        "delay_87" : begin 
        end
        "delay_88" : begin 
        end
        "delay_89" : begin 
        end
        "delay_90" : begin 
        end
        "delay_91" : begin 
        end
        "delay_92" : begin 
        end
        "delay_93" : begin 
        end
        "delay_94" : begin 
        end
        "delay_95" : begin 
        end
        "delay_96" : begin 
        end
        "delay_97" : begin 
        end
        "delay_98" : begin 
        end
        "delay_99" : begin 
        end
        "delay_100" : begin 
        end
        "delay_101" : begin 
        end
        "delay_102" : begin 
        end
        "delay_103" : begin 
        end
        "delay_104" : begin 
        end
        "delay_105" : begin 
        end
        "delay_106" : begin 
        end
        "delay_107" : begin 
        end
        "delay_108" : begin 
        end
        "delay_109" : begin 
        end
        "delay_110" : begin 
        end
        "delay_111" : begin 
        end
        "delay_112" : begin 
        end
        "delay_113" : begin 
        end
        "delay_114" : begin 
        end
        "delay_115" : begin 
        end
        "delay_116" : begin 
        end
        "delay_117" : begin 
        end
        "delay_118" : begin 
        end
        "delay_119" : begin 
        end
        "delay_120" : begin 
        end
        "delay_121" : begin 
        end
        "delay_122" : begin 
        end
        "delay_123" : begin 
        end
        "delay_124" : begin 
        end
        "delay_125" : begin 
        end
    endcase
    case (xio_dqs_custom__xio_nand_x128_delay_line_b__a_delay_step)
        "delay_0" : begin 
        end
        "delay_1" : begin 
        end
        "delay_2" : begin 
        end
        "delay_3" : begin 
        end
        "delay_4" : begin 
        end
        "delay_5" : begin 
        end
        "delay_6" : begin 
        end
        "delay_7" : begin 
        end
        "delay_8" : begin 
        end
        "delay_9" : begin 
        end
        "delay_10" : begin 
        end
        "delay_11" : begin 
        end
        "delay_12" : begin 
        end
        "delay_13" : begin 
        end
        "delay_14" : begin 
        end
        "delay_15" : begin 
        end
        "delay_16" : begin 
        end
        "delay_17" : begin 
        end
        "delay_18" : begin 
        end
        "delay_19" : begin 
        end
        "delay_20" : begin 
        end
        "delay_21" : begin 
        end
        "delay_22" : begin 
        end
        "delay_23" : begin 
        end
        "delay_24" : begin 
        end
        "delay_25" : begin 
        end
        "delay_26" : begin 
        end
        "delay_27" : begin 
        end
        "delay_28" : begin 
        end
        "delay_29" : begin 
        end
        "delay_30" : begin 
        end
        "delay_31" : begin 
        end
        "delay_32" : begin 
        end
        "delay_33" : begin 
        end
        "delay_34" : begin 
        end
        "delay_35" : begin 
        end
        "delay_36" : begin 
        end
        "delay_37" : begin 
        end
        "delay_38" : begin 
        end
        "delay_39" : begin 
        end
        "delay_40" : begin 
        end
        "delay_41" : begin 
        end
        "delay_42" : begin 
        end
        "delay_43" : begin 
        end
        "delay_44" : begin 
        end
        "delay_45" : begin 
        end
        "delay_46" : begin 
        end
        "delay_47" : begin 
        end
        "delay_48" : begin 
        end
        "delay_49" : begin 
        end
        "delay_50" : begin 
        end
        "delay_51" : begin 
        end
        "delay_52" : begin 
        end
        "delay_53" : begin 
        end
        "delay_54" : begin 
        end
        "delay_55" : begin 
        end
        "delay_56" : begin 
        end
        "delay_57" : begin 
        end
        "delay_58" : begin 
        end
        "delay_59" : begin 
        end
        "delay_60" : begin 
        end
        "delay_61" : begin 
        end
        "delay_62" : begin 
        end
        "delay_63" : begin 
        end
        "delay_64" : begin 
        end
        "delay_65" : begin 
        end
        "delay_66" : begin 
        end
        "delay_67" : begin 
        end
        "delay_68" : begin 
        end
        "delay_69" : begin 
        end
        "delay_70" : begin 
        end
        "delay_71" : begin 
        end
        "delay_72" : begin 
        end
        "delay_73" : begin 
        end
        "delay_74" : begin 
        end
        "delay_75" : begin 
        end
        "delay_76" : begin 
        end
        "delay_77" : begin 
        end
        "delay_78" : begin 
        end
        "delay_79" : begin 
        end
        "delay_80" : begin 
        end
        "delay_81" : begin 
        end
        "delay_82" : begin 
        end
        "delay_83" : begin 
        end
        "delay_84" : begin 
        end
        "delay_85" : begin 
        end
        "delay_86" : begin 
        end
        "delay_87" : begin 
        end
        "delay_88" : begin 
        end
        "delay_89" : begin 
        end
        "delay_90" : begin 
        end
        "delay_91" : begin 
        end
        "delay_92" : begin 
        end
        "delay_93" : begin 
        end
        "delay_94" : begin 
        end
        "delay_95" : begin 
        end
        "delay_96" : begin 
        end
        "delay_97" : begin 
        end
        "delay_98" : begin 
        end
        "delay_99" : begin 
        end
        "delay_100" : begin 
        end
        "delay_101" : begin 
        end
        "delay_102" : begin 
        end
        "delay_103" : begin 
        end
        "delay_104" : begin 
        end
        "delay_105" : begin 
        end
        "delay_106" : begin 
        end
        "delay_107" : begin 
        end
        "delay_108" : begin 
        end
        "delay_109" : begin 
        end
        "delay_110" : begin 
        end
        "delay_111" : begin 
        end
        "delay_112" : begin 
        end
        "delay_113" : begin 
        end
        "delay_114" : begin 
        end
        "delay_115" : begin 
        end
        "delay_116" : begin 
        end
        "delay_117" : begin 
        end
        "delay_118" : begin 
        end
        "delay_119" : begin 
        end
        "delay_120" : begin 
        end
        "delay_121" : begin 
        end
        "delay_122" : begin 
        end
        "delay_123" : begin 
        end
        "delay_124" : begin 
        end
        "delay_125" : begin 
        end
    endcase
    case (xio_dqs_custom__xio_interpolator_a__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (xio_dqs_custom__xio_interpolator_a__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (xio_dqs_custom__xio_interpolator_b__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (xio_dqs_custom__xio_interpolator_b__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (xio_dqs_custom__xio_min_inter_1__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (xio_dqs_custom__xio_min_inter_1__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (xio_dqs_custom__xio_min_inter_3__a_filter_code)
        "freq_08ghz" : begin 
        end
        "freq_10ghz" : begin 
        end
        "freq_12ghz" : begin 
        end
        "freq_16ghz" : begin 
        end
    endcase
    case (xio_dqs_custom__xio_min_inter_3__a_couple_enable)
        "couple_en" : begin 
        end
        "couple_dis" : begin 
        end
    endcase
    case (ioereg_struct_0_0__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_0_0__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_0_0__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase
    case (ioereg_struct_0_1__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_0_1__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_0_1__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase
    case (ioereg_struct_1_0__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_1_0__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_1_0__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase
    case (ioereg_struct_1_1__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_1_1__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_1_1__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase
    case (ioereg_struct_2_0__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_2_0__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_2_0__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase
    case (ioereg_struct_2_1__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_2_1__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_2_1__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase
    case (ioereg_struct_3_0__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_3_0__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_3_0__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase
    case (ioereg_struct_3_1__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_3_1__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_3_1__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase
    case (ioereg_struct_4_0__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_4_0__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_4_0__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase
    case (ioereg_struct_4_1__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_4_1__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_4_1__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase
    case (ioereg_struct_5_0__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_5_0__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_5_0__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase
    case (ioereg_struct_5_1__a_dq_in_select)
        "dq_sstl_in" : begin 
        end
        "dq_disabled" : begin 
        end
        "dq_loopback_in" : begin 
        end
        "dq_xor_loopback_in" : begin 
        end
        "dq_differential_in" : begin 
        end
    endcase
    case (ioereg_struct_5_1__a_rb_gpio_or_ddr_sel)
        "gpio_sel" : begin 
        end
        "ddr_sel" : begin 
        end
    endcase
    case (ioereg_struct_5_1__a_mode_ddr)
        "mode_sdr" : begin 
        end
        "mode_ddr" : begin 
        end
    endcase

#111
force csr_en = 1'b1;
force csr_shift_n = 1'b1;  

end

defparam u_io_12_lane_bcm.io_ioereg_custom_0.xio_interpolator_0.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.io_ioereg_custom_0.xio_interpolator_1.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.io_ioereg_custom_1.xio_interpolator_0.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.io_ioereg_custom_1.xio_interpolator_1.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.io_ioereg_custom_2.xio_interpolator_0.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.io_ioereg_custom_2.xio_interpolator_1.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.io_ioereg_custom_3.xio_interpolator_0.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.io_ioereg_custom_3.xio_interpolator_1.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.io_ioereg_custom_4.xio_interpolator_0.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.io_ioereg_custom_4.xio_interpolator_1.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.io_ioereg_custom_5.xio_interpolator_0.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.io_ioereg_custom_5.xio_interpolator_1.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.xio_dqs_custom.xio_interpolator_a.fast_interpolator_sim = fast_interpolator_sim;
defparam u_io_12_lane_bcm.xio_dqs_custom.xio_interpolator_b.fast_interpolator_sim = fast_interpolator_sim;

endmodule


