// (C) 2001-2017 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module io_12_lane__mdev40_abphy (
   inout             ic50u,
   inout             it50u,
   inout             atbi_0,                    
   inout             atbi_1,                    
   input             reset_n,                   
   input       [7:0] phy_clk_phs_dqs,           
   input       [4:0] phy_clk_0,                 
   input       [4:0] phy_clk_1,                 
   input       [4:0] phy_clk_2,                 
   input       [4:0] phy_clk_3,                 
   input       [4:0] phy_clk_4,                 
   input       [4:0] phy_clk_5,                 
   input       [4:0] phy_clk_fb,                
   input       [4:0] phy_clk_dqs,               
   input       [1:0] broadcast_in_top,          
   input       [1:0] broadcast_in_bot,          
   output      [1:0] broadcast_out_top,         
   output      [1:0] broadcast_out_bot,         
   output     [11:0] weak_pullup_enable,        
   output     [11:0] codin_p,                   
   output     [11:0] codin_pb,                  
   output     [11:0] codin_n,                   
   output     [11:0] codin_nb,                  
   output     [11:0] oct_enable,                
   input      [11:0] codatovr,
   input      [11:0] codatovrb,
   input       [5:0] dqscodatovr,
   input       [5:0] dqscodatovrb,
   input             dqs_diff_in_0_0,           
   input             dqs_diff_in_0_1,           
   input             dqs_diff_in_1_0,           
   input             dqs_diff_in_1_1,           
   input             dqs_diff_in_2_0,           
   input             dqs_diff_in_2_1,           
   input             dqs_diff_in_3_0,           
   input             dqs_diff_in_3_1,           
   input             dqs_sstl_p_0_0,            
   input             dqs_sstl_p_0_1,            
   input             dqs_sstl_p_1_0,            
   input             dqs_sstl_p_1_1,            
   input             dqs_sstl_p_2_0,            
   input             dqs_sstl_p_2_1,            
   input             dqs_sstl_p_3_0,            
   input             dqs_sstl_p_3_1,            
   input             dqs_sstl_n_0_0,            
   input             dqs_sstl_n_0_1,            
   input             dqs_sstl_n_1_0,            
   input             dqs_sstl_n_1_1,            
   input             dqs_sstl_n_2_0,            
   input             dqs_sstl_n_2_1,            
   input             dqs_sstl_n_3_0,            
   input             dqs_sstl_n_3_1,            
   input             avl_clk_in,                
   output            avl_clk_out,               
   input      [19:0] avl_address_in,            
   output     [19:0] avl_address_out,           
   input             avl_write_in,              
   output            avl_write_out,             
   input             avl_read_in,               
   output            avl_read_out,              
   input      [31:0] avl_writedata_in,          
   output     [31:0] avl_writedata_out,         
   input      [31:0] avl_readdata_in,           
   output     [31:0] avl_readdata_out,          
   input             csr_clk,                   
   input             csr_rclk,                  
   input             csr_in,                    
   input             csr_en,                    
   input             csr_shift_n,               
   output            csr_out,                   
   input             pll_locked,                
   output      [5:0] ioereg_locked,             

   input             frzreg,                    
   input             niotri,                    
   input  [12*1-1:0] ncein,                     
   input  [12*1-1:0] nceout,                    
   input  [12*1-1:0] naclr,                     
   input  [12*1-1:0] nsclr,                     
   input  [12*1-1:0] fr_in_clk,                 
   input  [12*1-1:0] hr_in_clk,                 
   input  [12*1-1:0] fr_out_clk,                
   input  [12*1-1:0] hr_out_clk,                
   input             pll_clk,                   

   input             osc_sel_n,                 
   input             osc_en_n,                  
   output            osc_rocount_to_core,       
   input             osc_enable_in,             
   input             osc_mode_in,               
   output            x1024_osc_out,             


   input             test_tdf_select_n,         
   input             atpg_en_n,                 
   input             pipeline_global_en_n,      
   input             lane_test_clr_n,           
   input  [12*1-1:0] tpin,                      
   input  [12*1-1:0] tpctl,                     
   input             test_io_ctrl_3,            
   input  [12*1-1:0] progctl,                   
   input  [12*1-1:0] progout,                   
   input  [12*1-1:0] progoe,                    
   input             scan_shift_n,              
   input  [79:0]      scanin,                    
   output [79:0]      scanout,                   
   output [12*1-1:0] tpdata,                    
   output            test_xor_clk,              
   input      [11:0] test_dbg_out,              
   output     [11:0] test_dbg_in,               

   input             jtag_shftdr,               
   input             jtag_clk,                  
   input             jtag_highz,                
   input             jtag_sdin,                 
   input             jtag_updtdr,               
   input             jtag_mode,                 
   output            jtag_sdout,                

   input      [47:0] oeb_from_core,             
   input      [95:0] data_from_core,            
   output     [95:0] data_to_core,              
   input      [15:0] mrnk_read_core,            
   input      [15:0] mrnk_write_core,           
   input       [3:0] rdata_en_full_core,        
   output      [3:0] rdata_valid_core,          
   output      [5:0] afi_wlat_core,             
   output      [5:0] afi_rlat_core,             

   input             core2dbc_wr_data_vld0,     
   output            dbc2core_wr_data_rdy,      
   output            dbc2core_rd_data_vld0,     
   output            dbc2core_rd_type,          
   input             core2dbc_rd_data_rdy,      
   input      [12:0] core2dbc_wr_ecc_info,      
   output     [11:0] dbc2core_wb_pointer,       
   input             dft_prbs_ena_n,            
   output            dft_prbs_pass,             
   output            dft_prbs_done,             
   input       [7:0] dft_core2db,               
   output      [7:0] dft_db2core,               
   output      [1:0] dft_phy_clk,               

   input      [95:0] ac_hmc,                    
   input             ctl2dbc_wrdata_vld0,       
   input             ctl2dbc_mask_entry0,       
   input             ctl2dbc_wb_rdptr_vld0,     
   input       [5:0] ctl2dbc_wb_rdptr0,         
   input             ctl2dbc_rb_wrptr_vld0,     
   input       [5:0] ctl2dbc_rb_wrptr0,         
   input       [1:0] ctl2dbc_rb_rdptr_vld0,     
   input      [11:0] ctl2dbc_rb_rdptr0,         
   input       [3:0] ctl2dbc_rdata_en_full0,    
   input       [7:0] ctl2dbc_mrnk_read0,        
   input             ctl2dbc_seq_en0,           
   input             ctl2dbc_nop0,              
   input       [1:0] ctl2dbc_cs0,               
   input             ctl2dbc_rd_type0,          
   input       [3:0] ctl2dbc_misc0,             
   input             ctl2dbc_wrdata_vld1,       
   input             ctl2dbc_mask_entry1,       
   input             ctl2dbc_wb_rdptr_vld1,     
   input       [5:0] ctl2dbc_wb_rdptr1,         
   input             ctl2dbc_rb_wrptr_vld1,     
   input       [5:0] ctl2dbc_rb_wrptr1,         
   input       [1:0] ctl2dbc_rb_rdptr_vld1,     
   input      [11:0] ctl2dbc_rb_rdptr1,         
   input       [3:0] ctl2dbc_rdata_en_full1,    
   input       [7:0] ctl2dbc_mrnk_read1,        
   input             ctl2dbc_seq_en1,           
   input             ctl2dbc_nop1,              
   input       [1:0] ctl2dbc_cs1,               
   input             ctl2dbc_rd_type1,          
   input       [3:0] ctl2dbc_misc1,             
   input             cfg_dbc_ctrl_sel,          
   input             cfg_reorder_rdata,         
   input             cfg_rmw_en,                
   input             cfg_output_regd,           
   input             cfg_dbc_in_protocol,       
   input             cfg_dbc_dualport_en,       
   input       [2:0] cfg_dbc_pipe_lat,          
   input       [2:0] cfg_cmd_rate,              
   input             cfg_dbc_rc_en,             
   input       [2:0] cfg_dbc_slot_rotate_en,    
   input       [1:0] cfg_dbc_slot_offset,       


   input             sync_clk_bot_in,
   input             sync_data_bot_in,
   output            sync_clk_bot_out,
   output            sync_data_bot_out,
   input             sync_clk_top_in,
   input             sync_data_top_in,
   output            sync_clk_top_out,
   output            sync_data_top_out,

   input       [2:0] core_dll,                  
   input             clk_pll,                   
   input             reinit,                    
   output     [12:0] dll_core,                  

   output      [2:0] fb_clkout,                 
   input  wire       early_csren,               
   input  wire       bhniotri,                  
   input  wire       early_bhniotri,            
   input  wire       enrnsl,                    
   input  wire       early_enrnsl,              
   input  wire       early_frzreg,              
   input  wire       nfrzdrv,                   
   input  wire       early_nfrzdrv,             
   input  wire       early_niotri,              
   input  wire       plniotri,                  
   input  wire       early_plniotri,            
   input  wire       usrmode,                   
   input  wire       early_usrmode,             
   input  wire       wkpullup,                  
   input  wire       early_pllbiasen,           
   output wire       local_bhniotri,            
   output wire       local_enrnsl,              
   output wire       local_nfrzdrv,             
   output wire       local_niotri,              
   output wire       local_plniotri,            
   output wire       local_usrmode,             
   output wire       local_wkpullup,            
   output wire       hps_to_core_ctrl_en,       
   input  wire       sample_clk_0,              
   input  wire       sample_clk_1,              
   input  wire       sample_clk_2,              
   input  wire       sample_clk_3,              
   input  wire       sample_clk_4,              
   input  wire       sample_clk_5,              
   input  wire [5:0] sample_value_iob,          
   output wire [5:0] sample_value_lane,         
   input  wire       xprio_clk,                 
   input  wire       xprio_sync,                
   input  wire [7:0] xprio_xbus,                
   input             test_db_csr_in,            
   input             test_dqs_csr_in,           
   output            test_dp_csr_out,           
   output            test_ioereg2_csr_out,      
   output            test_dll_csr_out,           
   input  wire [4:0] cas_csrdin,                
   output wire [4:0] cas_csrdout,               
   output            csr_clk_left,              
   output            csr_en_left,               
   input      [11:0] loopback_p,                
   input      [11:0] loopback_n,                
   input      [11:0] loopback_en_n,             
   output      [5:0] sel_vref,                  
   output            csr_scan_shift_n_vref,
   input             test_dp_csr_in,
   input             csr_test_clk,
   input       [5:0] dpahold_pp,
   input       [5:0] dparst_pp,
   input       [5:0] dpaswitch_pp,
   input       [5:0] fiforst_pp,
   input       [5:0] testin_fclk_pp,
   input       [5:0] test_loaden_pp,
   input       [9:0] par_in_pp0,
   input       [9:0] par_in_pp1,
   input       [9:0] par_in_pp2,
   input       [9:0] par_in_pp3,
   input       [9:0] par_in_pp4,
   input       [9:0] par_in_pp5,
   input       [5:0] bslipcntl_pp,
   input       [5:0] bsliprst_pp,
   output      [5:0] lock_pp,
   output            pclk_0,
   output            pclk_1,
   output            pclk_2,
   output            pclk_3,
   output            pclk_4,
   output            pclk_5,
   output      [5:0] bslipmax_pp,
   output      [9:0] par_out_pp0,
   output      [9:0] par_out_pp1,
   output      [9:0] par_out_pp2,
   output      [9:0] par_out_pp3,
   output      [9:0] par_out_pp4,
   output      [9:0] par_out_pp5,
   input       [5:0] pclkdpa,                   
   input       [5:0] lvdsin,                    
   output      [5:0] lvdsout,                   
   input             test_csr_in_spare,
   input             test_clock,

   input             xor_vref_inbuf,
   output            xor_vref_outbuf,
   input             s2pload_input,
   output            s2pload_output
);

  timeunit 1ps;
  timeprecision 1ps;

supply1         vcc_io;



   wire       [7:0] phy_clk_phs_lane_out;      

   wire       [3:0] dqs_rise_gray_a;           
   wire       [3:0] dqs_fall_gray_a;           
   wire       [3:0] dqs_rise_gray_b;           
   wire       [3:0] dqs_fall_gray_b;           
   wire       [9:0] pvt_ref_gry;               
   wire      [95:0] data_from_ioreg;           
   wire      [95:0] data_from_ioreg_abphy;     
   wire      [47:0] avl_readchain_bot;         
   wire      [47:0] avl_readchain_top;         
   wire       [7:0] ioereg_csrout;             
   wire       [4:0] ioereg_jtag_sdout;         
   wire      [19:0] avl_address_dbc;           
   wire       [4:0] avl_wr_address_top;        
   wire       [4:0] avl_wr_address_bot;        
   wire       [4:0] avl_rd_address_top;        
   wire       [4:0] avl_rd_address_bot;        
   wire      [31:0] avl_writedata_dbc;         
   wire      [15:0] avl_writedata_top;         
   wire      [15:0] avl_writedata_bot;         
   wire      [31:0] avl_readdata_dbc;          
   wire       [1:0] avl_write_dbc;             
   wire             avl_sync_write_top;        
   wire             avl_sync_write_bot;        
   wire             avl_destruct_read_top;     
   wire             avl_destruct_read_bot;     
   wire       [3:0] rdata_valid_local;         
   wire       [3:0] rdata_valid_mid;
   wire       [3:0] rdata_valid_out;
   wire             chk_x12_track_out_up_top;  
   wire             chk_x12_track_out_up_bot;  
   wire             chk_x12_track_out_dn_top;  
   wire             chk_x12_track_out_dn_bot;  
   wire       [1:0] fifo_pack_select_top;      
   wire             fifo_read_enable_top;      
   wire             fifo_reset_n_top;          
   wire             fifo_rank_sel_top;         
   wire       [1:0] fifo_pack_select_bot;      
   wire             fifo_read_enable_bot;      
   wire             fifo_reset_n_bot;          
   wire             fifo_rank_sel_bot;         
   wire       [5:0] pvt_write;                 
   wire       [2:0] pvt_address_top;           
   wire       [2:0] pvt_address_bot;           
   wire       [8:0] pvt_data_top;              
   wire       [8:0] pvt_data_bot;              
   wire       [1:0] dqs_out_a_n;               
   wire       [1:0] dqs_out_b_n;               
   wire       [1:0] rank_in_a_top;             
   wire       [1:0] rank_in_a_bot;             
   wire       [1:0] rank_in_b_top;             
   wire       [1:0] rank_in_b_bot;             
   wire       [7:0] rank_out_top;              
   wire       [7:0] rank_out_bot;              
   wire             oct_enable_out_top;        
   wire             oct_enable_out_bot;        
   wire             rb_phy_clk_mode_bot;       
   wire       [3:0] rb_track_speed_bot;        
   wire       [1:0] rb_kicker_size_bot;        
   wire       [1:0] rb_mode_rate_in_bot;       
   wire       [1:0] rb_mode_rate_out_bot;      
   wire       [1:0] rb_filter_code_bot;        
   wire             rb_phy_clk_mode_top;       
   wire       [3:0] rb_track_speed_top;        
   wire       [1:0] rb_kicker_size_top;        
   wire       [1:0] rb_mode_rate_in_top;       
   wire       [1:0] rb_mode_rate_out_top;      
   wire       [1:0] rb_filter_code_top;        
   wire             rb_phy_clk_mode_right;     
   wire             csr_clk_top;               
   wire             csr_clk_bot;               
   wire             csr_clk_dbc;               
   wire             csr_en_top;                
   wire             csr_en_bot;                
   wire             csr_en_dbc;                
   wire             csr_en_dll;                
   wire             csr_en_local;              
   wire             csr_shift_n_top;           
   wire             csr_shift_n_bot;           
   wire             csr_shift_n_left;          
   wire             csr_shift_n_dbc;           
   wire             nfrzdrv_top;               
   wire             nfrzdrv_bot;               
   wire             frzreg_top;                
   wire             frzreg_bot;                
   wire             atpg_en_n_top;             
   wire             atpg_en_n_bot;             
   wire             atpg_en_n_left;            
   wire             pipeline_global_en_n_top;  
   wire             pipeline_global_en_n_bot;  
   wire             pipeline_global_en_n_left; 
   wire             test_clr_n_top;            
   wire             test_clr_n_bot;            
   wire             test_tdf_select_n_top;     
   wire             test_tdf_select_n_bot;     
   wire             test_clk_struct;           
   wire             niotri_top;                
   wire             niotri_bot;                
   wire             scan_shift_n_top;          
   wire             scan_shift_n_bot;          
   wire             scan_shift_n_dbc;          
   wire             scan_shift_n_left;         
   wire             jtag_shftdr_top;           
   wire             jtag_shftdr_bot;           
   wire             jtag_clk_top;              
   wire             jtag_clk_bot;              
   wire             jtag_highz_top;            
   wire             jtag_highz_bot;            
   wire             jtag_updtdr_top;           
   wire             jtag_updtdr_bot;           
   wire             jtag_mode_top;             
   wire             jtag_mode_bot;             
   wire      [12:0] avl_select_ioereg;         
   wire       [5:0] avl_select_dcc;            
   wire      [47:0] oeb_to_ioreg;              
   wire      [95:0] data_to_ioreg;             
   wire      [11:0] chk_x1_track_in_up;        
   wire      [11:0] chk_x1_track_in_dn;        
   wire      [11:0] chk_x1_track_out_up;       
   wire      [11:0] chk_x1_track_out_dn;       
   wire             chk_x12_track_in_up;       
   wire             chk_x12_track_in_dn;       
   wire             chk_x12_track_out_up;      
   wire             chk_x12_track_out_dn;      
   wire       [3:0] rdata_en_full_local;       
   wire             rdata_en_full_mid_3;
   wire             rdata_en_full_out_3;   
   wire       [7:0] mrnk_read_local;           
   wire             mrnk_read_mid_3;            
   wire             mrnk_read_out_3;            
   wire             mrnk_read_mid_7;             
   wire             mrnk_read_out_7;             
   wire       [7:0] mrnk_write_local;          
   wire      [23:0] dqs_clk_a;                 
   wire      [23:0] dqs_clk_b;                 
   wire       [5:0] xor_clk;                   
   wire      [11:0] dqs_probe;                   
   wire      [35:0] rd_probe;                    
   wire      [11:0] link_gpio_dout_n;            
   wire      [11:0] link_gpio_oeb;               
   wire      [11:0] select_ac_hmc;               
   wire      [23:0] dq_in_del_n;                 
   wire      [23:0] dq_in_tree;                  
   wire      [11:0] test_dbg_out_local; 
   wire       [5:0] sync_clk_up_chn;
   wire       [5:0] sync_data_up_chn;
   wire       [5:0] sync_clk_dn_chn;
   wire       [5:0] sync_data_dn_chn;
   wire       [7:0] x64_osc_chain_p;              
   wire       [7:0] x64_osc_chain_n;              
   wire             x64_osc_mode_out;             

   wire      [3:0] interpolator_clk_0;    
   wire      [3:0] d_out_p_mux_0;         
   wire      [3:0] d_out_n_mux_0;         
   wire      [5:0] rb_dq_in_select_0;     
   wire      [1:0] datovr_0;              
   wire      [1:0] datovrb_0;             
   wire      [1:0] data_dq_0;             
   wire      [1:0] data_dqb_0;            
   wire      [1:0] struct_latch_open_n_0; 
   wire      [1:0] nfrzdrv_struct_0;      
   wire      [1:0] dcc_select_0;          
   wire       [1:0] sample_value_struct_0; 
   wire      [1:0] rb_gpio_or_ddr_sel_0;  
   wire      [1:0] rb_mode_ddr_0;      

   wire      [3:0] interpolator_clk_1;    
   wire      [3:0] d_out_p_mux_1;         
   wire      [3:0] d_out_n_mux_1;         
   wire      [5:0] rb_dq_in_select_1;     
   wire      [1:0] datovr_1;              
   wire      [1:0] datovrb_1;             
   wire      [1:0] data_dq_1;             
   wire      [1:0] data_dqb_1;            
   wire      [1:0] struct_latch_open_n_1; 
   wire      [1:0] nfrzdrv_struct_1;      
   wire      [1:0] dcc_select_1;          
   wire       [1:0] sample_value_struct_1; 
   wire      [1:0] rb_gpio_or_ddr_sel_1;  
   wire      [1:0] rb_mode_ddr_1;         

   wire      [3:0] interpolator_clk_2;    
   wire      [3:0] d_out_p_mux_2;         
   wire      [3:0] d_out_n_mux_2;         
   wire      [5:0] rb_dq_in_select_2;     
   wire      [1:0] datovr_2;              
   wire      [1:0] datovrb_2;             
   wire      [1:0] data_dq_2;             
   wire      [1:0] data_dqb_2;            
   wire      [1:0] struct_latch_open_n_2; 
   wire      [1:0] nfrzdrv_struct_2;      
   wire      [1:0] dcc_select_2;          
   wire       [1:0] sample_value_struct_2; 
   wire      [1:0] rb_gpio_or_ddr_sel_2;  
   wire      [1:0] rb_mode_ddr_2;         

   wire      [3:0] interpolator_clk_3;    
   wire      [3:0] d_out_p_mux_3;         
   wire      [3:0] d_out_n_mux_3;         
   wire      [5:0] rb_dq_in_select_3;     
   wire      [1:0] datovr_3;              
   wire      [1:0] datovrb_3;             
   wire      [1:0] data_dq_3;             
   wire      [1:0] data_dqb_3;            
   wire      [1:0] struct_latch_open_n_3; 
   wire      [1:0] nfrzdrv_struct_3;      
   wire      [1:0] dcc_select_3;          
   wire       [1:0] sample_value_struct_3; 
   wire      [1:0] rb_gpio_or_ddr_sel_3;  
   wire      [1:0] rb_mode_ddr_3;         

   wire      [3:0] interpolator_clk_4;    
   wire      [3:0] d_out_p_mux_4;         
   wire      [3:0] d_out_n_mux_4;         
   wire      [5:0] rb_dq_in_select_4;     
   wire      [1:0] datovr_4;              
   wire      [1:0] datovrb_4;             
   wire      [1:0] data_dq_4;             
   wire      [1:0] data_dqb_4;            
   wire      [1:0] struct_latch_open_n_4; 
   wire      [1:0] nfrzdrv_struct_4;      
   wire      [1:0] dcc_select_4;          
   wire       [1:0] sample_value_struct_4; 
   wire      [1:0] rb_gpio_or_ddr_sel_4;  
   wire      [1:0] rb_mode_ddr_4;         

   wire      [3:0] interpolator_clk_5;    
   wire      [3:0] d_out_p_mux_5;         
   wire      [3:0] d_out_n_mux_5;         
   wire      [5:0] rb_dq_in_select_5;     
   wire      [1:0] datovr_5;              
   wire      [1:0] datovrb_5;             
   wire      [1:0] data_dq_5;             
   wire      [1:0] data_dqb_5;            
   wire      [1:0] struct_latch_open_n_5; 
   wire      [1:0] nfrzdrv_struct_5;      
   wire      [1:0] dcc_select_5;          
   wire       [1:0] sample_value_struct_5; 
   wire      [1:0] rb_gpio_or_ddr_sel_5;  
   wire      [1:0] rb_mode_ddr_5;         

   wire      [5:1] osc_in_up;              
   wire      [5:0] osc_out_dn;             
   wire            osc_start_in;          
   wire            osc_start_out;         

   wire            ioereg_reset_n;        
   wire      [1:0] dqs_loop_back_0;
   wire      [1:0] dqs_loop_back_1;
   wire      [1:0] dqs_loop_back_0_nc;
   wire      [1:0] dqs_loop_back_1_nc;

   wire            dll_test_si1;
   wire            dll_test_si2;
   wire            dll_test_so1;
   wire            dll_test_so2;

   wire            xpr_clk_bot;           
   wire            xpr_clk_top;           
   wire      [2:0] xpr_write_bot;         
   wire      [2:0] xpr_write_top;         
   wire      [7:0] xpr_data_bot;          
   wire      [7:0] xpr_data_top;          

   wire            db_csrin;
   wire            dqs_csrin;


   wire      [1:0] dqs_clean_a;
   wire      [1:0] dqs_clean_b;
   wire            x128_osc_lca_p;
   wire            x128_osc_lca_n;
   wire            x128_osc_lcb_p;
   wire            x128_osc_lcb_n;
   wire      [6:0] dqs_f_gray_a;
   wire      [2:0] dqs_i_gray_a;
   wire      [6:0] dqs_f_gray_b;
   wire      [2:0] dqs_i_gray_b;
   wire            nfrzdrv_left;
   wire      [2:0] power_down_n;
   wire      [1:0] rb_filter_code_left;
   wire      [2:0] mux_sel_a_a;
   wire      [2:0] mux_sel_b_a;
   wire      [3:0] interp_sel_a_a;
   wire      [3:0] interp_sel_b_a;
   wire      [1:0] dirty_clk_out_a;
   wire            int_clk_a;
   wire      [1:0] interp_clk_out_a;
   wire      [2:0] mux_sel_a_b;
   wire      [2:0] mux_sel_b_b;
   wire      [3:0] interp_sel_a_b;
   wire      [3:0] interp_sel_b_b;
   wire      [1:0] dirty_clk_out_b;
   wire            int_clk_b;
   wire      [1:0] interp_clk_out_b;
   wire            test_enable;
   wire            rb_couple_enable;
   wire            clk_ph_1_buf;
   wire            clk_ph_3_buf;

   wire      [1:0] power_down_n_0;
   wire            nfrzdrv_nand_x64_0;
   wire      [5:0] mux_sel_a_0;
   wire      [5:0] mux_sel_b_0;
   wire      [7:0] interp_sel_a_0;
   wire      [7:0] interp_sel_b_0;
   wire      [3:0] dirty_clk_0;
   wire      [1:0] interp_enable_0;
   wire      [1:0] int_clk_0;
   wire      [3:0] interp_clk_out_0;
   wire     [11:0] dq_f_gray_0;
   wire      [5:0] dq_i_gray_0;
   wire      [7:0] dq_fall_gray_0;
   wire      [7:0] dq_rise_gray_0;
   wire            test_enable_0;

   wire      [1:0] power_down_n_1;
   wire            nfrzdrv_nand_x64_1;
   wire      [5:0] mux_sel_a_1;
   wire      [5:0] mux_sel_b_1;
   wire      [7:0] interp_sel_a_1;
   wire      [7:0] interp_sel_b_1;
   wire      [3:0] dirty_clk_1;
   wire      [1:0] interp_enable_1;
   wire      [1:0] int_clk_1;
   wire      [3:0] interp_clk_out_1;
   wire     [11:0] dq_f_gray_1;
   wire      [5:0] dq_i_gray_1;
   wire      [7:0] dq_fall_gray_1;
   wire      [7:0] dq_rise_gray_1;
   wire            test_enable_1;

   wire      [1:0] power_down_n_2;
   wire            nfrzdrv_nand_x64_2;
   wire      [5:0] mux_sel_a_2;
   wire      [5:0] mux_sel_b_2;
   wire      [7:0] interp_sel_a_2;
   wire      [7:0] interp_sel_b_2;
   wire      [3:0] dirty_clk_2;
   wire      [1:0] interp_enable_2;
   wire      [1:0] int_clk_2;
   wire      [3:0] interp_clk_out_2;
   wire     [11:0] dq_f_gray_2;
   wire      [5:0] dq_i_gray_2;
   wire      [7:0] dq_fall_gray_2;
   wire      [7:0] dq_rise_gray_2;
   wire            test_enable_2;

   wire      [1:0] power_down_n_3;
   wire            nfrzdrv_nand_x64_3;
   wire      [5:0] mux_sel_a_3;
   wire      [5:0] mux_sel_b_3;
   wire      [7:0] interp_sel_a_3;
   wire      [7:0] interp_sel_b_3;
   wire      [3:0] dirty_clk_3;
   wire      [1:0] interp_enable_3;
   wire      [1:0] int_clk_3;
   wire      [3:0] interp_clk_out_3;
   wire     [11:0] dq_f_gray_3;
   wire      [5:0] dq_i_gray_3;
   wire      [7:0] dq_fall_gray_3;
   wire      [7:0] dq_rise_gray_3;
   wire            test_enable_3;

   wire      [1:0] power_down_n_4;
   wire            nfrzdrv_nand_x64_4;
   wire      [5:0] mux_sel_a_4;
   wire      [5:0] mux_sel_b_4;
   wire      [7:0] interp_sel_a_4;
   wire      [7:0] interp_sel_b_4;
   wire      [3:0] dirty_clk_4;
   wire      [1:0] interp_enable_4;
   wire      [1:0] int_clk_4;
   wire      [3:0] interp_clk_out_4;
   wire     [11:0] dq_f_gray_4;
   wire      [5:0] dq_i_gray_4;
   wire      [7:0] dq_fall_gray_4;
   wire      [7:0] dq_rise_gray_4;
   wire            test_enable_4;

   wire      [1:0] power_down_n_5;
   wire            nfrzdrv_nand_x64_5;
   wire      [5:0] mux_sel_a_5;
   wire      [5:0] mux_sel_b_5;
   wire      [7:0] interp_sel_a_5;
   wire      [7:0] interp_sel_b_5;
   wire      [3:0] dirty_clk_5;
   wire      [1:0] interp_enable_5;
   wire      [1:0] int_clk_5;
   wire      [3:0] interp_clk_out_5;
   wire     [11:0] dq_f_gray_5;
   wire      [5:0] dq_i_gray_5;
   wire      [7:0] dq_fall_gray_5;
   wire      [7:0] dq_rise_gray_5;
   wire            test_enable_5;

   wire      [4:0] vreg_calsel;
   wire            vreg_cal_en;
   wire      [1:0] vreg_atbsel;
   wire            vreg_pdb;
   wire            vreg_ovrride;

   wire     [10:0] scan_chn_struct;
   wire            scan_chn_0;

   wire            dp_csr_in;
   wire            csren_gate;
   wire            csrclk_mux_o;
   wire      [5:0] dp_csrout;
   wire      [5:0] switch_up;                 
   wire      [5:0] switch_dn;                 
   wire      [5:0] up_ph;                     
   wire      [5:0] dzoutx;                    
   wire            local_frzreg;              
   wire      [4:0] loopback2_l2r, loopback13_l2r;
   wire      [4:0] loopback2_r2l, loopback13_r2l;
   wire      [1:0] dp_scan01_r2l, dp_scan01_l2r;
   wire      [1:0] dp_scan12_r2l, dp_scan12_l2r;
   wire      [1:0] dp_scan23_r2l, dp_scan23_l2r;
   wire      [1:0] dp_scan34_r2l, dp_scan34_l2r;
   wire      [1:0] dp_scan45_r2l, dp_scan45_l2r;
   wire      [1:0] dp_scan_int;


   wire     [23:0] dq_diff_in;                
   wire     [23:0] dq_sstl_in;                
   wire      [1:0] dqs_diff_in_0;
   wire      [1:0] dqs_diff_in_1;
   wire      [1:0] dqs_diff_in_2;
   wire      [1:0] dqs_diff_in_3;
   wire      [1:0] dqs_sstl_p_0;
   wire      [1:0] dqs_sstl_p_1;
   wire      [1:0] dqs_sstl_p_2;
   wire      [1:0] dqs_sstl_p_3;
   wire      [1:0] dqs_sstl_n_0;
   wire      [1:0] dqs_sstl_n_1;
   wire      [1:0] dqs_sstl_n_2;
   wire      [1:0] dqs_sstl_n_3;

   wire            sync_a_ioereg_top;
   wire            sync_a_ioereg_bot;

   wire      [31:0] ioereg_scanout_used_0;
   wire      [31:0] ioereg_scanout_used_1;
   wire      [31:0] ioereg_scanout_used_2;
   wire      [31:0] ioereg_scanout_used_3;
   wire      [31:0] ioereg_scanout_used_4;
   wire      [31:0] ioereg_scanout_used_5;
   wire               scan_31_0_1;
   wire               scan_31_0_lane;
   wire               scan_31_1_2;
   wire               scan_31_2_3;
   wire               scan_31_3_4;
   wire               scan_31_4_5;
   wire               scan_32_0_1;
   wire               scan_32_1_2;
   wire               scan_32_2_3;
   wire               scan_32_3_4;
   wire               scan_32_4_5;
   wire               scan_32_5_lane;
   wire               scan_33_0_1;
   wire               scan_33_0_lane;
   wire               scan_33_1_2;
   wire               scan_33_2_3;
   wire               scan_33_3_4;
   wire               scan_33_4_5;
   wire               scan_34_0_1;
   wire               scan_34_1_2;
   wire               scan_34_2_3;
   wire               scan_34_3_4;
   wire               scan_34_4_5;
   wire               scan_34_5_lane;
   
   wire             afi_cal_success;






assign test_dp_csr_out = dp_csrout[5];
assign test_ioereg2_csr_out = ioereg_csrout[3];
assign test_dll_csr_out = csr_out;

assign mrnk_read_mid_3 = mrnk_read_local[3];
assign mrnk_read_out_3 = mrnk_read_mid_3;
assign mrnk_read_mid_7 = mrnk_read_local[7];
assign mrnk_read_out_7 = mrnk_read_mid_7;
assign rdata_en_full_mid_3 = rdata_en_full_local[3];
assign rdata_en_full_out_3 = rdata_en_full_mid_3;

assign rdata_valid_mid = rdata_valid_local;
assign rdata_valid_out = rdata_valid_mid;

assign dqs_diff_in_0[0] = dqs_diff_in_0_0;
assign dqs_diff_in_0[1] = dqs_diff_in_0_1;
assign dqs_diff_in_1[0] = dqs_diff_in_1_0;
assign dqs_diff_in_1[1] = dqs_diff_in_1_1;
assign dqs_diff_in_2[0] = dqs_diff_in_2_0;
assign dqs_diff_in_2[1] = dqs_diff_in_2_1;
assign dqs_diff_in_3[0] = dqs_diff_in_3_0;
assign dqs_diff_in_3[1] = dqs_diff_in_3_1;
assign dqs_sstl_p_0[0] = dqs_sstl_p_0_0;
assign dqs_sstl_p_0[1] = dqs_sstl_p_0_1;
assign dqs_sstl_p_1[0] = dqs_sstl_p_1_0;
assign dqs_sstl_p_1[1] = dqs_sstl_p_1_1;
assign dqs_sstl_p_2[0] = dqs_sstl_p_2_0;
assign dqs_sstl_p_2[1] = dqs_sstl_p_2_1;
assign dqs_sstl_p_3[0] = dqs_sstl_p_3_0;
assign dqs_sstl_p_3[1] = dqs_sstl_p_3_1;
assign dqs_sstl_n_0[0] = dqs_sstl_n_0_0;
assign dqs_sstl_n_0[1] = dqs_sstl_n_0_1;
assign dqs_sstl_n_1[0] = dqs_sstl_n_1_0;
assign dqs_sstl_n_1[1] = dqs_sstl_n_1_1;
assign dqs_sstl_n_2[0] = dqs_sstl_n_2_0;
assign dqs_sstl_n_2[1] = dqs_sstl_n_2_1;
assign dqs_sstl_n_3[0] = dqs_sstl_n_3_0;
assign dqs_sstl_n_3[1] = dqs_sstl_n_3_1;

assign  dq_diff_in  = { dqscodatovr[5],
                        dqscodatovrb[5],
                        dqscodatovr[5],
                        dqscodatovrb[5],
                        dqscodatovr[4],
                        dqscodatovrb[4],
                        dqscodatovr[4],
                        dqscodatovrb[4],
                        dqscodatovr[3],
                        dqscodatovrb[3],
                        dqscodatovr[3],
                        dqscodatovrb[3],
                        dqscodatovr[2],
                        dqscodatovrb[2],
                        dqscodatovr[2],
                        dqscodatovrb[2],
                        dqscodatovr[1],
                        dqscodatovrb[1],
                        dqscodatovr[1],
                        dqscodatovrb[1],
                        dqscodatovr[0],
                        dqscodatovrb[0],
                        dqscodatovr[0],
                        dqscodatovrb[0] };

assign  dq_sstl_in  = { codatovr[11],
                        codatovrb[11],
                        codatovr[10],
                        codatovrb[10],
                        codatovr[9],
                        codatovrb[9],
                        codatovr[8],
                        codatovrb[8],
                        codatovr[7],
                        codatovrb[7],
                        codatovr[6],
                        codatovrb[6],
                        codatovr[5],
                        codatovrb[5],
                        codatovr[4],
                        codatovrb[4],
                        codatovr[3],
                        codatovrb[3],
                        codatovr[2],
                        codatovrb[2],
                        codatovr[1],
                        codatovrb[1],
                        codatovr[0],
                        codatovrb[0] };

assign csr_scan_shift_n_vref = csr_shift_n_left;

assign xor_vref_outbuf = xor_vref_inbuf;
assign s2pload_output  = s2pload_input;

assign scanout[79]  =  dft_db2core[0];
assign scanout[78]  =  dft_db2core[0];



io_dft_mux__mdev40 xdb_csrin_mux (
.testin (test_db_csr_in),
.usrin (dp_csrout[5]),
.s (scan_shift_n),
.dout (db_csrin)
);

io_dft_mux__mdev40 xdqs_csrin_mux (
.testin (test_dqs_csr_in),
.usrin ( ioereg_csrout[3]),
.s (scan_shift_n),
.dout (dqs_csrin)

);




io_ioereg_top__mdev40 ioereg_top_0_ (
.reset_n                 ( ioereg_reset_n                   ), 
.phy_clk                 ( 'd0                              ), 
.chk_x1_track_out_up     ( chk_x1_track_out_up[1:0]         ), 
.chk_x1_track_out_dn     ( chk_x1_track_out_dn[1:0]         ), 
.core_data_out           ( data_to_ioreg[15:0]              ), 
.core_oeb                ( oeb_to_ioreg[7:0]                ), 
.core_data_in            ( data_from_ioreg[15:0]            ), 
.avl_select              ( avl_select_ioereg[1:0]           ), 
.avl_select_dcc          ( avl_select_dcc[0]                ), 
.dpa_track_out_up        ( switch_up[0]                     ), 
.dpa_track_out_dn        ( switch_dn[0]                     ), 
.phase_kicker            ( dzoutx[0]                        ), 
.phase_direction         ( up_ph[0]                         ), 
.dqs_clk_a               ( dqs_clk_a[3:0]                   ), 
.dqs_clk_b               ( dqs_clk_b[3:0]                   ), 
.chk_x12_track_out_up    ( chk_x12_track_out_up_bot         ), 
.chk_x12_track_out_dn    ( chk_x12_track_out_dn_bot         ), 
.rb_phy_clk_mode         ( rb_phy_clk_mode_bot              ), 
.rb_track_speed          ( rb_track_speed_bot[3:0]          ), 
.rb_kicker_size          ( rb_kicker_size_bot[1:0]          ), 
.rb_mode_rate_in         ( rb_mode_rate_in_bot[1:0]         ), 
.rb_mode_rate_out        ( rb_mode_rate_out_bot[1:0]        ), 
.fifo_pack_select        ( fifo_pack_select_bot[1:0]        ), 
.fifo_read_enable        ( fifo_read_enable_bot             ), 
.fifo_reset_n            ( fifo_reset_n_bot                 ), 
.fifo_rank_sel           ( fifo_rank_sel_bot                ), 
.rank_in_a               ( rank_in_a_bot[1:0]               ), 
.rank_in_b               ( rank_in_b_bot[1:0]               ), 
.rank_out                ( rank_out_bot[7:0]                ), 
.oct_enable_out          ( oct_enable_out_bot               ), 
.oct_enable_pin          ( oct_enable[1:0]                  ), 
.avl_wr_address          ( avl_wr_address_bot[4:0]          ), 
.avl_rd_address          ( avl_rd_address_bot[4:0]          ), 
.avl_sync_write          ( avl_sync_write_bot               ), 
.avl_destruct_read       ( avl_destruct_read_bot            ), 
.avl_writedata           ( avl_writedata_bot[15:0]          ), 
.avl_readchain_in        ( 16'h0000                         ), 
.avl_readchain_out       ( avl_readchain_bot[15:0]          ), 
.pvt_write               ( pvt_write[0]                     ), 
.pvt_address             ( pvt_address_bot[2:0]             ), 
.pvt_data                ( pvt_data_bot[8:0]                ), 
.csr_clk                 ( csr_clk_bot                      ), 
.csr_in                  ( ioereg_csrout[0]                 ), 
.csr_en                  ( csr_en_bot                       ), 
.csr_shift_n             ( 1'b1                             ), 
.csr_out                 ( ioereg_csrout[1]                 ), 
.nfrzdrv                 ( nfrzdrv_bot                      ), 
.frzreg                  ( frzreg_bot                       ), 
.ncein                   ( ncein[1:0]                       ), 
.nceout                  ( nceout[1:0]                      ), 
.naclr                   ( naclr[1:0]                       ), 
.nsclr                   ( nsclr[1:0]                       ), 
.fr_in_clk               ( fr_in_clk[1:0]                   ), 
.hr_in_clk               ( hr_in_clk[1:0]                   ), 
.fr_out_clk              ( fr_out_clk[1:0]                  ), 
.hr_out_clk              ( hr_out_clk[1:0]                  ), 
.pll_clk                 ( 1'b0                             ), 
.atpg_en_n               ( atpg_en_n_bot                    ), 
.pipeline_global_en_n    ( pipeline_global_en_n_bot         ), 
.test_clr_n              ( test_clr_n_bot                   ), 
.test_tdf_select_n       ( test_tdf_select_n_bot            ), 
.tpin                    ( tpin[1:0]                        ), 
.tpctl                   ( tpctl[1:0]                       ), 
.test_io_ctrl_3          ( test_io_ctrl_3                   ), 
.tpdata                  ( tpdata[1:0]                      ), 
.niotri                  ( niotri_bot                       ), 
.progctl                 ( progctl[1:0]                     ), 
.progout                 ( progout[1:0]                     ), 
.progoe                  ( progoe[1:0]                      ), 
.test_clk                ( test_clock                     ), 
.scan_shift_n            ( scan_shift_n_bot                 ), 
.scan_in                 ( { 1'b0, scan_33_0_1, 1'b0, 32'b0}  ), 
.scan_out                ( { scan_34_0_1, scan_33_0_lane, scan_32_0_1,ioereg_scanout_used_0}), 
.xor_clk                 ( xor_clk[0]                       ), 
.test_dbg_out            ( test_dbg_out_local[1:0]          ), 
.test_dbg_in             ( test_dbg_in[1:0]                 ), 
.probe_out               ( {dqs_probe[1:0],rd_probe[17:0]}  ), 
.read_path_probe         ( rd_probe[5:0]                    ), 
.jtag_shftdr             ( jtag_shftdr_bot                  ), 
.jtag_clk                ( jtag_clk_bot                     ), 
.jtag_highz              ( jtag_highz_bot                   ), 
.jtag_sdin               ( jtag_sdin                        ), 
.jtag_updtdr             ( jtag_updtdr_bot                  ), 
.jtag_mode               ( jtag_mode_bot                    ), 
.jtag_sdout              ( ioereg_jtag_sdout[0]             ), 
.osc_sel_n               ( osc_sel_n                        ), 
.osc_in_dn               ( osc_out_dn[1]                    ), 
.osc_in_up               ( osc_out_dn[0]                    ), 
.osc_out_dn              ( osc_out_dn[0]                    ), 
.osc_out_up              ( osc_in_up[1]                     ), 
.sync_clk_bot_in         ( sync_clk_bot_in                  ), 
.sync_data_bot_in        ( sync_data_bot_in                 ), 
.sync_clk_bot_out        ( sync_clk_bot_out                 ), 
.sync_data_bot_out       ( sync_data_bot_out                ), 
.sync_clk_top_in         ( sync_clk_dn_chn[0]               ), 
.sync_data_top_in        ( sync_data_dn_chn[0]              ), 
.sync_clk_top_out        ( sync_clk_up_chn[0]               ), 
.sync_data_top_out       ( sync_data_up_chn[0]              ), 
.d_out_p_mux_out         ( d_out_p_mux_0[3:0]               ), 
.d_out_n_mux_out         ( d_out_n_mux_0[3:0]               ), 
.rb_dq_in_select         ( rb_dq_in_select_0[5:0]           ), 
.datovr_in               ( datovr_0[1:0]                    ), 
.datovrb_in              ( datovrb_0[1:0]                   ), 
.struct_latch_open_n_out ( struct_latch_open_n_0[1:0]       ), 
.nfrzdrv_struct_out      ( nfrzdrv_struct_0[1:0]            ), 
.ac_hmc                  ( ac_hmc[15:0]                     ), 
.select_ac_hmc           ( select_ac_hmc[1:0]               ), 
.dq_in_tree              ( dq_in_tree[3:0]                  ), 
.xpr_clk                 ( xpr_clk_bot                      ), 
.xpr_write               ( xpr_write_bot[0]                 ), 
.xpr_data                ( xpr_data_bot[7:0]                ), 
.ioereg_locked           ( ioereg_locked[0]                 ),
.weak_pullup_enable      ( weak_pullup_enable[1:0]          ),
.power_down_n            ( power_down_n_0[1:0]              ), 
.nfrzdrv_nand_x64        ( nfrzdrv_nand_x64_0               ), 
.mux_sel_a               ( mux_sel_a_0[5:0]                 ), 
.mux_sel_b               ( mux_sel_b_0[5:0]                 ), 
.interp_sel_a            ( interp_sel_a_0[7:0]              ), 
.interp_sel_b            ( interp_sel_b_0[7:0]              ), 
.dirty_clk               ( dirty_clk_0[3:0]                 ), 
.interp_enable           ( interp_enable_0[1:0]             ), 
.test_enable             ( test_enable_0                    ), 
.int_clk                 ( int_clk_0[1:0]                   ), 
.interp_clk_out          ( interp_clk_out_0[3:0]            ), 
.clk_ph_1_buf            ( clk_ph_1_buf                     ), 
.clk_ph_3_buf            ( clk_ph_3_buf                     ), 
.dq_fall_gray            ( dq_fall_gray_0[7:0]              ), 
.dq_rise_gray            ( dq_rise_gray_0[7:0]              ), 
.dq_f_gray               ( dq_f_gray_0[11:0]                ), 
.dq_i_gray               ( dq_i_gray_0[5:0]                 ), 
.sample_value_iob        ( sample_value_iob[0]              ), 
.sample_value_struct     ( sample_value_struct_0[1:0]       ), 
.rb_gpio_or_ddr_sel      ( rb_gpio_or_ddr_sel_0[1:0]        ), 
.rb_0_mode_ddr           ( rb_mode_ddr_0[0]                 ), 
.rb_1_mode_ddr           ( rb_mode_ddr_0[1]                 ), 
.dcc_select              ( dcc_select_0[1:0]                ), 
.sample_value_lane       ( sample_value_lane[0]             ), 
.sync_a_ioereg           ( sync_a_ioereg_bot                ), 
.sample_clk              ( sample_clk_0                     ) 
);

io_ioereg_struct__mdev40 ioereg_struct_0_0 (
.interpolator_clk   ( interpolator_clk_0[1:0]  ), 
.d_out_p_mux        ( d_out_p_mux_0[1:0]       ), 
.d_out_n_mux        ( d_out_n_mux_0[1:0]       ), 
.codin_p            ( codin_p[0]               ), 
.codin_pb           ( codin_pb[0]              ), 
.codin_n            ( codin_n[0]               ), 
.codin_nb           ( codin_nb[0]              ), 
.rb_dq_select       ( rb_dq_in_select_0[2:0]   ), 
.latch_open_n       ( struct_latch_open_n_0[0] ), 
.dq_diff_in         ( dq_diff_in[1:0]          ), 
.dq_sstl_in         ( dq_sstl_in[1:0]          ), 
.nfrzdrv            ( nfrzdrv_struct_0[0]      ), 
.loopback_p         ( loopback_p[0]            ), 
.loopback_n         ( loopback_n[0]            ), 
.loopback_en_n      ( loopback_en_n[0]         ), 
.datovr             ( datovr_0[0]              ), 
.datovrb            ( datovrb_0[0]             ), 
.data_dq            ( data_dq_0[0]             ), 
.data_dqb           ( data_dqb_0[0]            ), 
.dqs_loop_back      (                          ),
.sample_clk         ( sample_clk_0             ),
.dcc_select         ( dcc_select_0[1:0]        ),
.dcc_sample         ( sample_value_struct_0[0] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_0[0]  ), 
.rb_mode_ddr        ( rb_mode_ddr_0[0]         ), 
.scan_in            ( scanin[75]               ), 
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scan_chn_struct[0]       )
);

io_ioereg_struct__mdev40 ioereg_struct_0_1 (
.interpolator_clk   ( interpolator_clk_0[3:2]  ), 
.d_out_p_mux        ( d_out_p_mux_0[3:2]       ), 
.d_out_n_mux        ( d_out_n_mux_0[3:2]       ), 
.codin_p            ( codin_p[1]               ), 
.codin_pb           ( codin_pb[1]              ), 
.codin_n            ( codin_n[1]               ), 
.codin_nb           ( codin_nb[1]              ), 
.rb_dq_select       ( rb_dq_in_select_0[5:3]   ), 
.latch_open_n       ( struct_latch_open_n_0[1] ), 
.dq_diff_in         ( dq_diff_in[3:2]          ), 
.dq_sstl_in         ( dq_sstl_in[3:2]          ), 
.nfrzdrv            ( nfrzdrv_struct_0[1]      ), 
.loopback_p         ( loopback_p[1]            ), 
.loopback_n         ( loopback_n[1]            ), 
.loopback_en_n      ( loopback_en_n[1]         ), 
.datovr             ( datovr_0[1]              ), 
.datovrb            ( datovrb_0[1]             ), 
.data_dq            ( data_dq_0[1]             ), 
.data_dqb           ( data_dqb_0[1]            ), 
.dqs_loop_back      (                          ), 
.sample_clk         ( sample_clk_0             ),
.dcc_select         ( dcc_select_0[1:0]        ),
.dcc_sample         ( sample_value_struct_0[1] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_0[1]  ), 
.rb_mode_ddr        ( rb_mode_ddr_0[1]         ), 
.scan_in            ( scan_chn_struct[0]       ),
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scan_chn_struct[1]       )
);

io_ioereg_custom__mdev40 io_ioereg_custom_0 (
.data_dq_in             ( data_dq_0[1:0]                   ),
.data_dqb_in            ( data_dqb_0[1:0]                  ),
.x64_osc_in_p           ( x64_osc_chain_p[0]               ),
.x64_osc_in_n           ( x64_osc_chain_n[0]               ),
.x64_osc_out_p          ( x64_osc_chain_p[1]               ),
.x64_osc_out_n          ( x64_osc_chain_n[1]               ),
.x64_osc_mode           ( x64_osc_mode_out                 ),
.nfrzdrv                ( nfrzdrv_nand_x64_0               ),
.dq_f_gray              ( dq_f_gray_0[11:0]                ),
.dq_i_gray              ( dq_i_gray_0[5:0]                 ),
.dq_fall_gray           ( dq_fall_gray_0[7:0]              ),
.dq_rise_gray           ( dq_rise_gray_0[7:0]              ),
.dq_in_del              ( dq_in_del_n[3:0]                 ),
.phy_clk_phs            ( 8'd0                             ),
.rb_filter_code         ( rb_filter_code_bot[1:0]          ),
.test_enable            ( test_enable_0                    ),
.rb_couple_enable       ( rb_couple_enable                 ),
.power_down_n           ( power_down_n_0[1:0]              ),
.mux_sel_a              ( mux_sel_a_0[5:0]                 ),
.mux_sel_b              ( mux_sel_b_0[5:0]                 ),
.interp_sel_a           ( interp_sel_a_0[7:0]              ),
.interp_sel_b           ( interp_sel_b_0[7:0]              ),
.dirty_clk              ( dirty_clk_0[3:0]                 ),
.interp_enable          ( interp_enable_0[1:0]             ),
.int_clk                ( int_clk_0[1:0]                   ),
.interp_clk_out         ( interp_clk_out_0[3:0]            ),
.interpolator_clk       ( interpolator_clk_0[3:0]          )
);

io_ioereg_top__mdev40 ioereg_top_1_ (
.reset_n                 ( ioereg_reset_n                   ), 
.phy_clk                 ( 'd0                              ), 
.chk_x1_track_out_up     ( chk_x1_track_out_up[3:2]         ), 
.chk_x1_track_out_dn     ( chk_x1_track_out_dn[3:2]         ), 
.core_data_out           ( data_to_ioreg[31:16]             ), 
.core_oeb                ( oeb_to_ioreg[15:8]               ), 
.core_data_in            ( data_from_ioreg[31:16]           ), 
.avl_select              ( avl_select_ioereg[3:2]           ), 
.avl_select_dcc          ( avl_select_dcc[1]                ), 
.dpa_track_out_up        ( switch_up[1]                     ), 
.dpa_track_out_dn        ( switch_dn[1]                     ), 
.phase_kicker            ( dzoutx[1]                        ), 
.phase_direction         ( up_ph[1]                         ), 
.dqs_clk_a               ( dqs_clk_a[7:4]                   ), 
.dqs_clk_b               ( dqs_clk_b[7:4]                   ), 
.chk_x12_track_out_up    ( chk_x12_track_out_up_bot         ), 
.chk_x12_track_out_dn    ( chk_x12_track_out_dn_bot         ), 
.rb_phy_clk_mode         ( rb_phy_clk_mode_bot              ), 
.rb_track_speed          ( rb_track_speed_bot[3:0]          ), 
.rb_kicker_size          ( rb_kicker_size_bot[1:0]          ), 
.rb_mode_rate_in         ( rb_mode_rate_in_bot[1:0]         ), 
.rb_mode_rate_out        ( rb_mode_rate_out_bot[1:0]        ), 
.fifo_pack_select        ( fifo_pack_select_bot[1:0]        ), 
.fifo_read_enable        ( fifo_read_enable_bot             ), 
.fifo_reset_n            ( fifo_reset_n_bot                 ), 
.fifo_rank_sel           ( fifo_rank_sel_bot                ), 
.rank_in_a               ( rank_in_a_bot[1:0]               ), 
.rank_in_b               ( rank_in_b_bot[1:0]               ), 
.rank_out                ( rank_out_bot[7:0]                ), 
.oct_enable_out          ( oct_enable_out_bot               ), 
.oct_enable_pin          ( oct_enable[3:2]                  ), 
.avl_wr_address          ( avl_wr_address_bot[4:0]          ), 
.avl_rd_address          ( avl_rd_address_bot[4:0]          ), 
.avl_sync_write          ( avl_sync_write_bot               ), 
.avl_destruct_read       ( avl_destruct_read_bot            ), 
.avl_writedata           ( avl_writedata_bot[15:0]          ), 
.avl_readchain_in        ( avl_readchain_bot[15:0]          ), 
.avl_readchain_out       ( avl_readchain_bot[31:16]         ), 
.pvt_write               ( pvt_write[1]                     ), 
.pvt_address             ( pvt_address_bot[2:0]             ), 
.pvt_data                ( pvt_data_bot[8:0]                ), 
.csr_clk                 ( csr_clk_bot                      ), 
.csr_in                  ( ioereg_csrout[1]                 ), 
.csr_en                  ( csr_en_bot                       ), 
.csr_shift_n             ( 1'b1                             ), 
.csr_out                 ( ioereg_csrout[2]                 ), 
.nfrzdrv                 ( nfrzdrv_bot                      ), 
.frzreg                  ( frzreg_bot                       ), 
.ncein                   ( ncein[3:2]                       ), 
.nceout                  ( nceout[3:2]                      ), 
.naclr                   ( naclr[3:2]                       ), 
.nsclr                   ( nsclr[3:2]                       ), 
.fr_in_clk               ( fr_in_clk[3:2]                   ), 
.hr_in_clk               ( hr_in_clk[3:2]                   ), 
.fr_out_clk              ( fr_out_clk[3:2]                  ), 
.hr_out_clk              ( hr_out_clk[3:2]                  ), 
.pll_clk                 ( 1'b0                             ), 
.atpg_en_n               ( atpg_en_n_bot                    ), 
.pipeline_global_en_n    ( pipeline_global_en_n_bot         ), 
.test_clr_n              ( test_clr_n_bot                   ), 
.test_tdf_select_n       ( test_tdf_select_n_bot            ), 
.tpin                    ( tpin[3:2]                        ), 
.tpctl                   ( tpctl[3:2]                       ), 
.test_io_ctrl_3          ( test_io_ctrl_3                   ), 
.tpdata                  ( tpdata[3:2]                      ), 
.niotri                  ( niotri_bot                       ), 
.progctl                 ( progctl[3:2]                     ), 
.progout                 ( progout[3:2]                     ), 
.progoe                  ( progoe[3:2]                      ), 
.test_clk                ( test_clock                     ), 
.scan_shift_n            ( scan_shift_n_bot                 ), 
.scan_in                 ( { scan_34_0_1, scan_33_1_2, scan_32_0_1, 32'b0}  ), 
.scan_out                ( { scan_34_1_2, scan_33_0_1, scan_32_1_2, ioereg_scanout_used_1}), 
.xor_clk                 ( xor_clk[1]                       ), 
.test_dbg_out            ( test_dbg_out_local[3:2]          ), 
.test_dbg_in             ( test_dbg_in[3:2]                 ), 
.probe_out               ( {dqs_probe[3:2],rd_probe[17:0]}  ), 
.read_path_probe         ( rd_probe[11:6]                   ), 
.jtag_shftdr             ( jtag_shftdr_bot                  ), 
.jtag_clk                ( jtag_clk_bot                     ), 
.jtag_highz              ( jtag_highz_bot                   ), 
.jtag_sdin               ( ioereg_jtag_sdout[0]             ), 
.jtag_updtdr             ( jtag_updtdr_bot                  ), 
.jtag_mode               ( jtag_mode_bot                    ), 
.jtag_sdout              ( ioereg_jtag_sdout[1]             ), 
.osc_sel_n               ( osc_sel_n                        ), 
.osc_in_dn               ( osc_out_dn[2]                    ), 
.osc_in_up               ( osc_in_up[1]                     ), 
.osc_out_dn              ( osc_out_dn[1]                    ), 
.osc_out_up              ( osc_in_up[2]                     ), 
.sync_clk_bot_in         ( sync_clk_up_chn[0]               ), 
.sync_data_bot_in        ( sync_data_up_chn[0]              ), 
.sync_clk_bot_out        ( sync_clk_dn_chn[0]               ), 
.sync_data_bot_out       ( sync_data_dn_chn[0]              ), 
.sync_clk_top_in         ( sync_clk_dn_chn[1]               ), 
.sync_data_top_in        ( sync_data_dn_chn[1]              ), 
.sync_clk_top_out        ( sync_clk_up_chn[1]               ), 
.sync_data_top_out       ( sync_data_up_chn[1]              ), 
.d_out_p_mux_out         ( d_out_p_mux_1[3:0]               ), 
.d_out_n_mux_out         ( d_out_n_mux_1[3:0]               ), 
.rb_dq_in_select         ( rb_dq_in_select_1[5:0]           ), 
.datovr_in               ( datovr_1[1:0]                    ), 
.datovrb_in              ( datovrb_1[1:0]                   ), 
.struct_latch_open_n_out ( struct_latch_open_n_1[1:0]       ), 
.nfrzdrv_struct_out      ( nfrzdrv_struct_1[1:0]            ), 
.ac_hmc                  ( ac_hmc[31:16]                    ), 
.select_ac_hmc           ( select_ac_hmc[3:2]               ), 
.dq_in_tree              ( dq_in_tree[7:4]                  ), 
.xpr_clk                 ( xpr_clk_bot                      ), 
.xpr_write               ( xpr_write_bot[1]                 ), 
.xpr_data                ( xpr_data_bot[7:0]                ), 
.ioereg_locked           ( ioereg_locked[1]                 ),
.weak_pullup_enable      ( weak_pullup_enable[3:2]          ),
.power_down_n            ( power_down_n_1[1:0]              ), 
.nfrzdrv_nand_x64        ( nfrzdrv_nand_x64_1               ), 
.mux_sel_a               ( mux_sel_a_1[5:0]                 ), 
.mux_sel_b               ( mux_sel_b_1[5:0]                 ), 
.interp_sel_a            ( interp_sel_a_1[7:0]              ), 
.interp_sel_b            ( interp_sel_b_1[7:0]              ), 
.dirty_clk               ( dirty_clk_1[3:0]                 ), 
.interp_enable           ( interp_enable_1[1:0]             ), 
.test_enable             ( test_enable_1                    ), 
.int_clk                 ( int_clk_1[1:0]                   ), 
.interp_clk_out          ( interp_clk_out_1[3:0]            ), 
.clk_ph_1_buf            ( clk_ph_1_buf                     ), 
.clk_ph_3_buf            ( clk_ph_3_buf                     ), 
.dq_fall_gray            ( dq_fall_gray_1[7:0]              ), 
.dq_rise_gray            ( dq_rise_gray_1[7:0]              ), 
.dq_f_gray               ( dq_f_gray_1[11:0]                ), 
.dq_i_gray               ( dq_i_gray_1[5:0]                 ), 
.sample_value_iob        ( sample_value_iob[1]              ), 
.sample_value_struct     ( sample_value_struct_1[1:0]       ), 
.rb_gpio_or_ddr_sel      ( rb_gpio_or_ddr_sel_1[1:0]        ), 
.rb_0_mode_ddr           ( rb_mode_ddr_1[0]                 ), 
.rb_1_mode_ddr           ( rb_mode_ddr_1[1]                 ), 
.dcc_select              ( dcc_select_1[1:0]                ), 
.sample_value_lane       ( sample_value_lane[1]             ), 
.sync_a_ioereg           ( sync_a_ioereg_bot                ), 
.sample_clk              ( sample_clk_1                     ) 
);

io_ioereg_struct__mdev40 ioereg_struct_1_0 (
.interpolator_clk   ( interpolator_clk_1[1:0]  ), 
.d_out_p_mux        ( d_out_p_mux_1[1:0]       ), 
.d_out_n_mux        ( d_out_n_mux_1[1:0]       ), 
.codin_p            ( codin_p[2]               ), 
.codin_pb           ( codin_pb[2]              ), 
.codin_n            ( codin_n[2]               ), 
.codin_nb           ( codin_nb[2]              ), 
.rb_dq_select       ( rb_dq_in_select_1[2:0]   ), 
.latch_open_n       ( struct_latch_open_n_1[0] ), 
.dq_diff_in         ( dq_diff_in[5:4]          ), 
.dq_sstl_in         ( dq_sstl_in[5:4]          ), 
.nfrzdrv            ( nfrzdrv_struct_1[0]      ), 
.loopback_p         ( loopback_p[2]            ), 
.loopback_n         ( loopback_n[2]            ), 
.loopback_en_n      ( loopback_en_n[2]         ), 
.datovr             ( datovr_1[0]              ), 
.datovrb            ( datovrb_1[0]             ), 
.data_dq            ( data_dq_1[0]             ), 
.data_dqb           ( data_dqb_1[0]            ), 
.dqs_loop_back      (                          ),
.sample_clk         ( sample_clk_1             ),
.dcc_select         ( dcc_select_1[1:0]        ),
.dcc_sample         ( sample_value_struct_1[0] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_1[0]  ), 
.rb_mode_ddr        ( rb_mode_ddr_1[0]         ), 
.scan_in            ( scan_chn_struct[1]       ),
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scan_chn_struct[2]       )
);

io_ioereg_struct__mdev40 ioereg_struct_1_1 (
.interpolator_clk   ( interpolator_clk_1[3:2]  ), 
.d_out_p_mux        ( d_out_p_mux_1[3:2]       ), 
.d_out_n_mux        ( d_out_n_mux_1[3:2]       ), 
.codin_p            ( codin_p[3]               ), 
.codin_pb           ( codin_pb[3]              ), 
.codin_n            ( codin_n[3]               ), 
.codin_nb           ( codin_nb[3]              ), 
.rb_dq_select       ( rb_dq_in_select_1[5:3]   ), 
.latch_open_n       ( struct_latch_open_n_1[1] ), 
.dq_diff_in         ( dq_diff_in[7:6]          ), 
.dq_sstl_in         ( dq_sstl_in[7:6]          ), 
.nfrzdrv            ( nfrzdrv_struct_1[1]      ), 
.loopback_p         ( loopback_p[3]            ), 
.loopback_n         ( loopback_n[3]            ), 
.loopback_en_n      ( loopback_en_n[3]         ), 
.datovr             ( datovr_1[1]              ), 
.datovrb            ( datovrb_1[1]             ), 
.data_dq            ( data_dq_1[1]             ), 
.data_dqb           ( data_dqb_1[1]            ), 
.dqs_loop_back      (                          ), 
.sample_clk         ( sample_clk_1             ),
.dcc_select         ( dcc_select_1[1:0]        ),
.dcc_sample         ( sample_value_struct_1[1] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_1[1]  ), 
.rb_mode_ddr        ( rb_mode_ddr_1[1]         ), 
.scan_in            ( scan_chn_struct[2]       ),
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scan_chn_struct[3]       )
);

io_ioereg_custom__mdev40 io_ioereg_custom_1 (
.data_dq_in             ( data_dq_1[1:0]                   ),
.data_dqb_in            ( data_dqb_1[1:0]                  ),
.x64_osc_in_p           ( x64_osc_chain_p[1]               ),
.x64_osc_in_n           ( x64_osc_chain_n[1]               ),
.x64_osc_out_p          ( x64_osc_chain_p[2]               ),
.x64_osc_out_n          ( x64_osc_chain_n[2]               ),
.x64_osc_mode           ( x64_osc_mode_out                 ),
.nfrzdrv                ( nfrzdrv_nand_x64_1               ),
.dq_f_gray              ( dq_f_gray_1[11:0]                ),
.dq_i_gray              ( dq_i_gray_1[5:0]                 ),
.dq_fall_gray           ( dq_fall_gray_1[7:0]              ),
.dq_rise_gray           ( dq_rise_gray_1[7:0]              ),
.dq_in_del              ( dq_in_del_n[7:4]                 ),
.phy_clk_phs            ( 8'd0                     	   ),
.rb_filter_code         ( rb_filter_code_bot[1:0]          ),
.test_enable            ( test_enable_1                    ),
.rb_couple_enable       ( rb_couple_enable                 ),
.power_down_n           ( power_down_n_1[1:0]              ),
.mux_sel_a              ( mux_sel_a_1[5:0]                 ),
.mux_sel_b              ( mux_sel_b_1[5:0]                 ),
.interp_sel_a           ( interp_sel_a_1[7:0]              ),
.interp_sel_b           ( interp_sel_b_1[7:0]              ),
.dirty_clk              ( dirty_clk_1[3:0]                 ),
.interp_enable          ( interp_enable_1[1:0]             ),
.int_clk                ( int_clk_1[1:0]                   ),
.interp_clk_out         ( interp_clk_out_1[3:0]            ),
.interpolator_clk       ( interpolator_clk_1[3:0]          )
);

io_ioereg_top__mdev40 ioereg_top_2_ (
.reset_n                 ( ioereg_reset_n                   ), 
.phy_clk                 ( 'd0                              ), 
.chk_x1_track_out_up     ( chk_x1_track_out_up[5:4]         ), 
.chk_x1_track_out_dn     ( chk_x1_track_out_dn[5:4]         ), 
.core_data_out           ( data_to_ioreg[47:32]             ), 
.core_oeb                ( oeb_to_ioreg[23:16]              ), 
.core_data_in            ( data_from_ioreg[47:32]           ), 
.avl_select              ( avl_select_ioereg[5:4]           ), 
.avl_select_dcc          ( avl_select_dcc[2]                ), 
.dpa_track_out_up        ( switch_up[2]                     ), 
.dpa_track_out_dn        ( switch_dn[2]                     ), 
.phase_kicker            ( dzoutx[2]                        ), 
.phase_direction         ( up_ph[2]                         ), 
.dqs_clk_a               ( dqs_clk_a[11:8]                  ), 
.dqs_clk_b               ( dqs_clk_b[11:8]                  ), 
.chk_x12_track_out_up    ( chk_x12_track_out_up_bot         ), 
.chk_x12_track_out_dn    ( chk_x12_track_out_dn_bot         ), 
.rb_phy_clk_mode         ( rb_phy_clk_mode_bot              ), 
.rb_track_speed          ( rb_track_speed_bot[3:0]          ), 
.rb_kicker_size          ( rb_kicker_size_bot[1:0]          ), 
.rb_mode_rate_in         ( rb_mode_rate_in_bot[1:0]         ), 
.rb_mode_rate_out        ( rb_mode_rate_out_bot[1:0]        ), 
.fifo_pack_select        ( fifo_pack_select_bot[1:0]        ), 
.fifo_read_enable        ( fifo_read_enable_bot             ), 
.fifo_reset_n            ( fifo_reset_n_bot                 ), 
.fifo_rank_sel           ( fifo_rank_sel_bot                ), 
.rank_in_a               ( rank_in_a_bot[1:0]               ), 
.rank_in_b               ( rank_in_b_bot[1:0]               ), 
.rank_out                ( rank_out_bot[7:0]                ), 
.oct_enable_out          ( oct_enable_out_bot               ), 
.oct_enable_pin          ( oct_enable[5:4]                  ), 
.avl_wr_address          ( avl_wr_address_bot[4:0]          ), 
.avl_rd_address          ( avl_rd_address_bot[4:0]          ), 
.avl_sync_write          ( avl_sync_write_bot               ), 
.avl_destruct_read       ( avl_destruct_read_bot            ), 
.avl_writedata           ( avl_writedata_bot[15:0]          ), 
.avl_readchain_in        ( avl_readchain_bot[31:16]         ), 
.avl_readchain_out       ( avl_readchain_bot[47:32]         ), 
.pvt_write               ( pvt_write[2]                     ), 
.pvt_address             ( pvt_address_bot[2:0]             ), 
.pvt_data                ( pvt_data_bot[8:0]                ), 
.csr_clk                 ( csr_clk_bot                      ), 
.csr_in                  ( ioereg_csrout[2]                 ), 
.csr_en                  ( csr_en_bot                       ), 
.csr_shift_n             ( csr_shift_n_bot                  ), 
.csr_out                 ( ioereg_csrout[3]                 ), 
.nfrzdrv                 ( nfrzdrv_bot                      ), 
.frzreg                  ( frzreg_bot                       ), 
.ncein                   ( ncein[5:4]                       ), 
.nceout                  ( nceout[5:4]                      ), 
.naclr                   ( naclr[5:4]                       ), 
.nsclr                   ( nsclr[5:4]                       ), 
.fr_in_clk               ( fr_in_clk[5:4]                   ), 
.hr_in_clk               ( hr_in_clk[5:4]                   ), 
.fr_out_clk              ( fr_out_clk[5:4]                  ), 
.hr_out_clk              ( hr_out_clk[5:4]                  ), 
.pll_clk                 ( pll_clk                          ), 
.atpg_en_n               ( atpg_en_n_bot                    ), 
.pipeline_global_en_n    ( pipeline_global_en_n_bot         ), 
.test_clr_n              ( test_clr_n_bot                   ), 
.test_tdf_select_n       ( test_tdf_select_n_bot            ), 
.tpin                    ( tpin[5:4]                        ), 
.tpctl                   ( tpctl[5:4]                       ), 
.test_io_ctrl_3          ( test_io_ctrl_3                   ), 
.tpdata                  ( tpdata[5:4]                      ), 
.niotri                  ( niotri_bot                       ), 
.progctl                 ( progctl[5:4]                     ), 
.progout                 ( progout[5:4]                     ), 
.progoe                  ( progoe[5:4]                      ), 
.test_clk                ( test_clock                     ), 
.scan_shift_n            ( scan_shift_n_bot                 ), 
.scan_in                 ( { scan_34_1_2, scan_33_2_3, scan_32_1_2, 32'b0}  ), 
.scan_out                ( { scan_34_2_3, scan_33_1_2, scan_32_2_3, ioereg_scanout_used_2}), 
.xor_clk                 ( xor_clk[2]                       ), 
.test_dbg_out            ( test_dbg_out_local[5:4]          ), 
.test_dbg_in             ( test_dbg_in[5:4]                 ), 
.probe_out               ( {dqs_probe[5:4],rd_probe[17:0]}  ), 
.read_path_probe         ( rd_probe[17:12]                  ), 
.jtag_shftdr             ( jtag_shftdr_bot                  ), 
.jtag_clk                ( jtag_clk_bot                     ), 
.jtag_highz              ( jtag_highz_bot                   ), 
.jtag_sdin               ( ioereg_jtag_sdout[1]             ), 
.jtag_updtdr             ( jtag_updtdr_bot                  ), 
.jtag_mode               ( jtag_mode_bot                    ), 
.jtag_sdout              ( ioereg_jtag_sdout[2]             ), 
.osc_sel_n               ( osc_sel_n                        ), 
.osc_in_dn               ( osc_out_dn[3]                    ), 
.osc_in_up               ( osc_in_up[2]                     ), 
.osc_out_dn              ( osc_out_dn[2]                    ), 
.osc_out_up              ( osc_in_up[3]                     ), 
.sync_clk_bot_in         ( sync_clk_up_chn[1]               ), 
.sync_data_bot_in        ( sync_data_up_chn[1]              ), 
.sync_clk_bot_out        ( sync_clk_dn_chn[1]               ), 
.sync_data_bot_out       ( sync_data_dn_chn[1]              ), 
.sync_clk_top_in         ( sync_clk_dn_chn[2]               ), 
.sync_data_top_in        ( sync_data_dn_chn[2]              ), 
.sync_clk_top_out        ( sync_clk_up_chn[2]               ), 
.sync_data_top_out       ( sync_data_up_chn[2]              ), 
.d_out_p_mux_out         ( d_out_p_mux_2[3:0]               ), 
.d_out_n_mux_out         ( d_out_n_mux_2[3:0]               ), 
.rb_dq_in_select         ( rb_dq_in_select_2[5:0]           ), 
.datovr_in               ( datovr_2[1:0]                    ), 
.datovrb_in              ( datovrb_2[1:0]                   ), 
.struct_latch_open_n_out ( struct_latch_open_n_2[1:0]       ), 
.nfrzdrv_struct_out      ( nfrzdrv_struct_2[1:0]            ), 
.ac_hmc                  ( ac_hmc[47:32]                    ), 
.select_ac_hmc           ( select_ac_hmc[5:4]               ), 
.dq_in_tree              ( dq_in_tree[11:8]                 ), 
.xpr_clk                 ( xpr_clk_bot                      ), 
.xpr_write               ( xpr_write_bot[2]                 ), 
.xpr_data                ( xpr_data_bot[7:0]                ), 
.ioereg_locked           ( ioereg_locked[2]                 ),
.weak_pullup_enable      ( weak_pullup_enable[5:4]          ),
.power_down_n            ( power_down_n_2[1:0]              ), 
.nfrzdrv_nand_x64        ( nfrzdrv_nand_x64_2               ), 
.mux_sel_a               ( mux_sel_a_2[5:0]                 ), 
.mux_sel_b               ( mux_sel_b_2[5:0]                 ), 
.interp_sel_a            ( interp_sel_a_2[7:0]              ), 
.interp_sel_b            ( interp_sel_b_2[7:0]              ), 
.dirty_clk               ( dirty_clk_2[3:0]                 ), 
.interp_enable           ( interp_enable_2[1:0]             ), 
.test_enable             ( test_enable_2                    ), 
.int_clk                 ( int_clk_2[1:0]                   ), 
.interp_clk_out          ( interp_clk_out_2[3:0]            ), 
.clk_ph_1_buf            ( clk_ph_1_buf                     ), 
.clk_ph_3_buf            ( clk_ph_3_buf                     ), 
.dq_fall_gray            ( dq_fall_gray_2[7:0]              ), 
.dq_rise_gray            ( dq_rise_gray_2[7:0]              ), 
.dq_f_gray               ( dq_f_gray_2[11:0]                ), 
.dq_i_gray               ( dq_i_gray_2[5:0]                 ), 
.sample_value_iob        ( sample_value_iob[2]              ), 
.sample_value_struct     ( sample_value_struct_2[1:0]       ), 
.rb_gpio_or_ddr_sel      ( rb_gpio_or_ddr_sel_2[1:0]        ), 
.rb_0_mode_ddr           ( rb_mode_ddr_2[0]                 ), 
.rb_1_mode_ddr           ( rb_mode_ddr_2[1]                 ), 
.dcc_select              ( dcc_select_2[1:0]                ), 
.sample_value_lane       ( sample_value_lane[2]             ), 
.sync_a_ioereg           ( sync_a_ioereg_bot                ), 
.sample_clk              ( sample_clk_2                     ) 
);

io_ioereg_struct__mdev40 ioereg_struct_2_0 (
.interpolator_clk   ( interpolator_clk_2[1:0]  ), 
.d_out_p_mux        ( d_out_p_mux_2[1:0]       ), 
.d_out_n_mux        ( d_out_n_mux_2[1:0]       ), 
.codin_p            ( codin_p[4]               ), 
.codin_pb           ( codin_pb[4]              ), 
.codin_n            ( codin_n[4]               ), 
.codin_nb           ( codin_nb[4]              ), 
.rb_dq_select       ( rb_dq_in_select_2[2:0]   ), 
.latch_open_n       ( struct_latch_open_n_2[0] ), 
.dq_diff_in         ( dq_diff_in[9:8]          ), 
.dq_sstl_in         ( dq_sstl_in[9:8]          ), 
.nfrzdrv            ( nfrzdrv_struct_2[0]      ), 
.loopback_p         ( loopback_p[4]            ), 
.loopback_n         ( loopback_n[4]            ), 
.loopback_en_n      ( loopback_en_n[4]         ), 
.datovr             ( datovr_2[0]              ), 
.datovrb            ( datovrb_2[0]             ), 
.data_dq            ( data_dq_2[0]             ), 
.data_dqb           ( data_dqb_2[0]            ), 
.dqs_loop_back      ( {dqs_loop_back_0_nc[0],dqs_loop_back_0[0]}     ),
.sample_clk         ( sample_clk_2             ),
.dcc_select         ( dcc_select_2[1:0]        ),
.dcc_sample         ( sample_value_struct_2[0] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_2[0]  ), 
.rb_mode_ddr        ( rb_mode_ddr_2[0]         ), 
.scan_in            ( scan_chn_struct[3]       ),
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scan_chn_struct[4]       )
);

io_ioereg_struct__mdev40 ioereg_struct_2_1 (
.interpolator_clk   ( interpolator_clk_2[3:2]  ), 
.d_out_p_mux        ( d_out_p_mux_2[3:2]       ), 
.d_out_n_mux        ( d_out_n_mux_2[3:2]       ), 
.codin_p            ( codin_p[5]               ), 
.codin_pb           ( codin_pb[5]              ), 
.codin_n            ( codin_n[5]               ), 
.codin_nb           ( codin_nb[5]              ), 
.rb_dq_select       ( rb_dq_in_select_2[5:3]   ), 
.latch_open_n       ( struct_latch_open_n_2[1] ), 
.dq_diff_in         ( dq_diff_in[11:10]        ), 
.dq_sstl_in         ( dq_sstl_in[11:10]        ), 
.nfrzdrv            ( nfrzdrv_struct_2[1]      ), 
.loopback_p         ( loopback_p[5]            ), 
.loopback_n         ( loopback_n[5]            ), 
.loopback_en_n      ( loopback_en_n[5]         ), 
.datovr             ( datovr_2[1]              ), 
.datovrb            ( datovrb_2[1]             ), 
.data_dq            ( data_dq_2[1]             ), 
.data_dqb           ( data_dqb_2[1]            ), 
.dqs_loop_back      ( {dqs_loop_back_0_nc[1],dqs_loop_back_0[1]} ),  
.sample_clk         ( sample_clk_2             ),
.dcc_select         ( dcc_select_2[1:0]        ),
.dcc_sample         ( sample_value_struct_2[1] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_2[1]  ), 
.rb_mode_ddr        ( rb_mode_ddr_2[1]         ), 
.scan_in            ( scan_chn_struct[4]       ),
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scan_chn_struct[5]       )
);

io_ioereg_custom__mdev40 io_ioereg_custom_2 (
.data_dq_in             ( data_dq_2[1:0]                   ),
.data_dqb_in            ( data_dqb_2[1:0]                  ),
.x64_osc_in_p           ( x64_osc_chain_p[2]               ),
.x64_osc_in_n           ( x64_osc_chain_n[2]               ),
.x64_osc_out_p          ( x64_osc_chain_p[3]               ),
.x64_osc_out_n          ( x64_osc_chain_n[3]               ),
.x64_osc_mode           ( x64_osc_mode_out                 ),
.nfrzdrv                ( nfrzdrv_nand_x64_2               ),
.dq_f_gray              ( dq_f_gray_2[11:0]                ),
.dq_i_gray              ( dq_i_gray_2[5:0]                 ),
.dq_fall_gray           ( dq_fall_gray_2[7:0]              ),
.dq_rise_gray           ( dq_rise_gray_2[7:0]              ),
.dq_in_del              ( dq_in_del_n[11:8]                ),
.phy_clk_phs            ( 8'd0                		   ),
.rb_filter_code         ( rb_filter_code_bot[1:0]          ),
.test_enable            ( test_enable_2                    ),
.rb_couple_enable       ( rb_couple_enable                 ),
.power_down_n           ( power_down_n_2[1:0]              ),
.mux_sel_a              ( mux_sel_a_2[5:0]                 ),
.mux_sel_b              ( mux_sel_b_2[5:0]                 ),
.interp_sel_a           ( interp_sel_a_2[7:0]              ),
.interp_sel_b           ( interp_sel_b_2[7:0]              ),
.dirty_clk              ( dirty_clk_2[3:0]                 ),
.interp_enable          ( interp_enable_2[1:0]             ),
.int_clk                ( int_clk_2[1:0]                   ),
.interp_clk_out         ( interp_clk_out_2[3:0]            ),
.interpolator_clk       ( interpolator_clk_2[3:0]          )
);

io_ioereg_top__mdev40 ioereg_top_3_ (
.reset_n                 ( ioereg_reset_n                   ), 
.phy_clk                 ( 'd0                              ), 
.chk_x1_track_out_up     ( chk_x1_track_out_up[7:6]         ), 
.chk_x1_track_out_dn     ( chk_x1_track_out_dn[7:6]         ), 
.core_data_out           ( data_to_ioreg[63:48]             ), 
.core_oeb                ( oeb_to_ioreg[31:24]              ), 
.core_data_in            ( data_from_ioreg[63:48]           ), 
.avl_select              ( avl_select_ioereg[7:6]           ), 
.avl_select_dcc          ( avl_select_dcc[3]                ), 
.dpa_track_out_up        ( switch_up[3]                     ), 
.dpa_track_out_dn        ( switch_dn[3]                     ), 
.phase_kicker            ( dzoutx[3]                        ), 
.phase_direction         ( up_ph[3]                         ), 
.dqs_clk_a               ( dqs_clk_a[15:12]                 ), 
.dqs_clk_b               ( dqs_clk_b[15:12]                 ), 
.chk_x12_track_out_up    ( chk_x12_track_out_up_top         ), 
.chk_x12_track_out_dn    ( chk_x12_track_out_dn_top         ), 
.rb_phy_clk_mode         ( rb_phy_clk_mode_top              ), 
.rb_track_speed          ( rb_track_speed_top[3:0]          ), 
.rb_kicker_size          ( rb_kicker_size_top[1:0]          ), 
.rb_mode_rate_in         ( rb_mode_rate_in_top[1:0]         ), 
.rb_mode_rate_out        ( rb_mode_rate_out_top[1:0]        ), 
.fifo_pack_select        ( fifo_pack_select_top[1:0]        ), 
.fifo_read_enable        ( fifo_read_enable_top             ), 
.fifo_reset_n            ( fifo_reset_n_top                 ), 
.fifo_rank_sel           ( fifo_rank_sel_top                ), 
.rank_in_a               ( rank_in_a_top[1:0]               ), 
.rank_in_b               ( rank_in_b_top[1:0]               ), 
.rank_out                ( rank_out_top[7:0]                ), 
.oct_enable_out          ( oct_enable_out_top               ), 
.oct_enable_pin          ( oct_enable[7:6]                  ), 
.avl_wr_address          ( avl_wr_address_top[4:0]          ), 
.avl_rd_address          ( avl_rd_address_top[4:0]          ), 
.avl_sync_write          ( avl_sync_write_top               ), 
.avl_destruct_read       ( avl_destruct_read_top            ), 
.avl_writedata           ( avl_writedata_top[15:0]          ), 
.avl_readchain_in        ( avl_readchain_top[31:16]         ), 
.avl_readchain_out       ( avl_readchain_top[47:32]         ), 
.pvt_write               ( pvt_write[3]                     ), 
.pvt_address             ( pvt_address_top[2:0]             ), 
.pvt_data                ( pvt_data_top[8:0]                ), 
.csr_clk                 ( csr_clk_top                      ), 
.csr_in                  ( ioereg_csrout[4]                 ), 
.csr_en                  ( csr_en_top                       ), 
.csr_shift_n             ( 1'b1                             ), 
.csr_out                 ( ioereg_csrout[5]                 ), 
.nfrzdrv                 ( nfrzdrv_top                      ), 
.frzreg                  ( frzreg_top                       ), 
.ncein                   ( ncein[7:6]                       ), 
.nceout                  ( nceout[7:6]                      ), 
.naclr                   ( naclr[7:6]                       ), 
.nsclr                   ( nsclr[7:6]                       ), 
.fr_in_clk               ( fr_in_clk[7:6]                   ), 
.hr_in_clk               ( hr_in_clk[7:6]                   ), 
.fr_out_clk              ( fr_out_clk[7:6]                  ), 
.hr_out_clk              ( hr_out_clk[7:6]                  ), 
.pll_clk                 ( pll_clk                          ), 
.atpg_en_n               ( atpg_en_n_top                    ), 
.pipeline_global_en_n    ( pipeline_global_en_n_top         ), 
.test_clr_n              ( test_clr_n_top                   ), 
.test_tdf_select_n       ( test_tdf_select_n_top            ), 
.tpin                    ( tpin[7:6]                        ), 
.tpctl                   ( tpctl[7:6]                       ), 
.test_io_ctrl_3          ( test_io_ctrl_3                   ), 
.tpdata                  ( tpdata[7:6]                      ), 
.niotri                  ( niotri_top                       ), 
.progctl                 ( progctl[7:6]                     ), 
.progout                 ( progout[7:6]                     ), 
.progoe                  ( progoe[7:6]                      ), 
.test_clk                ( test_clock                       ), 
.scan_shift_n            ( scan_shift_n_top                 ), 
.scan_in                 ( { scan_34_2_3, scan_33_3_4, scan_32_2_3, 32'b0}  ), 
.scan_out                ( { scan_34_3_4, scan_33_2_3, scan_32_3_4, ioereg_scanout_used_3}), 
.xor_clk                 ( xor_clk[3]                       ), 
.test_dbg_out            ( test_dbg_out_local[7:6]          ), 
.test_dbg_in             ( test_dbg_in[7:6]                 ), 
.probe_out               ( {dqs_probe[7:6],rd_probe[35:18]} ), 
.read_path_probe         ( rd_probe[23:18]                  ), 
.jtag_shftdr             ( jtag_shftdr_top                  ), 
.jtag_clk                ( jtag_clk_top                     ), 
.jtag_highz              ( jtag_highz_top                   ), 
.jtag_sdin               ( ioereg_jtag_sdout[2]             ), 
.jtag_updtdr             ( jtag_updtdr_top                  ), 
.jtag_mode               ( jtag_mode_top                    ), 
.jtag_sdout              ( ioereg_jtag_sdout[3]             ), 
.osc_sel_n               ( osc_sel_n                        ), 
.osc_in_dn               ( osc_out_dn[4]                    ), 
.osc_in_up               ( osc_in_up[3]                     ), 
.osc_out_dn              ( osc_out_dn[3]                    ), 
.osc_out_up              ( osc_in_up[4]                     ), 
.sync_clk_bot_in         ( sync_clk_up_chn[3]               ), 
.sync_data_bot_in        ( sync_data_up_chn[3]              ), 
.sync_clk_bot_out        ( sync_clk_dn_chn[3]               ), 
.sync_data_bot_out       ( sync_data_dn_chn[3]              ), 
.sync_clk_top_in         ( sync_clk_dn_chn[4]               ), 
.sync_data_top_in        ( sync_data_dn_chn[4]              ), 
.sync_clk_top_out        ( sync_clk_up_chn[4]               ), 
.sync_data_top_out       ( sync_data_up_chn[4]              ), 
.d_out_p_mux_out         ( d_out_p_mux_3[3:0]               ), 
.d_out_n_mux_out         ( d_out_n_mux_3[3:0]               ), 
.rb_dq_in_select         ( rb_dq_in_select_3[5:0]           ), 
.datovr_in               ( datovr_3[1:0]                    ), 
.datovrb_in              ( datovrb_3[1:0]                   ), 
.struct_latch_open_n_out ( struct_latch_open_n_3[1:0]       ), 
.nfrzdrv_struct_out      ( nfrzdrv_struct_3[1:0]            ), 
.ac_hmc                  ( ac_hmc[63:48]                    ), 
.select_ac_hmc           ( select_ac_hmc[7:6]               ), 
.dq_in_tree              ( dq_in_tree[15:12]                ), 
.xpr_clk                 ( xpr_clk_top                      ), 
.xpr_write               ( xpr_write_top[0]                 ), 
.xpr_data                ( xpr_data_top[7:0]                ), 
.ioereg_locked           ( ioereg_locked[3]                 ),
.weak_pullup_enable      ( weak_pullup_enable[7:6]          ),
.power_down_n            ( power_down_n_3[1:0]              ), 
.nfrzdrv_nand_x64        ( nfrzdrv_nand_x64_3               ), 
.mux_sel_a               ( mux_sel_a_3[5:0]                 ), 
.mux_sel_b               ( mux_sel_b_3[5:0]                 ), 
.interp_sel_a            ( interp_sel_a_3[7:0]              ), 
.interp_sel_b            ( interp_sel_b_3[7:0]              ), 
.dirty_clk               ( dirty_clk_3[3:0]                 ), 
.interp_enable           ( interp_enable_3[1:0]             ), 
.test_enable             ( test_enable_3                    ), 
.int_clk                 ( int_clk_3[1:0]                   ), 
.interp_clk_out          ( interp_clk_out_3[3:0]            ), 
.clk_ph_1_buf            ( clk_ph_1_buf                     ), 
.clk_ph_3_buf            ( clk_ph_3_buf                     ), 
.dq_fall_gray            ( dq_fall_gray_3[7:0]              ), 
.dq_rise_gray            ( dq_rise_gray_3[7:0]              ), 
.dq_f_gray               ( dq_f_gray_3[11:0]                ), 
.dq_i_gray               ( dq_i_gray_3[5:0]                 ), 
.sample_value_iob        ( sample_value_iob[3]              ), 
.sample_value_struct     ( sample_value_struct_3[1:0]       ), 
.rb_gpio_or_ddr_sel      ( rb_gpio_or_ddr_sel_3[1:0]        ), 
.rb_0_mode_ddr           ( rb_mode_ddr_3[0]                 ), 
.rb_1_mode_ddr           ( rb_mode_ddr_3[1]                 ), 
.dcc_select              ( dcc_select_3[1:0]                ), 
.sample_value_lane       ( sample_value_lane[3]             ), 
.sync_a_ioereg           ( sync_a_ioereg_top                ), 
.sample_clk              ( sample_clk_3                     ) 
);

io_ioereg_struct__mdev40 ioereg_struct_3_0 (
.interpolator_clk   ( interpolator_clk_3[1:0]  ), 
.d_out_p_mux        ( d_out_p_mux_3[1:0]       ), 
.d_out_n_mux        ( d_out_n_mux_3[1:0]       ), 
.codin_p            ( codin_p[6]               ), 
.codin_pb           ( codin_pb[6]              ), 
.codin_n            ( codin_n[6]               ), 
.codin_nb           ( codin_nb[6]              ), 
.rb_dq_select       ( rb_dq_in_select_3[2:0]   ), 
.latch_open_n       ( struct_latch_open_n_3[0] ), 
.dq_diff_in         ( dq_diff_in[13:12]        ), 
.dq_sstl_in         ( dq_sstl_in[13:12]        ), 
.nfrzdrv            ( nfrzdrv_struct_3[0]      ), 
.loopback_p         ( loopback_p[6]            ), 
.loopback_n         ( loopback_n[6]            ), 
.loopback_en_n      ( loopback_en_n[6]         ), 
.datovr             ( datovr_3[0]              ), 
.datovrb            ( datovrb_3[0]             ), 
.data_dq            ( data_dq_3[0]             ), 
.data_dqb           ( data_dqb_3[0]            ), 
.dqs_loop_back      ( {dqs_loop_back_1_nc[0],dqs_loop_back_1[0]} ),
.sample_clk         ( sample_clk_3             ),
.dcc_select         ( dcc_select_3[1:0]        ),
.dcc_sample         ( sample_value_struct_3[0] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_3[0]  ), 
.rb_mode_ddr        ( rb_mode_ddr_3[0]         ), 
.scan_in            ( scan_chn_struct[5]       ),
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scan_chn_struct[6]       )
);

io_ioereg_struct__mdev40 ioereg_struct_3_1 (
.interpolator_clk   ( interpolator_clk_3[3:2]  ), 
.d_out_p_mux        ( d_out_p_mux_3[3:2]       ), 
.d_out_n_mux        ( d_out_n_mux_3[3:2]       ), 
.codin_p            ( codin_p[7]               ), 
.codin_pb           ( codin_pb[7]              ), 
.codin_n            ( codin_n[7]               ), 
.codin_nb           ( codin_nb[7]              ), 
.rb_dq_select       ( rb_dq_in_select_3[5:3]   ), 
.latch_open_n       ( struct_latch_open_n_3[1] ), 
.dq_diff_in         ( dq_diff_in[15:14]        ), 
.dq_sstl_in         ( dq_sstl_in[15:14]        ), 
.nfrzdrv            ( nfrzdrv_struct_3[1]      ), 
.loopback_p         ( loopback_p[7]            ), 
.loopback_n         ( loopback_n[7]            ), 
.loopback_en_n      ( loopback_en_n[7]         ), 
.datovr             ( datovr_3[1]              ), 
.datovrb            ( datovrb_3[1]             ), 
.data_dq            ( data_dq_3[1]             ), 
.data_dqb           ( data_dqb_3[1]            ), 
.dqs_loop_back      ( {dqs_loop_back_1_nc[1],dqs_loop_back_1[1]} ),  
.sample_clk         ( sample_clk_3             ),
.dcc_select         ( dcc_select_3[1:0]        ),
.dcc_sample         ( sample_value_struct_3[1] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_3[1]  ), 
.rb_mode_ddr        ( rb_mode_ddr_3[1]         ), 
.scan_in            ( scan_chn_struct[6]       ),
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scan_chn_struct[7]       )
);

io_ioereg_custom__mdev40 io_ioereg_custom_3 (
.data_dq_in             ( data_dq_3[1:0]                   ),
.data_dqb_in            ( data_dqb_3[1:0]                  ),
.x64_osc_in_p           ( x64_osc_chain_p[3]               ),
.x64_osc_in_n           ( x64_osc_chain_n[3]               ),
.x64_osc_out_p          ( x64_osc_chain_p[4]               ),
.x64_osc_out_n          ( x64_osc_chain_n[4]               ),
.x64_osc_mode           ( x64_osc_mode_out                 ),
.nfrzdrv                ( nfrzdrv_nand_x64_3               ),
.dq_f_gray              ( dq_f_gray_3[11:0]                ),
.dq_i_gray              ( dq_i_gray_3[5:0]                 ),
.dq_fall_gray           ( dq_fall_gray_3[7:0]              ),
.dq_rise_gray           ( dq_rise_gray_3[7:0]              ),
.dq_in_del              ( dq_in_del_n[15:12]               ),
.phy_clk_phs            ( 8'd0                		   ),
.rb_filter_code         ( rb_filter_code_top[1:0]          ),
.test_enable            ( test_enable_3                    ),
.rb_couple_enable       ( rb_couple_enable                 ),
.power_down_n           ( power_down_n_3[1:0]              ),
.mux_sel_a              ( mux_sel_a_3[5:0]                 ),
.mux_sel_b              ( mux_sel_b_3[5:0]                 ),
.interp_sel_a           ( interp_sel_a_3[7:0]              ),
.interp_sel_b           ( interp_sel_b_3[7:0]              ),
.dirty_clk              ( dirty_clk_3[3:0]                 ),
.interp_enable          ( interp_enable_3[1:0]             ),
.int_clk                ( int_clk_3[1:0]                   ),
.interp_clk_out         ( interp_clk_out_3[3:0]            ),
.interpolator_clk       ( interpolator_clk_3[3:0]          )
);

io_ioereg_top__mdev40 ioereg_top_4_ (
.reset_n                 ( ioereg_reset_n                   ), 
.phy_clk                 ( 'd0                              ), 
.chk_x1_track_out_up     ( chk_x1_track_out_up[9:8]         ), 
.chk_x1_track_out_dn     ( chk_x1_track_out_dn[9:8]         ), 
.core_data_out           ( data_to_ioreg[79:64]             ), 
.core_oeb                ( oeb_to_ioreg[39:32]              ), 
.core_data_in            ( data_from_ioreg[79:64]           ), 
.avl_select              ( avl_select_ioereg[9:8]           ), 
.avl_select_dcc          ( avl_select_dcc[4]                ), 
.dpa_track_out_up        ( switch_up[4]                     ), 
.dpa_track_out_dn        ( switch_dn[4]                     ), 
.phase_kicker            ( dzoutx[4]                        ), 
.phase_direction         ( up_ph[4]                         ), 
.dqs_clk_a               ( dqs_clk_a[19:16]                 ), 
.dqs_clk_b               ( dqs_clk_b[19:16]                 ), 
.chk_x12_track_out_up    ( chk_x12_track_out_up_top         ), 
.chk_x12_track_out_dn    ( chk_x12_track_out_dn_top         ), 
.rb_phy_clk_mode         ( rb_phy_clk_mode_top              ), 
.rb_track_speed          ( rb_track_speed_top[3:0]          ), 
.rb_kicker_size          ( rb_kicker_size_top[1:0]          ), 
.rb_mode_rate_in         ( rb_mode_rate_in_top[1:0]         ), 
.rb_mode_rate_out        ( rb_mode_rate_out_top[1:0]        ), 
.fifo_pack_select        ( fifo_pack_select_top[1:0]        ), 
.fifo_read_enable        ( fifo_read_enable_top             ), 
.fifo_reset_n            ( fifo_reset_n_top                 ), 
.fifo_rank_sel           ( fifo_rank_sel_top                ), 
.rank_in_a               ( rank_in_a_top[1:0]               ), 
.rank_in_b               ( rank_in_b_top[1:0]               ), 
.rank_out                ( rank_out_top[7:0]                ), 
.oct_enable_out          ( oct_enable_out_top               ), 
.oct_enable_pin          ( oct_enable[9:8]                  ), 
.avl_wr_address          ( avl_wr_address_top[4:0]          ), 
.avl_rd_address          ( avl_rd_address_top[4:0]          ), 
.avl_sync_write          ( avl_sync_write_top               ), 
.avl_destruct_read       ( avl_destruct_read_top            ), 
.avl_writedata           ( avl_writedata_top[15:0]          ), 
.avl_readchain_in        ( avl_readchain_top[15:0]          ), 
.avl_readchain_out       ( avl_readchain_top[31:16]         ), 
.pvt_write               ( pvt_write[4]                     ), 
.pvt_address             ( pvt_address_top[2:0]             ), 
.pvt_data                ( pvt_data_top[8:0]                ), 
.csr_clk                 ( csr_clk_top                      ), 
.csr_in                  ( ioereg_csrout[5]                 ), 
.csr_en                  ( csr_en_top                       ), 
.csr_shift_n             ( 1'b1                             ), 
.csr_out                 ( ioereg_csrout[6]                 ), 
.nfrzdrv                 ( nfrzdrv_top                      ), 
.frzreg                  ( frzreg_top                       ), 
.ncein                   ( ncein[9:8]                       ), 
.nceout                  ( nceout[9:8]                      ), 
.naclr                   ( naclr[9:8]                       ), 
.nsclr                   ( nsclr[9:8]                       ), 
.fr_in_clk               ( fr_in_clk[9:8]                   ), 
.hr_in_clk               ( hr_in_clk[9:8]                   ), 
.fr_out_clk              ( fr_out_clk[9:8]                  ), 
.hr_out_clk              ( hr_out_clk[9:8]                  ), 
.pll_clk                 ( 1'b0                             ), 
.atpg_en_n               ( atpg_en_n_top                    ), 
.pipeline_global_en_n    ( pipeline_global_en_n_top         ), 
.test_clr_n              ( test_clr_n_top                   ), 
.test_tdf_select_n       ( test_tdf_select_n_top            ), 
.tpin                    ( tpin[9:8]                        ), 
.tpctl                   ( tpctl[9:8]                       ), 
.test_io_ctrl_3          ( test_io_ctrl_3                   ), 
.tpdata                  ( tpdata[9:8]                      ), 
.niotri                  ( niotri_top                       ), 
.progctl                 ( progctl[9:8]                     ), 
.progout                 ( progout[9:8]                     ), 
.progoe                  ( progoe[9:8]                      ), 
.test_clk                ( test_clock                     ), 
.scan_shift_n            ( scan_shift_n_top                 ), 
.scan_in                 ( { scan_34_3_4, scan_33_4_5, scan_32_3_4, 32'b0}  ), 
.scan_out                ( { scan_34_4_5, scan_33_3_4, scan_32_4_5, ioereg_scanout_used_4}), 
.xor_clk                 ( xor_clk[4]                       ), 
.test_dbg_out            ( test_dbg_out_local[9:8]          ), 
.test_dbg_in             ( test_dbg_in[9:8]                 ), 
.probe_out               ( {dqs_probe[9:8],rd_probe[35:18]} ), 
.read_path_probe         ( rd_probe[29:24]                  ), 
.jtag_shftdr             ( jtag_shftdr_top                  ), 
.jtag_clk                ( jtag_clk_top                     ), 
.jtag_highz              ( jtag_highz_top                   ), 
.jtag_sdin               ( ioereg_jtag_sdout[3]             ), 
.jtag_updtdr             ( jtag_updtdr_top                  ), 
.jtag_mode               ( jtag_mode_top                    ), 
.jtag_sdout              ( ioereg_jtag_sdout[4]             ), 
.osc_sel_n               ( osc_sel_n                        ), 
.osc_in_dn               ( osc_out_dn[5]                    ), 
.osc_in_up               ( osc_in_up[4]                     ), 
.osc_out_dn              ( osc_out_dn[4]                    ), 
.osc_out_up              ( osc_in_up[5]                     ), 
.sync_clk_bot_in         ( sync_clk_up_chn[4]               ), 
.sync_data_bot_in        ( sync_data_up_chn[4]              ), 
.sync_clk_bot_out        ( sync_clk_dn_chn[4]               ), 
.sync_data_bot_out       ( sync_data_dn_chn[4]              ), 
.sync_clk_top_in         ( sync_clk_dn_chn[5]               ), 
.sync_data_top_in        ( sync_data_dn_chn[5]              ), 
.sync_clk_top_out        ( sync_clk_up_chn[5]               ), 
.sync_data_top_out       ( sync_data_up_chn[5]              ), 
.d_out_p_mux_out         ( d_out_p_mux_4[3:0]               ), 
.d_out_n_mux_out         ( d_out_n_mux_4[3:0]               ), 
.rb_dq_in_select         ( rb_dq_in_select_4[5:0]           ), 
.datovr_in               ( datovr_4[1:0]                    ), 
.datovrb_in              ( datovrb_4[1:0]                   ), 
.struct_latch_open_n_out ( struct_latch_open_n_4[1:0]       ), 
.nfrzdrv_struct_out      ( nfrzdrv_struct_4[1:0]            ), 
.ac_hmc                  ( ac_hmc[79:64]                    ), 
.select_ac_hmc           ( select_ac_hmc[9:8]               ), 
.dq_in_tree              ( dq_in_tree[19:16]                ), 
.xpr_clk                 ( xpr_clk_top                      ), 
.xpr_write               ( xpr_write_top[1]                 ), 
.xpr_data                ( xpr_data_top[7:0]                ), 
.ioereg_locked           ( ioereg_locked[4]                 ),
.weak_pullup_enable      ( weak_pullup_enable[9:8]          ),
.power_down_n            ( power_down_n_4[1:0]              ), 
.nfrzdrv_nand_x64        ( nfrzdrv_nand_x64_4               ), 
.mux_sel_a               ( mux_sel_a_4[5:0]                 ), 
.mux_sel_b               ( mux_sel_b_4[5:0]                 ), 
.interp_sel_a            ( interp_sel_a_4[7:0]              ), 
.interp_sel_b            ( interp_sel_b_4[7:0]              ), 
.dirty_clk               ( dirty_clk_4[3:0]                 ), 
.interp_enable           ( interp_enable_4[1:0]             ), 
.test_enable             ( test_enable_4                    ), 
.int_clk                 ( int_clk_4[1:0]                   ), 
.interp_clk_out          ( interp_clk_out_4[3:0]            ), 
.clk_ph_1_buf            ( clk_ph_1_buf                     ), 
.clk_ph_3_buf            ( clk_ph_3_buf                     ), 
.dq_fall_gray            ( dq_fall_gray_4[7:0]              ), 
.dq_rise_gray            ( dq_rise_gray_4[7:0]              ), 
.dq_f_gray               ( dq_f_gray_4[11:0]                ), 
.dq_i_gray               ( dq_i_gray_4[5:0]                 ), 
.sample_value_iob        ( sample_value_iob[4]              ), 
.sample_value_struct     ( sample_value_struct_4[1:0]       ), 
.rb_gpio_or_ddr_sel      ( rb_gpio_or_ddr_sel_4[1:0]        ), 
.rb_0_mode_ddr           ( rb_mode_ddr_4[0]                 ), 
.rb_1_mode_ddr           ( rb_mode_ddr_4[1]                 ), 
.dcc_select              ( dcc_select_4[1:0]                ), 
.sample_value_lane       ( sample_value_lane[4]             ), 
.sync_a_ioereg           ( sync_a_ioereg_top                ), 
.sample_clk              ( sample_clk_4                     ) 
);

io_ioereg_struct__mdev40 ioereg_struct_4_0 (
.interpolator_clk   ( interpolator_clk_4[1:0]  ), 
.d_out_p_mux        ( d_out_p_mux_4[1:0]       ), 
.d_out_n_mux        ( d_out_n_mux_4[1:0]       ), 
.codin_p            ( codin_p[8]               ), 
.codin_pb           ( codin_pb[8]              ), 
.codin_n            ( codin_n[8]               ), 
.codin_nb           ( codin_nb[8]              ), 
.rb_dq_select       ( rb_dq_in_select_4[2:0]   ), 
.latch_open_n       ( struct_latch_open_n_4[0] ), 
.dq_diff_in         ( dq_diff_in[17:16]        ), 
.dq_sstl_in         ( dq_sstl_in[17:16]        ), 
.nfrzdrv            ( nfrzdrv_struct_4[0]      ), 
.loopback_p         ( loopback_p[8]            ), 
.loopback_n         ( loopback_n[8]            ), 
.loopback_en_n      ( loopback_en_n[8]         ), 
.datovr             ( datovr_4[0]              ), 
.datovrb            ( datovrb_4[0]             ), 
.data_dq            ( data_dq_4[0]             ), 
.data_dqb           ( data_dqb_4[0]            ), 
.dqs_loop_back      (                          ),
.sample_clk         ( sample_clk_4             ),
.dcc_select         ( dcc_select_4[1:0]        ),
.dcc_sample         ( sample_value_struct_4[0] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_4[0]  ), 
.rb_mode_ddr        ( rb_mode_ddr_4[0]         ), 
.scan_in            ( scan_chn_struct[7]       ),
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scan_chn_struct[8]       )
);

io_ioereg_struct__mdev40 ioereg_struct_4_1 (
.interpolator_clk   ( interpolator_clk_4[3:2]  ), 
.d_out_p_mux        ( d_out_p_mux_4[3:2]       ), 
.d_out_n_mux        ( d_out_n_mux_4[3:2]       ), 
.codin_p            ( codin_p[9]               ), 
.codin_pb           ( codin_pb[9]              ), 
.codin_n            ( codin_n[9]               ), 
.codin_nb           ( codin_nb[9]              ), 
.rb_dq_select       ( rb_dq_in_select_4[5:3]   ), 
.latch_open_n       ( struct_latch_open_n_4[1] ), 
.dq_diff_in         ( dq_diff_in[19:18]        ), 
.dq_sstl_in         ( dq_sstl_in[19:18]        ), 
.nfrzdrv            ( nfrzdrv_struct_4[1]      ), 
.loopback_p         ( loopback_p[9]            ), 
.loopback_n         ( loopback_n[9]            ), 
.loopback_en_n      ( loopback_en_n[9]         ), 
.datovr             ( datovr_4[1]              ), 
.datovrb            ( datovrb_4[1]             ), 
.data_dq            ( data_dq_4[1]             ), 
.data_dqb           ( data_dqb_4[1]            ), 
.dqs_loop_back      (                          ), 
.sample_clk         ( sample_clk_4             ),
.dcc_select         ( dcc_select_4[1:0]        ),
.dcc_sample         ( sample_value_struct_4[1] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_4[1]  ), 
.rb_mode_ddr        ( rb_mode_ddr_4[1]         ), 
.scan_in            ( scan_chn_struct[8]       ),
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scan_chn_struct[9]       )
);

io_ioereg_custom__mdev40 io_ioereg_custom_4 (
.data_dq_in             ( data_dq_4[1:0]                   ),
.data_dqb_in            ( data_dqb_4[1:0]                  ),
.x64_osc_in_p           ( x64_osc_chain_p[4]               ),
.x64_osc_in_n           ( x64_osc_chain_n[4]               ),
.x64_osc_out_p          ( x64_osc_chain_p[5]               ),
.x64_osc_out_n          ( x64_osc_chain_n[5]               ),
.x64_osc_mode           ( x64_osc_mode_out                 ),
.nfrzdrv                ( nfrzdrv_nand_x64_4               ),
.dq_f_gray              ( dq_f_gray_4[11:0]                ),
.dq_i_gray              ( dq_i_gray_4[5:0]                 ),
.dq_fall_gray           ( dq_fall_gray_4[7:0]              ),
.dq_rise_gray           ( dq_rise_gray_4[7:0]              ),
.dq_in_del              ( dq_in_del_n[19:16]               ),
.phy_clk_phs            ( 8'd0                		   ),
.rb_filter_code         ( rb_filter_code_top[1:0]          ),
.test_enable            ( test_enable_4                    ),
.rb_couple_enable       ( rb_couple_enable                 ),
.power_down_n           ( power_down_n_4[1:0]              ),
.mux_sel_a              ( mux_sel_a_4[5:0]                 ),
.mux_sel_b              ( mux_sel_b_4[5:0]                 ),
.interp_sel_a           ( interp_sel_a_4[7:0]              ),
.interp_sel_b           ( interp_sel_b_4[7:0]              ),
.dirty_clk              ( dirty_clk_4[3:0]                 ),
.interp_enable          ( interp_enable_4[1:0]             ),
.int_clk                ( int_clk_4[1:0]                   ),
.interp_clk_out         ( interp_clk_out_4[3:0]            ),
.interpolator_clk       ( interpolator_clk_4[3:0]          )
);

io_ioereg_top__mdev40 ioereg_top_5_ (
.reset_n                 ( ioereg_reset_n                   ), 
.phy_clk                 ( 'd0                              ), 
.chk_x1_track_out_up     ( chk_x1_track_out_up[11:10]       ), 
.chk_x1_track_out_dn     ( chk_x1_track_out_dn[11:10]       ), 
.core_data_out           ( data_to_ioreg[95:80]             ), 
.core_oeb                ( oeb_to_ioreg[47:40]              ), 
.core_data_in            ( data_from_ioreg[95:80]           ), 
.avl_select              ( avl_select_ioereg[11:10]         ), 
.avl_select_dcc          ( avl_select_dcc[5]                ), 
.dpa_track_out_up        ( switch_up[5]                     ), 
.dpa_track_out_dn        ( switch_dn[5]                     ), 
.phase_kicker            ( dzoutx[5]                        ), 
.phase_direction         ( up_ph[5]                         ), 
.dqs_clk_a               ( dqs_clk_a[23:20]                 ), 
.dqs_clk_b               ( dqs_clk_b[23:20]                 ), 
.chk_x12_track_out_up    ( chk_x12_track_out_up_top         ), 
.chk_x12_track_out_dn    ( chk_x12_track_out_dn_top         ), 
.rb_phy_clk_mode         ( rb_phy_clk_mode_top              ), 
.rb_track_speed          ( rb_track_speed_top[3:0]          ), 
.rb_kicker_size          ( rb_kicker_size_top[1:0]          ), 
.rb_mode_rate_in         ( rb_mode_rate_in_top[1:0]         ), 
.rb_mode_rate_out        ( rb_mode_rate_out_top[1:0]        ), 
.fifo_pack_select        ( fifo_pack_select_top[1:0]        ), 
.fifo_read_enable        ( fifo_read_enable_top             ), 
.fifo_reset_n            ( fifo_reset_n_top                 ), 
.fifo_rank_sel           ( fifo_rank_sel_top                ), 
.rank_in_a               ( rank_in_a_top[1:0]               ), 
.rank_in_b               ( rank_in_b_top[1:0]               ), 
.rank_out                ( rank_out_top[7:0]                ), 
.oct_enable_out          ( oct_enable_out_top               ), 
.oct_enable_pin          ( oct_enable[11:10]                ), 
.avl_wr_address          ( avl_wr_address_top[4:0]          ), 
.avl_rd_address          ( avl_rd_address_top[4:0]          ), 
.avl_sync_write          ( avl_sync_write_top               ), 
.avl_destruct_read       ( avl_destruct_read_top            ), 
.avl_writedata           ( avl_writedata_top[15:0]          ), 
.avl_readchain_in        ( 16'h0000                         ), 
.avl_readchain_out       ( avl_readchain_top[15:0]          ), 
.pvt_write               ( pvt_write[5]                     ), 
.pvt_address             ( pvt_address_top[2:0]             ), 
.pvt_data                ( pvt_data_top[8:0]                ), 
.csr_clk                 ( csr_clk_top                      ), 
.csr_in                  ( ioereg_csrout[6]                 ), 
.csr_en                  ( csr_en_top                       ), 
.csr_shift_n             ( 1'b1                             ), 
.csr_out                 ( ioereg_csrout[7]                 ), 
.nfrzdrv                 ( nfrzdrv_top                      ), 
.frzreg                  ( frzreg_top                       ), 
.ncein                   ( ncein[11:10]                     ), 
.nceout                  ( nceout[11:10]                    ), 
.naclr                   ( naclr[11:10]                     ), 
.nsclr                   ( nsclr[11:10]                     ), 
.fr_in_clk               ( fr_in_clk[11:10]                 ), 
.hr_in_clk               ( hr_in_clk[11:10]                 ), 
.fr_out_clk              ( fr_out_clk[11:10]                ), 
.hr_out_clk              ( hr_out_clk[11:10]                ), 
.pll_clk                 ( 1'b0                             ), 
.atpg_en_n               ( atpg_en_n_top                    ), 
.pipeline_global_en_n    ( pipeline_global_en_n_top         ), 
.test_clr_n              ( test_clr_n_top                   ), 
.test_tdf_select_n       ( test_tdf_select_n_top            ), 
.tpin                    ( tpin[11:10]                      ), 
.tpctl                   ( tpctl[11:10]                     ), 
.test_io_ctrl_3          ( test_io_ctrl_3                   ), 
.tpdata                  ( tpdata[11:10]                    ), 
.niotri                  ( niotri_top                       ), 
.progctl                 ( progctl[11:10]                   ), 
.progout                 ( progout[11:10]                   ), 
.progoe                  ( progoe[11:10]                    ), 
.test_clk                ( test_clock                     ), 
.scan_shift_n            ( scan_shift_n_top                 ), 
.scan_in                 ( { scan_34_4_5, 1'b0, scan_32_4_5, 32'b0}  ), 
.scan_out                ( { scan_34_5_lane, scan_33_4_5, scan_32_5_lane, ioereg_scanout_used_5}), 
.xor_clk                 ( xor_clk[5]                       ), 
.test_dbg_out            ( test_dbg_out_local[11:10]        ), 
.test_dbg_in             ( test_dbg_in[11:10]               ), 
.probe_out               ( {dqs_probe[11:10],rd_probe[35:18]}), 
.read_path_probe         ( rd_probe[35:30]                  ), 
.jtag_shftdr             ( jtag_shftdr_top                  ), 
.jtag_clk                ( jtag_clk_top                     ), 
.jtag_highz              ( jtag_highz_top                   ), 
.jtag_sdin               ( ioereg_jtag_sdout[4]             ), 
.jtag_updtdr             ( jtag_updtdr_top                  ), 
.jtag_mode               ( jtag_mode_top                    ), 
.jtag_sdout              ( jtag_sdout                       ), 
.osc_sel_n               ( osc_sel_n                        ), 
.osc_in_dn               ( osc_start_in                     ), 
.osc_in_up               ( osc_in_up[5]                     ), 
.osc_out_dn              ( osc_out_dn[5]                    ), 
.osc_out_up              ( osc_start_out                    ), 
.sync_clk_bot_in         ( sync_clk_up_chn[5]               ), 
.sync_data_bot_in        ( sync_data_up_chn[5]              ), 
.sync_clk_bot_out        ( sync_clk_dn_chn[5]               ), 
.sync_data_bot_out       ( sync_data_dn_chn[5]              ), 
.sync_clk_top_in         ( sync_clk_top_in                  ), 
.sync_data_top_in        ( sync_data_top_in                 ), 
.sync_clk_top_out        ( sync_clk_top_out                 ), 
.sync_data_top_out       ( sync_data_top_out                ), 
.d_out_p_mux_out         ( d_out_p_mux_5[3:0]               ), 
.d_out_n_mux_out         ( d_out_n_mux_5[3:0]               ), 
.rb_dq_in_select         ( rb_dq_in_select_5[5:0]           ), 
.datovr_in               ( datovr_5[1:0]                    ), 
.datovrb_in              ( datovrb_5[1:0]                   ), 
.struct_latch_open_n_out ( struct_latch_open_n_5[1:0]       ), 
.nfrzdrv_struct_out      ( nfrzdrv_struct_5[1:0]            ), 
.ac_hmc                  ( ac_hmc[95:80]                    ), 
.select_ac_hmc           ( select_ac_hmc[11:10]             ), 
.dq_in_tree              ( dq_in_tree[23:20]                ), 
.xpr_clk                 ( xpr_clk_top                      ), 
.xpr_write               ( xpr_write_top[2]                 ), 
.xpr_data                ( xpr_data_top[7:0]                ), 
.ioereg_locked           ( ioereg_locked[5]                 ),
.weak_pullup_enable      ( weak_pullup_enable[11:10]        ),
.power_down_n            ( power_down_n_5[1:0]              ), 
.nfrzdrv_nand_x64        ( nfrzdrv_nand_x64_5               ), 
.mux_sel_a               ( mux_sel_a_5[5:0]                 ), 
.mux_sel_b               ( mux_sel_b_5[5:0]                 ), 
.interp_sel_a            ( interp_sel_a_5[7:0]              ), 
.interp_sel_b            ( interp_sel_b_5[7:0]              ), 
.dirty_clk               ( dirty_clk_5[3:0]                 ), 
.interp_enable           ( interp_enable_5[1:0]             ), 
.test_enable             ( test_enable_5                    ), 
.int_clk                 ( int_clk_5[1:0]                   ), 
.interp_clk_out          ( interp_clk_out_5[3:0]            ), 
.clk_ph_1_buf            ( clk_ph_1_buf                     ), 
.clk_ph_3_buf            ( clk_ph_3_buf                     ), 
.dq_fall_gray            ( dq_fall_gray_5[7:0]              ), 
.dq_rise_gray            ( dq_rise_gray_5[7:0]              ), 
.dq_f_gray               ( dq_f_gray_5[11:0]                ), 
.dq_i_gray               ( dq_i_gray_5[5:0]                 ), 
.sample_value_iob        ( sample_value_iob[5]              ), 
.sample_value_struct     ( sample_value_struct_5[1:0]       ), 
.rb_gpio_or_ddr_sel      ( rb_gpio_or_ddr_sel_5[1:0]        ), 
.rb_0_mode_ddr           ( rb_mode_ddr_5[0]                 ), 
.rb_1_mode_ddr           ( rb_mode_ddr_5[1]                 ), 
.dcc_select              ( dcc_select_5[1:0]                ), 
.sample_value_lane       ( sample_value_lane[5]             ), 
.sync_a_ioereg           ( sync_a_ioereg_top                ), 
.sample_clk              ( sample_clk_5                     ) 
);

io_ioereg_struct__mdev40 ioereg_struct_5_0 (
.interpolator_clk   ( interpolator_clk_5[1:0]  ), 
.d_out_p_mux        ( d_out_p_mux_5[1:0]       ), 
.d_out_n_mux        ( d_out_n_mux_5[1:0]       ), 
.codin_p            ( codin_p[10]              ), 
.codin_pb           ( codin_pb[10]             ), 
.codin_n            ( codin_n[10]              ), 
.codin_nb           ( codin_nb[10]             ), 
.rb_dq_select       ( rb_dq_in_select_5[2:0]   ), 
.latch_open_n       ( struct_latch_open_n_5[0] ), 
.dq_diff_in         ( dq_diff_in[21:20]        ), 
.dq_sstl_in         ( dq_sstl_in[21:20]        ), 
.nfrzdrv            ( nfrzdrv_struct_5[0]      ), 
.loopback_p         ( loopback_p[10]           ), 
.loopback_n         ( loopback_n[10]           ), 
.loopback_en_n      ( loopback_en_n[10]        ), 
.datovr             ( datovr_5[0]              ), 
.datovrb            ( datovrb_5[0]             ), 
.data_dq            ( data_dq_5[0]             ), 
.data_dqb           ( data_dqb_5[0]            ), 
.dqs_loop_back      (                          ),
.sample_clk         ( sample_clk_5             ),
.dcc_select         ( dcc_select_5[1:0]        ),
.dcc_sample         ( sample_value_struct_5[0] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_5[0]  ), 
.rb_mode_ddr        ( rb_mode_ddr_5[0]         ), 
.scan_in            ( scan_chn_struct[9]       ),
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scan_chn_struct[10]      )
);

io_ioereg_struct__mdev40 ioereg_struct_5_1 (
.interpolator_clk   ( interpolator_clk_5[3:2]  ), 
.d_out_p_mux        ( d_out_p_mux_5[3:2]       ), 
.d_out_n_mux        ( d_out_n_mux_5[3:2]       ), 
.codin_p            ( codin_p[11]              ), 
.codin_pb           ( codin_pb[11]             ), 
.codin_n            ( codin_n[11]              ), 
.codin_nb           ( codin_nb[11]             ), 
.rb_dq_select       ( rb_dq_in_select_5[5:3]   ), 
.latch_open_n       ( struct_latch_open_n_5[1] ), 
.dq_diff_in         ( dq_diff_in[23:22]        ), 
.dq_sstl_in         ( dq_sstl_in[23:22]        ), 
.nfrzdrv            ( nfrzdrv_struct_5[1]      ), 
.loopback_p         ( loopback_p[11]           ), 
.loopback_n         ( loopback_n[11]           ), 
.loopback_en_n      ( loopback_en_n[11]        ), 
.datovr             ( datovr_5[1]              ), 
.datovrb            ( datovrb_5[1]             ), 
.data_dq            ( data_dq_5[1]             ), 
.data_dqb           ( data_dqb_5[1]            ), 
.dqs_loop_back      (                          ),  
.sample_clk         ( sample_clk_5             ),
.dcc_select         ( dcc_select_5[1:0]        ),
.dcc_sample         ( sample_value_struct_5[1] ),
.rb_gpio_or_ddr_sel ( rb_gpio_or_ddr_sel_5[1]  ), 
.rb_mode_ddr        ( rb_mode_ddr_5[1]         ), 
.scan_in            ( scan_chn_struct[10]      ),
.scan_shift_n       ( scan_shift_n	       ),
.test_clk           ( test_clk_struct	       ),
.scan_out           ( scanout[75]              )
);

io_ioereg_custom__mdev40 io_ioereg_custom_5 (
.data_dq_in             ( data_dq_5[1:0]                   ),
.data_dqb_in            ( data_dqb_5[1:0]                  ),
.x64_osc_in_p           ( x64_osc_chain_p[5]               ),
.x64_osc_in_n           ( x64_osc_chain_n[5]               ),
.x64_osc_out_p          ( x64_osc_chain_p[6]               ),
.x64_osc_out_n          ( x64_osc_chain_n[6]               ),
.x64_osc_mode           ( x64_osc_mode_out                 ),
.nfrzdrv                ( nfrzdrv_nand_x64_5               ),
.dq_f_gray              ( dq_f_gray_5[11:0]                ),
.dq_i_gray              ( dq_i_gray_5[5:0]                 ),
.dq_fall_gray           ( dq_fall_gray_5[7:0]              ),
.dq_rise_gray           ( dq_rise_gray_5[7:0]              ),
.dq_in_del              ( dq_in_del_n[23:20]               ),
.phy_clk_phs            ( 8'd0                		   ),
.rb_filter_code         ( rb_filter_code_top[1:0]          ),
.test_enable            ( test_enable_5                    ),
.rb_couple_enable       ( rb_couple_enable                 ),
.power_down_n           ( power_down_n_5[1:0]              ),
.mux_sel_a              ( mux_sel_a_5[5:0]                 ),
.mux_sel_b              ( mux_sel_b_5[5:0]                 ),
.interp_sel_a           ( interp_sel_a_5[7:0]              ),
.interp_sel_b           ( interp_sel_b_5[7:0]              ),
.dirty_clk              ( dirty_clk_5[3:0]                 ),
.interp_enable          ( interp_enable_5[1:0]             ),
.int_clk                ( int_clk_5[1:0]                   ),
.interp_clk_out         ( interp_clk_out_5[3:0]            ),
.interpolator_clk       ( interpolator_clk_5[3:0]          )
);

io_dqs_lgc_top__mdev40 xio_dqs_lgc_top ( 
  .reset_n                    ( ioereg_reset_n             ), 
  .phy_clk                    ( afi_cal_success ? 'd0 : phy_clk_dqs[1:0]  ), 
  .broadcast_in_top           ( broadcast_in_top[1:0]      ), 
  .broadcast_in_bot           ( broadcast_in_bot[1:0]      ), 
  .broadcast_out_top          ( broadcast_out_top[1:0]     ), 
  .broadcast_out_bot          ( broadcast_out_bot[1:0]     ), 
  .avl_clk_in                 ( avl_clk_in                 ), 
  .avl_clk_out                ( avl_clk_out                ), 
  .avl_address_in             ( avl_address_in[19:0]       ), 
  .avl_address_out            ( avl_address_out[19:0]      ), 
  .avl_address_dbc            ( avl_address_dbc[19:0]      ), 
  .avl_wr_address_top         ( avl_wr_address_top[4:0]    ), 
  .avl_rd_address_top         ( avl_rd_address_top[4:0]    ), 
  .avl_wr_address_bot         ( avl_wr_address_bot[4:0]    ), 
  .avl_rd_address_bot         ( avl_rd_address_bot[4:0]    ), 
  .avl_writedata_in           ( avl_writedata_in[31:0]     ), 
  .avl_writedata_out          ( avl_writedata_out[31:0]    ), 
  .avl_writedata_dbc          ( avl_writedata_dbc[31:0]    ), 
  .avl_writedata_top          ( avl_writedata_top[15:0]    ), 
  .avl_writedata_bot          ( avl_writedata_bot[15:0]    ), 
  .avl_readdata_in            ( avl_readdata_in[31:0]      ), 
  .avl_readdata_out           ( avl_readdata_out[31:0]     ), 
  .avl_readdata_dbc           ( avl_readdata_dbc[31:0]     ), 
  .avl_readchain_top          ( avl_readchain_top[47:32]   ), 
  .avl_readchain_bot          ( avl_readchain_bot[47:32]   ), 
  .avl_write_in               ( avl_write_in               ), 
  .avl_write_out              ( avl_write_out              ), 
  .avl_write_dbc              ( avl_write_dbc[1:0]         ), 
  .avl_sync_write_top         ( avl_sync_write_top         ), 
  .avl_sync_write_bot         ( avl_sync_write_bot         ), 
  .avl_read_in                ( avl_read_in                ), 
  .avl_read_out               ( avl_read_out               ), 
  .avl_destruct_read_top      ( avl_destruct_read_top      ), 
  .avl_destruct_read_bot      ( avl_destruct_read_bot      ), 
  .avl_select                 ( avl_select_ioereg[12]      ), 
  .afi_rddata_en_full         ( {rdata_en_full_out_3, rdata_en_full_local[2], rdata_en_full_local[1], rdata_en_full_local[0]} ), 
  .afi_mrnk_read              ( {mrnk_read_out_7,mrnk_read_local[6],mrnk_read_local[5],mrnk_read_local[4],mrnk_read_out_3,mrnk_read_local[2],mrnk_read_local[1],mrnk_read_local[0] }       ), 
  .afi_mrnk_write             ( mrnk_write_local[7:0]      ), 
  .afi_rddata_valid           (                            ), 
  .chk_x1_track_in_up         ( chk_x1_track_in_up[11:0]   ), 
  .chk_x1_track_in_dn         ( chk_x1_track_in_dn[11:0]   ), 
  .chk_x12_track_in_up        ( chk_x12_track_in_up        ), 
  .chk_x12_track_in_dn        ( chk_x12_track_in_dn        ), 
  .chk_x12_track_out_up       ( chk_x12_track_out_up       ), 
  .chk_x12_track_out_dn       ( chk_x12_track_out_dn       ), 
  .chk_x12_track_out_up_top   ( chk_x12_track_out_up_top   ), 
  .chk_x12_track_out_up_bot   ( chk_x12_track_out_up_bot   ), 
  .chk_x12_track_out_dn_top   ( chk_x12_track_out_dn_top   ), 
  .chk_x12_track_out_dn_bot   ( chk_x12_track_out_dn_bot   ), 
  .fifo_pack_select_top       ( fifo_pack_select_top[1:0]  ), 
  .fifo_read_enable_top       ( fifo_read_enable_top       ), 
  .fifo_reset_n_top           ( fifo_reset_n_top           ), 
  .fifo_rank_sel_top          ( fifo_rank_sel_top          ), 
  .fifo_pack_select_bot       ( fifo_pack_select_bot[1:0]  ), 
  .fifo_read_enable_bot       ( fifo_read_enable_bot       ), 
  .fifo_reset_n_bot           ( fifo_reset_n_bot           ), 
  .fifo_rank_sel_bot          ( fifo_rank_sel_bot          ), 
  .dqs_diff_in_0              ( dqs_diff_in_0[1:0]         ), 
  .dqs_diff_in_1              ( dqs_diff_in_1[1:0]         ), 
  .dqs_diff_in_2              ( dqs_diff_in_2[1:0]         ), 
  .dqs_diff_in_3              ( dqs_diff_in_3[1:0]         ), 
  .dqs_sstl_p_0               ( dqs_sstl_p_0[1:0]          ), 
  .dqs_sstl_p_1               ( dqs_sstl_p_1[1:0]          ), 
  .dqs_sstl_p_2               ( dqs_sstl_p_2[1:0]          ), 
  .dqs_sstl_p_3               ( dqs_sstl_p_3[1:0]          ), 
  .dqs_sstl_n_0               ( dqs_sstl_n_0[1:0]          ), 
  .dqs_sstl_n_1               ( dqs_sstl_n_1[1:0]          ), 
  .dqs_sstl_n_2               ( dqs_sstl_n_2[1:0]          ), 
  .dqs_sstl_n_3               ( dqs_sstl_n_3[1:0]          ), 
  .pvt_ref_gry                ( pvt_ref_gry[9:0]           ), 
  .pvt_write                  ( pvt_write[5:0]             ), 
  .pvt_address_top            ( pvt_address_top[2:0]       ), 
  .pvt_address_bot            ( pvt_address_bot[2:0]       ), 
  .pvt_data_top               ( pvt_data_top[8:0]          ), 
  .pvt_data_bot               ( pvt_data_bot[8:0]          ), 
  .rank_in_a_top              ( rank_in_a_top[1:0]         ), 
  .rank_in_a_bot              ( rank_in_a_bot[1:0]         ), 
  .rank_in_b_top              ( rank_in_b_top[1:0]         ), 
  .rank_in_b_bot              ( rank_in_b_bot[1:0]         ), 
  .rank_out_top               ( rank_out_top[7:0]          ), 
  .rank_out_bot               ( rank_out_bot[7:0]          ), 
  .oct_enable_out_top         ( oct_enable_out_top         ), 
  .oct_enable_out_bot         ( oct_enable_out_bot         ), 
  .rb_phy_clk_mode_bot        ( rb_phy_clk_mode_bot        ), 
  .rb_track_speed_bot         ( rb_track_speed_bot[3:0]    ), 
  .rb_kicker_size_bot         ( rb_kicker_size_bot[1:0]    ), 
  .rb_mode_rate_in_bot        ( rb_mode_rate_in_bot[1:0]   ), 
  .rb_mode_rate_out_bot       ( rb_mode_rate_out_bot[1:0]  ), 
  .rb_filter_code_bot         ( rb_filter_code_bot[1:0]    ), 
  .rb_phy_clk_mode_top        ( rb_phy_clk_mode_top        ), 
  .rb_track_speed_top         ( rb_track_speed_top[3:0]    ), 
  .rb_kicker_size_top         ( rb_kicker_size_top[1:0]    ), 
  .rb_mode_rate_in_top        ( rb_mode_rate_in_top[1:0]   ), 
  .rb_mode_rate_out_top       ( rb_mode_rate_out_top[1:0]  ), 
  .rb_filter_code_top         ( rb_filter_code_top[1:0]    ), 
  .rb_phy_clk_mode_right      ( rb_phy_clk_mode_right      ), 
  .sel_vref                   ( sel_vref[5:0]              ), 
  .csr_clk                    ( csrclk_mux_o               ), 
  .csr_clk_top                ( csr_clk_top                ), 
  .csr_clk_bot                ( csr_clk_bot                ), 
  .csr_clk_left               ( csr_clk_left               ), 
  .csr_clk_dbc                ( csr_clk_dbc                ), 
  .csr_in                     ( dqs_csrin                  ), 
  .csr_out                    ( ioereg_csrout[4]           ), 
  .csr_en                     ( csren_gate                 ), 
  .csr_en_top                 ( csr_en_top                 ), 
  .csr_en_bot                 ( csr_en_bot                 ), 
  .csr_en_left                ( csr_en_dll                 ), 
  .csr_en_dbc                 ( csr_en_dbc                 ), 
  .csr_shift_n                ( csr_shift_n                ), 
  .csr_shift_n_top            ( csr_shift_n_top            ), 
  .csr_shift_n_bot            ( csr_shift_n_bot            ), 
  .csr_shift_n_left           ( csr_shift_n_left           ), 
  .csr_shift_n_dbc            ( csr_shift_n_dbc            ), 
  .nfrzdrv                    ( local_nfrzdrv              ), 
  .nfrzdrv_top                ( nfrzdrv_top                ), 
  .nfrzdrv_bot                ( nfrzdrv_bot                ), 
  .frzreg                     ( local_frzreg               ), 
  .frzreg_top                 ( frzreg_top                 ), 
  .frzreg_bot                 ( frzreg_bot                 ), 
  .dll_lock                   ( dll_core[10]               ), 
  .test_tdf_select_n          ( test_tdf_select_n          ), 
  .test_tdf_select_n_top      ( test_tdf_select_n_top      ), 
  .test_tdf_select_n_bot      ( test_tdf_select_n_bot      ), 
  .atpg_en_n                  ( atpg_en_n                  ), 
  .atpg_en_n_top              ( atpg_en_n_top              ), 
  .atpg_en_n_bot              ( atpg_en_n_bot              ), 
  .atpg_en_n_left             ( atpg_en_n_left             ), 
  .pipeline_global_en_n       ( pipeline_global_en_n       ), 
  .pipeline_global_en_n_top   ( pipeline_global_en_n_top   ), 
  .pipeline_global_en_n_bot   ( pipeline_global_en_n_bot   ), 
  .pipeline_global_en_n_left  ( pipeline_global_en_n_left  ), 
  .test_clr_n                 ( lane_test_clr_n            ), 
  .test_clr_n_top             ( test_clr_n_top             ), 
  .test_clr_n_bot             ( test_clr_n_bot             ), 
  .niotri                     ( local_niotri               ), 
  .niotri_top                 ( niotri_top                 ), 
  .niotri_bot                 ( niotri_bot                 ), 
  .test_clk                   ( test_clock                 ), 
  .test_clk_struct            ( test_clk_struct            ), 
  .scan_shift_n               ( scan_shift_n               ), 
  .scan_shift_n_top           ( scan_shift_n_top           ), 
  .scan_shift_n_bot           ( scan_shift_n_bot           ), 
  .scan_shift_n_dbc           ( scan_shift_n_dbc           ), 
  .scan_shift_n_left          ( scan_shift_n_left          ), 
  .jtag_shftdr                ( jtag_shftdr                ), 
  .jtag_shftdr_top            ( jtag_shftdr_top            ), 
  .jtag_shftdr_bot            ( jtag_shftdr_bot            ), 
  .jtag_clk                   ( jtag_clk                   ), 
  .jtag_clk_top               ( jtag_clk_top               ), 
  .jtag_clk_bot               ( jtag_clk_bot               ), 
  .jtag_highz                 ( jtag_highz                 ), 
  .jtag_highz_top             ( jtag_highz_top             ), 
  .jtag_highz_bot             ( jtag_highz_bot             ), 
  .jtag_updtdr                ( jtag_updtdr                ), 
  .jtag_updtdr_top            ( jtag_updtdr_top            ), 
  .jtag_updtdr_bot            ( jtag_updtdr_bot            ), 
  .jtag_mode                  ( jtag_mode                  ), 
  .jtag_mode_top              ( jtag_mode_top              ), 
  .jtag_mode_bot              ( jtag_mode_bot              ), 
  .xor_clk                    ( xor_clk[5:0]               ), 
  .test_xor_clk               ( test_xor_clk               ), 
  .probe_out                  ( dqs_probe[11:0]            ), 
  .sync_data_bot_in           ( sync_data_up_chn[2]        ),
  .sync_clk_bot_out           ( sync_clk_dn_chn[2]         ),
  .sync_data_bot_out          ( sync_data_dn_chn[2]        ),
  .sync_data_top_in           ( sync_data_dn_chn[3]        ),
  .sync_clk_top_out           ( sync_clk_up_chn[3]         ),
  .sync_data_top_out          ( sync_data_up_chn[3]        ),
  .xprio_clk                  ( xprio_clk                  ), 
  .xprio_sync                 ( xprio_sync                 ), 
  .xprio_xbus                 ( xprio_xbus[7:0]            ), 
  .xpr_clk_bot                ( xpr_clk_bot                ), 
  .xpr_clk_top                ( xpr_clk_top                ), 
  .xpr_write_bot              ( xpr_write_bot[2:0]         ), 
  .xpr_write_top              ( xpr_write_top[2:0]         ), 
  .xpr_data_bot               ( xpr_data_bot[7:0]          ), 
  .xpr_data_top               ( xpr_data_top[7:0]          ), 
  .dqs_loop_back_0a           ( dqs_loop_back_0[1:0]       ),
  .dqs_loop_back_1a           ( dqs_loop_back_1[1:0]       ),
  .dqs_loop_back_0b           ( dqs_loop_back_0[1:0]       ),
  .dqs_loop_back_1b           ( dqs_loop_back_1[1:0]       ),
  .osc_enable_in              ( osc_enable_in              ), 
  .osc_mode_in                ( osc_mode_in                ), 
  .osc_mode_out               ( x64_osc_mode_out           ), 
  .x1024_osc_out              ( x1024_osc_out              ), 
  .power_down_n               ( power_down_n[2:0]          ), 
  .nfrzdrv_left               ( nfrzdrv_left               ), 
  .rb_filter_code_left        ( rb_filter_code_left[1:0]   ), 
  .mux_sel_a_a                ( mux_sel_a_a[2:0]           ), 
  .mux_sel_b_a                ( mux_sel_b_a[2:0]           ), 
  .interp_sel_a_a             ( interp_sel_a_a[3:0]        ), 
  .interp_sel_b_a             ( interp_sel_b_a[3:0]        ), 
  .dirty_clk_out_a            ( dirty_clk_out_a[1:0]       ), 
  .mux_sel_a_b                ( mux_sel_a_b[2:0]           ), 
  .mux_sel_b_b                ( mux_sel_b_b[2:0]           ), 
  .interp_sel_a_b             ( interp_sel_a_b[3:0]        ), 
  .interp_sel_b_b             ( interp_sel_b_b[3:0]        ), 
  .dirty_clk_out_b            ( dirty_clk_out_b[1:0]       ), 
  .test_enable                ( test_enable                ), 
  .int_clk_a                  ( int_clk_a                  ), 
  .int_clk_b                  ( int_clk_b                  ), 
  .interp_clk_out_a           ( interp_clk_out_a[1:0]      ), 
  .interp_clk_out_b           ( interp_clk_out_b[1:0]      ), 
  .interpolator_clk_a         ( interp_clk_out_a[1:0]      ), 
  .interpolator_clk_b         ( interp_clk_out_b[1:0]      ), 
  .clk_ph_1_buf               ( clk_ph_1_buf               ), 
  .clk_ph_3_buf               ( clk_ph_3_buf               ), 
  .dqs_clean_a                ( dqs_clean_a[1:0]           ), 
  .x128_osc_lca_p             ( x128_osc_lca_p             ), 
  .x128_osc_lca_n             ( x128_osc_lca_n             ), 
  .dqs_f_gray_a               ( dqs_f_gray_a[6:0]          ), 
  .dqs_i_gray_a               ( dqs_i_gray_a[2:0]          ), 
  .dqs_fall_gray_a            ( dqs_fall_gray_a[3:0]       ), 
  .dqs_rise_gray_a            ( dqs_rise_gray_a[3:0]       ), 
  .dqs_clean_b                ( dqs_clean_b[1:0]           ), 
  .x128_osc_lcb_p             ( x128_osc_lcb_p             ), 
  .x128_osc_lcb_n             ( x128_osc_lcb_n             ), 
  .dqs_f_gray_b               ( dqs_f_gray_b[6:0]          ), 
  .dqs_i_gray_b               ( dqs_i_gray_b[2:0]          ), 
  .dqs_fall_gray_b            ( dqs_fall_gray_b[3:0]       ), 
  .dqs_rise_gray_b            ( dqs_rise_gray_b[3:0]       ), 
  .rb_couple_enable           ( rb_couple_enable           ),
  .vreg_calsel                ( vreg_calsel                ),
  .vreg_cal_en                ( vreg_cal_en                ),
  .vreg_atbsel                ( vreg_atbsel                ),
  .vreg_pdb                   ( vreg_pdb                   ),
  .vreg_ovrride               ( vreg_ovrride               ),
  .sync_a_ioereg_top          ( sync_a_ioereg_top          ),
  .sync_a_ioereg_bot          ( sync_a_ioereg_bot          )
);

io_dqs_custom__mdev40 xio_dqs_custom (
  .phy_clk_phs               ( 8'd0                        ),
  .phy_clk_phs_lane_out      ( phy_clk_phs_lane_out[7:0]   ),
  .dqs_clean_a               ( dqs_clean_a[1:0]            ),
  .dqs_clean_b               ( dqs_clean_b[1:0]            ),
  .x128_osc_in_p             ( x64_osc_chain_p[7]          ),
  .x128_osc_in_n             ( x64_osc_chain_n[7]          ),
  .x128_osc_out_p            ( x64_osc_chain_p[0]          ),
  .x128_osc_out_n            ( x64_osc_chain_n[0]          ),
  .x128_osc_lca_p            ( x128_osc_lca_p              ),
  .x128_osc_lca_n            ( x128_osc_lca_n              ),
  .x128_osc_lcb_p            ( x128_osc_lcb_p              ),
  .x128_osc_lcb_n            ( x128_osc_lcb_n              ),
  .dqs_f_gray_a              ( dqs_f_gray_a[6:0]           ),
  .dqs_i_gray_a              ( dqs_i_gray_a[2:0]           ),
  .dqs_fall_gray_a           ( dqs_fall_gray_a[3:0]        ), 
  .dqs_rise_gray_a           ( dqs_rise_gray_a[3:0]        ), 
  .dqs_f_gray_b              ( dqs_f_gray_b[6:0]           ),
  .dqs_i_gray_b              ( dqs_i_gray_b[2:0]           ),
  .dqs_fall_gray_b           ( dqs_fall_gray_b[3:0]        ), 
  .dqs_rise_gray_b           ( dqs_rise_gray_b[3:0]        ), 
  .osc_mode                  ( x64_osc_mode_out            ),
  .dqs_out_a                 ( dqs_out_a_n[1:0]            ),
  .dqs_out_b                 ( dqs_out_b_n[1:0]            ),
  .nfrzdrv                   ( nfrzdrv_left                ),
  .reset_n                   ( ioereg_reset_n              ),
  .power_down_n              ( power_down_n[2:0]           ),
  .rb_filter_code            ( rb_filter_code_left[1:0]    ),
  .mux_sel_a_a               ( mux_sel_a_a[2:0]            ),
  .mux_sel_b_a               ( mux_sel_b_a[2:0]            ),
  .interp_sel_a_a            ( interp_sel_a_a[3:0]         ),
  .interp_sel_b_a            ( interp_sel_b_a[3:0]         ),
  .dirty_clk_out_a           ( dirty_clk_out_a[1:0]        ),
  .int_clk_a                 ( int_clk_a                   ),
  .interp_clk_out_a          ( interp_clk_out_a[1:0]       ),
  .mux_sel_a_b               ( mux_sel_a_b[2:0]            ),
  .mux_sel_b_b               ( mux_sel_b_b[2:0]            ),
  .interp_sel_a_b            ( interp_sel_a_b[3:0]         ),
  .interp_sel_b_b            ( interp_sel_b_b[3:0]         ),
  .dirty_clk_out_b           ( dirty_clk_out_b[1:0]        ),
  .int_clk_b                 ( int_clk_b                   ),
  .interp_clk_out_b          ( interp_clk_out_b[1:0]       ),
  .test_enable               ( test_enable                 ),
  .rb_couple_enable          ( rb_couple_enable            ),
  .clk_ph_1_buf              ( clk_ph_1_buf                ),
  .clk_ph_3_buf              ( clk_ph_3_buf                )
);


wire  [5:0]  dummy_a, dummy_b;

io_data_buffer__mdev40 data_buffer (
  .phy_clk                   ( phy_clk_dqs[1:0]               ),  
  .frzreg                    ( local_frzreg                   ),  
  .pll_locked                ( pll_locked                     ),  
  .global_reset_n            ( reset_n                        ),  
  .scan_shift_n              ( scan_shift_n_dbc               ),  
  .csr_scan_shift_n          ( 1'b1                           ),  
  .atpg_en_n                 ( atpg_en_n                      ),  
  .dft_pipeline_global_en_n  ( pipeline_global_en_n           ),  
  .dft_prbs_ena_n            ( dft_prbs_ena_n                 ),  
  .dft_prbs_pass             ( dft_prbs_pass                  ),  
  .dft_prbs_done             ( dft_prbs_done                  ),  
  .dft_core2db               ( dft_core2db[7:0]               ),  
  .dft_db2core               ( dft_db2core[7:0]               ),  
  .dft_phy_clk               ( dft_phy_clk[1:0]               ),  
  .avl_address               ( avl_address_dbc[19:0]          ),  
  .avl_write                 ( avl_write_dbc[1:0]             ),  
  .avl_writedata             ( avl_writedata_dbc[31:0]        ),  
  .avl_readdata              ( avl_readdata_dbc[31:0]         ),  
  .avl_select                ( avl_select_ioereg[12:0]        ),  
  .avl_select_dcc            ( avl_select_dcc[5:0]            ),  
  .ctl2dbc_wrdata_vld0       ( ctl2dbc_wrdata_vld0            ),  
  .ctl2dbc_mask_entry0       ( ctl2dbc_mask_entry0            ),  
  .ctl2dbc_wb_rdptr_vld0     ( ctl2dbc_wb_rdptr_vld0          ),  
  .ctl2dbc_wb_rdptr0         ( ctl2dbc_wb_rdptr0[5:0]         ),  
  .ctl2dbc_rb_wrptr_vld0     ( ctl2dbc_rb_wrptr_vld0          ),  
  .ctl2dbc_rb_wrptr0         ( ctl2dbc_rb_wrptr0[5:0]         ),  
  .ctl2dbc_rb_rdptr_vld0     ( ctl2dbc_rb_rdptr_vld0[1:0]     ),  
  .ctl2dbc_rb_rdptr0         ( ctl2dbc_rb_rdptr0[11:0]        ),  
  .ctl2dbc_rdata_en_full0    ( ctl2dbc_rdata_en_full0[3:0]    ),  
  .ctl2dbc_mrnk_read0        ( ctl2dbc_mrnk_read0[7:0]        ),  
  .ctl2dbc_seq_en0           ( ctl2dbc_seq_en0                ),  
  .ctl2dbc_nop0              ( ctl2dbc_nop0                   ),  
  .ctl2dbc_cs0               ( ctl2dbc_cs0[1:0]               ),  
  .ctl2dbc_rd_type0          ( ctl2dbc_rd_type0               ),  
  .ctl2dbc_misc0             ( ctl2dbc_misc0[3:0]             ),  
  .ctl2dbc_wrdata_vld1       ( ctl2dbc_wrdata_vld1            ),  
  .ctl2dbc_mask_entry1       ( ctl2dbc_mask_entry1            ),  
  .ctl2dbc_wb_rdptr_vld1     ( ctl2dbc_wb_rdptr_vld1          ),  
  .ctl2dbc_wb_rdptr1         ( ctl2dbc_wb_rdptr1[5:0]         ),  
  .ctl2dbc_rb_wrptr_vld1     ( ctl2dbc_rb_wrptr_vld1          ),  
  .ctl2dbc_rb_wrptr1         ( ctl2dbc_rb_wrptr1[5:0]         ),  
  .ctl2dbc_rb_rdptr_vld1     ( ctl2dbc_rb_rdptr_vld1[1:0]     ),  
  .ctl2dbc_rb_rdptr1         ( ctl2dbc_rb_rdptr1[11:0]        ),  
  .ctl2dbc_rdata_en_full1    ( ctl2dbc_rdata_en_full1[3:0]    ),  
  .ctl2dbc_mrnk_read1        ( ctl2dbc_mrnk_read1[7:0]        ),  
  .ctl2dbc_seq_en1           ( ctl2dbc_seq_en1                ),  
  .ctl2dbc_nop1              ( ctl2dbc_nop1                   ),  
  .ctl2dbc_cs1               ( ctl2dbc_cs1[1:0]               ),  
  .ctl2dbc_rd_type1          ( ctl2dbc_rd_type1               ),  
  .ctl2dbc_misc1             ( ctl2dbc_misc1[3:0]             ),  
  .dbc2ctl_wb_retire_ptr_vld (                                ),  
  .dbc2ctl_wb_retire_ptr     (                                ),  
  .dbc2ctl_rb_retire_ptr_vld (                                ),  
  .dbc2ctl_rb_retire_ptr     (                                ),  
  .dbc2ctl_rd_data_vld       (                                ),  
  .dbc2ctl_all_rd_done       (                                ),  
  .dbc2db_wb_wrptr_vld       (                                ),  
  .dbc2db_wb_wrptr           (                                ),  
  .cfg_dbc_ctrl_sel          ( cfg_dbc_ctrl_sel               ),  
  .cfg_reorder_rdata         ( cfg_reorder_rdata              ),  
  .cfg_rmw_en                ( cfg_rmw_en                     ),  
  .cfg_output_regd           ( cfg_output_regd                ),  
  .cfg_dbc_in_protocol       ( cfg_dbc_in_protocol            ),  
  .cfg_dbc_dualport_en       ( cfg_dbc_dualport_en            ),  
  .cfg_dbc_pipe_lat          ( cfg_dbc_pipe_lat[2:0]          ),  
  .cfg_cmd_rate              ( cfg_cmd_rate[2:0]              ),  
  .cfg_dbc_rc_en             ( cfg_dbc_rc_en                  ),  
  .cfg_dbc_slot_rotate_en    ( cfg_dbc_slot_rotate_en[2:0]    ),  
  .cfg_dbc_slot_offset       ( cfg_dbc_slot_offset[1:0]       ),  
  .rb_phy_clk_mode           ( rb_phy_clk_mode_right          ),  
  .oe_to_ioreg               ( oeb_to_ioreg[47:0]             ),  
  .data_to_ioreg             ( data_to_ioreg[95:0]            ),  
  .data_from_ioreg           ( data_from_ioreg_abphy[95:0]    ),  
  .read_data_valid           ( rdata_valid_out[3:0]           ),  
  .dq_in_dly_up              ( chk_x1_track_in_up[11:0]       ),  
  .dq_in_dly_dn              ( chk_x1_track_in_dn[11:0]       ),  
  .dq_out_dly_up             ( chk_x1_track_out_up[11:0]      ),  
  .dq_out_dly_dn             ( chk_x1_track_out_dn[11:0]      ),  
  .dqs_in_dly_up             ( chk_x12_track_in_up            ),  
  .dqs_in_dly_dn             ( chk_x12_track_in_dn            ),  
  .dqs_out_dly_up            ( chk_x12_track_out_up           ),  
  .dqs_out_dly_dn            ( chk_x12_track_out_dn           ),  
  .rdata_en_full             ( rdata_en_full_local[3:0]       ),  
  .mrnk_read                 ( mrnk_read_local[7:0]           ),  
  .mrnk_write                ( mrnk_write_local[7:0]          ),  
  .select_ac_hmc             ( select_ac_hmc[11:0]            ),  
  .ioereg_reset_n            ( ioereg_reset_n                 ),  
  .test_dbg_in               ( test_dbg_in[11:0]              ),  
  .test_dbg_out_db_in        ( test_dbg_out[11:0]             ),  
  .test_dbg_out_db_out       ( test_dbg_out_local[11:0]       ),  
  .oe_from_core              ( oeb_from_core[47:0]            ),  
  .data_from_core            ( data_from_core[95:0]           ),  
  .data_to_core              ( data_to_core[95:0]             ),  
  .rdata_en_full_core        ( rdata_en_full_core[3:0]        ),  
  .mrnk_read_core            ( mrnk_read_core[15:0]           ),  
  .mrnk_write_core           ( mrnk_write_core[15:0]          ),  
  .rdata_valid_core          ( rdata_valid_core[3:0]          ),  
  .afi_wlat_core             ( afi_wlat_core[5:0]             ),  
  .afi_rlat_core             ( afi_rlat_core[5:0]             ),  
  .core2dbc_wr_data_vld0     ( core2dbc_wr_data_vld0          ),  
  .dbc2core_wr_data_rdy      ( dbc2core_wr_data_rdy           ),  
  .dbc2core_rd_data_vld0     ( dbc2core_rd_data_vld0          ),  
  .dbc2core_rd_type          ( dbc2core_rd_type               ),  
  .core2dbc_rd_data_rdy      ( core2dbc_rd_data_rdy           ),  
  .core2dbc_wr_ecc_info      ( core2dbc_wr_ecc_info[12:0]     ),  
  .dbc2core_wb_pointer       ( dbc2core_wb_pointer[11:0]      ),  
  .csr_clk                   ( csr_clk_dbc                    ),  
  .csr_ena                   ( csr_en_dbc                     ),  
  .csr_din                   ( db_csrin                       ),  
  .csr_dout                  ( ioereg_csrout[0]               )   
);


io_phy_ckt__mdev40 phy_ckt (
.lvds_rxloaden_in      ( phy_clk_fb[0] ),
.lvds_rxclk_in         ( phy_clk_fb[1] ),
.fb_clkin              ( phy_clk_fb[2] ),
.phy_clk0fb            ( fb_clkout[0]              ), 
.phy_clk1fb            ( fb_clkout[1]              ), 
.fb_clkout             ( fb_clkout[2]              )
); 


io_dqs_ckt__mdev40 dqs_ckt (
.dqsin_a              ( dqs_out_a_n[1:0]   ), 
.dqsin_b              ( dqs_out_b_n[1:0]   ), 
.dq0_in               ( dq_in_del_n[1:0]   ), 
.dq1_in               ( dq_in_del_n[3:2]   ), 
.dq2_in               ( dq_in_del_n[5:4]   ), 
.dq3_in               ( dq_in_del_n[7:6]   ), 
.dq4_in               ( dq_in_del_n[9:8]   ), 
.dq5_in               ( dq_in_del_n[11:10] ), 
.dq6_in               ( dq_in_del_n[13:12] ), 
.dq7_in               ( dq_in_del_n[15:14] ), 
.dq8_in               ( dq_in_del_n[17:16] ), 
.dq9_in               ( dq_in_del_n[19:18] ), 
.dq10_in              ( dq_in_del_n[21:20] ), 
.dq11_in              ( dq_in_del_n[23:22] ), 
.n_dqsout_a_ioreg0    ( dqs_clk_a[1:0]     ), 
.n_dqsout_b_ioreg0    ( dqs_clk_b[1:0]     ), 
.n_dqsout_a_ioreg1    ( dqs_clk_a[3:2]     ), 
.n_dqsout_b_ioreg1    ( dqs_clk_b[3:2]     ), 
.n_dqsout_a_ioreg2    ( dqs_clk_a[5:4]     ), 
.n_dqsout_b_ioreg2    ( dqs_clk_b[5:4]     ), 
.n_dqsout_a_ioreg3    ( dqs_clk_a[7:6]     ), 
.n_dqsout_b_ioreg3    ( dqs_clk_b[7:6]     ), 
.n_dqsout_a_ioreg4    ( dqs_clk_a[9:8]     ), 
.n_dqsout_b_ioreg4    ( dqs_clk_b[9:8]     ), 
.n_dqsout_a_ioreg5    ( dqs_clk_a[11:10]   ), 
.n_dqsout_b_ioreg5    ( dqs_clk_b[11:10]   ), 
.n_dqsout_a_ioreg6    ( dqs_clk_a[13:12]   ), 
.n_dqsout_b_ioreg6    ( dqs_clk_b[13:12]   ), 
.n_dqsout_a_ioreg7    ( dqs_clk_a[15:14]   ), 
.n_dqsout_b_ioreg7    ( dqs_clk_b[15:14]   ), 
.n_dqsout_a_ioreg8    ( dqs_clk_a[17:16]   ), 
.n_dqsout_b_ioreg8    ( dqs_clk_b[17:16]   ), 
.n_dqsout_a_ioreg9    ( dqs_clk_a[19:18]   ), 
.n_dqsout_b_ioreg9    ( dqs_clk_b[19:18]   ), 
.n_dqsout_a_ioreg10   ( dqs_clk_a[21:20]   ), 
.n_dqsout_b_ioreg10   ( dqs_clk_b[21:20]   ), 
.n_dqsout_a_ioreg11   ( dqs_clk_a[23:22]   ), 
.n_dqsout_b_ioreg11   ( dqs_clk_b[23:22]   ), 
.n_dq0out             ( dq_in_tree[1:0]    ), 
.n_dq1out             ( dq_in_tree[3:2]    ), 
.n_dq2out             ( dq_in_tree[5:4]    ), 
.n_dq3out             ( dq_in_tree[7:6]    ), 
.n_dq4out             ( dq_in_tree[9:8]    ), 
.n_dq5out             ( dq_in_tree[11:10]  ), 
.n_dq6out             ( dq_in_tree[13:12]  ), 
.n_dq7out             ( dq_in_tree[15:14]  ), 
.n_dq8out             ( dq_in_tree[17:16]  ), 
.n_dq9out             ( dq_in_tree[19:18]  ), 
.n_dq10out            ( dq_in_tree[21:20]  ), 
.n_dq11out            ( dq_in_tree[23:22]  )  
);
                   

io_dll_top__mdev40 xio_dll_top (
.core_dll                 ( 'd0                    ), 
.csr_rclk                 ( csr_rclk               ), 
.csrclk                   ( csr_clk_left           ), 
.csren                    ( csr_en_dll             ), 
.csr_en_local             ( csr_en_local           ), 
.early_csren              ( early_csren            ), 
.csrdatain                ( ioereg_csrout[7]       ), 
.clk_pll                  ( 'd0                    ), 
.reinit                   ( 'd0                    ), 
.latch_en                 ( csr_shift_n_left       ),
.csr_scan_shift_n         ( csr_shift_n_left       ), 
.cas_csrdin               ( cas_csrdin[4:0]        ), 
.cas_csrdout              ( cas_csrdout[4:0]       ), 
.scan_shift_n             ( scan_shift_n_left      ), 
.atpg_en_n                ( atpg_en_n_left         ), 
.dll_core                 ( dll_core[12:0]         ), 
.pvt_ref_gry              ( pvt_ref_gry[9:0]       ), 
.csrdataout               ( csr_out                ), 
.dft_pipeline_global_en_n ( pipeline_global_en_n_left   ), 
.test_clk                 ( test_clock          ), 
.test_clr_n               ( test_clr_n_bot         ), 
.bhniotri                 ( bhniotri               ), 
.early_bhniotri           ( early_bhniotri         ), 
.enrnsl                   ( enrnsl                 ), 
.early_enrnsl             ( early_enrnsl           ), 
.frzreg                   ( frzreg                 ), 
.early_frzreg             ( early_frzreg           ), 
.nfrzdrv                  ( nfrzdrv                ), 
.early_nfrzdrv            ( early_nfrzdrv          ), 
.niotri                   ( niotri                 ), 
.early_niotri             ( early_niotri           ), 
.plniotri                 ( plniotri               ), 
.early_plniotri           ( early_plniotri         ), 
.usermode                 ( usrmode                ), 
.early_usermode           ( early_usrmode          ), 
.wkpullup                 ( wkpullup               ), 
.local_bhniotri           ( local_bhniotri         ), 
.local_enrnsl             ( local_enrnsl           ), 
.local_frzreg             ( local_frzreg           ), 
.local_nfrzdrv            ( local_nfrzdrv          ), 
.local_niotri             ( local_niotri           ), 
.local_plniotri           ( local_plniotri         ), 
.local_usermode           ( local_usrmode          ), 
.local_wkpullup           ( local_wkpullup         ), 
.hps_to_core_ctrl_en      ( hps_to_core_ctrl_en    ), 
.osc_mode                 ( x64_osc_mode_out       ), 
.osc_in_p                 ( 'd0                    ), 
.osc_in_n                 ( 'd0                    ), 
.osc_out_p                ( x64_osc_chain_p[7]     ), 
.osc_out_n                ( x64_osc_chain_n[7]     )  
);

io_regulator__mdev40 xio_regulator (
.calsel             ( vreg_calsel            ),
.cal_en             ( vreg_cal_en            ),
.atbsel             ( vreg_atbsel            ),
.pdb                ( vreg_pdb               ),
.ovrride            ( vreg_ovrride           ),
.ic50u              ( ic50u                  ),
.it50u              ( it50u                  ),
.atb0               ( atbi_0                 ),
.atb1               ( atbi_1                 ),
.vref               ( vcc_io                 )
);




io_gpio_osc_en__mdev40 xio_gpio_osc_en (
.osc_en_n         ( osc_en_n              ),
.osc_in           ( osc_start_out         ),
.osc_out          ( osc_start_in          ),
.rocount_to_core  ( osc_rocount_to_core   ),
.frzreg           ( local_frzreg          )
);


/* not needed, pnr in ND
io_12lane_tclk_buf__mdev40 xio_12lane_tclk_buf (
.test_clock         ( test_clock       ),
.test_clk_dpa_top   ( test_clk_dpa_top ),
.test_clk_dpa_btm   ( test_clk_dpa_btm ),
.test_clk_lane      ( test_clk         )
);
*/

io_12lane_dft_mux__mdev40 xdpa_csrin_mux (
.testin ( test_dp_csr_in ),
.usrin  ( csr_in         ),
.s      ( scan_shift_n   ),
.dout    ( dp_csr_in      )
);

assign csr_en_local = hps_to_core_ctrl_en  ? early_csren : csr_en;
assign csr_en_left  = csr_en_local;                                         

io_12lane_csren_gate__mdev40 csren_gate_lgc (
.csren              ( csr_en_local     ),
.csr_scan_shift_n   ( csr_shift_n      ),
.csren_gate         ( csren_gate       )
);

io_12lane_csrclk_mux__mdev40 csrclk_mux (
.csr_test_clock   ( csr_test_clk ),
.csrclk           ( csr_clk      ),
.s                ( atpg_en_n    ),
.csr_shift_n	  ( csr_shift_n  ),
.cout             ( csrclk_mux_o )
);


ioserdesdpa_top__mdev40 ioserdesdpa_0 (
.csr_in                 ( dp_csr_in                ),
.csr_en                 ( csren_gate               ),
.csr_clk                ( csrclk_mux_o             ),
.csr_out                ( dp_csrout[0]             ),

.crnt_clk               ( interp_clk_out_0[1]      ),
.n_crnt_clk             ( interp_clk_out_0[0]      ),
.next_clk               ( interp_clk_out_0[3]      ),
.n_next_clk             ( interp_clk_out_0[2]      ),
.switch_up              ( switch_up[0]             ),
.switch_dn              ( switch_dn[0]             ),
.up_ph                  ( up_ph[0]                 ),
.dzoutx                 ( dzoutx[0]                ),

.frzreg                 ( local_frzreg             ),
.pull_high              ( local_frzreg             ), 

.dpahold                ( dpahold_pp[0]            ),
.dparst                 ( dparst_pp[0]             ),
.dpaswitch              ( dpaswitch_pp[0]          ),
.fiforst                ( fiforst_pp[0]            ),
.testin_fclk            ( testin_fclk_pp[0]        ),
.testin_loaden          ( test_loaden_pp[0]        ),
.par_in                 ( par_in_pp0               ),
.bslipcntl              ( bslipcntl_pp[0]          ),
.bsliprst               ( bsliprst_pp[0]           ),
.lock                   ( lock_pp[0]               ),
.pclk                   ( pclk_0                   ),
.bslipmax               ( bslipmax_pp[0]           ),
.par_out                ( par_out_pp0              ),

.lvdsin                 ( lvdsin[0]                ),
.pclkdpa                ( pclkdpa[0]               ),
.lvdsout                ( lvdsout[0]               ),
.fclk_in                ( {phy_clk_0[4],phy_clk_0[1]} ),		
.loaden_in              ( {phy_clk_0[3],phy_clk_0[0]} ),		
.loopback2_data_right_in ( 1'b0                    ),
.loopback2_data_left_in  ( loopback2_l2r[0]        ), 
.data_lback_adj_right_in ( 1'b0                    ),
.data_lback_adj_left_in  ( loopback13_l2r[0]       ),
.data_lback2_right_out   (                         ), 
.data_lback2_left_out    ( loopback2_r2l[0]        ),
.data_lback13_right_out  (                         ), 
.data_lback13_left_out   ( loopback13_r2l[0]       ),

.dummy_top_in           (  atpg_en_n               ),
.dummy_top_out          (                          ),
.dummy_bot_in           (  {2{atpg_en_n}}          ),
.dummy_bot_out          (                          ),

.atpg_en_n              ( atpg_en_n                ),
.pipeline_en_n          ( pipeline_global_en_n     ),
.latch_en               ( 1'b1                     ), 
.scan_right_in          ( 2'b0                     ),
.scan_left_in           ( dp_scan01_l2r[1:0]       ),
.scan_shift_n           ( scan_shift_n             ),
.scan_right_out         (                          ),
.scan_left_out          ( dp_scan01_r2l[1:0]       )
);

ioserdesdpa_top__mdev40 ioserdesdpa_1 (
.csr_in                 ( dp_csrout[0]             ),
.csr_en                 ( csren_gate               ),
.csr_clk                ( csrclk_mux_o             ),
.csr_out                ( dp_csrout[1]             ),

.crnt_clk               ( interp_clk_out_1[1]      ),
.n_crnt_clk             ( interp_clk_out_1[0]      ),
.next_clk               ( interp_clk_out_1[3]      ),
.n_next_clk             ( interp_clk_out_1[2]      ),
.switch_up              ( switch_up[1]             ),
.switch_dn              ( switch_dn[1]             ),
.up_ph                  ( up_ph[1]                 ),
.dzoutx                 ( dzoutx[1]                ),

.frzreg                 ( local_frzreg             ),
.pull_high              ( local_frzreg             ), 

.dpahold                ( dpahold_pp[1]            ),
.dparst                 ( dparst_pp[1]             ),
.dpaswitch              ( dpaswitch_pp[1]          ),
.fiforst                ( fiforst_pp[1]            ),
.testin_fclk            ( testin_fclk_pp[1]        ),
.testin_loaden          ( test_loaden_pp[1]        ),
.par_in                 ( par_in_pp1               ),
.bslipcntl              ( bslipcntl_pp[1]          ),
.bsliprst               ( bsliprst_pp[1]           ),
.lock                   ( lock_pp[1]               ),
.pclk                   ( pclk_1                   ),
.bslipmax               ( bslipmax_pp[1]           ),
.par_out                ( par_out_pp1              ),

.lvdsin                 ( lvdsin[1]                ),
.pclkdpa                ( pclkdpa[1]               ),
.lvdsout                ( lvdsout[1]               ),
.fclk_in                ( {phy_clk_1[4],phy_clk_1[1]} ),                
.loaden_in              ( {phy_clk_1[3],phy_clk_1[0]} ),                
.loopback2_data_right_in ( loopback2_r2l[0]        ),
.loopback2_data_left_in  ( loopback2_l2r[1]        ),
.data_lback_adj_right_in ( loopback13_r2l[0]       ),
.data_lback_adj_left_in  ( loopback13_l2r[1]       ),
.data_lback2_right_out   ( loopback2_l2r[0]        ),
.data_lback2_left_out    ( loopback2_r2l[1]        ),
.data_lback13_right_out  ( loopback13_l2r[0]       ),
.data_lback13_left_out   ( loopback13_r2l[1]       ),

.dummy_top_in           (  atpg_en_n               ),
.dummy_top_out          (                          ),
.dummy_bot_in           (  {2{atpg_en_n}}          ),
.dummy_bot_out          (                          ),

.atpg_en_n              ( atpg_en_n                ),
.pipeline_en_n          ( pipeline_global_en_n     ),
.latch_en               ( 1'b1                     ), 
.scan_right_in          ( dp_scan01_r2l[1:0]       ),
.scan_left_in           ( dp_scan12_l2r[1:0]       ),
.scan_shift_n           ( scan_shift_n             ),
.scan_right_out         ( dp_scan01_l2r[1:0]       ),
.scan_left_out          ( dp_scan12_r2l[1:0]       )
);

ioserdesdpa_top__mdev40 ioserdesdpa_2 (
.csr_in                 ( dp_csrout[1]             ),
.csr_en                 ( csren_gate               ),
.csr_clk                ( csrclk_mux_o             ),
.csr_out                ( dp_csrout[2]             ),

.crnt_clk               ( interp_clk_out_2[1]      ),
.n_crnt_clk             ( interp_clk_out_2[0]      ),
.next_clk               ( interp_clk_out_2[3]      ),
.n_next_clk             ( interp_clk_out_2[2]      ),
.switch_up              ( switch_up[2]             ),
.switch_dn              ( switch_dn[2]             ),
.up_ph                  ( up_ph[2]                 ),
.dzoutx                 ( dzoutx[2]                ),

.frzreg                 ( local_frzreg             ),
.pull_high              ( local_frzreg             ), 

.dpahold                ( dpahold_pp[2]            ),
.dparst                 ( dparst_pp[2]             ),
.dpaswitch              ( dpaswitch_pp[2]          ),
.fiforst                ( fiforst_pp[2]            ),
.testin_fclk            ( testin_fclk_pp[2]        ),
.testin_loaden          ( test_loaden_pp[2]        ),
.par_in                 ( par_in_pp2               ),
.bslipcntl              ( bslipcntl_pp[2]          ),
.bsliprst               ( bsliprst_pp[2]           ),
.lock                   ( lock_pp[2]               ),
.pclk                   ( pclk_2                   ),
.bslipmax               ( bslipmax_pp[2]           ),
.par_out                ( par_out_pp2              ),

.lvdsin                 ( lvdsin[2]                ),
.pclkdpa                ( pclkdpa[2]               ),
.lvdsout                ( lvdsout[2]               ),
.fclk_in                ( {phy_clk_2[4],phy_clk_2[1]} ),                
.loaden_in              ( {phy_clk_2[3],phy_clk_2[0]} ),                
.loopback2_data_right_in ( loopback2_r2l[1]        ),
.loopback2_data_left_in  ( loopback2_l2r[2]        ), 
.data_lback_adj_right_in ( loopback13_r2l[1]       ),
.data_lback_adj_left_in  ( loopback13_l2r[2]       ),
.data_lback2_right_out   ( loopback2_l2r[1]        ),
.data_lback2_left_out    ( loopback2_r2l[2]        ),
.data_lback13_right_out  ( loopback13_l2r[1]       ),
.data_lback13_left_out   ( loopback13_r2l[2]       ),

.dummy_top_in           (  atpg_en_n               ),
.dummy_top_out          (                          ),
.dummy_bot_in           (  {2{atpg_en_n}}          ),
.dummy_bot_out          (                          ),

.atpg_en_n              ( atpg_en_n                ),
.pipeline_en_n          ( pipeline_global_en_n     ),
.latch_en               ( 1'b1                     ), 
.scan_right_in          ( dp_scan12_r2l[1:0]       ),
.scan_left_in           ( dp_scan23_l2r[1:0]       ),
.scan_shift_n           ( scan_shift_n             ),
.scan_right_out         ( dp_scan12_l2r[1:0]       ),
.scan_left_out          ( dp_scan23_r2l[1:0]       )
);

ioserdesdpa_top__mdev40 ioserdesdpa_3 (
.csr_in                 ( dp_csrout[2]             ),
.csr_en                 ( csren_gate               ),
.csr_clk                ( csrclk_mux_o             ),
.csr_out                ( dp_csrout[3]             ),

.crnt_clk               ( interp_clk_out_3[1]      ),
.n_crnt_clk             ( interp_clk_out_3[0]      ),
.next_clk               ( interp_clk_out_3[3]      ),
.n_next_clk             ( interp_clk_out_3[2]      ),
.switch_up              ( switch_up[3]             ),
.switch_dn              ( switch_dn[3]             ),
.up_ph                  ( up_ph[3]                 ),
.dzoutx                 ( dzoutx[3]                ),

.frzreg                 ( local_frzreg             ),
.pull_high              ( local_frzreg             ), 

.dpahold                ( dpahold_pp[3]            ),
.dparst                 ( dparst_pp[3]             ),
.dpaswitch              ( dpaswitch_pp[3]          ),
.fiforst                ( fiforst_pp[3]            ),
.testin_fclk            ( testin_fclk_pp[3]        ),
.testin_loaden          ( test_loaden_pp[3]        ),
.par_in                 ( par_in_pp3               ),
.bslipcntl              ( bslipcntl_pp[3]          ),
.bsliprst               ( bsliprst_pp[3]           ),
.lock                   ( lock_pp[3]               ),
.pclk                   ( pclk_3                   ),
.bslipmax               ( bslipmax_pp[3]           ),
.par_out                ( par_out_pp3              ),

.lvdsin                 ( lvdsin[3]                ),
.pclkdpa                ( pclkdpa[3]               ),
.lvdsout                ( lvdsout[3]               ),
.fclk_in                ( {phy_clk_3[4],phy_clk_3[1]} ),                
.loaden_in              ( {phy_clk_3[3],phy_clk_3[0]} ),                
.loopback2_data_right_in ( loopback2_r2l[2]        ),
.loopback2_data_left_in  ( loopback2_l2r[3]        ),
.data_lback_adj_right_in ( loopback13_r2l[2]       ),
.data_lback_adj_left_in  ( loopback13_l2r[3]       ),
.data_lback2_right_out   ( loopback2_l2r[2]        ),
.data_lback2_left_out    ( loopback2_r2l[3]        ),
.data_lback13_right_out  ( loopback13_l2r[2]       ),
.data_lback13_left_out   ( loopback13_r2l[3]       ),

.dummy_top_in           (  atpg_en_n               ),
.dummy_top_out          (                          ),
.dummy_bot_in           (  {2{atpg_en_n}}          ),
.dummy_bot_out          (                          ),

.atpg_en_n              ( atpg_en_n                ),
.pipeline_en_n          ( pipeline_global_en_n     ),
.latch_en               ( 1'b1                     ), 
.scan_right_in          ( dp_scan23_r2l[1:0]       ),
.scan_left_in           ( dp_scan34_l2r[1:0]       ),
.scan_shift_n           ( scan_shift_n             ),
.scan_right_out         ( dp_scan23_l2r[1:0]       ),
.scan_left_out          ( dp_scan34_r2l[1:0]       )
);

ioserdesdpa_top__mdev40 ioserdesdpa_4 (
.csr_in                 ( dp_csrout[3]             ),
.csr_en                 ( csren_gate               ),
.csr_clk                ( csrclk_mux_o             ),
.csr_out                ( dp_csrout[4]             ),

.crnt_clk               ( interp_clk_out_4[1]      ),
.n_crnt_clk             ( interp_clk_out_4[0]      ),
.next_clk               ( interp_clk_out_4[3]      ),
.n_next_clk             ( interp_clk_out_4[2]      ),
.switch_up              ( switch_up[4]             ),
.switch_dn              ( switch_dn[4]             ),
.up_ph                  ( up_ph[4]                 ),
.dzoutx                 ( dzoutx[4]                ),

.frzreg                 ( local_frzreg             ),
.pull_high              ( local_frzreg             ), 

.dpahold                ( dpahold_pp[4]            ),
.dparst                 ( dparst_pp[4]             ),
.dpaswitch              ( dpaswitch_pp[4]          ),
.fiforst                ( fiforst_pp[4]            ),
.testin_fclk            ( testin_fclk_pp[4]        ),
.testin_loaden          ( test_loaden_pp[4]        ),
.par_in                 ( par_in_pp4               ),
.bslipcntl              ( bslipcntl_pp[4]          ),
.bsliprst               ( bsliprst_pp[4]           ),
.lock                   ( lock_pp[4]               ),
.pclk                   ( pclk_4                   ),
.bslipmax               ( bslipmax_pp[4]           ),
.par_out                ( par_out_pp4              ),

.lvdsin                 ( lvdsin[4]                ),
.pclkdpa                ( pclkdpa[4]               ),
.lvdsout                ( lvdsout[4]               ),
.fclk_in                ( {phy_clk_4[4],phy_clk_4[1]} ),                
.loaden_in              ( {phy_clk_4[3],phy_clk_4[0]} ),                
.loopback2_data_right_in ( loopback2_r2l[3]        ),
.loopback2_data_left_in  ( loopback2_l2r[4]        ), 
.data_lback_adj_right_in ( loopback13_r2l[3]       ),
.data_lback_adj_left_in  ( loopback13_l2r[4]       ),
.data_lback2_right_out   ( loopback2_l2r[3]        ),
.data_lback2_left_out    ( loopback2_r2l[4]        ),
.data_lback13_right_out  ( loopback13_l2r[3]       ),
.data_lback13_left_out   ( loopback13_r2l[4]       ),

.dummy_top_in           (  atpg_en_n               ),
.dummy_top_out          (                          ),
.dummy_bot_in           (  {2{atpg_en_n}}          ),
.dummy_bot_out          (                          ),

.atpg_en_n              ( atpg_en_n                ),
.pipeline_en_n          ( pipeline_global_en_n     ),
.latch_en               ( 1'b1                     ), 
.scan_right_in          ( dp_scan34_r2l[1:0]       ),
.scan_left_in           ( dp_scan45_l2r[1:0]       ),
.scan_shift_n           ( scan_shift_n             ),
.scan_right_out         ( dp_scan34_l2r[1:0]       ),
.scan_left_out          ( dp_scan45_r2l[1:0]       )
);

ioserdesdpa_top__mdev40 ioserdesdpa_5 (
.csr_in                 ( dp_csrout[4]             ),
.csr_en                 ( csren_gate               ),
.csr_clk                ( csrclk_mux_o             ),
.csr_out                ( dp_csrout[5]             ),

.crnt_clk               ( interp_clk_out_5[1]      ),
.n_crnt_clk             ( interp_clk_out_5[0]      ),
.next_clk               ( interp_clk_out_5[3]      ),
.n_next_clk             ( interp_clk_out_5[2]      ),
.switch_up              ( switch_up[5]             ),
.switch_dn              ( switch_dn[5]             ),
.up_ph                  ( up_ph[5]                 ),
.dzoutx                 ( dzoutx[5]                ),

.frzreg                 ( local_frzreg             ),
.pull_high              ( local_frzreg             ), 

.dpahold                ( dpahold_pp[5]            ),
.dparst                 ( dparst_pp[5]             ),
.dpaswitch              ( dpaswitch_pp[5]          ),
.fiforst                ( fiforst_pp[5]            ),
.testin_fclk            ( testin_fclk_pp[5]        ),
.testin_loaden          ( test_loaden_pp[5]        ),
.par_in                 ( par_in_pp5               ),
.bslipcntl              ( bslipcntl_pp[5]          ),
.bsliprst               ( bsliprst_pp[5]           ),
.lock                   ( lock_pp[5]               ),
.pclk                   ( pclk_5                   ),
.bslipmax               ( bslipmax_pp[5]           ),
.par_out                ( par_out_pp5              ),

.lvdsin                 ( lvdsin[5]                ),
.pclkdpa                ( pclkdpa[5]               ),
.lvdsout                ( lvdsout[5]               ),
.fclk_in                ( {phy_clk_5[4],phy_clk_5[1]} ),                
.loaden_in              ( {phy_clk_5[3],phy_clk_5[0]} ),                
.loopback2_data_right_in ( loopback2_r2l[4]        ),
.loopback2_data_left_in  ( 1'b0                    ),
.data_lback_adj_right_in ( loopback13_r2l[4]       ),
.data_lback_adj_left_in  ( 1'b0                    ),
.data_lback2_right_out   ( loopback2_l2r[4]        ),
.data_lback2_left_out    (                         ), 
.data_lback13_right_out  ( loopback13_l2r[4]       ),
.data_lback13_left_out   (                         ), 

.dummy_top_in           (  atpg_en_n               ),
.dummy_top_out          (                          ),
.dummy_bot_in           (  {2{atpg_en_n}}          ),
.dummy_bot_out          (                          ),

.atpg_en_n              ( atpg_en_n                ),
.pipeline_en_n          ( pipeline_global_en_n     ),
.latch_en               ( csr_shift_n_top          ), 
.scan_right_in          ( dp_scan45_r2l[1:0]       ),
.scan_left_in           ( 2'b0                     ),
.scan_shift_n           ( scan_shift_n             ),
.scan_right_out         ( dp_scan45_l2r[1:0]       ),
.scan_left_out          (                          )
);

endmodule

